/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(ie){for(var t=[],A=0,P=ie.length;A<P;A++)t[A]=be[ie[A]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:jt,setPrototypeOf:zt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Pt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,A,P){return t.apply(A,P)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Pt||(Pt=function(t,A){return new t(...A)});const oi=ct(Array.prototype.forEach),Ut=ct(Array.prototype.pop),$t=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Ct=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),pt=ui(TypeError);function ct(ie){return function(t){for(var A=arguments.length,P=new Array(A>1?A-1:0),n=1;n<A;n++)P[n-1]=arguments[n];return Nt(ie,t,P)}}function ui(ie){return function(){for(var t=arguments.length,A=new Array(t),P=0;P<t;P++)A[P]=arguments[P];return Pt(ie,A)}}function He(ie,t,A){var P;A=(P=A)!==null&&P!==void 0?P:yt,zt&&zt(ie,null);let n=t.length;for(;n--;){let z=t[n];if(typeof z=="string"){const E=A(z);E!==z&&(ii(t)||(t[n]=E),z=E)}ie[z]=!0}return ie}function mt(ie){const t=ri(null);for(const[A,P]of jt(ie))t[A]=P;return t}function Et(ie,t){for(;ie!==null;){const P=si(ie,t);if(P){if(P.get)return ct(P.get);if(typeof P.value=="function")return ct(P.value)}ie=ni(ie)}function A(P){return console.warn("fallback value for",P),null}return A}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),_t=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,Di=function(t,A){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let P=null;const n="data-tt-policy-suffix";A&&A.hasAttribute(n)&&(P=A.getAttribute(n));const z="dompurify"+(P?"#"+P:"");try{return t.createPolicy(z,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+z+" could not be created."),null}};function xt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=je=>xt(je);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const A=ie.document,P=A.currentScript;let{document:n}=ie;const{DocumentFragment:z,HTMLTemplateElement:E,Node:k,Element:b,NodeFilter:v,NamedNodeMap:y=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:L,DOMParser:o,trustedTypes:l}=ie,e=b.prototype,s=Et(e,"cloneNode"),m=Et(e,"nextSibling"),$=Et(e,"childNodes"),a=Et(e,"parentNode");if(typeof E=="function"){const je=n.createElement("template");je.content&&je.content.ownerDocument&&(n=je.content.ownerDocument)}let p,f="";const{implementation:g,createNodeIterator:h,createDocumentFragment:T,getElementsByTagName:O}=n,{importNode:R}=A;let w={};t.isSupported=typeof jt=="function"&&typeof a=="function"&&g&&g.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:S,ERB_EXPR:M,TMPLIT_EXPR:H,DATA_ATTR:_,ARIA_ATTR:N,IS_SCRIPT_OR_DATA:I,ATTR_WHITESPACE:B}=Kt;let{IS_ALLOWED_URI:X}=Kt,Y=null;const ue=He({},[...Ht,...Rt,...Lt,...It,...Wt]);let ne=null;const te=He({},[...qt,...Ot,...Vt,...At]);let we=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Re=null,Te=null,Oe=!0,re=!0,J=!1,ae=!0,K=!1,U=!1,Z=!1,me=!1,ve=!1,ke=!1,Ee=!1,ge=!0,D=!1;const i="user-content-";let r=!0,c=!1,u={},d=null;const F=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let C=null;const W=He({},["audio","video","img","source","image","track"]);let j=null;const V=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),G="http://www.w3.org/1998/Math/MathML",oe="http://www.w3.org/2000/svg",se="http://www.w3.org/1999/xhtml";let de=se,De=!1,pe=null;const Ce=He({},[G,oe,se],Ct);let Fe;const Me=["application/xhtml+xml","text/html"],Be="text/html";let Ie,Je=null;const Ke=n.createElement("form"),xe=function(he){return he instanceof RegExp||he instanceof Function},x=function(he){if(!(Je&&Je===he)){if((!he||typeof he!="object")&&(he={}),he=mt(he),Fe=Me.indexOf(he.PARSER_MEDIA_TYPE)===-1?Fe=Be:Fe=he.PARSER_MEDIA_TYPE,Ie=Fe==="application/xhtml+xml"?Ct:yt,Y="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Ie):ue,ne="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Ie):te,pe="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Ct):Ce,j="ADD_URI_SAFE_ATTR"in he?He(mt(V),he.ADD_URI_SAFE_ATTR,Ie):V,C="ADD_DATA_URI_TAGS"in he?He(mt(W),he.ADD_DATA_URI_TAGS,Ie):W,d="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Ie):F,Re="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Ie):{},Te="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Ie):{},u="USE_PROFILES"in he?he.USE_PROFILES:!1,Oe=he.ALLOW_ARIA_ATTR!==!1,re=he.ALLOW_DATA_ATTR!==!1,J=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,K=he.SAFE_FOR_TEMPLATES||!1,U=he.WHOLE_DOCUMENT||!1,ve=he.RETURN_DOM||!1,ke=he.RETURN_DOM_FRAGMENT||!1,Ee=he.RETURN_TRUSTED_TYPE||!1,me=he.FORCE_BODY||!1,ge=he.SANITIZE_DOM!==!1,D=he.SANITIZE_NAMED_PROPS||!1,r=he.KEEP_CONTENT!==!1,c=he.IN_PLACE||!1,X=he.ALLOWED_URI_REGEXP||_t,de=he.NAMESPACE||se,we=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(we.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(we.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(we.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),K&&(re=!1),ke&&(ve=!0),u&&(Y=He({},[...Wt]),ne=[],u.html===!0&&(He(Y,Ht),He(ne,qt)),u.svg===!0&&(He(Y,Rt),He(ne,Ot),He(ne,At)),u.svgFilters===!0&&(He(Y,Lt),He(ne,Ot),He(ne,At)),u.mathMl===!0&&(He(Y,It),He(ne,Vt),He(ne,At))),he.ADD_TAGS&&(Y===ue&&(Y=mt(Y)),He(Y,he.ADD_TAGS,Ie)),he.ADD_ATTR&&(ne===te&&(ne=mt(ne)),He(ne,he.ADD_ATTR,Ie)),he.ADD_URI_SAFE_ATTR&&He(j,he.ADD_URI_SAFE_ATTR,Ie),he.FORBID_CONTENTS&&(d===F&&(d=mt(d)),He(d,he.FORBID_CONTENTS,Ie)),r&&(Y["#text"]=!0),U&&He(Y,["html","head","body"]),Y.table&&(He(Y,["tbody"]),delete Re.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');p=he.TRUSTED_TYPES_POLICY,f=p.createHTML("")}else p===void 0&&(p=Di(l,P)),p!==null&&typeof f=="string"&&(f=p.createHTML(""));ot&&ot(he),Je=he}},le=He({},["mi","mo","mn","ms","mtext"]),fe=He({},["foreignobject","desc","title","annotation-xml"]),Ae=He({},["title","style","font","a","script"]),Ne=He({},Rt);He(Ne,Lt),He(Ne,ci);const ze=He({},It);He(ze,fi);const qe=function(he){let Se=a(he);(!Se||!Se.tagName)&&(Se={namespaceURI:de,tagName:"template"});const Pe=yt(he.tagName),We=yt(Se.tagName);return pe[he.namespaceURI]?he.namespaceURI===oe?Se.namespaceURI===se?Pe==="svg":Se.namespaceURI===G?Pe==="svg"&&(We==="annotation-xml"||le[We]):!!Ne[Pe]:he.namespaceURI===G?Se.namespaceURI===se?Pe==="math":Se.namespaceURI===oe?Pe==="math"&&fe[We]:!!ze[Pe]:he.namespaceURI===se?Se.namespaceURI===oe&&!fe[We]||Se.namespaceURI===G&&!le[We]?!1:!ze[Pe]&&(Ae[Pe]||!Ne[Pe]):!!(Fe==="application/xhtml+xml"&&pe[he.namespaceURI]):!1},_e=function(he){$t(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,Se){try{$t(t.removed,{attribute:Se.getAttributeNode(he),from:Se})}catch{$t(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(he),he==="is"&&!ne[he])if(ve||ke)try{_e(Se)}catch{}else try{Se.setAttribute(he,"")}catch{}},tt=function(he){let Se,Pe;if(me)he="<remove></remove>"+he;else{const at=li(he,/^[\r\n\t ]+/);Pe=at&&at[0]}Fe==="application/xhtml+xml"&&de===se&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const We=p?p.createHTML(he):he;if(de===se)try{Se=new o().parseFromString(We,Fe)}catch{}if(!Se||!Se.documentElement){Se=g.createDocument(de,"template",null);try{Se.documentElement.innerHTML=De?f:We}catch{}}const it=Se.body||Se.documentElement;return he&&Pe&&it.insertBefore(n.createTextNode(Pe),it.childNodes[0]||null),de===se?O.call(Se,U?"html":"body")[0]:U?Se.documentElement:it},Ze=function(he){return h.call(he.ownerDocument||he,he,v.SHOW_ELEMENT|v.SHOW_COMMENT|v.SHOW_TEXT,null,!1)},nt=function(he){return he instanceof L&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof y)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},st=function(he){return typeof k=="object"?he instanceof k:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},rt=function(he,Se,Pe){w[he]&&oi(w[he],We=>{We.call(t,Se,Pe,Je)})},gt=function(he){let Se;if(rt("beforeSanitizeElements",he,null),nt(he))return _e(he),!0;const Pe=Ie(he.nodeName);if(rt("uponSanitizeElement",he,{tagName:Pe,allowedTags:Y}),he.hasChildNodes()&&!st(he.firstElementChild)&&(!st(he.content)||!st(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return _e(he),!0;if(!Y[Pe]||Re[Pe]){if(!Re[Pe]&&St(Pe)&&(we.tagNameCheck instanceof RegExp&&ht(we.tagNameCheck,Pe)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Pe)))return!1;if(r&&!d[Pe]){const We=a(he)||he.parentNode,it=$(he)||he.childNodes;if(it&&We){const at=it.length;for(let Qe=at-1;Qe>=0;--Qe)We.insertBefore(s(it[Qe],!0),m(he))}}return _e(he),!0}return he instanceof b&&!qe(he)||(Pe==="noscript"||Pe==="noembed"||Pe==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(_e(he),!0):(K&&he.nodeType===3&&(Se=he.textContent,Se=dt(Se,S," "),Se=dt(Se,M," "),Se=dt(Se,H," "),he.textContent!==Se&&($t(t.removed,{element:he.cloneNode()}),he.textContent=Se)),rt("afterSanitizeElements",he,null),!1)},kt=function(he,Se,Pe){if(ge&&(Se==="id"||Se==="name")&&(Pe in n||Pe in Ke))return!1;if(!(re&&!Te[Se]&&ht(_,Se))){if(!(Oe&&ht(N,Se))){if(!ne[Se]||Te[Se]){if(!(St(he)&&(we.tagNameCheck instanceof RegExp&&ht(we.tagNameCheck,he)||we.tagNameCheck instanceof Function&&we.tagNameCheck(he))&&(we.attributeNameCheck instanceof RegExp&&ht(we.attributeNameCheck,Se)||we.attributeNameCheck instanceof Function&&we.attributeNameCheck(Se))||Se==="is"&&we.allowCustomizedBuiltInElements&&(we.tagNameCheck instanceof RegExp&&ht(we.tagNameCheck,Pe)||we.tagNameCheck instanceof Function&&we.tagNameCheck(Pe))))return!1}else if(!j[Se]){if(!ht(X,dt(Pe,B,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&he!=="script"&&ai(Pe,"data:")===0&&C[he])){if(!(J&&!ht(I,dt(Pe,B,"")))){if(Pe)return!1}}}}}}return!0},St=function(he){return he.indexOf("-")>0},wt=function(he){let Se,Pe,We,it;rt("beforeSanitizeAttributes",he,null);const{attributes:at}=he;if(!at)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ne};for(it=at.length;it--;){Se=at[it];const{name:ut,namespaceURI:vt}=Se;if(Pe=ut==="value"?Se.value:hi(Se.value),We=Ie(ut),Qe.attrName=We,Qe.attrValue=Pe,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,rt("uponSanitizeAttribute",he,Qe),Pe=Qe.attrValue,Qe.forceKeepAttr||(et(ut,he),!Qe.keepAttr))continue;if(!ae&&ht(/\/>/i,Pe)){et(ut,he);continue}K&&(Pe=dt(Pe,S," "),Pe=dt(Pe,M," "),Pe=dt(Pe,H," "));const Ft=Ie(he.nodeName);if(kt(Ft,We,Pe)){if(D&&(We==="id"||We==="name")&&(et(ut,he),Pe=i+Pe),p&&typeof l=="object"&&typeof l.getAttributeType=="function"&&!vt)switch(l.getAttributeType(Ft,We)){case"TrustedHTML":{Pe=p.createHTML(Pe);break}case"TrustedScriptURL":{Pe=p.createScriptURL(Pe);break}}try{vt?he.setAttributeNS(vt,ut,Pe):he.setAttribute(ut,Pe),Ut(t.removed)}catch{}}}rt("afterSanitizeAttributes",he,null)},Mt=function je(he){let Se;const Pe=Ze(he);for(rt("beforeSanitizeShadowDOM",he,null);Se=Pe.nextNode();)rt("uponSanitizeShadowNode",Se,null),!gt(Se)&&(Se.content instanceof z&&je(Se.content),wt(Se));rt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(je){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Se,Pe,We,it;if(De=!je,De&&(je="<!-->"),typeof je!="string"&&!st(je))if(typeof je.toString=="function"){if(je=je.toString(),typeof je!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return je;if(Z||x(he),t.removed=[],typeof je=="string"&&(c=!1),c){if(je.nodeName){const ut=Ie(je.nodeName);if(!Y[ut]||Re[ut])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(je instanceof k)Se=tt("<!---->"),Pe=Se.ownerDocument.importNode(je,!0),Pe.nodeType===1&&Pe.nodeName==="BODY"||Pe.nodeName==="HTML"?Se=Pe:Se.appendChild(Pe);else{if(!ve&&!K&&!U&&je.indexOf("<")===-1)return p&&Ee?p.createHTML(je):je;if(Se=tt(je),!Se)return ve?null:Ee?f:""}Se&&me&&_e(Se.firstChild);const at=Ze(c?je:Se);for(;We=at.nextNode();)gt(We)||(We.content instanceof z&&Mt(We.content),wt(We));if(c)return je;if(ve){if(ke)for(it=T.call(Se.ownerDocument);Se.firstChild;)it.appendChild(Se.firstChild);else it=Se;return(ne.shadowroot||ne.shadowrootmode)&&(it=R.call(A,it,!0)),it}let Qe=U?Se.outerHTML:Se.innerHTML;return U&&Y["!doctype"]&&Se.ownerDocument&&Se.ownerDocument.doctype&&Se.ownerDocument.doctype.name&&ht(Qt,Se.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+Se.ownerDocument.doctype.name+`>
`+Qe),K&&(Qe=dt(Qe,S," "),Qe=dt(Qe,M," "),Qe=dt(Qe,H," ")),p&&Ee?p.createHTML(Qe):Qe},t.setConfig=function(je){x(je),Z=!0},t.clearConfig=function(){Je=null,Z=!1},t.isValidAttribute=function(je,he,Se){Je||x({});const Pe=Ie(je),We=Ie(he);return kt(Pe,We,Se)},t.addHook=function(je,he){typeof he=="function"&&(w[je]=w[je]||[],$t(w[je],he))},t.removeHook=function(je){if(w[je])return Ut(w[je])},t.removeHooks=function(je){w[je]&&(w[je]=[])},t.removeAllHooks=function(){w={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=t.$1Q=void 0;class A{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const k=P(E);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(E){const k=P(E);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(E){const k=P(E);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(E){const k=P(E);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(E){const k=P(E);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(E){const k=P(E);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(E){const k=P(E);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(E){const k=P(E);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const k=P(E);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const k=P(E);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const k=P(E);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const k=P(E);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const k=P(E);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const k=P(E);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,k){this.domNode.classList.toggle(E,k),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,k){this.domNode.setAttribute(E,k)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$1Q=A;function P(z){return typeof z=="number"?`${z}px`:z}function n(z){return new A(z)}t.$2Q=n}),define(be[69],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hP=t.$gP=void 0;const A=new WeakMap;function P(k){if(!k.parent||k.parent===k)return null;try{const b=k.location,v=k.parent.location;if(b.origin!=="null"&&v.origin!=="null"&&b.origin!==v.origin)return null}catch{return null}return k.parent}class n{static a(b){let v=A.get(b);if(!v){v=[],A.set(b,v);let y=b,L;do L=P(y),L?v.push({window:new WeakRef(y),iframeElement:y.frameElement||null}):v.push({window:new WeakRef(y),iframeElement:null}),y=L;while(y)}return v.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,v){if(!v||b===v)return{top:0,left:0};let y=0,L=0;const o=this.a(b);for(const l of o){const e=l.window.deref();if(y+=e?.scrollY??0,L+=e?.scrollX??0,e===v||!l.iframeElement)break;const s=l.iframeElement.getBoundingClientRect();y+=s.top,L+=s.left}return{top:y,left:L}}}t.$gP=n;async function z(k,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const v=JSON.stringify({parentOrigin:k,salt:b}),L=new TextEncoder().encode(v),o=await crypto.subtle.digest("sha-256",L);return E(o)}t.$hP=z;function E(k){const v=Array.from(new Uint8Array(k)).map(y=>y.toString(16).padStart(2,"0")).join("");return BigInt(`0x${v}`).toString(32).padStart(52,"0")}}),define(be[70],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=t.ListDragOverEffect=void 0;var A;(function(z){z[z.Copy=0]="Copy",z[z.Move=1]="Move"})(A||(t.ListDragOverEffect=A={})),t.$wR={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(E,k){super(`ListError [${E}] ${k}`)}}t.$xR=P;class n{constructor(){this.c=new WeakMap}getHeight(E){return this.c.get(E)??this.d(E)}setDynamicHeight(E,k){k>0&&this.c.set(E,k)}}t.$yR=n}),define(be[71],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vR=void 0;class A{constructor(n){this.a=n}splice(n,z,E){this.a.forEach(k=>k.splice(n,z,E))}}t.$vR=A}),define(be[42],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=void 0;const A=20;class P{constructor(z,E,k,b,v,y){this.a=Math.round(E),this.b=Math.round(k),this.c=Math.round(z),this.d=b,this.e=v,this.f=y,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new P(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(z){const E=Math.round(z);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(z){const E=Math.round(z);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(z){const E=Math.round(z);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(z){this.a=Math.round(z)}setOppositeScrollbarSize(z){this.b=Math.round(z)}static l(z,E,k,b,v){const y=Math.max(0,k-z),L=Math.max(0,y-2*E),o=b>0&&b>k;if(!o)return{computedAvailableSize:Math.round(y),computedIsNeeded:o,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(A,Math.floor(k*L/b))),e=(L-l)/(b-k),s=v*e;return{computedAvailableSize:Math.round(y),computedIsNeeded:o,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const z=P.l(this.b,this.c,this.d,this.e,this.f);this.g=z.computedAvailableSize,this.h=z.computedIsNeeded,this.i=z.computedSliderSize,this.j=z.computedSliderRatio,this.k=z.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(z){if(!this.h)return 0;const E=z-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(z){if(!this.h)return 0;const E=z-this.c;let k=this.f;return E<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(z){if(!this.h)return 0;const E=this.k+z;return Math.round(E/this.j)}}t.$7Q=P}),define(be[26],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xT=t.$wT=t.$vT=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var A;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(A||(t.TreeVisibility=A={}));var P;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var n;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var z;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(z||(t.TreeDragOverBubble=z={})),t.$vT={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:0,autoExpand:b}}};class E extends Error{constructor(v,y){super(`TreeError [${v}] ${y}`)}}t.$wT=E;class k{constructor(v){this.a=v,this.b=new WeakMap}map(v){let y=this.b.get(v);return y||(y=this.a(v),this.b.set(v,y)),y}}t.$xT=k}),define(be[21],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WO=t.$window=t.$UO=t.$TO=void 0;function A(n,z){const E=n;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>z})}t.$TO=A,t.$UO=window,t.$window=t.$UO;function P(n){return n===t.$UO?!1:typeof n?.vscodeWindowId=="number"}t.$WO=P}),define(be[72],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function A(s,m,$){const a=P(s,m);if(a!==-1)return s[a]}t.$fb=A;function P(s,m,$=s.length-1){for(let a=$;a>=0;a--){const p=s[a];if(m(p))return a}return-1}t.$gb=P;function n(s,m){const $=z(s,m);return $===-1?void 0:s[$]}t.$hb=n;function z(s,m,$=0,a=s.length){let p=$,f=a;for(;p<f;){const g=Math.floor((p+f)/2);m(s[g])?p=g+1:f=g}return p-1}t.$ib=z;function E(s,m){const $=k(s,m);return $===s.length?void 0:s[$]}t.$jb=E;function k(s,m,$=0,a=s.length){let p=$,f=a;for(;p<f;){const g=Math.floor((p+f)/2);m(s[g])?f=g:p=g+1}return p}t.$kb=k;function b(s,m,$=0,a=s.length){const p=k(s,m,$,a);return p===s.length?-1:p}t.$lb=b;class v{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(v.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!m(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=z(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}t.$mb=v;function y(s,m){if(s.length===0)return;let $=s[0];for(let a=1;a<s.length;a++){const p=s[a];m(p,$)>0&&($=p)}return $}t.$nb=y;function L(s,m){if(s.length===0)return;let $=s[0];for(let a=1;a<s.length;a++){const p=s[a];m(p,$)>=0&&($=p)}return $}t.$ob=L;function o(s,m){return y(s,($,a)=>-m($,a))}t.$pb=o;function l(s,m){if(s.length===0)return-1;let $=0;for(let a=1;a<s.length;a++){const p=s[a];m(p,s[$])>0&&($=a)}return $}t.$qb=l;function e(s,m){for(const $ of s){const a=m($);if(a!==void 0)return a}}t.$rb=e}),define(be[73],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function A(E,k){const b=Object.create(null);for(const v of E){const y=k(v);let L=b[y];L||(L=b[y]=[]),L.push(v)}return b}t.$K=A;function P(E,k){const b=[],v=[];for(const y of E)k.has(y)||b.push(y);for(const y of k)E.has(y)||v.push(y);return{removed:b,added:v}}t.$L=P;function n(E,k){const b=[],v=[];for(const[y,L]of E)k.has(y)||b.push(L);for(const[y,L]of k)E.has(y)||v.push(L);return{removed:b,added:v}}t.$M=n;function z(E,k){const b=new Set;for(const v of k)E.has(v)&&b.add(v);return b}t.$N=z}),define(be[74],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=t.$bt=t.$at=t.$_s=void 0;function A(k,b){const v=Math.pow(10,b);return Math.round(k*v)/v}class P{constructor(b,v,y,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,v))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=A(Math.max(Math.min(1,L),0),3)}static equals(b,v){return b.r===v.r&&b.g===v.g&&b.b===v.b&&b.a===v.a}}t.$_s=P;class n{constructor(b,v,y,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=A(Math.max(Math.min(1,v),0),3),this.l=A(Math.max(Math.min(1,y),0),3),this.a=A(Math.max(Math.min(1,L),0),3)}static equals(b,v){return b.h===v.h&&b.s===v.s&&b.l===v.l&&b.a===v.a}static fromRGBA(b){const v=b.r/255,y=b.g/255,L=b.b/255,o=b.a,l=Math.max(v,y,L),e=Math.min(v,y,L);let s=0,m=0;const $=(e+l)/2,a=l-e;if(a>0){switch(m=Math.min($<=.5?a/(2*$):a/(2-2*$),1),l){case v:s=(y-L)/a+(y<L?6:0);break;case y:s=(L-v)/a+2;break;case L:s=(v-y)/a+4;break}s*=60,s=Math.round(s)}return new n(s,m,$,o)}static i(b,v,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?b+(v-b)*6*y:y<1/2?v:y<2/3?b+(v-b)*(2/3-y)*6:b}static toRGBA(b){const v=b.h/360,{s:y,l:L,a:o}=b;let l,e,s;if(y===0)l=e=s=L;else{const m=L<.5?L*(1+y):L+y-L*y,$=2*L-m;l=n.i($,m,v+1/3),e=n.i($,m,v),s=n.i($,m,v-1/3)}return new P(Math.round(l*255),Math.round(e*255),Math.round(s*255),o)}}t.$at=n;class z{constructor(b,v,y,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=A(Math.max(Math.min(1,v),0),3),this.v=A(Math.max(Math.min(1,y),0),3),this.a=A(Math.max(Math.min(1,L),0),3)}static equals(b,v){return b.h===v.h&&b.s===v.s&&b.v===v.v&&b.a===v.a}static fromRGBA(b){const v=b.r/255,y=b.g/255,L=b.b/255,o=Math.max(v,y,L),l=Math.min(v,y,L),e=o-l,s=o===0?0:e/o;let m;return e===0?m=0:o===v?m=((y-L)/e%6+6)%6:o===y?m=(L-v)/e+2:m=(v-y)/e+4,new z(Math.round(m*60),s,o,b.a)}static toRGBA(b){const{h:v,s:y,v:L,a:o}=b,l=L*y,e=l*(1-Math.abs(v/60%2-1)),s=L-l;let[m,$,a]=[0,0,0];return v<60?(m=l,$=e):v<120?(m=e,$=l):v<180?($=l,a=e):v<240?($=e,a=l):v<300?(m=e,a=l):v<=360&&(m=l,a=e),m=Math.round((m+s)*255),$=Math.round(($+s)*255),a=Math.round((a+s)*255),new P(m,$,a,o)}}t.$bt=z;class E{static fromHex(b){return E.Format.CSS.parseHex(b)||E.red}static equals(b,v){return!b&&!v?!0:!b||!v?!1:b.equals(v)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:z.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof P)this.rgba=b;else if(b instanceof n)this.i=b,this.rgba=n.toRGBA(b);else if(b instanceof z)this.j=b,this.rgba=z.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&P.equals(this.rgba,b.rgba)&&n.equals(this.hsla,b.hsla)&&z.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=E.k(this.rgba.r),v=E.k(this.rgba.g),y=E.k(this.rgba.b),L=.2126*b+.7152*v+.0722*y;return A(L,4)}static k(b){const v=b/255;return v<=.03928?v/12.92:Math.pow((v+.055)/1.055,2.4)}getContrastRatio(b){const v=this.getRelativeLuminance(),y=b.getRelativeLuminance();return v>y?(v+.05)/(y+.05):(y+.05)/(v+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const v=this.getRelativeLuminance(),y=b.getRelativeLuminance();return v>y}isDarkerThan(b){const v=this.getRelativeLuminance(),y=b.getRelativeLuminance();return v<y}lighten(b){return new E(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new E(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:v,g:y,b:L,a:o}=this.rgba;return new E(new P(v,y,L,o*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const v=b.rgba,y=this.rgba.a,L=v.a,o=y+L*(1-y);if(o<1e-6)return E.transparent;const l=this.rgba.r*y/o+v.r*L*(1-y)/o,e=this.rgba.g*y/o+v.g*L*(1-y)/o,s=this.rgba.b*y/o+v.b*L*(1-y)/o;return new E(new P(l,e,s,o))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:v,g:y,b:L,a:o}=this.rgba;return new E(new P(b.rgba.r-o*(b.rgba.r-v),b.rgba.g-o*(b.rgba.g-y),b.rgba.b-o*(b.rgba.b-L),1))}flatten(...b){const v=b.reduceRight((y,L)=>E.o(L,y));return E.o(this,v)}static o(b,v){const y=1-b.rgba.a;return new E(new P(y*v.rgba.r+b.rgba.a*b.rgba.r,y*v.rgba.g+b.rgba.a*b.rgba.g,y*v.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(b,v,y){if(b.isLighterThan(v))return b;y=y||.5;const L=b.getRelativeLuminance(),o=v.getRelativeLuminance();return y=y*(o-L)/o,b.lighten(y)}static getDarkerColor(b,v,y){if(b.isDarkerThan(v))return b;y=y||.5;const L=b.getRelativeLuminance(),o=v.getRelativeLuminance();return y=y*(L-o)/L,b.darken(y)}static{this.white=new E(new P(255,255,255,1))}static{this.black=new E(new P(0,0,0,1))}static{this.red=new E(new P(255,0,0,1))}static{this.blue=new E(new P(0,0,255,1))}static{this.green=new E(new P(0,255,0,1))}static{this.cyan=new E(new P(0,255,255,1))}static{this.lightgrey=new E(new P(211,211,211,1))}static{this.transparent=new E(new P(0,0,0,0))}}t.$ct=E,function(k){let b;(function(v){let y;(function(L){function o(h){return h.rgba.a===1?`rgb(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b})`:k.Format.CSS.formatRGBA(h)}L.formatRGB=o;function l(h){return`rgba(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b}, ${+h.rgba.a.toFixed(2)})`}L.formatRGBA=l;function e(h){return h.hsla.a===1?`hsl(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(h)}L.formatHSL=e;function s(h){return`hsla(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%, ${h.hsla.a.toFixed(2)})`}L.formatHSLA=s;function m(h){const T=h.toString(16);return T.length!==2?"0"+T:T}function $(h){return`#${m(h.rgba.r)}${m(h.rgba.g)}${m(h.rgba.b)}`}L.formatHex=$;function a(h,T=!1){return T&&h.rgba.a===1?k.Format.CSS.formatHex(h):`#${m(h.rgba.r)}${m(h.rgba.g)}${m(h.rgba.b)}${m(Math.round(h.rgba.a*255))}`}L.formatHexA=a;function p(h){return h.isOpaque()?k.Format.CSS.formatHex(h):k.Format.CSS.formatRGBA(h)}L.format=p;function f(h){const T=h.length;if(T===0||h.charCodeAt(0)!==35)return null;if(T===7){const O=16*g(h.charCodeAt(1))+g(h.charCodeAt(2)),R=16*g(h.charCodeAt(3))+g(h.charCodeAt(4)),w=16*g(h.charCodeAt(5))+g(h.charCodeAt(6));return new k(new P(O,R,w,1))}if(T===9){const O=16*g(h.charCodeAt(1))+g(h.charCodeAt(2)),R=16*g(h.charCodeAt(3))+g(h.charCodeAt(4)),w=16*g(h.charCodeAt(5))+g(h.charCodeAt(6)),S=16*g(h.charCodeAt(7))+g(h.charCodeAt(8));return new k(new P(O,R,w,S/255))}if(T===4){const O=g(h.charCodeAt(1)),R=g(h.charCodeAt(2)),w=g(h.charCodeAt(3));return new k(new P(16*O+O,16*R+R,16*w+w))}if(T===5){const O=g(h.charCodeAt(1)),R=g(h.charCodeAt(2)),w=g(h.charCodeAt(3)),S=g(h.charCodeAt(4));return new k(new P(16*O+O,16*R+R,16*w+w,(16*S+S)/255))}return null}L.parseHex=f;function g(h){switch(h){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=v.CSS||(v.CSS={}))})(b=k.Format||(k.Format={}))}(E||(t.$ct=E={}))}),define(be[27],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xh=t.$wh=t.$vh=void 0;function A(E){return(k,b,v)=>{let y=null,L=null;if(typeof v.value=="function"?(y="value",L=v.value):typeof v.get=="function"&&(y="get",L=v.get),!L)throw new Error("not supported");v[y]=E(L,b)}}function P(E,k,b){let v=null,y=null;if(typeof b.value=="function"?(v="value",y=b.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(v="get",y=b.get),!y)throw new Error("not supported");const L=`$memoize$${k}`;b[v]=function(...o){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,o)}),this[L]}}t.$vh=P;function n(E,k,b){return A((v,y)=>{const L=`$debounce$${y}`,o=`$debounce$result$${y}`;return function(...l){this[o]||(this[o]=b?b():void 0),clearTimeout(this[L]),k&&(this[o]=k(this[o],...l),l=[this[o]]),this[L]=setTimeout(()=>{v.apply(this,l),this[o]=b?b():void 0},E)}})}t.$wh=n;function z(E,k,b){return A((v,y)=>{const L=`$throttle$timer$${y}`,o=`$throttle$result$${y}`,l=`$throttle$lastRun$${y}`,e=`$throttle$pending$${y}`;return function(...s){if(this[o]||(this[o]=b?b():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),k&&(this[o]=k(this[o],...s)),this[e])return;const m=this[l]+E;m<=Date.now()?(this[l]=Date.now(),v.apply(this,[this[o]]),this[o]=b?b():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),v.apply(this,[this[o]]),this[o]=b?b():void 0},m-Date.now()))}})}t.$xh=z}),define(be[75],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=void 0;class A{constructor(n,z,E,k){this.originalStart=n,this.originalLength=z,this.modifiedStart=E,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ns=A}),define(be[6],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class A{constructor(){this.b=[],this.a=function(h){setTimeout(()=>{throw h.stack?p.isErrorNoTelemetry(h)?new p(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.b.push(h),()=>{this.d(h)}}c(h){this.b.forEach(T=>{T(h)})}d(h){this.b.splice(this.b.indexOf(h),1)}setUnexpectedErrorHandler(h){this.a=h}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(h){this.a(h),this.c(h)}onUnexpectedExternalError(h){this.a(h)}}t.$W=A,t.$X=new A;function P(g){t.$X.setUnexpectedErrorHandler(g)}t.setUnexpectedErrorHandler=P;function n(g){if(!g||typeof g!="object")return!1;const h=g;return h.code==="EPIPE"&&h.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function z(g){v(g)||t.$X.onUnexpectedError(g)}t.$1=z;function E(g){v(g)||t.$X.onUnexpectedExternalError(g)}t.$2=E;function k(g){if(g instanceof Error){const{name:h,message:T}=g,O=g.stacktrace||g.stack;return{$isError:!0,name:h,message:T,stack:O,noTelemetry:p.isErrorNoTelemetry(g)}}return g}t.$3=k;const b="Canceled";function v(g){return g instanceof y?!0:g instanceof Error&&g.name===b&&g.message===b}t.$4=v;class y extends Error{constructor(){super(b),this.name=this.message}}t.$5=y;function L(){const g=new Error(b);return g.name=g.message,g}t.$6=L;function o(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}t.$7=o;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}t.$8=l;class e extends TypeError{constructor(h){super(h?`${h} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}t.$0=s;class m extends Error{constructor(h){super("NotImplemented"),h&&(this.message=h)}}t.$$=m;class $ extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}t.$_=$;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=a;class p extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof p)return h;const T=new p;return T.message=h.message,T.stack=h.stack,T}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}t.$bb=p;class f extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}t.$cb=f}),define(be[12],$e([1,0,6,72]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(D,i=0){return D[D.length-(1+i)]}t.$sb=n;function z(D){if(D.length===0)throw new Error("Invalid tail call");return[D.slice(0,D.length-1),D[D.length-1]]}t.$tb=z;function E(D,i,r=(c,u)=>c===u){if(D===i)return!0;if(!D||!i||D.length!==i.length)return!1;for(let c=0,u=D.length;c<u;c++)if(!r(D[c],i[c]))return!1;return!0}t.$ub=E;function k(D,i){const r=D.length-1;i<r&&(D[i]=D[r]),D.pop()}t.$vb=k;function b(D,i,r){return v(D.length,c=>r(D[c],i))}t.$wb=b;function v(D,i){let r=0,c=D-1;for(;r<=c;){const u=(r+c)/2|0,d=i(u);if(d<0)r=u+1;else if(d>0)c=u-1;else return u}return-(r+1)}t.$xb=v;function y(D,i,r){if(D=D|0,D>=i.length)throw new TypeError("invalid index");const c=i[Math.floor(i.length*Math.random())],u=[],d=[],F=[];for(const C of i){const W=r(C,c);W<0?u.push(C):W>0?d.push(C):F.push(C)}return D<u.length?y(D,u,r):D<u.length+F.length?F[0]:y(D-(u.length+F.length),d,r)}t.$yb=y;function L(D,i){const r=[];let c;for(const u of D.slice(0).sort(i))!c||i(c[0],u)!==0?(c=[u],r.push(c)):c.push(u);return r}t.$zb=L;function*o(D,i){let r,c;for(const u of D)c!==void 0&&i(c,u)?r.push(u):(r&&(yield r),r=[u]),c=u;r&&(yield r)}t.$Ab=o;function l(D,i){for(let r=0;r<=D.length;r++)i(r===0?void 0:D[r-1],r===D.length?void 0:D[r])}t.$Bb=l;function e(D,i){for(let r=0;r<D.length;r++)i(r===0?void 0:D[r-1],D[r],r+1===D.length?void 0:D[r+1])}t.$Cb=e;function s(D,i,r){const c=[];function u(C,W,j){if(W===0&&j.length===0)return;const V=c[c.length-1];V&&V.start+V.deleteCount===C?(V.deleteCount+=W,V.toInsert.push(...j)):c.push({start:C,deleteCount:W,toInsert:j})}let d=0,F=0;for(;;){if(d===D.length){u(d,0,i.slice(F));break}if(F===i.length){u(d,D.length-d,[]);break}const C=D[d],W=i[F],j=r(C,W);j===0?(d+=1,F+=1):j<0?(u(d,1,[]),d+=1):j>0&&(u(d,0,[W]),F+=1)}return c}t.$Db=s;function m(D,i,r){const c=s(D,i,r),u=[],d=[];for(const F of c)u.push(...D.slice(F.start,F.start+F.deleteCount)),d.push(...F.toInsert);return{removed:u,added:d}}t.$Eb=m;function $(D,i,r){if(r===0)return[];const c=D.slice(0,r).sort(i);return p(D,i,c,r,D.length),c}t.top=$;function a(D,i,r,c,u){return r===0?Promise.resolve([]):new Promise((d,F)=>{(async()=>{const C=D.length,W=D.slice(0,r).sort(i);for(let j=r,V=Math.min(r+c,C);j<C;j=V,V=Math.min(V+c,C)){if(j>r&&await new Promise(G=>setTimeout(G)),u&&u.isCancellationRequested)throw new A.$5;p(D,i,W,j,V)}return W})().then(d,F)})}t.$Gb=a;function p(D,i,r,c,u){for(const d=r.length;c<u;c++){const F=D[c];if(i(F,r[d-1])<0){r.pop();const C=(0,P.$kb)(r,W=>i(F,W)<0);r.splice(C,0,F)}}}function f(D){return D.filter(i=>!!i)}t.$Hb=f;function g(D){let i=0;for(let r=0;r<D.length;r++)D[r]&&(D[i]=D[r],i+=1);D.length=i}t.$Ib=g;function h(D,i,r){D.splice(r,0,D.splice(i,1)[0])}t.$Jb=h;function T(D){return!Array.isArray(D)||D.length===0}t.$Kb=T;function O(D){return Array.isArray(D)&&D.length>0}t.$Lb=O;function R(D,i=r=>r){const r=new Set;return D.filter(c=>{const u=i(c);return r.has(u)?!1:(r.add(u),!0)})}t.$Mb=R;function w(D){const i=new Set;return r=>{const c=D(r);return i.has(c)?!1:(i.add(c),!0)}}t.$Nb=w;function S(D,i){return D.length>0?D[0]:i}t.$Ob=S;function M(D,i){return D.length>0?D[D.length-1]:i}t.$Pb=M;function H(D,i,r=(c,u)=>c===u){let c=0;for(let u=0,d=Math.min(D.length,i.length);u<d&&r(D[u],i[u]);u++)c++;return c}t.$Qb=H;function _(D){return[].concat(...D)}t.$Rb=_;function N(D,i){let r=typeof i=="number"?D:0;typeof i=="number"?r=D:(r=0,i=D);const c=[];if(r<=i)for(let u=r;u<i;u++)c.push(u);else for(let u=r;u>i;u--)c.push(u);return c}t.$Sb=N;function I(D,i,r){return D.reduce((c,u)=>(c[i(u)]=r?r(u):u,c),Object.create(null))}t.$Tb=I;function B(D,i){return D.push(i),()=>X(D,i)}t.$Ub=B;function X(D,i){const r=D.indexOf(i);if(r>-1)return D.splice(r,1),i}t.$Vb=X;function Y(D,i,r){const c=D.slice(0,i),u=D.slice(i);return c.concat(r,u)}t.$Wb=Y;function ue(D,i){let r;if(typeof i=="number"){let c=i;r=()=>{const u=Math.sin(c++)*179426549;return u-Math.floor(u)}}else r=Math.random;for(let c=D.length-1;c>0;c-=1){const u=Math.floor(r()*(c+1)),d=D[c];D[c]=D[u],D[u]=d}}t.$Xb=ue;function ne(D,i){const r=D.indexOf(i);r>-1&&(D.splice(r,1),D.unshift(i))}t.$Yb=ne;function te(D,i){const r=D.indexOf(i);r>-1&&(D.splice(r,1),D.push(i))}t.$Zb=te;function we(D,i){for(const r of i)D.push(r)}t.$1b=we;function Re(D,i){return Array.isArray(D)?D.map(i):i(D)}t.$2b=Re;function Te(D){return Array.isArray(D)?D:[D]}t.$3b=Te;function Oe(D){return D[Math.floor(Math.random()*D.length)]}t.$4b=Oe;function re(D,i,r){const c=ae(D,i),u=D.length,d=r.length;D.length=u+d;for(let F=u-1;F>=c;F--)D[F+d]=D[F];for(let F=0;F<d;F++)D[F+c]=r[F]}t.$5b=re;function J(D,i,r,c){const u=ae(D,i);let d=D.splice(u,r);return d===void 0&&(d=[]),re(D,u,c),d}t.$6b=J;function ae(D,i){return i<0?Math.max(i+D.length,0):Math.min(i,D.length)}var K;(function(D){function i(d){return d<0}D.isLessThan=i;function r(d){return d<=0}D.isLessThanOrEqual=r;function c(d){return d>0}D.isGreaterThan=c;function u(d){return d===0}D.isNeitherLessOrGreaterThan=u,D.greaterThan=1,D.lessThan=-1,D.neitherLessOrGreaterThan=0})(K||(t.CompareResult=K={}));function U(D,i){return(r,c)=>i(D(r),D(c))}t.$7b=U;function Z(...D){return(i,r)=>{for(const c of D){const u=c(i,r);if(!K.isNeitherLessOrGreaterThan(u))return u}return K.neitherLessOrGreaterThan}}t.$8b=Z;const me=(D,i)=>D-i;t.$9b=me;const ve=(D,i)=>(0,t.$9b)(D?1:0,i?1:0);t.$0b=ve;function ke(D){return(i,r)=>-D(i,r)}t.$$b=ke;class Ee{constructor(i){this.g=i,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(i){let r=this.c;for(;r<this.g.length&&i(this.g[r]);)r++;const c=r===this.c?null:this.g.slice(this.c,r);return this.c=r,c}takeFromEndWhile(i){let r=this.d;for(;r>=0&&i(this.g[r]);)r--;const c=r===this.d?null:this.g.slice(r+1,this.d+1);return this.d=r,c}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const i=this.g[this.c];return this.c++,i}removeLast(){const i=this.g[this.d];return this.d--,i}takeCount(i){const r=this.g.slice(this.c,this.c+i);return this.c+=i,r}}t.$_b=Ee;class ge{static{this.empty=new ge(i=>{})}constructor(i){this.iterate=i}forEach(i){this.iterate(r=>(i(r),!0))}toArray(){const i=[];return this.iterate(r=>(i.push(r),!0)),i}filter(i){return new ge(r=>this.iterate(c=>i(c)?r(c):!0))}map(i){return new ge(r=>this.iterate(c=>r(i(c))))}some(i){let r=!1;return this.iterate(c=>(r=i(c),!r)),r}findFirst(i){let r;return this.iterate(c=>i(c)?(r=c,!1):!0),r}findLast(i){let r;return this.iterate(c=>(i(c)&&(r=c),!0)),r}findLastMaxBy(i){let r,c=!0;return this.iterate(u=>((c||K.isGreaterThan(i(u,r)))&&(c=!1,r=u),!0)),r}}t.$ac=ge}),define(be[76],$e([1,0,6]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function P(b,v){if(!b)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}t.ok=P;function n(b,v="Unreachable"){throw new Error(v)}t.$6c=n;function z(b){if(!b)throw new A.$cb("Assertion Failed")}t.$7c=z;function E(b){if(!b()){debugger;b(),(0,A.$1)(new A.$cb("Assertion Failed"))}}t.$8c=E;function k(b,v){let y=0;for(;y<b.length-1;){const L=b[y],o=b[y+1];if(!v(L,o))return!1;y++}return!0}t.$9c=k}),define(be[43],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function A(P,n){const z=this;let E=!1,k;return function(){if(E)return k;if(E=!0,n)try{k=P.apply(z,arguments)}finally{n()}else k=P.apply(z,arguments);return k}}t.$db=A}),define(be[77],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5M=t.$4M=void 0;class A{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$4M=A,t.$5M=new A("id#")}),define(be[28],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var A;(function(P){function n(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}P.is=n;const z=Object.freeze([]);function E(){return z}P.empty=E;function*k(h){yield h}P.single=k;function b(h){return n(h)?h:k(h)}P.wrap=b;function v(h){return h||z}P.from=v;function*y(h){for(let T=h.length-1;T>=0;T--)yield h[T]}P.reverse=y;function L(h){return!h||h[Symbol.iterator]().next().done===!0}P.isEmpty=L;function o(h){return h[Symbol.iterator]().next().value}P.first=o;function l(h,T){for(const O of h)if(T(O))return!0;return!1}P.some=l;function e(h,T){for(const O of h)if(T(O))return O}P.find=e;function*s(h,T){for(const O of h)T(O)&&(yield O)}P.filter=s;function*m(h,T){let O=0;for(const R of h)yield T(R,O++)}P.map=m;function*$(...h){for(const T of h)yield*T}P.concat=$;function a(h,T,O){let R=O;for(const w of h)R=T(R,w);return R}P.reduce=a;function*p(h,T,O=h.length){for(T<0&&(T+=h.length),O<0?O+=h.length:O>h.length&&(O=h.length);T<O;T++)yield h[T]}P.slice=p;function f(h,T=Number.POSITIVE_INFINITY){const O=[];if(T===0)return[O,h];const R=h[Symbol.iterator]();for(let w=0;w<T;w++){const S=R.next();if(S.done)return[O,P.empty()];O.push(S.value)}return[O,{[Symbol.iterator](){return R}}]}P.consume=f;async function g(h){const T=[];for await(const O of h)T.push(O);return Promise.resolve(T)}P.asyncToArray=g})(A||(t.Iterable=A={}))}),define(be[44],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vq=t.KeyMod=t.KeyCodeUtils=t.$Uq=t.$Tq=t.$Sq=t.$Rq=t.$Qq=t.ScanCode=t.KeyCode=void 0;var A;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(A||(t.KeyCode=A={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,m){this._keyCodeToStr[s]=m,this._strToKeyCode[m.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const z=new n,E=new n,k=new n;t.$Qq=new Array(230),t.$Rq={};const b=[],v=Object.create(null),y=Object.create(null);t.$Sq={lowerCaseToEnum:e=>y[e]||0,toEnum:e=>v[e]||0,toString:e=>b[e]||"None"},t.$Tq=[],t.$Uq=[];for(let e=0;e<=193;e++)t.$Tq[e]=-1;for(let e=0;e<=132;e++)t.$Uq[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],m=[],$=[];for(const a of s){const[p,f,g,h,T,O,R,w,S]=a;if($[f]||($[f]=!0,b[f]=g,v[g]=f,y[g.toLowerCase()]=f,p&&(t.$Tq[f]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(t.$Uq[h]=f))),!m[h]){if(m[h]=!0,!T)throw new Error(`String representation missing for key code ${h} around scan code ${g}`);z.define(h,T),E.define(h,w||T),k.define(h,S||w||T)}O&&(t.$Qq[O]=h),R&&(t.$Rq[R]=h)}t.$Uq[3]=46})();var L;(function(e){function s(g){return z.keyCodeToStr(g)}e.toString=s;function m(g){return z.strToKeyCode(g)}e.fromString=m;function $(g){return E.keyCodeToStr(g)}e.toUserSettingsUS=$;function a(g){return k.keyCodeToStr(g)}e.toUserSettingsGeneral=a;function p(g){return E.strToKeyCode(g)||k.strToKeyCode(g)}e.fromUserSettings=p;function f(g){if(g>=98&&g<=113)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return z.keyCodeToStr(g)}e.toElectronAccelerator=f})(L||(t.KeyCodeUtils=L={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o||(t.KeyMod=o={}));function l(e,s){const m=(s&65535)<<16>>>0;return(e|m)>>>0}t.$Vq=l}),define(be[78],$e([1,0,6]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3q=t.$2q=t.$1q=t.$Zq=t.$Yq=t.$Xq=t.$Wq=void 0;var P;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(P||(P={}));function n(L,o){if(typeof L=="number"){if(L===0)return null;const l=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new b([z(l,o),z(e,o)]):new b([z(l,o)])}else{const l=[];for(let e=0;e<L.length;e++)l.push(z(L[e],o));return new b(l)}}t.$Wq=n;function z(L,o){const l=!!(L&2048),e=!!(L&256),s=o===2?e:l,m=!!(L&1024),$=!!(L&512),a=o===2?l:e,p=L&255;return new E(s,m,$,a,p)}t.$Xq=z;class E{constructor(o,l,e,s,m){this.ctrlKey=o,this.shiftKey=l,this.altKey=e,this.metaKey=s,this.keyCode=m}equals(o){return o instanceof E&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${o}${l}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Yq=E;class k{constructor(o,l,e,s,m){this.ctrlKey=o,this.shiftKey=l,this.altKey=e,this.metaKey=s,this.scanCode=m}equals(o){return o instanceof k&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}getHashCode(){const o=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${o}${l}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Zq=k;class b{constructor(o){if(o.length===0)throw(0,A.$7)("chords");this.chords=o}getHashCode(){let o="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(o+=";"),o+=this.chords[l].getHashCode();return o}equals(o){if(o===null||this.chords.length!==o.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(o.chords[l]))return!1;return!0}}t.$1q=b;class v{constructor(o,l,e,s,m,$){this.ctrlKey=o,this.shiftKey=l,this.altKey=e,this.metaKey=s,this.keyLabel=m,this.keyAriaLabel=$}}t.$2q=v;class y{}t.$3q=y}),define(be[23],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class A{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=A}),define(be[45],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(z){this.element=z,this.next=A.Undefined,this.prev=A.Undefined}}class P{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let z=this.a;for(;z!==A.Undefined;){const E=z.next;z.prev=A.Undefined,z.next=A.Undefined,z=E}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(z){return this.d(z,!1)}push(z){return this.d(z,!0)}d(z,E){const k=new A(z);if(this.a===A.Undefined)this.a=k,this.b=k;else if(E){const v=this.b;this.b=k,k.prev=v,v.next=k}else{const v=this.a;this.a=k,k.next=v,v.prev=k}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(k))}}shift(){if(this.a!==A.Undefined){const z=this.a.element;return this.e(this.a),z}}pop(){if(this.b!==A.Undefined){const z=this.b.element;return this.e(this.b),z}}e(z){if(z.prev!==A.Undefined&&z.next!==A.Undefined){const E=z.prev;E.next=z.next,z.next.prev=E}else z.prev===A.Undefined&&z.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):z.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):z.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let z=this.a;for(;z!==A.Undefined;)yield z.element,z=z.next}}t.$4c=P}),define(be[32],$e([1,0]),function(ie,t){"use strict";var A,P,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function z(p,f,g){let h=p.get(f);return h===void 0&&(h=g,p.set(f,h)),h}t.$xc=z;function E(p){const f=[];return p.forEach((g,h)=>{f.push(`${h} => ${g}`)}),`Map(${p.size}) {${f.join(", ")}}`}t.$yc=E;function k(p){const f=[];return p.forEach(g=>{f.push(g)}),`Set(${p.size}) {${f.join(", ")}}`}t.$zc=k;class b{constructor(f,g){this.uri=f,this.value=g}}function v(p){return Array.isArray(p)}class y{static{this.c=f=>f.toString()}constructor(f,g){if(this[A]="ResourceMap",f instanceof y)this.d=new Map(f.d),this.e=g??y.c;else if(v(f)){this.d=new Map,this.e=g??y.c;for(const[h,T]of f)this.set(h,T)}else this.d=new Map,this.e=f??y.c}set(f,g){return this.d.set(this.e(f),new b(f,g)),this}get(f){return this.d.get(this.e(f))?.value}has(f){return this.d.has(this.e(f))}get size(){return this.d.size}clear(){this.d.clear()}delete(f){return this.d.delete(this.e(f))}forEach(f,g){typeof g<"u"&&(f=f.bind(g));for(const[h,T]of this.d)f(T.value,T.uri,this)}*values(){for(const f of this.d.values())yield f.value}*keys(){for(const f of this.d.values())yield f.uri}*entries(){for(const f of this.d.values())yield[f.uri,f.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.d)yield[f.uri,f.value]}}t.$Ac=y;class L{constructor(f,g){this[P]="ResourceSet",!f||typeof f=="function"?this.c=new y(f):(this.c=new y(g),f.forEach(this.add,this))}get size(){return this.c.size}add(f){return this.c.set(f,f),this}clear(){this.c.clear()}delete(f){return this.c.delete(f)}forEach(f,g){this.c.forEach((h,T)=>f.call(g,T,T,this))}has(f){return this.c.has(f)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=L;var o;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(o||(t.Touch=o={}));class l{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(f){return this.c.has(f)}get(f,g=0){const h=this.c.get(f);if(h)return g!==0&&this.l(h,g),h.value}set(f,g,h=0){let T=this.c.get(f);if(T)T.value=g,h!==0&&this.l(T,h);else{switch(T={key:f,value:g,next:void 0,previous:void 0},h){case 0:this.j(T);break;case 1:this.i(T);break;case 2:this.j(T);break;default:this.j(T);break}this.c.set(f,T),this.f++}return this}delete(f){return!!this.remove(f)}remove(f){const g=this.c.get(f);if(g)return this.c.delete(f),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const f=this.d;return this.c.delete(f.key),this.k(f),this.f--,f.value}forEach(f,g){const h=this.g;let T=this.d;for(;T;){if(g?f.bind(g)(T.value,T.key,this):f(T.value,T.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");T=T.next}}keys(){const f=this,g=this.g;let h=this.d;const T={[Symbol.iterator](){return T},next(){if(f.g!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const O={value:h.key,done:!1};return h=h.next,O}else return{value:void 0,done:!0}}};return T}values(){const f=this,g=this.g;let h=this.d;const T={[Symbol.iterator](){return T},next(){if(f.g!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const O={value:h.value,done:!1};return h=h.next,O}else return{value:void 0,done:!0}}};return T}entries(){const f=this,g=this.g;let h=this.d;const T={[Symbol.iterator](){return T},next(){if(f.g!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const O={value:[h.key,h.value],done:!1};return h=h.next,O}else return{value:void 0,done:!0}}};return T}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(f){if(f>=this.size)return;if(f===0){this.clear();return}let g=this.d,h=this.size;for(;g&&h>f;)this.c.delete(g.key),g=g.next,h--;this.d=g,this.f=h,g&&(g.previous=void 0),this.g++}i(f){if(!this.d&&!this.e)this.e=f;else if(this.d)f.next=this.d,this.d.previous=f;else throw new Error("Invalid list");this.d=f,this.g++}j(f){if(!this.d&&!this.e)this.d=f;else if(this.e)f.previous=this.e,this.e.next=f;else throw new Error("Invalid list");this.e=f,this.g++}k(f){if(f===this.d&&f===this.e)this.d=void 0,this.e=void 0;else if(f===this.d){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.d=f.next}else if(f===this.e){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.e=f.previous}else{const g=f.next,h=f.previous;if(!g||!h)throw new Error("Invalid list");g.previous=h,h.next=g}f.next=void 0,f.previous=void 0,this.g++}l(f,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(f===this.d)return;const h=f.next,T=f.previous;f===this.e?(T.next=void 0,this.e=T):(h.previous=T,T.next=h),f.previous=void 0,f.next=this.d,this.d.previous=f,this.d=f,this.g++}else if(g===2){if(f===this.e)return;const h=f.next,T=f.previous;f===this.d?(h.previous=void 0,this.d=h):(h.previous=T,T.next=h),f.next=void 0,f.previous=this.e,this.e.next=f,this.e=f,this.g++}}}toJSON(){const f=[];return this.forEach((g,h)=>{f.push([h,g])}),f}fromJSON(f){this.clear();for(const[g,h]of f)this.set(g,h)}}t.$Cc=l;class e extends l{constructor(f,g=1){super(),this.m=f,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(f){this.m=f,this.o()}get ratio(){return this.n}set ratio(f){this.n=Math.min(Math.max(0,f),1),this.o()}get(f,g=2){return super.get(f,g)}peek(f){return super.get(f,0)}set(f,g){return super.set(f,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class s{constructor(){this.c=new Map}add(f){return this.c.set(f,(this.c.get(f)||0)+1),this}delete(f){let g=this.c.get(f)||0;return g===0?!1:(g--,g===0?this.c.delete(f):this.c.set(f,g),!0)}has(f){return this.c.has(f)}}t.$Ec=s;class m{constructor(f){if(this.c=new Map,this.d=new Map,f)for(const[g,h]of f)this.set(g,h)}clear(){this.c.clear(),this.d.clear()}set(f,g){this.c.set(f,g),this.d.set(g,f)}get(f){return this.c.get(f)}getKey(f){return this.d.get(f)}delete(f){const g=this.c.get(f);return g===void 0?!1:(this.c.delete(f),this.d.delete(g),!0)}forEach(f,g){this.c.forEach((h,T)=>{f.call(g,h,T,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=m;class ${constructor(){this.c=new Map}add(f,g){let h=this.c.get(f);h||(h=new Set,this.c.set(f,h)),h.add(g)}delete(f,g){const h=this.c.get(f);h&&(h.delete(g),h.size===0&&this.c.delete(f))}forEach(f,g){const h=this.c.get(f);h&&h.forEach(g)}get(f){const g=this.c.get(f);return g||new Set}}t.$Gc=$;function a(p,f){if(p===f)return!0;if(p.size!==f.size)return!1;for(const[g,h]of p)if(!f.has(g)||f.get(g)!==h)return!1;for(const[g]of f)if(!p.has(g))return!1;return!0}t.$Hc=a}),define(be[2],$e([1,0,12,73,32,43,28]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const k=!1;let b=null;class v{constructor(){this.b=new Map}static{this.a=0}c(B){let X=this.b.get(B);return X||(X={parent:null,source:null,isSingleton:!1,value:B,idx:v.a++},this.b.set(B,X)),X}trackDisposable(B){const X=this.c(B);X.source||(X.source=new Error().stack)}setParent(B,X){const Y=this.c(B);Y.parent=X}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,X){const Y=X.get(B);if(Y)return Y;const ue=B.parent?this.f(this.c(B.parent),X):B;return X.set(B,ue),ue}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,B).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(B=10,X){let Y;if(X)Y=X;else{const Re=new Map,Te=[...this.b.values()].filter(re=>re.source!==null&&!this.f(re,Re).isSingleton);if(Te.length===0)return;const Oe=new Set(Te.map(re=>re.value));if(Y=Te.filter(re=>!(re.parent&&Oe.has(re.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function ue(Re){function Te(re,J){for(;re.length>0&&J.some(ae=>typeof ae=="string"?ae===re[0]:re[0].match(ae));)re.shift()}const Oe=Re.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Te(Oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Oe.reverse()}const ne=new n.$Gc;for(const Re of Y){const Te=ue(Re);for(let Oe=0;Oe<=Te.length;Oe++)ne.add(Te.slice(0,Oe).join(`
`),Re)}Y.sort((0,A.$7b)(Re=>Re.idx,A.$9b));let te="",we=0;for(const Re of Y.slice(0,B)){we++;const Te=ue(Re),Oe=[];for(let re=0;re<Te.length;re++){let J=Te[re];J=`(shared with ${ne.get(Te.slice(0,re+1).join(`
`)).size}/${Y.length} leaks) at ${J}`;const K=ne.get(Te.slice(0,re).join(`
`)),U=(0,P.$K)([...K].map(Z=>ue(Z)[re]),Z=>Z);delete U[Te[re]];for(const[Z,me]of Object.entries(U))Oe.unshift(`    - stacktraces of ${me.length} other leaks continue with ${Z}`);Oe.unshift(J)}te+=`


==================== Leaking disposable ${we}/${Y.length}: ${Re.value.constructor.name} ====================
${Oe.join(`
`)}
============================================================

`}return Y.length>B&&(te+=`


... and ${Y.length-B} more leaking disposables

`),{leaks:Y,details:te}}}t.$Ic=v;function y(I){b=I}if(t.$Jc=y,k){const I="__is_disposable_tracked__";y(new class{trackDisposable(B){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[I]||console.log(X)},3e3)}setParent(B,X){if(B&&B!==h.None)try{B[I]=!0}catch{}}markAsDisposed(B){if(B&&B!==h.None)try{B[I]=!0}catch{}}markAsSingleton(B){}})}function L(I){return b?.trackDisposable(I),I}t.$Kc=L;function o(I){b?.markAsDisposed(I)}t.$Lc=o;function l(I,B){b?.setParent(I,B)}function e(I,B){if(b)for(const X of I)b.setParent(X,B)}function s(I){return b?.markAsSingleton(I),I}t.$Mc=s;function m(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Nc=m;function $(I){if(E.Iterable.is(I)){const B=[];for(const X of I)if(X)try{X.dispose()}catch(Y){B.push(Y)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Oc=$;function a(I){for(const B of I)m(B)&&B.dispose();return[]}t.$Pc=a;function p(...I){const B=f(()=>$(I));return e(I,B),B}t.$Qc=p;function f(I){const B=L({dispose:(0,z.$db)(()=>{o(B),I()})});return B}t.$Rc=f;class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(o(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return l(B,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),l(B,null))}}t.$Sc=g;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,L(this),l(this.q,this)}dispose(){o(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Tc=h;class T{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&l(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,o(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&l(B,null),B}}t.$Uc=T;class O{constructor(B){this.a=new T,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=O;class R{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=R;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(B){let X=B;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,o(this))},this}}t.$Xc=w;class S{constructor(){this.a=new Map}acquire(B,...X){let Y=this.a.get(B);Y||(Y={counter:0,object:this.b(B,...X)},this.a.set(B,Y));const{object:ue}=Y,ne=(0,z.$db)(()=>{--Y.counter===0&&(this.c(B,Y.object),this.a.delete(B))});return Y.counter++,{object:ue,dispose:ne}}}t.$Yc=S;class M{constructor(B){this.a=B}async acquire(B,...X){const Y=this.a.acquire(B,...X);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(ue){throw Y.dispose(),ue}}}t.$Zc=M;class H{constructor(B){this.object=B}dispose(){}}t.$1c=H;function _(I){const B=new g;try{I(B)}finally{B.dispose()}}t.$2c=_;class N{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,X,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(B)?.dispose(),this.a.set(B,X)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=N}),function(ie,t){typeof define=="function"&&define.amd?define(be[79],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(i,r){for(var c=0;c<r.length;c++){var u=r[c];u.enumerable=u.enumerable||!1,u.configurable=!0,"value"in u&&(u.writable=!0),Object.defineProperty(i,u.key,u)}}function A(i,r,c){return r&&t(i.prototype,r),c&&t(i,c),Object.defineProperty(i,"prototype",{writable:!1}),i}function P(i,r){if(i){if(typeof i=="string")return n(i,r);var c=Object.prototype.toString.call(i).slice(8,-1);if(c==="Object"&&i.constructor&&(c=i.constructor.name),c==="Map"||c==="Set")return Array.from(i);if(c==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(c))return n(i,r)}}function n(i,r){(r==null||r>i.length)&&(r=i.length);for(var c=0,u=new Array(r);c<r;c++)u[c]=i[c];return u}function z(i,r){var c=typeof Symbol<"u"&&i[Symbol.iterator]||i["@@iterator"];if(c)return(c=c.call(i)).next.bind(c);if(Array.isArray(i)||(c=P(i))||r&&i&&typeof i.length=="number"){c&&(i=c);var u=0;return function(){return u>=i.length?{done:!0}:{done:!1,value:i[u++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=E();function k(i){ie.defaults=i}var b=/[&<>"']/,v=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(r){return o[r]};function e(i,r){if(r){if(b.test(i))return i.replace(v,l)}else if(y.test(i))return i.replace(L,l);return i}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(i){return i.replace(s,function(r,c){return c=c.toLowerCase(),c==="colon"?":":c.charAt(0)==="#"?c.charAt(1)==="x"?String.fromCharCode(parseInt(c.substring(2),16)):String.fromCharCode(+c.substring(1)):""})}var $=/(^|[^\[])\^/g;function a(i,r){i=typeof i=="string"?i:i.source,r=r||"";var c={replace:function(d,F){return F=F.source||F,F=F.replace($,"$1"),i=i.replace(d,F),c},getRegex:function(){return new RegExp(i,r)}};return c}var p=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(i,r,c){if(i){var u;try{u=decodeURIComponent(m(c)).replace(p,"").toLowerCase()}catch{return null}if(u.indexOf("javascript:")===0||u.indexOf("vbscript:")===0||u.indexOf("data:")===0)return null}r&&!f.test(c)&&(c=w(r,c));try{c=encodeURI(c).replace(/%25/g,"%")}catch{return null}return c}var h={},T=/^[^:]+:\/*[^/]*$/,O=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(i,r){h[" "+i]||(T.test(i)?h[" "+i]=i+"/":h[" "+i]=_(i,"/",!0)),i=h[" "+i];var c=i.indexOf(":")===-1;return r.substring(0,2)==="//"?c?r:i.replace(O,"$1")+r:r.charAt(0)==="/"?c?r:i.replace(R,"$1")+r:i+r}var S={exec:function(){}};function M(i){for(var r=1,c,u;r<arguments.length;r++){c=arguments[r];for(u in c)Object.prototype.hasOwnProperty.call(c,u)&&(i[u]=c[u])}return i}function H(i,r){var c=i.replace(/\|/g,function(F,C,W){for(var j=!1,V=C;--V>=0&&W[V]==="\\";)j=!j;return j?"|":" |"}),u=c.split(/ \|/),d=0;if(u[0].trim()||u.shift(),u.length>0&&!u[u.length-1].trim()&&u.pop(),u.length>r)u.splice(r);else for(;u.length<r;)u.push("");for(;d<u.length;d++)u[d]=u[d].trim().replace(/\\\|/g,"|");return u}function _(i,r,c){var u=i.length;if(u===0)return"";for(var d=0;d<u;){var F=i.charAt(u-d-1);if(F===r&&!c)d++;else if(F!==r&&c)d++;else break}return i.slice(0,u-d)}function N(i,r){if(i.indexOf(r[1])===-1)return-1;for(var c=i.length,u=0,d=0;d<c;d++)if(i[d]==="\\")d++;else if(i[d]===r[0])u++;else if(i[d]===r[1]&&(u--,u<0))return d;return-1}function I(i){i&&i.sanitize&&!i.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(i,r){if(r<1)return"";for(var c="";r>1;)r&1&&(c+=i),r>>=1,i+=i;return c+i}function X(i,r,c,u){var d=r.href,F=r.title?e(r.title):null,C=i[1].replace(/\\([\[\]])/g,"$1");if(i[0].charAt(0)!=="!"){u.state.inLink=!0;var W={type:"link",raw:c,href:d,title:F,text:C,tokens:u.inlineTokens(C)};return u.state.inLink=!1,W}return{type:"image",raw:c,href:d,title:F,text:e(C)}}function Y(i,r){var c=i.match(/^(\s+)(?:```)/);if(c===null)return r;var u=c[1];return r.split(`
`).map(function(d){var F=d.match(/^\s+/);if(F===null)return d;var C=F[0];return C.length>=u.length?d.slice(u.length):d}).join(`
`)}var ue=function(){function i(c){this.options=c||ie.defaults}var r=i.prototype;return r.space=function(u){var d=this.rules.block.newline.exec(u);if(d&&d[0].length>0)return{type:"space",raw:d[0]}},r.code=function(u){var d=this.rules.block.code.exec(u);if(d){var F=d[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:d[0],codeBlockStyle:"indented",text:this.options.pedantic?F:_(F,`
`)}}},r.fences=function(u){var d=this.rules.block.fences.exec(u);if(d){var F=d[0],C=Y(F,d[3]||"");return{type:"code",raw:F,lang:d[2]?d[2].trim():d[2],text:C}}},r.heading=function(u){var d=this.rules.block.heading.exec(u);if(d){var F=d[2].trim();if(/#$/.test(F)){var C=_(F,"#");(this.options.pedantic||!C||/ $/.test(C))&&(F=C.trim())}return{type:"heading",raw:d[0],depth:d[1].length,text:F,tokens:this.lexer.inline(F)}}},r.hr=function(u){var d=this.rules.block.hr.exec(u);if(d)return{type:"hr",raw:d[0]}},r.blockquote=function(u){var d=this.rules.block.blockquote.exec(u);if(d){var F=d[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:d[0],tokens:this.lexer.blockTokens(F,[]),text:F}}},r.list=function(u){var d=this.rules.block.list.exec(u);if(d){var F,C,W,j,V,G,oe,se,de,De,pe,Ce,Fe=d[1].trim(),Me=Fe.length>1,Be={type:"list",raw:"",ordered:Me,start:Me?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=Me?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=Me?Fe:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");u&&(Ce=!1,!(!(d=Ie.exec(u))||this.rules.block.hr.test(u)));){if(F=d[0],u=u.substring(F.length),se=d[2].split(`
`,1)[0],de=u.split(`
`,1)[0],this.options.pedantic?(j=2,pe=se.trimLeft()):(j=d[2].search(/[^ ]/),j=j>4?1:j,pe=se.slice(j),j+=d[1].length),G=!1,!se&&/^ *$/.test(de)&&(F+=de+`
`,u=u.substring(de.length+1),Ce=!0),!Ce)for(var Je=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ke=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");u&&(De=u.split(`
`,1)[0],se=De,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(se)||x.test(se)||Je.test(se)||Ke.test(u)));){if(se.search(/[^ ]/)>=j||!se.trim())pe+=`
`+se.slice(j);else if(!G)pe+=`
`+se;else break;!G&&!se.trim()&&(G=!0),F+=De+`
`,u=u.substring(De.length+1)}Be.loose||(oe?Be.loose=!0:/\n *\n *$/.test(F)&&(oe=!0)),this.options.gfm&&(C=/^\[[ xX]\] /.exec(pe),C&&(W=C[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:F,task:!!C,checked:W,loose:!1,text:pe}),Be.raw+=F}Be.items[Be.items.length-1].raw=F.trimRight(),Be.items[Be.items.length-1].text=pe.trimRight(),Be.raw=Be.raw.trimRight();var le=Be.items.length;for(V=0;V<le;V++){this.lexer.state.top=!1,Be.items[V].tokens=this.lexer.blockTokens(Be.items[V].text,[]);var fe=Be.items[V].tokens.filter(function(Ne){return Ne.type==="space"}),Ae=fe.every(function(Ne){for(var ze=Ne.raw.split(""),qe=0,_e=z(ze),et;!(et=_e()).done;){var tt=et.value;if(tt===`
`&&(qe+=1),qe>1)return!0}return!1});!Be.loose&&fe.length&&Ae&&(Be.loose=!0,Be.items[V].loose=!0)}return Be}},r.html=function(u){var d=this.rules.block.html.exec(u);if(d){var F={type:"html",raw:d[0],pre:!this.options.sanitizer&&(d[1]==="pre"||d[1]==="script"||d[1]==="style"),text:d[0]};if(this.options.sanitize){var C=this.options.sanitizer?this.options.sanitizer(d[0]):e(d[0]);F.type="paragraph",F.text=C,F.tokens=this.lexer.inline(C)}return F}},r.def=function(u){var d=this.rules.block.def.exec(u);if(d){d[3]&&(d[3]=d[3].substring(1,d[3].length-1));var F=d[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:F,raw:d[0],href:d[2],title:d[3]}}},r.table=function(u){var d=this.rules.block.table.exec(u);if(d){var F={type:"table",header:H(d[1]).map(function(oe){return{text:oe}}),align:d[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:d[3]&&d[3].trim()?d[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(F.header.length===F.align.length){F.raw=d[0];var C=F.align.length,W,j,V,G;for(W=0;W<C;W++)/^ *-+: *$/.test(F.align[W])?F.align[W]="right":/^ *:-+: *$/.test(F.align[W])?F.align[W]="center":/^ *:-+ *$/.test(F.align[W])?F.align[W]="left":F.align[W]=null;for(C=F.rows.length,W=0;W<C;W++)F.rows[W]=H(F.rows[W],F.header.length).map(function(oe){return{text:oe}});for(C=F.header.length,j=0;j<C;j++)F.header[j].tokens=this.lexer.inline(F.header[j].text);for(C=F.rows.length,j=0;j<C;j++)for(G=F.rows[j],V=0;V<G.length;V++)G[V].tokens=this.lexer.inline(G[V].text);return F}}},r.lheading=function(u){var d=this.rules.block.lheading.exec(u);if(d)return{type:"heading",raw:d[0],depth:d[2].charAt(0)==="="?1:2,text:d[1],tokens:this.lexer.inline(d[1])}},r.paragraph=function(u){var d=this.rules.block.paragraph.exec(u);if(d){var F=d[1].charAt(d[1].length-1)===`
`?d[1].slice(0,-1):d[1];return{type:"paragraph",raw:d[0],text:F,tokens:this.lexer.inline(F)}}},r.text=function(u){var d=this.rules.block.text.exec(u);if(d)return{type:"text",raw:d[0],text:d[0],tokens:this.lexer.inline(d[0])}},r.escape=function(u){var d=this.rules.inline.escape.exec(u);if(d)return{type:"escape",raw:d[0],text:e(d[1])}},r.tag=function(u){var d=this.rules.inline.tag.exec(u);if(d)return!this.lexer.state.inLink&&/^<a /i.test(d[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(d[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(d[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(d[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:d[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(d[0]):e(d[0]):d[0]}},r.link=function(u){var d=this.rules.inline.link.exec(u);if(d){var F=d[2].trim();if(!this.options.pedantic&&/^</.test(F)){if(!/>$/.test(F))return;var C=_(F.slice(0,-1),"\\");if((F.length-C.length)%2===0)return}else{var W=N(d[2],"()");if(W>-1){var j=d[0].indexOf("!")===0?5:4,V=j+d[1].length+W;d[2]=d[2].substring(0,W),d[0]=d[0].substring(0,V).trim(),d[3]=""}}var G=d[2],oe="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);se&&(G=se[1],oe=se[3])}else oe=d[3]?d[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(F)?G=G.slice(1):G=G.slice(1,-1)),X(d,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},d[0],this.lexer)}},r.reflink=function(u,d){var F;if((F=this.rules.inline.reflink.exec(u))||(F=this.rules.inline.nolink.exec(u))){var C=(F[2]||F[1]).replace(/\s+/g," ");if(C=d[C.toLowerCase()],!C||!C.href){var W=F[0].charAt(0);return{type:"text",raw:W,text:W}}return X(F,C,F[0],this.lexer)}},r.emStrong=function(u,d,F){F===void 0&&(F="");var C=this.rules.inline.emStrong.lDelim.exec(u);if(C&&!(C[3]&&F.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=C[1]||C[2]||"";if(!W||W&&(F===""||this.rules.inline.punctuation.exec(F))){var j=C[0].length-1,V,G,oe=j,se=0,de=C[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,d=d.slice(-1*u.length+j);(C=de.exec(d))!=null;)if(V=C[1]||C[2]||C[3]||C[4]||C[5]||C[6],!!V){if(G=V.length,C[3]||C[4]){oe+=G;continue}else if((C[5]||C[6])&&j%3&&!((j+G)%3)){se+=G;continue}if(oe-=G,!(oe>0)){if(G=Math.min(G,G+oe+se),Math.min(j,G)%2){var De=u.slice(1,j+C.index+G);return{type:"em",raw:u.slice(0,j+C.index+G+1),text:De,tokens:this.lexer.inlineTokens(De)}}var pe=u.slice(2,j+C.index+G-1);return{type:"strong",raw:u.slice(0,j+C.index+G+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},r.codespan=function(u){var d=this.rules.inline.code.exec(u);if(d){var F=d[2].replace(/\n/g," "),C=/[^ ]/.test(F),W=/^ /.test(F)&&/ $/.test(F);return C&&W&&(F=F.substring(1,F.length-1)),F=e(F,!0),{type:"codespan",raw:d[0],text:F}}},r.br=function(u){var d=this.rules.inline.br.exec(u);if(d)return{type:"br",raw:d[0]}},r.del=function(u){var d=this.rules.inline.del.exec(u);if(d)return{type:"del",raw:d[0],text:d[2],tokens:this.lexer.inlineTokens(d[2])}},r.autolink=function(u,d){var F=this.rules.inline.autolink.exec(u);if(F){var C,W;return F[2]==="@"?(C=e(this.options.mangle?d(F[1]):F[1]),W="mailto:"+C):(C=e(F[1]),W=C),{type:"link",raw:F[0],text:C,href:W,tokens:[{type:"text",raw:C,text:C}]}}},r.url=function(u,d){var F;if(F=this.rules.inline.url.exec(u)){var C,W;if(F[2]==="@")C=e(this.options.mangle?d(F[0]):F[0]),W="mailto:"+C;else{var j;do j=F[0],F[0]=this.rules.inline._backpedal.exec(F[0])[0];while(j!==F[0]);C=e(F[0]),F[1]==="www."?W="http://"+C:W=C}return{type:"link",raw:F[0],text:C,href:W,tokens:[{type:"text",raw:C,text:C}]}}},r.inlineText=function(u,d){var F=this.rules.inline.text.exec(u);if(F){var C;return this.lexer.state.inRawBlock?C=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(F[0]):e(F[0]):F[0]:C=e(this.options.smartypants?d(F[0]):F[0]),{type:"text",raw:F[0],text:C}}},i}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=a(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=a(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=a(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=a(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=a(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=a(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=M({},ne),ne.gfm=M({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=a(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=a(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=M({},ne.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:a(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=a(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=a(ne._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=a(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=a(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=a(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=a(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=a(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=a(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=a(te.reflink).replace("label",te._label).replace("ref",ne._label).getRegex(),te.nolink=a(te.nolink).replace("ref",ne._label).getRegex(),te.reflinkSearch=a(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=M({},te),te.pedantic=M({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=M({},te.normal,{escape:a(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=a(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=M({},te.gfm,{br:a(te.br).replace("{2,}","*").getRegex(),text:a(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function we(i){return i.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Re(i){var r="",c,u,d=i.length;for(c=0;c<d;c++)u=i.charCodeAt(c),Math.random()>.5&&(u="x"+u.toString(16)),r+="&#"+u+";";return r}var Te=function(){function i(c){this.tokens=[],this.tokens.links=Object.create(null),this.options=c||ie.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var u={block:ne.normal,inline:te.normal};this.options.pedantic?(u.block=ne.pedantic,u.inline=te.pedantic):this.options.gfm&&(u.block=ne.gfm,this.options.breaks?u.inline=te.breaks:u.inline=te.gfm),this.tokenizer.rules=u}i.lex=function(u,d){var F=new i(d);return F.lex(u)},i.lexInline=function(u,d){var F=new i(d);return F.inlineTokens(u)};var r=i.prototype;return r.lex=function(u){u=u.replace(/\r\n|\r/g,`
`),this.blockTokens(u,this.tokens);for(var d;d=this.inlineQueue.shift();)this.inlineTokens(d.src,d.tokens);return this.tokens},r.blockTokens=function(u,d){var F=this;d===void 0&&(d=[]),this.options.pedantic?u=u.replace(/\t/g,"    ").replace(/^ +$/gm,""):u=u.replace(/^( *)(\t+)/gm,function(oe,se,de){return se+"    ".repeat(de.length)});for(var C,W,j,V;u;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(C=oe.call({lexer:F},u,d))?(u=u.substring(C.raw.length),d.push(C),!0):!1}))){if(C=this.tokenizer.space(u)){u=u.substring(C.raw.length),C.raw.length===1&&d.length>0?d[d.length-1].raw+=`
`:d.push(C);continue}if(C=this.tokenizer.code(u)){u=u.substring(C.raw.length),W=d[d.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+C.raw,W.text+=`
`+C.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):d.push(C);continue}if(C=this.tokenizer.fences(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.heading(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.hr(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.blockquote(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.list(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.html(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.def(u)){u=u.substring(C.raw.length),W=d[d.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+C.raw,W.text+=`
`+C.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[C.tag]||(this.tokens.links[C.tag]={href:C.href,title:C.title});continue}if(C=this.tokenizer.table(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.lheading(u)){u=u.substring(C.raw.length),d.push(C);continue}if(j=u,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,se=u.slice(1),de=void 0;F.options.extensions.startBlock.forEach(function(De){de=De.call({lexer:this},se),typeof de=="number"&&de>=0&&(oe=Math.min(oe,de))}),oe<1/0&&oe>=0&&(j=u.substring(0,oe+1))}(),this.state.top&&(C=this.tokenizer.paragraph(j))){W=d[d.length-1],V&&W.type==="paragraph"?(W.raw+=`
`+C.raw,W.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):d.push(C),V=j.length!==u.length,u=u.substring(C.raw.length);continue}if(C=this.tokenizer.text(u)){u=u.substring(C.raw.length),W=d[d.length-1],W&&W.type==="text"?(W.raw+=`
`+C.raw,W.text+=`
`+C.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):d.push(C);continue}if(u){var G="Infinite loop on byte: "+u.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,d},r.inline=function(u,d){return d===void 0&&(d=[]),this.inlineQueue.push({src:u,tokens:d}),d},r.inlineTokens=function(u,d){var F=this;d===void 0&&(d=[]);var C,W,j,V=u,G,oe,se;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)de.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,G.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;u;)if(oe||(se=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(C=pe.call({lexer:F},u,d))?(u=u.substring(C.raw.length),d.push(C),!0):!1}))){if(C=this.tokenizer.escape(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.tag(u)){u=u.substring(C.raw.length),W=d[d.length-1],W&&C.type==="text"&&W.type==="text"?(W.raw+=C.raw,W.text+=C.text):d.push(C);continue}if(C=this.tokenizer.link(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.reflink(u,this.tokens.links)){u=u.substring(C.raw.length),W=d[d.length-1],W&&C.type==="text"&&W.type==="text"?(W.raw+=C.raw,W.text+=C.text):d.push(C);continue}if(C=this.tokenizer.emStrong(u,V,se)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.codespan(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.br(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.del(u)){u=u.substring(C.raw.length),d.push(C);continue}if(C=this.tokenizer.autolink(u,Re)){u=u.substring(C.raw.length),d.push(C);continue}if(!this.state.inLink&&(C=this.tokenizer.url(u,Re))){u=u.substring(C.raw.length),d.push(C);continue}if(j=u,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Ce=u.slice(1),Fe=void 0;F.options.extensions.startInline.forEach(function(Me){Fe=Me.call({lexer:this},Ce),typeof Fe=="number"&&Fe>=0&&(pe=Math.min(pe,Fe))}),pe<1/0&&pe>=0&&(j=u.substring(0,pe+1))}(),C=this.tokenizer.inlineText(j,we)){u=u.substring(C.raw.length),C.raw.slice(-1)!=="_"&&(se=C.raw.slice(-1)),oe=!0,W=d[d.length-1],W&&W.type==="text"?(W.raw+=C.raw,W.text+=C.text):d.push(C);continue}if(u){var De="Infinite loop on byte: "+u.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return d},A(i,null,[{key:"rules",get:function(){return{block:ne,inline:te}}}]),i}(),Oe=function(){function i(c){this.options=c||ie.defaults}var r=i.prototype;return r.code=function(u,d,F){var C=(d||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(u,C);W!=null&&W!==u&&(F=!0,u=W)}return u=u.replace(/\n$/,"")+`
`,C?'<pre><code class="'+this.options.langPrefix+e(C,!0)+'">'+(F?u:e(u,!0))+`</code></pre>
`:"<pre><code>"+(F?u:e(u,!0))+`</code></pre>
`},r.blockquote=function(u){return`<blockquote>
`+u+`</blockquote>
`},r.html=function(u){return u},r.heading=function(u,d,F,C){if(this.options.headerIds){var W=this.options.headerPrefix+C.slug(F);return"<h"+d+' id="'+W+'">'+u+"</h"+d+`>
`}return"<h"+d+">"+u+"</h"+d+`>
`},r.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},r.list=function(u,d,F){var C=d?"ol":"ul",W=d&&F!==1?' start="'+F+'"':"";return"<"+C+W+`>
`+u+"</"+C+`>
`},r.listitem=function(u){return"<li>"+u+`</li>
`},r.checkbox=function(u){return"<input "+(u?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},r.paragraph=function(u){return"<p>"+u+`</p>
`},r.table=function(u,d){return d&&(d="<tbody>"+d+"</tbody>"),`<table>
<thead>
`+u+`</thead>
`+d+`</table>
`},r.tablerow=function(u){return`<tr>
`+u+`</tr>
`},r.tablecell=function(u,d){var F=d.header?"th":"td",C=d.align?"<"+F+' align="'+d.align+'">':"<"+F+">";return C+u+("</"+F+`>
`)},r.strong=function(u){return"<strong>"+u+"</strong>"},r.em=function(u){return"<em>"+u+"</em>"},r.codespan=function(u){return"<code>"+u+"</code>"},r.br=function(){return this.options.xhtml?"<br/>":"<br>"},r.del=function(u){return"<del>"+u+"</del>"},r.link=function(u,d,F){if(u=g(this.options.sanitize,this.options.baseUrl,u),u===null)return F;var C='<a href="'+e(u)+'"';return d&&(C+=' title="'+d+'"'),C+=">"+F+"</a>",C},r.image=function(u,d,F){if(u=g(this.options.sanitize,this.options.baseUrl,u),u===null)return F;var C='<img src="'+u+'" alt="'+F+'"';return d&&(C+=' title="'+d+'"'),C+=this.options.xhtml?"/>":">",C},r.text=function(u){return u},i}(),re=function(){function i(){}var r=i.prototype;return r.strong=function(u){return u},r.em=function(u){return u},r.codespan=function(u){return u},r.del=function(u){return u},r.html=function(u){return u},r.text=function(u){return u},r.link=function(u,d,F){return""+F},r.image=function(u,d,F){return""+F},r.br=function(){return""},i}(),J=function(){function i(){this.seen={}}var r=i.prototype;return r.serialize=function(u){return u.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},r.getNextSafeSlug=function(u,d){var F=u,C=0;if(this.seen.hasOwnProperty(F)){C=this.seen[u];do C++,F=u+"-"+C;while(this.seen.hasOwnProperty(F))}return d||(this.seen[u]=C,this.seen[F]=0),F},r.slug=function(u,d){d===void 0&&(d={});var F=this.serialize(u);return this.getNextSafeSlug(F,d.dryrun)},i}(),ae=function(){function i(c){this.options=c||ie.defaults,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new J}i.parse=function(u,d){var F=new i(d);return F.parse(u)},i.parseInline=function(u,d){var F=new i(d);return F.parseInline(u)};var r=i.prototype;return r.parse=function(u,d){d===void 0&&(d=!0);var F="",C,W,j,V,G,oe,se,de,De,pe,Ce,Fe,Me,Be,Ie,Je,Ke,xe,x,le=u.length;for(C=0;C<le;C++){if(pe=u[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(x=this.options.extensions.renderers[pe.type].call({parser:this},pe),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){F+=x||"";continue}switch(pe.type){case"space":continue;case"hr":{F+=this.renderer.hr();continue}case"heading":{F+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,m(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{F+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(de="",se="",V=pe.header.length,W=0;W<V;W++)se+=this.renderer.tablecell(this.parseInline(pe.header[W].tokens),{header:!0,align:pe.align[W]});for(de+=this.renderer.tablerow(se),De="",V=pe.rows.length,W=0;W<V;W++){for(oe=pe.rows[W],se="",G=oe.length,j=0;j<G;j++)se+=this.renderer.tablecell(this.parseInline(oe[j].tokens),{header:!1,align:pe.align[j]});De+=this.renderer.tablerow(se)}F+=this.renderer.table(de,De);continue}case"blockquote":{De=this.parse(pe.tokens),F+=this.renderer.blockquote(De);continue}case"list":{for(Ce=pe.ordered,Fe=pe.start,Me=pe.loose,V=pe.items.length,De="",W=0;W<V;W++)Ie=pe.items[W],Je=Ie.checked,Ke=Ie.task,Be="",Ie.task&&(xe=this.renderer.checkbox(Je),Me?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=xe+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=xe+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:xe}):Be+=xe),Be+=this.parse(Ie.tokens,Me),De+=this.renderer.listitem(Be,Ke,Je);F+=this.renderer.list(De,Ce,Fe);continue}case"html":{F+=this.renderer.html(pe.text);continue}case"paragraph":{F+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(De=pe.tokens?this.parseInline(pe.tokens):pe.text;C+1<le&&u[C+1].type==="text";)pe=u[++C],De+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);F+=d?this.renderer.paragraph(De):De;continue}default:{var fe='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return F},r.parseInline=function(u,d){d=d||this.renderer;var F="",C,W,j,V=u.length;for(C=0;C<V;C++){if(W=u[C],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(j=this.options.extensions.renderers[W.type].call({parser:this},W),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){F+=j||"";continue}switch(W.type){case"escape":{F+=d.text(W.text);break}case"html":{F+=d.html(W.text);break}case"link":{F+=d.link(W.href,W.title,this.parseInline(W.tokens,d));break}case"image":{F+=d.image(W.href,W.title,W.text);break}case"strong":{F+=d.strong(this.parseInline(W.tokens,d));break}case"em":{F+=d.em(this.parseInline(W.tokens,d));break}case"codespan":{F+=d.codespan(W.text);break}case"br":{F+=d.br();break}case"del":{F+=d.del(this.parseInline(W.tokens,d));break}case"text":{F+=d.text(W.text);break}default:{var G='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return F},i}();function K(i,r,c){if(typeof i>"u"||i===null)throw new Error("marked(): input parameter is undefined or null");if(typeof i!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(i)+", string expected");if(typeof r=="function"&&(c=r,r=null),r=M({},K.defaults,r||{}),I(r),c){var u=r.highlight,d;try{d=Te.lex(i,r)}catch(V){return c(V)}var F=function(G){var oe;if(!G)try{r.walkTokens&&K.walkTokens(d,r.walkTokens),oe=ae.parse(d,r)}catch(se){G=se}return r.highlight=u,G?c(G):c(null,oe)};if(!u||u.length<3||(delete r.highlight,!d.length))return F();var C=0;K.walkTokens(d,function(V){V.type==="code"&&(C++,setTimeout(function(){u(V.text,V.lang,function(G,oe){if(G)return F(G);oe!=null&&oe!==V.text&&(V.text=oe,V.escaped=!0),C--,C===0&&F()})},0))}),C===0&&F();return}function W(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,r.silent)return"<p>An error occurred:</p><pre>"+e(V.message+"",!0)+"</pre>";throw V}try{var j=Te.lex(i,r);if(r.walkTokens){if(r.async)return Promise.all(K.walkTokens(j,r.walkTokens)).then(function(){return ae.parse(j,r)}).catch(W);K.walkTokens(j,r.walkTokens)}return ae.parse(j,r)}catch(V){W(V)}}K.options=K.setOptions=function(i){return M(K.defaults,i),k(K.defaults),K},K.getDefaults=E,K.defaults=ie.defaults,K.use=function(){for(var i=arguments.length,r=new Array(i),c=0;c<i;c++)r[c]=arguments[c];var u=M.apply(void 0,[{}].concat(r)),d=K.defaults.extensions||{renderers:{},childTokens:{}},F;r.forEach(function(C){if(C.extensions&&(F=!0,C.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var V=d.renderers?d.renderers[j.name]:null;V?d.renderers[j.name]=function(){for(var G=arguments.length,oe=new Array(G),se=0;se<G;se++)oe[se]=arguments[se];var de=j.renderer.apply(this,oe);return de===!1&&(de=V.apply(this,oe)),de}:d.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");d[j.level]?d[j.level].unshift(j.tokenizer):d[j.level]=[j.tokenizer],j.start&&(j.level==="block"?d.startBlock?d.startBlock.push(j.start):d.startBlock=[j.start]:j.level==="inline"&&(d.startInline?d.startInline.push(j.start):d.startInline=[j.start]))}j.childTokens&&(d.childTokens[j.name]=j.childTokens)})),C.renderer&&function(){var j=K.defaults.renderer||new Oe,V=function(se){var de=j[se];j[se]=function(){for(var De=arguments.length,pe=new Array(De),Ce=0;Ce<De;Ce++)pe[Ce]=arguments[Ce];var Fe=C.renderer[se].apply(j,pe);return Fe===!1&&(Fe=de.apply(j,pe)),Fe}};for(var G in C.renderer)V(G);u.renderer=j}(),C.tokenizer&&function(){var j=K.defaults.tokenizer||new ue,V=function(se){var de=j[se];j[se]=function(){for(var De=arguments.length,pe=new Array(De),Ce=0;Ce<De;Ce++)pe[Ce]=arguments[Ce];var Fe=C.tokenizer[se].apply(j,pe);return Fe===!1&&(Fe=de.apply(j,pe)),Fe}};for(var G in C.tokenizer)V(G);u.tokenizer=j}(),C.walkTokens){var W=K.defaults.walkTokens;u.walkTokens=function(j){var V=[];return V.push(C.walkTokens.call(this,j)),W&&(V=V.concat(W.call(this,j))),V}}F&&(u.extensions=d),K.setOptions(u)})},K.walkTokens=function(i,r){for(var c=[],u=function(){var W=F.value;switch(c=c.concat(r.call(K,W)),W.type){case"table":{for(var j=z(W.header),V;!(V=j()).done;){var G=V.value;c=c.concat(K.walkTokens(G.tokens,r))}for(var oe=z(W.rows),se;!(se=oe()).done;)for(var de=se.value,De=z(de),pe;!(pe=De()).done;){var Ce=pe.value;c=c.concat(K.walkTokens(Ce.tokens,r))}break}case"list":{c=c.concat(K.walkTokens(W.items,r));break}default:K.defaults.extensions&&K.defaults.extensions.childTokens&&K.defaults.extensions.childTokens[W.type]?K.defaults.extensions.childTokens[W.type].forEach(function(Fe){c=c.concat(K.walkTokens(W[Fe],r))}):W.tokens&&(c=c.concat(K.walkTokens(W.tokens,r)))}},d=z(i),F;!(F=d()).done;)u();return c},K.parseInline=function(i,r){if(typeof i>"u"||i===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof i!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(i)+", string expected");r=M({},K.defaults,r||{}),I(r);try{var c=Te.lexInline(i,r);return r.walkTokens&&K.walkTokens(c,r.walkTokens),ae.parseInline(c,r)}catch(u){if(u.message+=`
Please report this to https://github.com/markedjs/marked.`,r.silent)return"<p>An error occurred:</p><pre>"+e(u.message+"",!0)+"</pre>";throw u}},K.Parser=ae,K.parser=ae.parse,K.Renderer=Oe,K.TextRenderer=re,K.Lexer=Te,K.lexer=Te.lex,K.Tokenizer=ue,K.Slugger=J,K.parse=K;var U=K.options,Z=K.setOptions,me=K.use,ve=K.walkTokens,ke=K.parseInline,Ee=K,ge=ae.parse,D=Te.lex;ie.Lexer=Te,ie.Parser=ae,ie.Renderer=Oe,ie.Slugger=J,ie.TextRenderer=re,ie.Tokenizer=ue,ie.getDefaults=E,ie.lexer=D,ie.marked=K,ie.options=U,ie.parse=Ee,ie.parseInline=ke,ie.parser=ge,ie.setOptions=Z,ie.use=me,ie.walkTokens=ve,Object.defineProperty(ie,"__esModule",{value:!0})}),define(be[80],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=void 0;function A(s){const m=z(s);if(m&&m.length>0)return new Uint32Array(m)}t.$Pj=A;let P=0;const n=new Uint32Array(10);function z(s){if(P=0,E(s,L,4352),P>0||(E(s,o,4449),P>0)||(E(s,l,4520),P>0)||(E(s,e,12593),P))return n.subarray(0,P);if(s>=44032&&s<=55203){const m=s-44032,$=m%588,a=Math.floor(m/588),p=Math.floor($/28),f=$%28-1;if(a<L.length?E(a,L,0):4352+a-12593<e.length&&E(4352+a,e,12593),p<o.length?E(p,o,0):4449+p-12593<e.length&&E(4449+p-12593,e,12593),f>=0&&(f<l.length?E(f,l,0):4520+f-12593<e.length&&E(4520+f-12593,e,12593)),P>0)return n.subarray(0,P)}}function E(s,m,$){s>=$&&s<$+m.length&&k(m[s-$])}function k(s){s!==0&&(n[P++]=s&255,s>>8&&(n[P++]=s>>8&255),s>>16&&(n[P++]=s>>16&255))}var b;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var v;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(v||(v={}));var y;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(y||(y={}));const L=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),o=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),l=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=void 0;class A{constructor(n,z=0,E=n.length,k=z-1){this.a=n,this.b=z,this.c=E,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$OS=A}),define(be[82],$e([1,0,81]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QS=t.$PS=void 0;class P{constructor(E=[],k=10){this.h(E),this.b=k,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new A.$OS(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const k of E)this.a.add(k)}get j(){const E=[];return this.a.forEach(k=>E.push(k)),E}}t.$PS=P;class n{get size(){return this.f}constructor(E,k=10){if(this.g=k,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let b=1;b<E.length;b++)this.add(E[b])}add(E){const k={value:E,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const k=this.c.value;return this.a.delete(k),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),k}prepend(E){if(this.f===this.g||this.a.has(E))return;const k={value:E,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let k=this.b;for(;k!==this.c;)k.value===E&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$QS=n}),define(be[46],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9l=t.$8l=t.$7l=t.rot=t.$5l=void 0;function A(k,b,v){return Math.min(Math.max(k,b),v)}t.$5l=A;function P(k,b){return(b+k%b)%b}t.rot=P;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$7l=n;class z{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$8l=z;class E{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const v=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$9l=E}),define(be[47],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var A;(function(P){function n(b,v){if(b.start>=v.end||v.start>=b.end)return{start:0,end:0};const y=Math.max(b.start,v.start),L=Math.min(b.end,v.end);return L-y<=0?{start:0,end:0}:{start:y,end:L}}P.intersect=n;function z(b){return b.end-b.start<=0}P.isEmpty=z;function E(b,v){return!z(n(b,v))}P.intersects=E;function k(b,v){const y=[],L={start:b.start,end:Math.min(v.start,b.end)},o={start:Math.max(v.end,b.start),end:b.end};return z(L)||y.push(L),z(o)||y.push(o),y}P.relativeComplement=k})(A||(t.Range=A={}))}),define(be[83],$e([1,0,47]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=t.$BR=t.$AR=t.$zR=void 0;function P(b,v){const y=[];for(const L of v){if(b.start>=L.range.end)continue;if(b.end<L.range.start)break;const o=A.Range.intersect(b,L.range);A.Range.isEmpty(o)||y.push({range:o,size:L.size})}return y}t.$zR=P;function n({start:b,end:v},y){return{start:b+y,end:v+y}}t.$AR=n;function z(b){const v=[];let y=null;for(const L of b){const o=L.range.start,l=L.range.end,e=L.size;if(y&&e===y.size){y.range.end=l;continue}y={range:{start:o,end:l},size:e},v.push(y)}return v}t.$BR=z;function E(...b){return z(b.reduce((v,y)=>v.concat(y),[]))}class k{get paddingTop(){return this.c}set paddingTop(v){this.b=this.b+v-this.c,this.c=v}constructor(v){this.a=[],this.b=0,this.c=0,this.c=v??0,this.b=this.c}splice(v,y,L=[]){const o=L.length-y,l=P({start:0,end:v},this.a),e=P({start:v+y,end:Number.POSITIVE_INFINITY},this.a).map(m=>({range:n(m.range,o),size:m.size})),s=L.map((m,$)=>({range:{start:v+$,end:v+$+1},size:m.size}));this.a=E(l,s,e),this.b=this.c+this.a.reduce((m,$)=>m+$.size*($.range.end-$.range.start),0)}get count(){const v=this.a.length;return v?this.a[v-1].range.end:0}get size(){return this.b}indexAt(v){if(v<0)return-1;if(v<this.c)return 0;let y=0,L=this.c;for(const o of this.a){const l=o.range.end-o.range.start,e=L+l*o.size;if(v<e)return y+Math.floor((v-L)/o.size);y+=l,L=e}return y}indexAfter(v){return Math.min(this.indexAt(v)+1,this.count)}positionAt(v){if(v<0)return-1;let y=0,L=0;for(const o of this.a){const l=o.range.end-o.range.start,e=L+l;if(v<e)return this.c+y+(v-L)*o.size;y+=l*o.size,L=e}return-1}}t.$CR=k}),define(be[84],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pd=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(z){return new P(z)}constructor(z){this.c=A&&z===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Pd=P}),define(be[4],$e([1,0,6,43,2,45,84]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.Event=void 0;const k=!1,b=!1;var v;(function(_){_.None=()=>n.$Tc.None;function N(d){if(b){const{onDidAddListener:F}=d,C=e.create();let W=0;d.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),C.print()),F?.()}}}function I(d,F){return Oe(d,()=>{},0,void 0,!0,void 0,F)}_.defer=I;function B(d){return(F,C=null,W)=>{let j=!1,V;return V=d(G=>{if(!j)return V?V.dispose():j=!0,F.call(C,G)},null,W),j&&V.dispose(),V}}_.once=B;function X(d,F,C){return Re((W,j=null,V)=>d(G=>W.call(j,F(G)),null,V),C)}_.map=X;function Y(d,F,C){return Re((W,j=null,V)=>d(G=>{F(G),W.call(j,G)},null,V),C)}_.forEach=Y;function ue(d,F,C){return Re((W,j=null,V)=>d(G=>F(G)&&W.call(j,G),null,V),C)}_.filter=ue;function ne(d){return d}_.signal=ne;function te(...d){return(F,C=null,W)=>{const j=(0,n.$Qc)(...d.map(V=>V(G=>F.call(C,G))));return Te(j,W)}}_.any=te;function we(d,F,C,W){let j=C;return X(d,V=>(j=F(j,V),j),W)}_.reduce=we;function Re(d,F){let C;const W={onWillAddFirstListener(){C=d(j.fire,j)},onDidRemoveLastListener(){C?.dispose()}};F||N(W);const j=new p(W);return F?.add(j),j.event}function Te(d,F){return F instanceof Array?F.push(d):F&&F.add(d),d}function Oe(d,F,C=100,W=!1,j=!1,V,G){let oe,se,de,De=0,pe;const Ce={leakWarningThreshold:V,onWillAddFirstListener(){oe=d(Me=>{De++,se=F(se,Me),W&&!de&&(Fe.fire(se),se=void 0),pe=()=>{const Be=se;se=void 0,de=void 0,(!W||De>1)&&Fe.fire(Be),De=0},typeof C=="number"?(clearTimeout(de),de=setTimeout(pe,C)):de===void 0&&(de=0,queueMicrotask(pe))})},onWillRemoveListener(){j&&De>0&&pe?.()},onDidRemoveLastListener(){pe=void 0,oe.dispose()}};G||N(Ce);const Fe=new p(Ce);return G?.add(Fe),Fe.event}_.debounce=Oe;function re(d,F=0,C){return _.debounce(d,(W,j)=>W?(W.push(j),W):[j],F,void 0,!0,void 0,C)}_.accumulate=re;function J(d,F=(W,j)=>W===j,C){let W=!0,j;return ue(d,V=>{const G=W||!F(V,j);return W=!1,j=V,G},C)}_.latch=J;function ae(d,F,C){return[_.filter(d,F,C),_.filter(d,W=>!F(W),C)]}_.split=ae;function K(d,F=!1,C=[],W){let j=C.slice(),V=d(se=>{j?j.push(se):oe.fire(se)});W&&W.add(V);const G=()=>{j?.forEach(se=>oe.fire(se)),j=null},oe=new p({onWillAddFirstListener(){V||(V=d(se=>oe.fire(se)),W&&W.add(V))},onDidAddFirstListener(){j&&(F?setTimeout(G):G())},onDidRemoveLastListener(){V&&V.dispose(),V=null}});return W&&W.add(oe),oe.event}_.buffer=K;function U(d,F){return(W,j,V)=>{const G=F(new me);return d(function(oe){const se=G.evaluate(oe);se!==Z&&W.call(j,se)},void 0,V)}}_.chain=U;const Z=Symbol("HaltChainable");class me{constructor(){this.f=[]}map(F){return this.f.push(F),this}forEach(F){return this.f.push(C=>(F(C),C)),this}filter(F){return this.f.push(C=>F(C)?C:Z),this}reduce(F,C){let W=C;return this.f.push(j=>(W=F(W,j),W)),this}latch(F=(C,W)=>C===W){let C=!0,W;return this.f.push(j=>{const V=C||!F(j,W);return C=!1,W=j,V?j:Z}),this}evaluate(F){for(const C of this.f)if(F=C(F),F===Z)break;return F}}function ve(d,F,C=W=>W){const W=(...oe)=>G.fire(C(...oe)),j=()=>d.on(F,W),V=()=>d.removeListener(F,W),G=new p({onWillAddFirstListener:j,onDidRemoveLastListener:V});return G.event}_.fromNodeEventEmitter=ve;function ke(d,F,C=W=>W){const W=(...oe)=>G.fire(C(...oe)),j=()=>d.addEventListener(F,W),V=()=>d.removeEventListener(F,W),G=new p({onWillAddFirstListener:j,onDidRemoveLastListener:V});return G.event}_.fromDOMEventEmitter=ke;function Ee(d){return new Promise(F=>B(d)(F))}_.toPromise=Ee;function ge(d){const F=new p;return d.then(C=>{F.fire(C)},()=>{F.fire(void 0)}).finally(()=>{F.dispose()}),F.event}_.fromPromise=ge;function D(d,F,C){return F(C),d(W=>F(W))}_.runAndSubscribe=D;function i(d,F){let C=null;function W(V){C?.dispose(),C=new n.$Sc,F(V,C)}W(void 0);const j=d(V=>W(V));return(0,n.$Rc)(()=>{j.dispose(),C?.dispose()})}_.runAndSubscribeWithStore=i;class r{constructor(F,C){this._observable=F,this.f=0,this.g=!1;const W={onWillAddFirstListener:()=>{F.addObserver(this)},onDidRemoveLastListener:()=>{F.removeObserver(this)}};C||N(W),this.emitter=new p(W),C&&C.add(this.emitter)}beginUpdate(F){this.f++}handlePossibleChange(F){}handleChange(F,C){this.g=!0}endUpdate(F){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function c(d,F){return new r(d,F).emitter.event}_.fromObservable=c;function u(d){return(F,C,W)=>{let j=0,V=!1;const G={beginUpdate(){j++},endUpdate(){j--,j===0&&(d.reportChanges(),V&&(V=!1,F.call(C)))},handlePossibleChange(){},handleChange(){V=!0}};d.addObserver(G),d.reportChanges();const oe={dispose(){d.removeObserver(G)}};return W instanceof n.$Sc?W.add(oe):Array.isArray(W)&&W.push(oe),oe}}_.fromObservableLight=u})(v||(t.Event=v={}));class y{static{this.all=new Set}static{this.f=0}constructor(N){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${N}_${y.f++}`,y.all.add(this)}start(N){this.g=new E.$Pd,this.listenerCount=N}stop(){if(this.g){const N=this.g.elapsed();this.durations.push(N),this.elapsedOverall+=N,this.invocationCount+=1,this.g=void 0}}}t.$Rd=y;let L=-1;function o(_){const N=L;return L=_,{dispose(){L=N}}}t.$Sd=o;class l{constructor(N,I=Math.random().toString(18).slice(2,5)){this.threshold=N,this.name=I,this.g=0}dispose(){this.f?.clear()}check(N,I){const B=this.threshold;if(B<=0||I<B)return;this.f||(this.f=new Map);const X=this.f.get(N.value)||0;if(this.f.set(N.value,X+1),this.g-=1,this.g<=0){this.g=B*.5;let Y,ue=0;for(const[ne,te]of this.f)(!Y||ue<te)&&(Y=ne,ue=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ue}):`),console.warn(Y)}return()=>{const Y=this.f.get(N.value)||0;this.f.set(N.value,Y-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(N){this.value=N}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class m{constructor(N){this.value=N,this.id=s++}}const $=2,a=(_,N)=>{if(_ instanceof m)N(_);else for(let I=0;I<_.length;I++){const B=_[I];B&&N(B)}};class p{constructor(N){this.w=0,this.f=N,this.g=L>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(k){const N=this.t;queueMicrotask(()=>{a(N,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(N,I,B)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;I&&(N=N.bind(I));const X=new m(N);let Y,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),Y=this.g.check(X.stack,this.w+1)),k&&(X.stack=ue??e.create()),this.t?this.t instanceof m?(this.u??=new g,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const ne=(0,n.$Rc)(()=>{Y?.(),this.x(X)});return B instanceof n.$Sc?B.add(ne):Array.isArray(B)&&B.push(ne),ne},this.q}x(N){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,B=I.indexOf(N);if(B===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[B]=void 0;const X=this.u.current===this;if(this.w*$<=I.length){let Y=0;for(let ue=0;ue<I.length;ue++)I[ue]?I[Y++]=I[ue]:X&&(this.u.end--,Y<this.u.i&&this.u.i--);I.length=Y}}y(N,I){if(!N)return;const B=this.f?.onListenerError||A.$1;if(!B){N.value(I);return}try{N.value(I)}catch(X){B(X)}}z(N){const I=N.current.t;for(;N.i<N.end;)this.y(I[N.i++],N.value);N.reset()}fire(N){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,N);else{const I=this.u;I.enqueue(this,N,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Td=p;const f=()=>new g;t.$Ud=f;class g{constructor(){this.i=-1,this.end=0}enqueue(N,I,B){this.i=0,this.end=B,this.current=N,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends p{async fireAsync(N,I,B){if(this.t)for(this.h||(this.h=new z.$4c),a(this.t,X=>this.h.push([X.value,N]));this.h.size>0&&!I.isCancellationRequested;){const[X,Y]=this.h.shift(),ue=[],ne={...Y,token:I,waitUntil:te=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");B&&(te=B(te,X)),ue.push(te)}};try{X(ne)}catch(te){(0,A.$1)(te);continue}Object.freeze(ue),await Promise.allSettled(ue).then(te=>{for(const we of te)we.status==="rejected"&&(0,A.$1)(we.reason)})}}}t.$Vd=h;class T extends p{get isPaused(){return this.h!==0}constructor(N){super(N),this.h=0,this.s=new z.$4c,this.A=N?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const N=Array.from(this.s);this.s.clear(),super.fire(this.A(N))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(N){this.w&&(this.h!==0?this.s.push(N):super.fire(N))}}t.$Wd=T;class O extends T{constructor(N){super(N),this.k=N.delay??100}fire(N){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(N)}}t.$Xd=O;class R extends p{constructor(N){super(N),this.h=[],this.k=N?.merge}fire(N){this.hasListeners()&&(this.h.push(N),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$Yd=R;class w{constructor(){this.g=!1,this.h=[],this.f=new p({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(N){const I={event:N,listener:null};this.h.push(I),this.g&&this.m(I);const B=()=>{this.g&&this.o(I);const X=this.h.indexOf(I);this.h.splice(X,1)};return(0,n.$Rc)((0,P.$db)(B))}j(){this.g=!0,this.h.forEach(N=>this.m(N))}k(){this.g=!1,this.h.forEach(N=>this.o(N))}m(N){N.listener=N.event(I=>this.f.fire(I))}o(N){N.listener&&N.listener.dispose(),N.listener=null}dispose(){this.f.dispose()}}t.$Zd=w;class S{constructor(N,I,B,X){this.f=new n.$Sc;const Y=this.f.add(new w),ue=this.f.add(new n.$3c);function ne(te){ue.set(te,Y.add(X(te)))}for(const te of N)ne(te);this.f.add(I(te=>{ne(te)})),this.f.add(B(te=>{ue.deleteAndDispose(te)})),this.event=Y.event}dispose(){this.f.dispose()}}t.$1d=S;class M{constructor(){this.f=[]}wrapEvent(N){return(I,B,X)=>N(Y=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>I.call(B,Y)):I.call(B,Y)},void 0,X)}bufferEvents(N){const I=[];this.f.push(I);const B=N();return this.f.pop(),I.forEach(X=>X()),B}}t.$2d=M;class H{constructor(){this.f=!1,this.g=v.None,this.h=n.$Tc.None,this.j=new p({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(N){this.g=N,this.f&&(this.h.dispose(),this.h=N(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$3d=H}),define(be[16],$e([1,0,21,4,2]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=void 0;class z{constructor(){this.a=new Map,this.b=new P.$Td,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new P.$Td,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new z}getZoomLevel(g){return this.a.get(this.f(g))??0}setZoomLevel(g,h){if(this.getZoomLevel(h)===g)return;const T=this.f(h);this.a.set(T,g),this.b.fire(T)}getZoomFactor(g){return this.c.get(this.f(g))??1}setZoomFactor(g,h){this.c.set(this.f(h),g)}setFullscreen(g,h){if(this.isFullscreen(h)===g)return;const T=this.f(h);this.e.set(T,g),this.d.fire(T)}isFullscreen(g){return!!this.e.get(this.f(g))}f(g){return g.vscodeWindowId}}class E extends n.$Tc{constructor(){super(),this.a=this.B(new P.$Td),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(g){this.c?.removeEventListener("change",this.b),this.c=A.$window.matchMedia(`(resolution: ${A.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),g&&this.a.fire()}}class k extends n.$Tc{get value(){return this.b}constructor(){super(),this.a=this.B(new P.$Td),this.onDidChange=this.a.event,this.b=this.c();const g=this.B(new E);this.B(g.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const g=document.createElement("canvas").getContext("2d"),h=A.$window.devicePixelRatio||1,T=g.webkitBackingStorePixelRatio||g.mozBackingStorePixelRatio||g.msBackingStorePixelRatio||g.oBackingStorePixelRatio||g.backingStorePixelRatio||1;return h/T}}class b{constructor(){this.a=null}b(){return this.a||(this.a=(0,n.$Mc)(new k)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function v(f,g,h){typeof g=="string"&&(g=f.matchMedia(g)),g.addEventListener("change",h)}t.$YO=v,t.$ZO=new b;function y(f,g){z.INSTANCE.setZoomLevel(f,g)}t.$1O=y;function L(f){return z.INSTANCE.getZoomLevel(f)}t.$2O=L,t.$3O=z.INSTANCE.onDidChangeZoomLevel;function o(f){return z.INSTANCE.getZoomFactor(f)}t.$4O=o;function l(f,g){z.INSTANCE.setZoomFactor(f,g)}t.$5O=l;function e(f,g){z.INSTANCE.setFullscreen(f,g)}t.$6O=e;function s(f){return z.INSTANCE.isFullscreen(f)}t.$7O=s,t.$8O=z.INSTANCE.onDidChangeFullscreen;const m=navigator.userAgent;t.$9O=m.indexOf("Firefox")>=0,t.$0O=m.indexOf("AppleWebKit")>=0,t.$$O=m.indexOf("Chrome")>=0,t.$_O=!t.$$O&&m.indexOf("Safari")>=0,t.$aP=!t.$$O&&!t.$_O&&t.$0O,t.$bP=m.indexOf("Electron/")>=0,t.$cP=m.indexOf("Android")>=0;let $=!1;if(typeof A.$UO.matchMedia=="function"){const f=A.$UO.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),g=A.$UO.matchMedia("(display-mode: fullscreen)");$=f.matches,v(A.$UO,f,({matches:h})=>{$&&g.matches||($=h)})}function a(){return $}t.$dP=a;function p(){return navigator?.windowControlsOverlay?.visible}t.$eP=p}),define(be[22],$e([1,0,4]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=void 0;class P{get event(){return this.a.event}constructor(z,E,k){const b=v=>this.a.fire(v);this.a=new A.$Td({onWillAddFirstListener:()=>z.addEventListener(E,b,k),onDidRemoveLastListener:()=>z.removeEventListener(E,b,k)})}dispose(){this.a.dispose()}}t.$rR=P}),define(be[29],$e([1,0,4]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=t.CancellationToken=void 0;const P=Object.freeze(function(k,b){const v=setTimeout(k.bind(b),0);return{dispose(){clearTimeout(v)}}});var n;(function(k){function b(v){return v===k.None||v===k.Cancelled||v instanceof z?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(n||(t.CancellationToken=n={}));class z{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new A.$Td),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new z),this.f}cancel(){this.f?this.f instanceof z&&this.f.cancel():this.f=n.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof z&&this.f.dispose():this.f=n.None}}t.$4d=E}),define(be[85],$e([1,0,29]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ee=t.$De=t.$Ce=void 0;class P{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new A.$4d,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}t.$Ce=P;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const b=JSON.stringify(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}t.$De=n;class z{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const b=this.b(k);return this.a.set(k,b),b}}t.$Ee=z}),define(be[48],$e([1,0,4,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cs=t.$bs=t.$as=t.$_r=t.ScrollbarVisibility=void 0;var n;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class z{constructor(e,s,m,$,a,p,f){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,m=m|0,$=$|0,a=a|0,p=p|0,f=f|0),this.rawScrollLeft=$,this.rawScrollTop=f,s<0&&(s=0),$+s>m&&($=m-s),$<0&&($=0),a<0&&(a=0),f+a>p&&(f=p-a),f<0&&(f=0),this.width=s,this.scrollWidth=m,this.scrollLeft=$,this.height=a,this.scrollHeight=p,this.scrollTop=f}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new z(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new z(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const m=this.width!==e.width,$=this.scrollWidth!==e.scrollWidth,a=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,f=this.scrollHeight!==e.scrollHeight,g=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:a,heightChanged:p,scrollHeightChanged:f,scrollTopChanged:g}}}t.$_r=z;class E extends P.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new A.$Td),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new z(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const m=this.g.withScrollDimensions(e,s);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const m=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;s?$=new y(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(e);this.h=y.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const m=this.g;m.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(m,s)))}}t.$as=E;class k{constructor(e,s,m){this.scrollLeft=e,this.scrollTop=s,this.isDone=m}}t.$bs=k;function b(l,e){const s=e-l;return function(m){return l+s*o(m)}}function v(l,e,s){return function(m){return m<s?l(m/s):e((m-s)/(1-s))}}class y{constructor(e,s,m,$){this.from=e,this.to=s,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,m){if(Math.abs(e-s)>2.5*m){let a,p;return e<s?(a=e+.75*m,p=s-.75*m):(a=e-.75*m,p=s+.75*m),v(b(e,a),b(p,s),.33)}return b(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const m=this.c(s),$=this.d(s);return new k(m,$,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,m){return y.start(e,s,m)}static start(e,s,m){m=m+10;const $=Date.now()-10;return new y(e,s,$,m)}}t.$cs=y;function L(l){return Math.pow(l,3)}function o(l){return 1-L(1-l)}}),define(be[86],$e([1,0,6,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=void 0;function n(f){const g=f;return g?typeof g.read=="function":!1}t.$5d=n;function z(f){const g=f;return g?[g.on,g.pause,g.resume,g.destroy].every(h=>typeof h=="function"):!1}t.$6d=z;function E(f){const g=f;return g?z(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}t.$7d=E;function k(f,g){return new b(f,g)}t.$8d=k;class b{constructor(g,h){this.e=g,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(h=>h(g))}h(g){this.c.error.length===0?(0,A.$1)(g):this.c.error.slice(0).forEach(h=>h(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,h){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(g,h){if(this.a.destroyed)return;let T;switch(g){case"data":T=this.c.data;break;case"end":T=this.c.end;break;case"error":T=this.c.error;break}if(T){const O=T.indexOf(h);O>=0&&T.splice(O,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(T=>T())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(f,g){const h=[];let T;for(;(T=f.read())!==null;)h.push(T);return g(h)}t.$9d=v;function y(f,g,h){const T=[];let O;for(;(O=f.read())!==null&&T.length<h;)T.push(O);return O===null&&T.length>0?g(T):{read:()=>{if(T.length>0)return T.shift();if(typeof O<"u"){const R=O;return O=void 0,R}return f.read()}}}t.$0d=y;function L(f,g){return new Promise((h,T)=>{const O=[];o(f,{onData:R=>{g&&O.push(R)},onError:R=>{g?T(R):h(void 0)},onEnd:()=>{h(g?g(O):void 0)}})})}t.$$d=L;function o(f,g,h){f.on("error",T=>{h?.isCancellationRequested||g.onError(T)}),f.on("end",()=>{h?.isCancellationRequested||g.onEnd()}),f.on("data",T=>{h?.isCancellationRequested||g.onData(T)})}t.$_d=o;function l(f,g){return new Promise((h,T)=>{const O=new P.$Sc,R=[],w=H=>{if(R.push(H),R.length>g)return O.dispose(),f.pause(),h({stream:f,buffer:R,ended:!1})},S=H=>(O.dispose(),T(H)),M=()=>(O.dispose(),h({stream:f,buffer:R,ended:!0}));O.add((0,P.$Rc)(()=>f.removeListener("error",S))),f.on("error",S),O.add((0,P.$Rc)(()=>f.removeListener("end",M))),f.on("end",M),O.add((0,P.$Rc)(()=>f.removeListener("data",w))),f.on("data",w)})}t.$ae=l;function e(f,g){const h=k(g);return h.end(f),h}t.$be=e;function s(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}t.$ce=s;function m(f){let g=!1;return{read:()=>g?null:(g=!0,f)}}t.$de=m;function $(f,g,h){const T=k(h);return o(f,{onData:O=>T.write(g.data(O)),onError:O=>T.error(g.error?g.error(O):O),onEnd:()=>T.end()}),T}t.$ee=$;function a(f,g,h){let T=!1;return{read:()=>{const O=g.read();return T?O:(T=!0,O!==null?h([f,O]):f)}}}t.$fe=a;function p(f,g,h){let T=!1;const O=k(h);return o(g,{onData:R=>T?O.write(R):(T=!0,O.write(h([f,R]))),onError:R=>O.error(R),onEnd:()=>{T||(T=!0,O.write(f)),O.end()}}),O}t.$ge=p}),define(be[33],$e([1,0,23,86]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=void 0;const n=typeof Buffer<"u",z=new A.$V(()=>new Uint8Array(256));let E,k;class b{static alloc(I){return n?new b(Buffer.allocUnsafe(I)):new b(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new b(I)}static fromString(I,B){return!(B?.dontUseNodeBuffer||!1)&&n?new b(Buffer.from(I)):(E||(E=new TextEncoder),new b(E.encode(I)))}static fromByteArray(I){const B=b.alloc(I.length);for(let X=0,Y=I.length;X<Y;X++)B.buffer[X]=I[X];return B}static concat(I,B){if(typeof B>"u"){B=0;for(let ue=0,ne=I.length;ue<ne;ue++)B+=I[ue].byteLength}const X=b.alloc(B);let Y=0;for(let ue=0,ne=I.length;ue<ne;ue++){const te=I[ue];X.set(te,Y),Y+=te.byteLength}return X}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=b.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(I,B){return new b(this.buffer.subarray(I,B))}set(I,B){if(I instanceof b)this.buffer.set(I.buffer,B);else if(I instanceof Uint8Array)this.buffer.set(I,B);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),B);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return o(this.buffer,I)}writeUInt32BE(I,B){l(this.buffer,I,B)}readUInt32LE(I){return e(this.buffer,I)}writeUInt32LE(I,B){s(this.buffer,I,B)}readUInt8(I){return m(this.buffer,I)}writeUInt8(I,B){$(this.buffer,I,B)}indexOf(I,B=0){return v(this.buffer,I instanceof b?I.buffer:I,B)}}t.$he=b;function v(N,I,B=0){const X=I.byteLength,Y=N.byteLength;if(X===0)return 0;if(X===1)return N.indexOf(I[0]);if(X>Y-B)return-1;const ue=z.value;ue.fill(I.length);for(let Re=0;Re<I.length;Re++)ue[I[Re]]=I.length-Re-1;let ne=B+I.length-1,te=ne,we=-1;for(;ne<Y;)if(N[ne]===I[te]){if(te===0){we=ne;break}ne--,te--}else ne+=Math.max(I.length-te,ue[N[ne]]),te=I.length-1;return we}t.$ie=v;function y(N,I){return N[I+0]<<0>>>0|N[I+1]<<8>>>0}t.$je=y;function L(N,I,B){N[B+0]=I&255,I=I>>>8,N[B+1]=I&255}t.$ke=L;function o(N,I){return N[I]*2**24+N[I+1]*2**16+N[I+2]*2**8+N[I+3]}t.$le=o;function l(N,I,B){N[B+3]=I,I=I>>>8,N[B+2]=I,I=I>>>8,N[B+1]=I,I=I>>>8,N[B]=I}t.$me=l;function e(N,I){return N[I+0]<<0>>>0|N[I+1]<<8>>>0|N[I+2]<<16>>>0|N[I+3]<<24>>>0}t.$ne=e;function s(N,I,B){N[B+0]=I&255,I=I>>>8,N[B+1]=I&255,I=I>>>8,N[B+2]=I&255,I=I>>>8,N[B+3]=I&255}t.$oe=s;function m(N,I){return N[I]}t.$pe=m;function $(N,I,B){N[B]=I}t.$qe=$;function a(N){return P.$9d(N,I=>b.concat(I))}t.$re=a;function p(N){return P.$de(N)}t.$se=p;function f(N){return P.$$d(N,I=>b.concat(I))}t.$te=f;async function g(N){return N.ended?b.concat(N.buffer):b.concat([...N.buffer,await f(N.stream)])}t.$ue=g;function h(N){return P.$be(N,I=>b.concat(I))}t.$ve=h;function T(N){return P.$ee(N,{data:I=>typeof I=="string"?b.fromString(I):b.wrap(I)},I=>b.concat(I))}t.$we=T;function O(N){return P.$8d(I=>b.concat(I),N)}t.$xe=O;function R(N,I){return P.$fe(N,I,B=>b.concat(B))}t.$ye=R;function w(N,I){return P.$ge(N,I,B=>b.concat(B))}t.$ze=w;function S(N){let I=0,B=0,X=0;const Y=new Uint8Array(Math.floor(N.length/4*3)),ue=te=>{switch(B){case 3:Y[X++]=I|te,B=0;break;case 2:Y[X++]=I|te>>>2,I=te<<6,B=3;break;case 1:Y[X++]=I|te>>>4,I=te<<4,B=2;break;default:I=te<<2,B=1}};for(let te=0;te<N.length;te++){const we=N.charCodeAt(te);if(we>=65&&we<=90)ue(we-65);else if(we>=97&&we<=122)ue(we-97+26);else if(we>=48&&we<=57)ue(we-48+52);else if(we===43||we===45)ue(62);else if(we===47||we===95)ue(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${N[te]}`)}}const ne=X;for(;B>0;)ue(0);return b.wrap(Y).slice(0,ne)}t.$Ae=S;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function _({buffer:N},I=!0,B=!1){const X=B?H:M;let Y="";const ue=N.byteLength%3;let ne=0;for(;ne<N.byteLength-ue;ne+=3){const te=N[ne+0],we=N[ne+1],Re=N[ne+2];Y+=X[te>>>2],Y+=X[(te<<4|we>>>4)&63],Y+=X[(we<<2|Re>>>6)&63],Y+=X[Re&63]}if(ue===1){const te=N[ne+0];Y+=X[te>>>2],Y+=X[te<<4&63],I&&(Y+="==")}else if(ue===2){const te=N[ne+0],we=N[ne+1];Y+=X[te>>>2],Y+=X[(te<<4|we>>>4)&63],Y+=X[we<<2&63],I&&(Y+="=")}return Y}t.$Be=_}),define(be[10],$e([1,0,85,23]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ff=t.$Ef=t.$Df=t.$Cf=t.GraphemeBreakType=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=void 0;function n(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$He=n;const z=/{(\d+)}/g;function E(x,...le){return le.length===0?x:x.replace(z,function(fe,Ae){const Ne=parseInt(Ae,10);return isNaN(Ne)||Ne<0||Ne>=le.length?fe:le[Ne]})}t.$Ie=E;const k=/{([^}]+)}/g;function b(x,le){return Object.keys(le).length===0?x:x.replace(k,(fe,Ae)=>le[Ae]??fe)}t.$Je=b;function v(x){return x.replace(/[<>"'&]/g,le=>{switch(le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return le})}t.$Ke=v;function y(x){return x.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.$Le=y;function L(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Me=L;function o(x,le){let fe=0;const Ae=le.charCodeAt(0);for(let Ne=x.length-1;Ne>=0;Ne--)x.charCodeAt(Ne)===Ae&&fe++;return fe}t.$Ne=o;function l(x,le,fe="\u2026"){return x.length<=le?x:`${x.substr(0,le)}${fe}`}t.$Oe=l;function e(x,le,fe="\u2026"){if(x.length<=le)return x;const Ae=Math.ceil(le/2)-fe.length/2,Ne=Math.floor(le/2)-fe.length/2;return`${x.substr(0,Ae)}${fe}${x.substr(x.length-Ne)}`}t.$Pe=e;function s(x,le=" "){const fe=m(x,le);return $(fe,le)}t.$Qe=s;function m(x,le){if(!x||!le)return x;const fe=le.length;if(fe===0||x.length===0)return x;let Ae=0;for(;x.indexOf(le,Ae)===Ae;)Ae=Ae+fe;return x.substring(Ae)}t.$Re=m;function $(x,le){if(!x||!le)return x;const fe=le.length,Ae=x.length;if(fe===0||Ae===0)return x;let Ne=Ae,ze=-1;for(;ze=x.lastIndexOf(le,Ne-1),!(ze===-1||ze+fe!==Ne);){if(ze===0)return"";Ne=ze}return x.substring(0,Ne)}t.$Se=$;function a(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Te=a;function p(x){return x.replace(/\*/g,"")}t.$Ue=p;function f(x,le,fe={}){if(!x)throw new Error("Cannot create regex from empty string");le||(x=L(x)),fe.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ae="";return fe.global&&(Ae+="g"),fe.matchCase||(Ae+="i"),fe.multiline&&(Ae+="m"),fe.unicode&&(Ae+="u"),new RegExp(x,Ae)}t.$Ve=f;function g(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$We=g;function h(x){return x.split(/\r\n|\r|\n/)}t.$Xe=h;function T(x){for(let le=0,fe=x.length;le<fe;le++){const Ae=x.charCodeAt(le);if(Ae!==32&&Ae!==9)return le}return-1}t.$Ye=T;function O(x,le=0,fe=x.length){for(let Ae=le;Ae<fe;Ae++){const Ne=x.charCodeAt(Ae);if(Ne!==32&&Ne!==9)return x.substring(le,Ae)}return x.substring(le,fe)}t.$Ze=O;function R(x,le=x.length-1){for(let fe=le;fe>=0;fe--){const Ae=x.charCodeAt(fe);if(Ae!==32&&Ae!==9)return fe}return-1}t.$1e=R;function w(x,le,fe){const Ae=[];let Ne=0;for(const ze of x.matchAll(le)){if(Ae.push(x.slice(Ne,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Ne=ze.index+ze[0].length,Ae.push(fe(ze[0],...ze.slice(1),ze.index,x,ze.groups))}return Ae.push(x.slice(Ne)),Promise.all(Ae).then(ze=>ze.join(""))}t.$2e=w;function S(x,le){return x<le?-1:x>le?1:0}t.$3e=S;function M(x,le,fe=0,Ae=x.length,Ne=0,ze=le.length){for(;fe<Ae&&Ne<ze;fe++,Ne++){const et=x.charCodeAt(fe),tt=le.charCodeAt(Ne);if(et<tt)return-1;if(et>tt)return 1}const qe=Ae-fe,_e=ze-Ne;return qe<_e?-1:qe>_e?1:0}t.$4e=M;function H(x,le){return _(x,le,0,x.length,0,le.length)}t.$5e=H;function _(x,le,fe=0,Ae=x.length,Ne=0,ze=le.length){for(;fe<Ae&&Ne<ze;fe++,Ne++){let et=x.charCodeAt(fe),tt=le.charCodeAt(Ne);if(et===tt)continue;if(et>=128||tt>=128)return M(x.toLowerCase(),le.toLowerCase(),fe,Ae,Ne,ze);I(et)&&(et-=32),I(tt)&&(tt-=32);const Ze=et-tt;if(Ze!==0)return Ze}const qe=Ae-fe,_e=ze-Ne;return qe<_e?-1:qe>_e?1:0}t.$6e=_;function N(x){return x>=48&&x<=57}t.$7e=N;function I(x){return x>=97&&x<=122}t.$8e=I;function B(x){return x>=65&&x<=90}t.$9e=B;function X(x,le){return x.length===le.length&&_(x,le)===0}t.$0e=X;function Y(x,le){const fe=le.length;return le.length>x.length?!1:_(x,le,0,fe)===0}t.$$e=Y;function ue(x,le){const fe=Math.min(x.length,le.length);let Ae;for(Ae=0;Ae<fe;Ae++)if(x.charCodeAt(Ae)!==le.charCodeAt(Ae))return Ae;return fe}t.$_e=ue;function ne(x,le){const fe=Math.min(x.length,le.length);let Ae;const Ne=x.length-1,ze=le.length-1;for(Ae=0;Ae<fe;Ae++)if(x.charCodeAt(Ne-Ae)!==le.charCodeAt(ze-Ae))return Ae;return fe}t.$af=ne;function te(x){return 55296<=x&&x<=56319}t.$bf=te;function we(x){return 56320<=x&&x<=57343}t.$cf=we;function Re(x,le){return(x-55296<<10)+(le-56320)+65536}t.$df=Re;function Te(x,le,fe){const Ae=x.charCodeAt(fe);if(te(Ae)&&fe+1<le){const Ne=x.charCodeAt(fe+1);if(we(Ne))return Re(Ae,Ne)}return Ae}t.$ef=Te;function Oe(x,le){const fe=x.charCodeAt(le-1);if(we(fe)&&le>1){const Ae=x.charCodeAt(le-2);if(te(Ae))return Re(Ae,fe)}return fe}class re{get offset(){return this.e}constructor(le,fe=0){this.c=le,this.d=le.length,this.e=fe}setOffset(le){this.e=le}prevCodePoint(){const le=Oe(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Te(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.$ff=re;class J{get offset(){return this.c.offset}constructor(le,fe=0){this.c=new re(le,fe)}nextGraphemeLength(){const le=Ce.getInstance(),fe=this.c,Ae=fe.offset;let Ne=le.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const ze=fe.offset,qe=le.getGraphemeBreakType(fe.nextCodePoint());if(De(Ne,qe)){fe.setOffset(ze);break}Ne=qe}return fe.offset-Ae}prevGraphemeLength(){const le=Ce.getInstance(),fe=this.c,Ae=fe.offset;let Ne=le.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const ze=fe.offset,qe=le.getGraphemeBreakType(fe.prevCodePoint());if(De(qe,Ne)){fe.setOffset(ze);break}Ne=qe}return Ae-fe.offset}eol(){return this.c.eol()}}t.$gf=J;function ae(x,le){return new J(x,le).nextGraphemeLength()}t.$hf=ae;function K(x,le){return new J(x,le).prevGraphemeLength()}t.$if=K;function U(x,le){le>0&&we(x.charCodeAt(le))&&le--;const fe=le+ae(x,le);return[fe-K(x,fe),fe]}t.$jf=U;function Z(x){const le=new J(x);let fe=0;for(;!le.eol();)fe++,le.nextGraphemeLength();return fe}t.$kf=Z;let me;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(x){return me||(me=ve()),me.test(x)}t.$lf=ke;const Ee=/^[\t\n\r\x20-\x7E]*$/;function ge(x){return Ee.test(x)}t.$mf=ge,t.$nf=/[\u2028\u2029]/;function D(x){return t.$nf.test(x)}t.$of=D;function i(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$pf=i;function r(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$qf=r;function c(x,le,fe=""){const Ae=x.trimStart();if(Ae.length<le)return Ae;const Ne=/\b/g;let ze=0;for(;Ne.test(Ae)&&!(Ae.length-Ne.lastIndex<le);)ze=Ne.lastIndex,Ne.lastIndex+=1;return ze===0?Ae:fe+Ae.substring(ze).trimStart()}t.$rf=c;const u=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,d=/\x1b\].*?\x07/g;function F(x){return x&&(x=x.replace(u,"").replace(d,"")),x}t.$sf=F,t.$tf=String.fromCharCode(65279);function C(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$uf=C;function W(x){return C(x)?x.substr(1):x}t.$vf=W;function j(x,le){if(!x||!le||x.length<le.length)return!1;const fe=le.length,Ae=x.toLowerCase();let Ne=0,ze=-1;for(;Ne<fe;){const qe=Ae.indexOf(le[Ne],ze+1);if(qe<0)return!1;ze=qe,Ne++}return!0}t.$wf=j;function V(x,le=!1){return x?(le&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$xf=V;function G(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$yf=G;function oe(x,le=1){if(le===0)return"";let fe=-1;do fe=x.indexOf(`
`,fe+1),le--;while(le>0&&fe>=0);return fe===-1?x:(x[fe-1]==="\r"&&fe--,x.substr(0,fe))}t.$zf=oe;function se(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$Af=se;function de(x){return Ce.getInstance().getGraphemeBreakType(x)}t.$Bf=de;function De(x,le){return x===0?le!==5&&le!==7:x===2&&le===3?!1:x===4||x===2||x===3||le===4||le===2||le===3?!0:!(x===8&&(le===8||le===9||le===11||le===12)||(x===11||x===9)&&(le===9||le===10)||(x===12||x===10)&&le===10||le===5||le===13||le===7||x===1||x===13&&le===14||x===6&&le===6)}var pe;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(pe||(t.GraphemeBreakType=pe={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Fe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const fe=this.d,Ae=fe.length/3;let Ne=1;for(;Ne<=Ae;)if(le<fe[3*Ne])Ne=2*Ne;else if(le>fe[3*Ne+1])Ne=2*Ne+1;else return fe[3*Ne+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(x,le){if(x===0)return 0;const fe=Be(x,le);if(fe!==void 0)return fe;const Ae=new re(le,x);return Ae.prevCodePoint(),Ae.offset}t.$Cf=Me;function Be(x,le){const fe=new re(le,x);let Ae=fe.prevCodePoint();for(;Ie(Ae)||Ae===65039||Ae===8419;){if(fe.offset===0)return;Ae=fe.prevCodePoint()}if(!r(Ae))return;let Ne=fe.offset;return Ne>0&&fe.prevCodePoint()===8205&&(Ne=fe.offset),Ne}function Ie(x){return 127995<=x&&x<=127999}var Je;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),t.$Df="\xA0";class Ke{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$De(le=>{function fe(Ze){const nt=new Map;for(let st=0;st<Ze.length;st+=2)nt.set(Ze[st],Ze[st+1]);return nt}function Ae(Ze,nt){const st=new Map(Ze);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ne(Ze,nt){if(!Ze)return nt;const st=new Map;for(const[rt,gt]of Ze)nt.has(rt)&&st.set(rt,gt);return st}const ze=this.c.value;let qe=le.filter(Ze=>!Ze.startsWith("_")&&Ze in ze);qe.length===0&&(qe=["_default"]);let _e;for(const Ze of qe){const nt=fe(ze[Ze]);_e=Ne(_e,nt)}const et=fe(ze._common),tt=Ae(et,_e);return new Ke(tt)})}static getInstance(le){return Ke.d.get(Array.from(le))}static{this.e=new P.$V(()=>Object.keys(Ke.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Ef=Ke;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(le){return xe.e().has(le)}static get codePoints(){return xe.e()}}t.$Ff=xe}),define(be[34],$e([1,0,32,80,10]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7j=t.$6j=t.$5j=t.$4j=t.FuzzyScore=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.or=void 0;function z(...j){return function(V,G){for(let oe=0,se=j.length;oe<se;oe++){const de=j[oe](V,G);if(de)return de}return null}}t.or=z,t.$Rj=E.bind(void 0,!1),t.$Sj=E.bind(void 0,!0);function E(j,V,G){if(!G||G.length<V.length)return null;let oe;return j?oe=n.$$e(G,V):oe=G.indexOf(V)===0,oe?V.length>0?[{start:0,end:V.length}]:[]:null}function k(j,V){const G=V.toLowerCase().indexOf(j.toLowerCase());return G===-1?null:[{start:G,end:G+j.length}]}t.$Tj=k;function b(j,V){return v(j.toLowerCase(),V.toLowerCase(),0,0)}t.$Uj=b;function v(j,V,G,oe){if(G===j.length)return[];if(oe===V.length)return null;if(j[G]===V[oe]){let se=null;return(se=v(j,V,G+1,oe+1))?f({start:oe,end:oe+1},se):null}return v(j,V,G,oe+1)}function y(j){return 97<=j&&j<=122}function L(j){return 65<=j&&j<=90}t.$Vj=L;function o(j){return 48<=j&&j<=57}function l(j){return j===32||j===9||j===10||j===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>e.add(j.charCodeAt(0)));function s(j){return l(j)||e.has(j)}function m(j,V){return j===V||s(j)&&s(V)}const $=new Map;function a(j){if($.has(j))return $.get(j);let V;const G=(0,P.$Pj)(j);return G&&(V=G),$.set(j,V),V}function p(j){return y(j)||L(j)||o(j)}function f(j,V){return V.length===0?V=[j]:j.end===V[0].start?V[0].start=j.start:V.unshift(j),V}function g(j,V){for(let G=V;G<j.length;G++){const oe=j.charCodeAt(G);if(L(oe)||o(oe)||G>0&&!p(j.charCodeAt(G-1)))return G}return j.length}function h(j,V,G,oe){if(G===j.length)return[];if(oe===V.length)return null;if(j[G]!==V[oe].toLowerCase())return null;{let se=null,de=oe+1;for(se=h(j,V,G+1,oe+1);!se&&(de=g(V,de))<V.length;)se=h(j,V,G+1,de),de++;return se===null?null:f({start:oe,end:oe+1},se)}}function T(j){let V=0,G=0,oe=0,se=0,de=0;for(let Me=0;Me<j.length;Me++)de=j.charCodeAt(Me),L(de)&&V++,y(de)&&G++,p(de)&&oe++,o(de)&&se++;const De=V/j.length,pe=G/j.length,Ce=oe/j.length,Fe=se/j.length;return{upperPercent:De,lowerPercent:pe,alphaPercent:Ce,numericPercent:Fe}}function O(j){const{upperPercent:V,lowerPercent:G}=j;return G===0&&V>.6}function R(j){const{upperPercent:V,lowerPercent:G,alphaPercent:oe,numericPercent:se}=j;return G>.2&&V<.8&&oe>.6&&se<.2}function w(j){let V=0,G=0,oe=0,se=0;for(let de=0;de<j.length;de++)oe=j.charCodeAt(de),L(oe)&&V++,y(oe)&&G++,l(oe)&&se++;return(V===0||G===0)&&se===0?j.length<=30:V<=5}function S(j,V){if(!V||(V=V.trim(),V.length===0)||!w(j)||V.length>60)return null;const G=T(V);if(!R(G)){if(!O(G))return null;V=V.toLowerCase()}let oe=null,se=0;for(j=j.toLowerCase();se<V.length&&(oe=h(j,V,0,se))===null;)se=g(V,se+1);return oe}t.$Wj=S;function M(j,V,G=!1){if(!V||V.length===0)return null;let oe=null,se=0;for(j=j.toLowerCase(),V=V.toLowerCase();se<V.length&&(oe=H(j,V,0,se,G),oe===null);)se=_(V,se+1);return oe}t.$Xj=M;function H(j,V,G,oe,se){let de=0;if(G===j.length)return[];if(oe===V.length)return null;if(!m(j.charCodeAt(G),V.charCodeAt(oe))){const Ce=a(j.charCodeAt(G));if(!Ce)return null;for(let Fe=0;Fe<Ce.length;Fe++)if(!m(Ce[Fe],V.charCodeAt(oe+Fe)))return null;de+=Ce.length-1}let De=null,pe=oe+de+1;if(De=H(j,V,G+1,pe,se),!se)for(;!De&&(pe=_(V,pe))<V.length;)De=H(j,V,G+1,pe,se),pe++;if(!De)return null;if(j.charCodeAt(G)!==V.charCodeAt(oe)){const Ce=a(j.charCodeAt(G));if(!Ce)return De;for(let Fe=0;Fe<Ce.length;Fe++)if(Ce[Fe]!==V.charCodeAt(oe+Fe))return De}return f({start:oe,end:oe+de+1},De)}function _(j,V){for(let G=V;G<j.length;G++)if(s(j.charCodeAt(G))||G>0&&s(j.charCodeAt(G-1)))return G;return j.length}const N=z(t.$Sj,S,k),I=z(t.$Sj,S,b),B=new A.$Dc(1e4);function X(j,V,G=!1){if(typeof j!="string"||typeof V!="string")return null;let oe=B.get(j);oe||(oe=new RegExp(n.$Te(j),"i"),B.set(j,oe));const se=oe.exec(V);return se?[{start:se.index,end:se.index+se[0].length}]:G?I(j,V):N(j,V)}t.$Yj=X;function Y(j,V){const G=r(j,j.toLowerCase(),0,V,V.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?ne(G):null}t.$Zj=Y;function ue(j,V,G,oe,se,de){const De=Math.min(13,j.length);for(;G<De;G++){const pe=r(j,V,G,oe,se,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,de]}t.$1j=ue;function ne(j){if(typeof j>"u")return[];const V=[],G=j[1];for(let oe=j.length-1;oe>1;oe--){const se=j[oe]+G,de=V[V.length-1];de&&de.end===se?de.end=se+1:V.push({start:se,end:se+1})}return V}t.$2j=ne;const te=128;function we(){const j=[],V=[];for(let G=0;G<=te;G++)V[G]=0;for(let G=0;G<=te;G++)j.push(V.slice(0));return j}function Re(j){const V=[];for(let G=0;G<=j;G++)V[G]=0;return V}const Te=Re(2*te),Oe=Re(2*te),re=we(),J=we(),ae=we(),K=!1;function U(j,V,G,oe,se){function de(pe,Ce,Fe=" "){for(;pe.length<Ce;)pe=Fe+pe;return pe}let De=` |   |${oe.split("").map(pe=>de(pe,3)).join("|")}
`;for(let pe=0;pe<=G;pe++)pe===0?De+=" |":De+=`${V[pe-1]}|`,De+=j[pe].slice(0,se+1).map(Ce=>de(Ce.toString(),3)).join("|")+`
`;return De}function Z(j,V,G,oe){j=j.substr(V),G=G.substr(oe),console.log(U(J,j,j.length,G,G.length)),console.log(U(ae,j,j.length,G,G.length)),console.log(U(re,j,j.length,G,G.length))}function me(j,V){if(V<0||V>=j.length)return!1;const G=j.codePointAt(V);switch(G){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$qf(G)}}function ve(j,V){if(V<0||V>=j.length)return!1;switch(j.charCodeAt(V)){case 32:case 9:return!0;default:return!1}}function ke(j,V,G){return V[j]!==G[j]}function Ee(j,V,G,oe,se,de,De=!1){for(;V<G&&se<de;)j[V]===oe[se]&&(De&&(Te[V]=se),V+=1),se+=1;return V===G}t.$3j=Ee;var ge;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var D;(function(j){j.Default=[-100,0];function V(G){return!G||G.length===2&&G[0]===-100&&G[1]===0}j.isDefault=V})(D||(t.FuzzyScore=D={}));class i{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(V,G){this.firstMatchCanBeWeak=V,this.boostFullMatch=G}}t.$4j=i;function r(j,V,G,oe,se,de,De=i.default){const pe=j.length>te?te:j.length,Ce=oe.length>te?te:oe.length;if(G>=pe||de>=Ce||pe-G>Ce-de||!Ee(V,G,pe,se,de,Ce,!0))return;c(pe,Ce,G,de,V,se);let Fe=1,Me=1,Be=G,Ie=de;const Je=[!1];for(Fe=1,Be=G;Be<pe;Fe++,Be++){const fe=Te[Be],Ae=Oe[Be],Ne=Be+1<pe?Oe[Be+1]:Ce;for(Me=fe-de+1,Ie=fe;Ie<Ne;Me++,Ie++){let ze=Number.MIN_SAFE_INTEGER,qe=!1;Ie<=Ae&&(ze=u(j,V,Be,G,oe,se,Ie,Ce,de,re[Fe-1][Me-1]===0,Je));let _e=0;ze!==Number.MAX_SAFE_INTEGER&&(qe=!0,_e=ze+J[Fe-1][Me-1]);const et=Ie>fe,tt=et?J[Fe][Me-1]+(re[Fe][Me-1]>0?-5:0):0,Ze=Ie>fe+1&&re[Fe][Me-1]>0,nt=Ze?J[Fe][Me-2]+(re[Fe][Me-2]>0?-5:0):0;if(Ze&&(!et||nt>=tt)&&(!qe||nt>=_e))J[Fe][Me]=nt,ae[Fe][Me]=3,re[Fe][Me]=0;else if(et&&(!qe||tt>=_e))J[Fe][Me]=tt,ae[Fe][Me]=2,re[Fe][Me]=0;else if(qe)J[Fe][Me]=_e,ae[Fe][Me]=1,re[Fe][Me]=re[Fe-1][Me-1]+1;else throw new Error("not possible")}}if(K&&Z(j,G,oe,de),!Je[0]&&!De.firstMatchCanBeWeak)return;Fe--,Me--;const Ke=[J[Fe][Me],de];let xe=0,x=0;for(;Fe>=1;){let fe=Me;do{const Ae=ae[Fe][fe];if(Ae===3)fe=fe-2;else if(Ae===2)fe=fe-1;else break}while(fe>=1);xe>1&&V[G+Fe-1]===se[de+Me-1]&&!ke(fe+de-1,oe,se)&&xe+1>re[Fe][fe]&&(fe=Me),fe===Me?xe++:xe=1,x||(x=fe),Fe--,Me=fe-1,Ke.push(Me)}Ce===pe&&De.boostFullMatch&&(Ke[0]+=2);const le=x-pe;return Ke[0]-=le,Ke}t.$5j=r;function c(j,V,G,oe,se,de){let De=j-1,pe=V-1;for(;De>=G&&pe>=oe;)se[De]===de[pe]&&(Oe[De]=pe,De--),pe--}function u(j,V,G,oe,se,de,De,pe,Ce,Fe,Me){if(V[G]!==de[De])return Number.MIN_SAFE_INTEGER;let Be=1,Ie=!1;return De===G-oe?Be=j[G]===se[De]?7:5:ke(De,se,de)&&(De===0||!ke(De-1,se,de))?(Be=j[G]===se[De]?7:5,Ie=!0):me(de,De)&&(De===0||!me(de,De-1))?Be=5:(me(de,De-1)||ve(de,De-1))&&(Be=5,Ie=!0),Be>1&&G===oe&&(Me[0]=!0),Ie||(Ie=ke(De,se,de)||me(de,De-1)||ve(de,De-1)),G===oe?De>Ce&&(Be-=Ie?3:5):Fe?Be+=Ie?2:0:Be+=Ie?0:1,De+1===pe&&(Be-=Ie?3:5),Be}function d(j,V,G,oe,se,de,De){return C(j,V,G,oe,se,de,!0,De)}t.$6j=d;function F(j,V,G,oe,se,de,De){return C(j,V,G,oe,se,de,!1,De)}t.$7j=F;function C(j,V,G,oe,se,de,De,pe){let Ce=r(j,V,G,oe,se,de,pe);if(Ce&&!De)return Ce;if(j.length>=3){const Fe=Math.min(7,j.length-1);for(let Me=G+1;Me<Fe;Me++){const Be=W(j,Me);if(Be){const Ie=r(Be,Be.toLowerCase(),G,oe,se,de,pe);Ie&&(Ie[0]-=3,(!Ce||Ie[0]>Ce[0])&&(Ce=Ie))}}}return Ce}function W(j,V){if(V+1>=j.length)return;const G=j[V],oe=j[V+1];if(G!==oe)return j.slice(0,V)+oe+G+j.slice(V+2)}}),define(be[49],$e([1,0,10]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xi=t.$Wi=t.$Vi=t.$Ui=t.$Ti=t.$Si=t.$Ri=void 0;function P($){return n($,0)}t.$Ri=P;function n($,a){switch(typeof $){case"object":return $===null?z(349,a):Array.isArray($)?b($,a):v($,a);case"string":return k($,a);case"boolean":return E($,a);case"number":return z($,a);case"undefined":return z(937,a);default:return z(617,a)}}t.$Si=n;function z($,a){return(a<<5)-a+$|0}t.$Ti=z;function E($,a){return z($?433:863,a)}function k($,a){a=z(149417,a);for(let p=0,f=$.length;p<f;p++)a=z($.charCodeAt(p),a);return a}t.$Ui=k;function b($,a){return a=z(104579,a),$.reduce((p,f)=>n(f,p),a)}function v($,a){return a=z(181387,a),Object.keys($).sort().reduce((p,f)=>(p=k(f,p),n($[f],p)),a)}class y{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=n(a,this.g),this.g}}t.$Vi=y;var L;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function o($,a,p=32){const f=p-a,g=~((1<<f)-1);return($<<a|(g&$)>>>f)>>>0}function l($,a=0,p=$.byteLength,f=0){for(let g=0;g<p;g++)$[a+g]=f}function e($,a,p="0"){for(;$.length<a;)$=p+$;return $}function s($,a=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(p=>p.toString(16).padStart(2,"0")).join(""):e(($>>>0).toString(16),a/4)}t.$Wi=s;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const p=a.length;if(p===0)return;const f=this.p;let g=this.r,h=this.u,T,O;for(h!==0?(T=h,O=-1,h=0):(T=a.charCodeAt(0),O=0);;){let R=T;if(A.$bf(T))if(O+1<p){const w=a.charCodeAt(O+1);A.$cf(w)?(O++,R=A.$df(T,w)):R=65533}else{h=T;break}else A.$cf(T)&&(R=65533);if(g=this.w(f,g,R),O++,O<p)T=a.charCodeAt(O);else break}this.r=g,this.u=h}w(a,p,f){return f<128?a[p++]=f:f<2048?(a[p++]=192|(f&1984)>>>6,a[p++]=128|(f&63)>>>0):f<65536?(a[p++]=224|(f&61440)>>>12,a[p++]=128|(f&4032)>>>6,a[p++]=128|(f&63)>>>0):(a[p++]=240|(f&1835008)>>>18,a[p++]=128|(f&258048)>>>12,a[p++]=128|(f&4032)>>>6,a[p++]=128|(f&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=m.g,p=this.q;for(let M=0;M<64;M+=4)a.setUint32(M,p.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)a.setUint32(M,o(a.getUint32(M-12,!1)^a.getUint32(M-32,!1)^a.getUint32(M-56,!1)^a.getUint32(M-64,!1),1),!1);let f=this.h,g=this.l,h=this.m,T=this.n,O=this.o,R,w,S;for(let M=0;M<80;M++)M<20?(R=g&h|~g&T,w=1518500249):M<40?(R=g^h^T,w=1859775393):M<60?(R=g&h|g&T|h&T,w=2400959708):(R=g^h^T,w=3395469782),S=o(f,5)+R+O+w+a.getUint32(M*4,!1)&4294967295,O=T,T=h,h=o(g,30),g=f,f=S;this.h=this.h+f&4294967295,this.l=this.l+g&4294967295,this.m=this.m+h&4294967295,this.n=this.n+T&4294967295,this.o=this.o+O&4294967295}}t.$Xi=m}),define(be[87],$e([1,0,75,49]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=t.$Ps=t.$Os=void 0;class n{constructor(o){this.a=o}getElements(){const o=this.a,l=new Int32Array(o.length);for(let e=0,s=o.length;e<s;e++)l[e]=o.charCodeAt(e);return l}}t.$Os=n;function z(L,o,l){return new y(new n(L),new n(o)).ComputeDiff(l).changes}t.$Ps=z;class E{static Assert(o,l){if(!o)throw new Error(l)}}class k{static Copy(o,l,e,s,m){for(let $=0;$<m;$++)e[s+$]=o[l+$]}static Copy2(o,l,e,s,m){for(let $=0;$<m;$++)e[s+$]=o[l+$]}}var b;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class v{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.$Ns(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,l){this.b=Math.min(this.b,o),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(o,l){this.b=Math.min(this.b,o),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(o,l,e=null){this.a=e,this.b=o,this.c=l;const[s,m,$]=y.o(o),[a,p,f]=y.o(l);this.d=$&&f,this.e=s,this.f=m,this.g=a,this.h=p,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const l=o.getElements();if(y.n(l)){const e=new Int32Array(l.length);for(let s=0,m=l.length;s<m;s++)e[s]=(0,P.$Ui)(l[s],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(o,l){return this.f[o]!==this.h[l]?!1:this.d?this.e[o]===this.g[l]:!0}q(o,l){if(!this.p(o,l))return!1;const e=y.r(this.b,o),s=y.r(this.c,l);return e===s}static r(o,l){return typeof o.getStrictElement=="function"?o.getStrictElement(l):null}s(o,l){return this.f[o]!==this.f[l]?!1:this.d?this.e[o]===this.e[l]:!0}u(o,l){return this.h[o]!==this.h[l]?!1:this.d?this.g[o]===this.g[l]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,l,e,s,m){const $=[!1];let a=this.w(o,l,e,s,$);return m&&(a=this.z(a)),{quitEarly:$[0],changes:a}}w(o,l,e,s,m){for(m[0]=!1;o<=l&&e<=s&&this.p(o,e);)o++,e++;for(;l>=o&&s>=e&&this.p(l,s);)l--,s--;if(o>l||e>s){let h;return e<=s?(E.Assert(o===l+1,"originalStart should only be one more than originalEnd"),h=[new A.$Ns(o,0,e,s-e+1)]):o<=l?(E.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),h=[new A.$Ns(o,l-o+1,e,0)]):(E.Assert(o===l+1,"originalStart should only be one more than originalEnd"),E.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const $=[0],a=[0],p=this.y(o,l,e,s,$,a,m),f=$[0],g=a[0];if(p!==null)return p;if(!m[0]){const h=this.w(o,f,e,g,m);let T=[];return m[0]?T=[new A.$Ns(f+1,l-(f+1)+1,g+1,s-(g+1)+1)]:T=this.w(f+1,l,g+1,s,m),this.H(h,T)}return[new A.$Ns(o,l-o+1,e,s-e+1)]}x(o,l,e,s,m,$,a,p,f,g,h,T,O,R,w,S,M,H){let _=null,N=null,I=new v,B=l,X=e,Y=O[0]-S[0]-s,ue=-1073741824,ne=this.k.length-1;do{const te=Y+o;te===B||te<X&&f[te-1]<f[te+1]?(h=f[te+1],R=h-Y-s,h<ue&&I.MarkNextChange(),ue=h,I.AddModifiedElement(h+1,R),Y=te+1-o):(h=f[te-1]+1,R=h-Y-s,h<ue&&I.MarkNextChange(),ue=h-1,I.AddOriginalElement(h,R+1),Y=te-1-o),ne>=0&&(f=this.k[ne],o=f[0],B=1,X=f.length-1)}while(--ne>=-1);if(_=I.getReverseChanges(),H[0]){let te=O[0]+1,we=S[0]+1;if(_!==null&&_.length>0){const Re=_[_.length-1];te=Math.max(te,Re.getOriginalEnd()),we=Math.max(we,Re.getModifiedEnd())}N=[new A.$Ns(te,T-te+1,we,w-we+1)]}else{I=new v,B=$,X=a,Y=O[0]-S[0]-p,ue=1073741824,ne=M?this.m.length-1:this.m.length-2;do{const te=Y+m;te===B||te<X&&g[te-1]>=g[te+1]?(h=g[te+1]-1,R=h-Y-p,h>ue&&I.MarkNextChange(),ue=h+1,I.AddOriginalElement(h+1,R+1),Y=te+1-m):(h=g[te-1],R=h-Y-p,h>ue&&I.MarkNextChange(),ue=h,I.AddModifiedElement(h+1,R+1),Y=te-1-m),ne>=0&&(g=this.m[ne],m=g[0],B=1,X=g.length-1)}while(--ne>=-1);N=I.getChanges()}return this.H(_,N)}y(o,l,e,s,m,$,a){let p=0,f=0,g=0,h=0,T=0,O=0;o--,e--,m[0]=0,$[0]=0,this.k=[],this.m=[];const R=l-o+(s-e),w=R+1,S=new Int32Array(w),M=new Int32Array(w),H=s-e,_=l-o,N=o-e,I=l-s,X=(_-H)%2===0;S[H]=o,M[_]=l,a[0]=!1;for(let Y=1;Y<=R/2+1;Y++){let ue=0,ne=0;g=this.J(H-Y,Y,H,w),h=this.J(H+Y,Y,H,w);for(let we=g;we<=h;we+=2){we===g||we<h&&S[we-1]<S[we+1]?p=S[we+1]:p=S[we-1]+1,f=p-(we-H)-N;const Re=p;for(;p<l&&f<s&&this.p(p+1,f+1);)p++,f++;if(S[we]=p,p+f>ue+ne&&(ue=p,ne=f),!X&&Math.abs(we-_)<=Y-1&&p>=M[we])return m[0]=p,$[0]=f,Re<=M[we]&&1447>0&&Y<=1447+1?this.x(H,g,h,N,_,T,O,I,S,M,p,l,m,f,s,$,X,a):null}const te=(ue-o+(ne-e)-Y)/2;if(this.a!==null&&!this.a(ue,te))return a[0]=!0,m[0]=ue,$[0]=ne,te>0&&1447>0&&Y<=1447+1?this.x(H,g,h,N,_,T,O,I,S,M,p,l,m,f,s,$,X,a):(o++,e++,[new A.$Ns(o,l-o+1,e,s-e+1)]);T=this.J(_-Y,Y,_,w),O=this.J(_+Y,Y,_,w);for(let we=T;we<=O;we+=2){we===T||we<O&&M[we-1]>=M[we+1]?p=M[we+1]-1:p=M[we-1],f=p-(we-_)-I;const Re=p;for(;p>o&&f>e&&this.p(p,f);)p--,f--;if(M[we]=p,X&&Math.abs(we-H)<=Y&&p<=S[we])return m[0]=p,$[0]=f,Re>=S[we]&&1447>0&&Y<=1447+1?this.x(H,g,h,N,_,T,O,I,S,M,p,l,m,f,s,$,X,a):null}if(Y<=1447){let we=new Int32Array(h-g+2);we[0]=H-g+1,k.Copy2(S,g,we,1,h-g+1),this.k.push(we),we=new Int32Array(O-T+2),we[0]=_-T+1,k.Copy2(M,T,we,1,O-T+1),this.m.push(we)}}return this.x(H,g,h,N,_,T,O,I,S,M,p,l,m,f,s,$,X,a)}z(o){for(let l=0;l<o.length;l++){const e=o[l],s=l<o.length-1?o[l+1].originalStart:this.f.length,m=l<o.length-1?o[l+1].modifiedStart:this.h.length,$=e.originalLength>0,a=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<m&&(!$||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!a||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const f=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!f)break;e.originalStart++,e.modifiedStart++}const p=[null];if(l<o.length-1&&this.I(o[l],o[l+1],p)){o[l]=p[0],o.splice(l+1,1),l--;continue}}for(let l=o.length-1;l>=0;l--){const e=o[l];let s=0,m=0;if(l>0){const h=o[l-1];s=h.originalStart+h.originalLength,m=h.modifiedStart+h.modifiedLength}const $=e.originalLength>0,a=e.modifiedLength>0;let p=0,f=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let h=1;;h++){const T=e.originalStart-h,O=e.modifiedStart-h;if(T<s||O<m||$&&!this.s(T,T+e.originalLength)||a&&!this.u(O,O+e.modifiedLength))break;const w=(T===s&&O===m?5:0)+this.G(T,e.originalLength,O,e.modifiedLength);w>f&&(f=w,p=h)}e.originalStart-=p,e.modifiedStart-=p;const g=[null];if(l>0&&this.I(o[l-1],o[l],g)){o[l-1]=g[0],o.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=o.length;l<e;l++){const s=o[l-1],m=o[l],$=m.originalStart-s.originalStart-s.originalLength,a=s.originalStart,p=m.originalStart+m.originalLength,f=p-a,g=s.modifiedStart,h=m.modifiedStart+m.modifiedLength,T=h-g;if($<5&&f<20&&T<20){const O=this.A(a,f,g,T,$);if(O){const[R,w]=O;(R!==s.originalStart+s.originalLength||w!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=R-s.originalStart,s.modifiedLength=w-s.modifiedStart,m.originalStart=R+$,m.modifiedStart=w+$,m.originalLength=p-m.originalStart,m.modifiedLength=h-m.modifiedStart)}}}return o}A(o,l,e,s,m){if(l<m||s<m)return null;const $=o+l-m+1,a=e+s-m+1;let p=0,f=0,g=0;for(let h=o;h<$;h++)for(let T=e;T<a;T++){const O=this.B(h,T,m);O>0&&O>p&&(p=O,f=h,g=T)}return p>0?[f,g]:null}B(o,l,e){let s=0;for(let m=0;m<e;m++){if(!this.p(o+m,l+m))return 0;s+=this.e[o+m].length}return s}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,l){if(this.C(o)||this.C(o-1))return!0;if(l>0){const e=o+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,l){if(this.E(o)||this.E(o-1))return!0;if(l>0){const e=o+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,l,e,s){const m=this.D(o,l)?1:0,$=this.F(e,s)?1:0;return m+$}H(o,l){const e=[];if(o.length===0||l.length===0)return l.length>0?l:o;if(this.I(o[o.length-1],l[0],e)){const s=new Array(o.length+l.length-1);return k.Copy(o,0,s,0,o.length-1),s[o.length-1]=e[0],k.Copy(l,1,s,o.length,l.length-1),s}else{const s=new Array(o.length+l.length);return k.Copy(o,0,s,0,o.length),k.Copy(l,0,s,o.length,l.length),s}}I(o,l,e){if(E.Assert(o.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),E.Assert(o.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=l.originalStart||o.modifiedStart+o.modifiedLength>=l.modifiedStart){const s=o.originalStart;let m=o.originalLength;const $=o.modifiedStart;let a=o.modifiedLength;return o.originalStart+o.originalLength>=l.originalStart&&(m=l.originalStart+l.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=l.modifiedStart&&(a=l.modifiedStart+l.modifiedLength-o.modifiedStart),e[0]=new A.$Ns(s,m,$,a),!0}else return e[0]=null,!1}J(o,l,e,s){if(o>=0&&o<s)return o;const m=e,$=s-e-1,a=l%2===0;if(o<0){const p=m%2===0;return a===p?0:1}else{const p=$%2===0;return a===p?s-1:s-2}}}t.$Qs=y}),define(be[50],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qd=void 0,t.$Qd=Symbol("MicrotaskDelay")}),define(be[88],$e([1,0,12,10]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=t.$9h=t.$8h=t.$7h=t.$6h=void 0;class n{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$6h=n;class z{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,P.$4e)(l,this.b,0,l.length,this.c,this.d):(0,P.$6e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$7h=z;class E{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,P.$4e)(l,this.b,0,l.length,this.d,this.e):(0,P.$6e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$8h=E;var k;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,P.$5e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,P.$5e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,P.$3e)(l,this.c.query);if(this.d[this.e]===5)return(0,P.$3e)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$9h=b;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(y||(y={}));class L{static forUris(l=()=>!1,e=()=>!1){return new L(new b(l,e))}static forPaths(l=!1){return new L(new E(void 0,!l))}static forStrings(){return new L(new n)}static forConfigKeys(){return new L(new z)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const s=e.slice(0);(0,A.$Xb)(s);for(const m of s)this.set(m,l)}else{const s=l.slice(0);(0,A.$Xb)(s);for(const m of s)this.set(m[0],m[1])}}set(l,e){const s=this.b.reset(l);let m;this.c||(this.c=new v,this.c.segment=s.value());const $=[];for(m=this.c;;){const p=s.cmp(m.segment);if(p>0)m.left||(m.left=new v,m.left.segment=s.value()),$.push([-1,m]),m=m.left;else if(p<0)m.right||(m.right=new v,m.right.segment=s.value()),$.push([1,m]),m=m.right;else if(s.hasNext())s.next(),m.mid||(m.mid=new v,m.mid.segment=s.value()),$.push([0,m]),m=m.mid;else break}const a=m.value;m.value=e,m.key=l;for(let p=$.length-1;p>=0;p--){const f=$[p][1];f.updateHeight();const g=f.balanceFactor();if(g<-1||g>1){const h=$[p][0],T=$[p+1][0];if(h===1&&T===1)$[p][1]=f.rotateLeft();else if(h===-1&&T===-1)$[p][1]=f.rotateRight();else if(h===1&&T===-1)f.right=$[p+1][1]=$[p+1][1].rotateRight(),$[p][1]=f.rotateLeft();else if(h===-1&&T===1)f.left=$[p+1][1]=$[p+1][1].rotateLeft(),$[p][1]=f.rotateRight();else throw new Error;if(p>0)switch($[p-1][0]){case-1:$[p-1][1].left=$[p][1];break;case 1:$[p-1][1].right=$[p][1];break;case 0:$[p-1][1].mid=$[p][1];break}else this.c=$[0][1]}}return a}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let s=this.c;for(;s;){const m=e.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const s=this.b.reset(l),m=[];let $=this.c;for(;$;){const a=s.cmp($.segment);if(a>0)m.push([-1,$]),$=$.left;else if(a<0)m.push([1,$]),$=$.right;else if(s.hasNext())s.next(),m.push([0,$]),$=$.mid;else break}if($){if(e?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const a=this.f($.right);if(a.key){const{key:p,value:f,segment:g}=a;this.e(a.key,!1),$.key=p,$.value=f,$.segment=g}}else{const a=$.left??$.right;if(m.length>0){const[p,f]=m[m.length-1];switch(p){case-1:f.left=a;break;case 0:f.mid=a;break;case 1:f.right=a;break}}else this.c=a}for(let a=m.length-1;a>=0;a--){const p=m[a][1];p.updateHeight();const f=p.balanceFactor();if(f>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),m[a][1]=p.rotateLeft()):f<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),m[a][1]=p.rotateRight()),a>0)switch(m[a-1][0]){case-1:m[a-1][1].left=m[a][1];break;case 1:m[a-1][1].right=m[a][1];break;case 0:m[a-1][1].mid=m[a][1];break}else this.c=m[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let s=this.c,m;for(;s;){const $=e.cmp(s.segment);if($>0)s=s.left;else if($<0)s=s.right;else if(e.hasNext())e.next(),m=s.value||m,s=s.mid;else break}return s&&s.value||m}findSuperstr(l){return this.g(l,!1)}g(l,e){const s=this.b.reset(l);let m=this.c;for(;m;){const $=s.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(s.hasNext())s.next(),m=m.mid;else return m.mid?this.h(m.mid):e?m.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,s]of this)l(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.$0h=L}),define(be[7],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=void 0;function A(g){return typeof g=="string"}t.$Gf=A;function P(g){return Array.isArray(g)&&g.every(h=>A(h))}t.$Hf=P;function n(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}t.$If=n;function z(g){const h=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof h}t.$Jf=z;function E(g){return typeof g=="number"&&!isNaN(g)}t.$Kf=E;function k(g){return!!g&&typeof g[Symbol.iterator]=="function"}t.$Lf=k;function b(g){return g===!0||g===!1}t.$Mf=b;function v(g){return typeof g>"u"}t.$Nf=v;function y(g){return!L(g)}t.$Of=y;function L(g){return v(g)||g===null}t.$Pf=L;function o(g,h){if(!g)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}t.$Qf=o;function l(g){if(L(g))throw new Error("Assertion Failed: argument is undefined or null");return g}t.$Rf=l;function e(...g){const h=[];for(let T=0;T<g.length;T++){const O=g[T];if(L(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);h.push(O)}return h}t.$Sf=e;const s=Object.prototype.hasOwnProperty;function m(g){if(!n(g))return!1;for(const h in g)if(s.call(g,h))return!1;return!0}t.$Tf=m;function $(g){return typeof g=="function"}t.$Uf=$;function a(...g){return g.length>0&&g.every($)}t.$Vf=a;function p(g,h){const T=Math.min(g.length,h.length);for(let O=0;O<T;O++)f(g[O],h[O])}t.$Wf=p;function f(g,h){if(A(h)){if(typeof g!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if($(h)){try{if(g instanceof h)return}catch{}if(!L(g)&&g.constructor===h||h.length===1&&h.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Xf=f}),define(be[17],$e([1,0,7]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0j=t.$9j=t.$8j=void 0;const P=Object.create(null);function n(k,b){if((0,A.$Gf)(b)){const v=P[b];if(v===void 0)throw new Error(`${k} references an unknown codicon: ${b}`);b=v}return P[k]=b,{id:k}}function z(){return P}t.$8j=z;function E(){return Object.values(t.$0j)}t.$9j=E,t.$0j={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(be[51],$e([1,0,7]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vn=t.$un=t.$tn=t.$sn=t.$rn=t.$qn=t.$pn=t.$on=t.$nn=t.$mn=t.$ln=t.$kn=void 0;function P($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const a=Array.isArray($)?[]:{};return Object.entries($).forEach(([p,f])=>{a[p]=f&&typeof f=="object"?P(f):f}),a}t.$kn=P;function n($){if(!$||typeof $!="object")return $;const a=[$];for(;a.length>0;){const p=a.shift();Object.freeze(p);for(const f in p)if(z.call(p,f)){const g=p[f];typeof g=="object"&&!Object.isFrozen(g)&&!(0,A.$Jf)(g)&&a.push(g)}}return $}t.$ln=n;const z=Object.prototype.hasOwnProperty;function E($,a){return k($,a,new Set)}t.$mn=E;function k($,a,p){if((0,A.$Pf)($))return $;const f=a($);if(typeof f<"u")return f;if(Array.isArray($)){const g=[];for(const h of $)g.push(k(h,a,p));return g}if((0,A.$If)($)){if(p.has($))throw new Error("Cannot clone recursive data-structure");p.add($);const g={};for(const h in $)z.call($,h)&&(g[h]=k($[h],a,p));return p.delete($),g}return $}function b($,a,p=!0){return(0,A.$If)($)?((0,A.$If)(a)&&Object.keys(a).forEach(f=>{f in $?p&&((0,A.$If)($[f])&&(0,A.$If)(a[f])?b($[f],a[f],p):$[f]=a[f]):$[f]=a[f]}),$):a}t.$nn=b;function v($,a){if($===a)return!0;if($==null||a===null||a===void 0||typeof $!=typeof a||typeof $!="object"||Array.isArray($)!==Array.isArray(a))return!1;let p,f;if(Array.isArray($)){if($.length!==a.length)return!1;for(p=0;p<$.length;p++)if(!v($[p],a[p]))return!1}else{const g=[];for(f in $)g.push(f);g.sort();const h=[];for(f in a)h.push(f);if(h.sort(),!v(g,h))return!1;for(p=0;p<g.length;p++)if(!v($[g[p]],a[g[p]]))return!1}return!0}t.$on=v;function y($){const a=new Set;return JSON.stringify($,(p,f)=>{if((0,A.$If)(f)||Array.isArray(f)){if(a.has(f))return"[Circular]";a.add(f)}return f})}t.$pn=y;function L($,a){const p=Object.create(null);return!$||!a||Object.keys(a).forEach(g=>{const h=$[g],T=a[g];v(h,T)||(p[g]=T)}),p}t.$qn=L;function o($,a){const p=a.toLowerCase(),f=Object.keys($).find(g=>g.toLowerCase()===p);return f?$[f]:$[a]}t.$rn=o;function l($,a){const p=Object.create(null);for(const[f,g]of Object.entries($))a(f,g)&&(p[f]=g);return p}t.$sn=l;function e($){let a=[];for(;Object.prototype!==$;)a=a.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return a}t.$tn=e;function s($){const a=[];for(const p of e($))typeof $[p]=="function"&&a.push(p);return a}t.$un=s;function m($,a){const p=g=>function(){const h=Array.prototype.slice.call(arguments,0);return a(g,h)},f={};for(const g of $)f[g]=p(g);return f}t.$vn=m}),define(be[18],$e([1,0,17]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$$j=t.ThemeColor=void 0;var P;(function(E){function k(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=k})(P||(t.ThemeColor=P={}));function n(E){return{id:E}}t.$$j=n;var z;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function b(a){const p=k.exec(a.id);if(!p)return b(A.$0j.error);const[,f,g]=p,h=["codicon","codicon-"+f];return g&&h.push("codicon-modifier-"+g.substring(1)),h}E.asClassNameArray=b;function v(a){return b(a).join(" ")}E.asClassName=v;function y(a){return"."+b(a).join(".")}E.asCSSSelector=y;function L(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||P.isThemeColor(a.color))}E.isThemeIcon=L;const o=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function l(a){const p=o.exec(a);if(!p)return;const[,f]=p;return{id:f}}E.fromString=l;function e(a){return{id:a}}E.fromId=e;function s(a,p){let f=a.id;const g=f.lastIndexOf("~");return g!==-1&&(f=f.substring(0,g)),p&&(f=`${f}~${p}`),{id:f}}E.modify=s;function m(a){const p=a.id.lastIndexOf("~");if(p!==-1)return a.id.substring(p+1)}E.getModifier=m;function $(a,p){return a.id===p.id&&a.color?.id===p.color?.id}E.isEqual=$})(z||(t.ThemeIcon=z={}))}),define(be[35],$e([1,0,34,10,18]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=void 0;const z="$(",E=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function b($){return $.replace(k,(a,p)=>p?a:`\\${a}`)}t.$_j=b;const v=new RegExp(`\\\\${E.source}`,"g");function y($){return $.replace(v,a=>`\\${a}`)}t.$ak=y;const L=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function o($){return $.indexOf(z)===-1?$:$.replace(L,(a,p,f,g)=>f?a:p||g||"")}t.$bk=o;function l($){return $?$.replace(/\$\((.*?)\)/g,(a,p)=>` ${p} `).trim():""}t.$ck=l;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s($){e.lastIndex=0;let a="";const p=[];let f=0;for(;;){const g=e.lastIndex,h=e.exec($),T=$.substring(g,h?.index);if(T.length>0){a+=T;for(let O=0;O<T.length;O++)p.push(f)}if(!h)break;f+=h[0].length}return{text:a,iconOffsets:p}}t.$dk=s;function m($,a,p=!1){const{text:f,iconOffsets:g}=a;if(!g||g.length===0)return(0,A.$Yj)($,f,p);const h=(0,P.$Re)(f," "),T=f.length-h.length,O=(0,A.$Yj)($,h,p);if(O)for(const R of O){const w=g[R.start+T]+T;R.start+=w,R.end+=w}return O}t.$ek=m}),define(be[89],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=t.$mU=void 0,t.$mU="vscode:contextmenu",t.$nU="vscode:onCloseContextMenu"}),define(be[90],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=void 0;class A{constructor(n,z){this.a=n,this.onMessage=z}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$uU=A}),define(be[30],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const A=globalThis.vscode;t.$O=A.ipcRenderer,t.$P=A.ipcMessagePort,t.$Q=A.webFrame,t.$R=A.process,t.$S=A.context}),define(be[91],$e([1,0,89,30]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=void 0;let n=0;function z(k,b,v){const y=[],L=n++,o=`vscode:onContextMenu${L}`,l=(e,s,m)=>{y[s].click?.(m)};P.$O.once(o,l),P.$O.once(A.$nU,(e,s)=>{s===L&&(P.$O.removeListener(o,l),v?.())}),P.$O.send(A.$mU,L,k.map(e=>E(e,y)),o,b)}t.$qU=z;function E(k,b){const v={id:b.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return b.push(k),Array.isArray(k.submenu)&&(v.submenu=k.submenu.map(y=>E(y,b))),v}}),define(be[52],$e([8]),{}),define(be[92],$e([8]),{}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([1,0,93,94]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([8]),{}),define(be[103],$e([8]),{}),define(be[104],$e([8]),{}),define(be[105],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],$e([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(be[36],$e([1,0,4,2,112]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ni=t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=void 0;class z extends P.$Tc{constructor(o,l="",e="",s=!0,m){super(),this.h=this.B(new A.$Td),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=l,this.u=e,this.w=s,this.C=m}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,l){this.C&&await this.C(o)}}t.$Ii=z;class E extends P.$Tc{constructor(){super(...arguments),this.f=this.B(new A.$Td),this.onWillRun=this.f.event,this.m=this.B(new A.$Td),this.onDidRun=this.m.event}async run(o,l){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.u(o,l)}catch(s){e=s}this.m.fire({action:o,error:e})}async u(o,l){await o.run(l)}}t.$Ji=E;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let l=[];for(const e of o)e.length&&(l.length?l=[...l,new k,...e]:l=e);return l}static{this.ID="vs.actions.separator"}async run(){}}t.$Ki=k;class b{get actions(){return this.a}constructor(o,l,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=l,this.class=s,this.a=e}async run(){}}t.$Li=b;class v extends z{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,n.localize(0,null),void 0,!1)}}t.$Mi=v;function y(L){return{id:L.id,label:L.label,class:L.class,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...o)=>L.run(...o),tooltip:L.label}}t.$Ni=y}),define(be[113],$e([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,113]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let P=!1,n=!1,z=!1,E=!1,k=!1,b=!1,v=!1,y=!1,L=!1,o=!1,l,e=t.$g,s=t.$g,m,$;const a=globalThis;let p;typeof a.vscode<"u"&&typeof a.vscode.process<"u"?p=a.vscode.process:typeof process<"u"&&(p=process);const f=typeof p?.versions?.electron=="string",g=f&&p?.type==="renderer";if(typeof p=="object"){P=p.platform==="win32",n=p.platform==="darwin",z=p.platform==="linux",E=z&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,v=f,L=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.$g,e=t.$g;const N=p.env.VSCODE_NLS_CONFIG;if(N)try{const I=JSON.parse(N),B=I.availableLanguages["*"];l=I.locale,s=I.osLocale,e=B||t.$g,m=I._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!g?($=navigator.userAgent,P=$.indexOf("Windows")>=0,n=$.indexOf("Macintosh")>=0,y=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,z=$.indexOf("Linux")>=0,o=$?.indexOf("Mobi")>=0,b=!0,l=A.getConfiguredDefaultLocale(A.localize(0,null))||t.$g,e=l,s=navigator.language):console.error("Unable to resolve platform.");var h;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(h||(t.Platform=h={}));function T(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=T;let O=0;n?O=1:P?O=3:z&&(O=2),t.$i=P,t.$j=n,t.$k=z,t.$l=E,t.$m=k,t.$n=v,t.$o=b,t.$p=b&&typeof a.importScripts=="function",t.$q=t.$p?a.origin:void 0,t.$r=y,t.$s=o,t.$t=L,t.$u=O,t.$v=$,t.$w=e;var R;(function(N){function I(){return t.$w}N.value=I;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}N.isDefaultVariant=B;function X(){return t.$w==="en"}N.isDefault=X})(R||(t.Language=R={})),t.$x=l,t.$y=s,t.$z=m,t.$A=typeof a.postMessage=="function"&&!a.importScripts,t.$B=(()=>{if(t.$A){const N=[];a.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let X=0,Y=N.length;X<Y;X++){const ue=N[X];if(ue.id===B.data.vscodeScheduleAsyncWork){N.splice(X,1),ue.callback();return}}});let I=0;return B=>{const X=++I;N.push({id:X,callback:B}),a.postMessage({vscodeScheduleAsyncWork:X},"*")}}return N=>setTimeout(N)})();var w;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=n||y?2:P?1:3;let S=!0,M=!1;function H(){if(!M){M=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,S=new Uint16Array(N.buffer)[0]===(2<<8)+1}return S}t.$D=H,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function _(N){return parseFloat(N)>=20}t.$J=_}),define(be[114],$e([1,0,16,21,5]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fP=t.KeyboardSupport=void 0;var z;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(z||(t.KeyboardSupport=z={})),t.$fP={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>n.$m||A.$dP()?0:navigator.keyboard||A.$_O?1:2)(),touch:"ontouchstart"in P.$UO||navigator.maxTouchPoints>0,pointerEvents:P.$UO.PointerEvent&&("ontouchstart"in P.$UO||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,44,78,5]),function(ie,t,A,P,n,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nP=t.$mP=t.$lP=void 0;function E(e){if(e.charCode){const m=String.fromCharCode(e.charCode).toUpperCase();return P.KeyCodeUtils.fromString(m)}const s=e.keyCode;if(s===3)return 7;if(A.$9O)switch(s){case 59:return 85;case 60:if(z.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(z.$j)return 57;break}else if(A.$0O){if(z.$j&&s===93)return 57;if(!z.$j&&s===92)return 57}return P.$Qq[s]||0}const k=z.$j?256:2048,b=512,v=1024,y=z.$j?2048:256;function L(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$lP=L;function o(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${P.KeyCodeUtils.toString(e.keyCode)}')`}t.$mP=o;class l{constructor(s){this._standardKeyboardEventBrand=!0;const m=s;this.browserEvent=m,this.target=m.target,this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,this.altGraphKey=m.getModifierState("AltGraph"),this.keyCode=E(m),this.code=m.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let m=0;return this.ctrlKey&&(m|=k),this.altKey&&(m|=b),this.shiftKey&&(m|=v),this.metaKey&&(m|=y),m|=s,m}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$Yq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$nP=l}),define(be[19],$e([1,0,16,69,5]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kP=t.$jP=t.$iP=void 0;class z{constructor(v,y){this.timestamp=Date.now(),this.browserEvent=y,this.leftButton=y.button===0,this.middleButton=y.button===1,this.rightButton=y.button===2,this.buttons=y.buttons,this.target=y.target,this.detail=y.detail||1,y.type==="dblclick"&&(this.detail=2),this.ctrlKey=y.ctrlKey,this.shiftKey=y.shiftKey,this.altKey=y.altKey,this.metaKey=y.metaKey,typeof y.pageX=="number"?(this.posx=y.pageX,this.posy=y.pageY):(this.posx=y.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=y.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const L=P.$gP.getPositionOfChildWindowRelativeToAncestorWindow(v,y.view);this.posx-=L.left,this.posy-=L.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$iP=z;class E extends z{constructor(v,y){super(v,y),this.dataTransfer=y.dataTransfer}}t.$jP=E;class k{constructor(v,y=0,L=0){if(this.browserEvent=v||null,this.target=v?v.target||v.targetNode||v.srcElement:null,this.deltaY=L,this.deltaX=y,v){const o=v,l=v;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(v.type==="wheel"){const e=v;e.deltaMode===e.DOM_DELTA_LINE?A.$9O&&!n.$j?this.deltaY=-v.deltaY/3:this.deltaY=-v.deltaY:this.deltaY=-v.deltaY/40}if(typeof o.wheelDeltaX<"u")A.$_O&&n.$i?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-v.detail/3;else if(v.type==="wheel"){const e=v;e.deltaMode===e.DOM_DELTA_LINE?A.$9O&&!n.$j?this.deltaX=-v.deltaX/3:this.deltaX=-v.deltaX:this.deltaX=-v.deltaX/40}this.deltaY===0&&this.deltaX===0&&v.wheelDelta&&(this.deltaY=v.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$kP=k}),define(be[115],$e([1,0,5]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const z=n.process;P={get platform(){return z.platform},get arch(){return z.arch},get env(){return z.env},cwd(){return z.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),define(be[24],$e([1,0,115]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,n=97,z=90,E=122,k=46,b=47,v=92,y=58,L=63;class o extends Error{constructor(T,O,R){let w;typeof O=="string"&&O.indexOf("not ")===0?(w="must not be",O=O.replace(/^not /,"")):w="must be";const S=T.indexOf(".")!==-1?"property":"argument";let M=`The "${T}" ${S} ${w} of type ${O}`;M+=`. Received type ${typeof R}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function l(h,T){if(h===null||typeof h!="object")throw new o(T,"Object",h)}function e(h,T){if(typeof h!="string")throw new o(T,"string",h)}const s=A.$dc==="win32";function m(h){return h===b||h===v}function $(h){return h===b}function a(h){return h>=P&&h<=z||h>=n&&h<=E}function p(h,T,O,R){let w="",S=0,M=-1,H=0,_=0;for(let N=0;N<=h.length;++N){if(N<h.length)_=h.charCodeAt(N);else{if(R(_))break;_=b}if(R(_)){if(!(M===N-1||H===1))if(H===2){if(w.length<2||S!==2||w.charCodeAt(w.length-1)!==k||w.charCodeAt(w.length-2)!==k){if(w.length>2){const I=w.lastIndexOf(O);I===-1?(w="",S=0):(w=w.slice(0,I),S=w.length-1-w.lastIndexOf(O)),M=N,H=0;continue}else if(w.length!==0){w="",S=0,M=N,H=0;continue}}T&&(w+=w.length>0?`${O}..`:"..",S=2)}else w.length>0?w+=`${O}${h.slice(M+1,N)}`:w=h.slice(M+1,N),S=N-M-1;M=N,H=0}else _===k&&H!==-1?++H:H=-1}return w}function f(h,T){l(T,"pathObject");const O=T.dir||T.root,R=T.base||`${T.name||""}${T.ext||""}`;return O?O===T.root?`${O}${R}`:`${O}${h}${R}`:R}t.$fc={resolve(...h){let T="",O="",R=!1;for(let w=h.length-1;w>=-1;w--){let S;if(w>=0){if(S=h[w],e(S,"path"),S.length===0)continue}else T.length===0?S=A.cwd():(S=A.env[`=${T}`]||A.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==T.toLowerCase()&&S.charCodeAt(2)===v)&&(S=`${T}\\`));const M=S.length;let H=0,_="",N=!1;const I=S.charCodeAt(0);if(M===1)m(I)&&(H=1,N=!0);else if(m(I))if(N=!0,m(S.charCodeAt(1))){let B=2,X=B;for(;B<M&&!m(S.charCodeAt(B));)B++;if(B<M&&B!==X){const Y=S.slice(X,B);for(X=B;B<M&&m(S.charCodeAt(B));)B++;if(B<M&&B!==X){for(X=B;B<M&&!m(S.charCodeAt(B));)B++;(B===M||B!==X)&&(_=`\\\\${Y}\\${S.slice(X,B)}`,H=B)}}}else H=1;else a(I)&&S.charCodeAt(1)===y&&(_=S.slice(0,2),H=2,M>2&&m(S.charCodeAt(2))&&(N=!0,H=3));if(_.length>0)if(T.length>0){if(_.toLowerCase()!==T.toLowerCase())continue}else T=_;if(R){if(T.length>0)break}else if(O=`${S.slice(H)}\\${O}`,R=N,N&&T.length>0)break}return O=p(O,!R,"\\",m),R?`${T}\\${O}`:`${T}${O}`||"."},normalize(h){e(h,"path");const T=h.length;if(T===0)return".";let O=0,R,w=!1;const S=h.charCodeAt(0);if(T===1)return $(S)?"\\":h;if(m(S))if(w=!0,m(h.charCodeAt(1))){let H=2,_=H;for(;H<T&&!m(h.charCodeAt(H));)H++;if(H<T&&H!==_){const N=h.slice(_,H);for(_=H;H<T&&m(h.charCodeAt(H));)H++;if(H<T&&H!==_){for(_=H;H<T&&!m(h.charCodeAt(H));)H++;if(H===T)return`\\\\${N}\\${h.slice(_)}\\`;H!==_&&(R=`\\\\${N}\\${h.slice(_,H)}`,O=H)}}}else O=1;else a(S)&&h.charCodeAt(1)===y&&(R=h.slice(0,2),O=2,T>2&&m(h.charCodeAt(2))&&(w=!0,O=3));let M=O<T?p(h.slice(O),!w,"\\",m):"";return M.length===0&&!w&&(M="."),M.length>0&&m(h.charCodeAt(T-1))&&(M+="\\"),R===void 0?w?`\\${M}`:M:w?`${R}\\${M}`:`${R}${M}`},isAbsolute(h){e(h,"path");const T=h.length;if(T===0)return!1;const O=h.charCodeAt(0);return m(O)||T>2&&a(O)&&h.charCodeAt(1)===y&&m(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let T,O;for(let S=0;S<h.length;++S){const M=h[S];e(M,"path"),M.length>0&&(T===void 0?T=O=M:T+=`\\${M}`)}if(T===void 0)return".";let R=!0,w=0;if(typeof O=="string"&&m(O.charCodeAt(0))){++w;const S=O.length;S>1&&m(O.charCodeAt(1))&&(++w,S>2&&(m(O.charCodeAt(2))?++w:R=!1))}if(R){for(;w<T.length&&m(T.charCodeAt(w));)w++;w>=2&&(T=`\\${T.slice(w)}`)}return t.$fc.normalize(T)},relative(h,T){if(e(h,"from"),e(T,"to"),h===T)return"";const O=t.$fc.resolve(h),R=t.$fc.resolve(T);if(O===R||(h=O.toLowerCase(),T=R.toLowerCase(),h===T))return"";let w=0;for(;w<h.length&&h.charCodeAt(w)===v;)w++;let S=h.length;for(;S-1>w&&h.charCodeAt(S-1)===v;)S--;const M=S-w;let H=0;for(;H<T.length&&T.charCodeAt(H)===v;)H++;let _=T.length;for(;_-1>H&&T.charCodeAt(_-1)===v;)_--;const N=_-H,I=M<N?M:N;let B=-1,X=0;for(;X<I;X++){const ue=h.charCodeAt(w+X);if(ue!==T.charCodeAt(H+X))break;ue===v&&(B=X)}if(X!==I){if(B===-1)return R}else{if(N>I){if(T.charCodeAt(H+X)===v)return R.slice(H+X+1);if(X===2)return R.slice(H+X)}M>I&&(h.charCodeAt(w+X)===v?B=X:X===2&&(B=3)),B===-1&&(B=0)}let Y="";for(X=w+B+1;X<=S;++X)(X===S||h.charCodeAt(X)===v)&&(Y+=Y.length===0?"..":"\\..");return H+=B,Y.length>0?`${Y}${R.slice(H,_)}`:(R.charCodeAt(H)===v&&++H,R.slice(H,_))},toNamespacedPath(h){if(typeof h!="string"||h.length===0)return h;const T=t.$fc.resolve(h);if(T.length<=2)return h;if(T.charCodeAt(0)===v){if(T.charCodeAt(1)===v){const O=T.charCodeAt(2);if(O!==L&&O!==k)return`\\\\?\\UNC\\${T.slice(2)}`}}else if(a(T.charCodeAt(0))&&T.charCodeAt(1)===y&&T.charCodeAt(2)===v)return`\\\\?\\${T}`;return h},dirname(h){e(h,"path");const T=h.length;if(T===0)return".";let O=-1,R=0;const w=h.charCodeAt(0);if(T===1)return m(w)?h:".";if(m(w)){if(O=R=1,m(h.charCodeAt(1))){let H=2,_=H;for(;H<T&&!m(h.charCodeAt(H));)H++;if(H<T&&H!==_){for(_=H;H<T&&m(h.charCodeAt(H));)H++;if(H<T&&H!==_){for(_=H;H<T&&!m(h.charCodeAt(H));)H++;if(H===T)return h;H!==_&&(O=R=H+1)}}}}else a(w)&&h.charCodeAt(1)===y&&(O=T>2&&m(h.charCodeAt(2))?3:2,R=O);let S=-1,M=!0;for(let H=T-1;H>=R;--H)if(m(h.charCodeAt(H))){if(!M){S=H;break}}else M=!1;if(S===-1){if(O===-1)return".";S=O}return h.slice(0,S)},basename(h,T){T!==void 0&&e(T,"ext"),e(h,"path");let O=0,R=-1,w=!0,S;if(h.length>=2&&a(h.charCodeAt(0))&&h.charCodeAt(1)===y&&(O=2),T!==void 0&&T.length>0&&T.length<=h.length){if(T===h)return"";let M=T.length-1,H=-1;for(S=h.length-1;S>=O;--S){const _=h.charCodeAt(S);if(m(_)){if(!w){O=S+1;break}}else H===-1&&(w=!1,H=S+1),M>=0&&(_===T.charCodeAt(M)?--M===-1&&(R=S):(M=-1,R=H))}return O===R?R=H:R===-1&&(R=h.length),h.slice(O,R)}for(S=h.length-1;S>=O;--S)if(m(h.charCodeAt(S))){if(!w){O=S+1;break}}else R===-1&&(w=!1,R=S+1);return R===-1?"":h.slice(O,R)},extname(h){e(h,"path");let T=0,O=-1,R=0,w=-1,S=!0,M=0;h.length>=2&&h.charCodeAt(1)===y&&a(h.charCodeAt(0))&&(T=R=2);for(let H=h.length-1;H>=T;--H){const _=h.charCodeAt(H);if(m(_)){if(!S){R=H+1;break}continue}w===-1&&(S=!1,w=H+1),_===k?O===-1?O=H:M!==1&&(M=1):O!==-1&&(M=-1)}return O===-1||w===-1||M===0||M===1&&O===w-1&&O===R+1?"":h.slice(O,w)},format:f.bind(null,"\\"),parse(h){e(h,"path");const T={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return T;const O=h.length;let R=0,w=h.charCodeAt(0);if(O===1)return m(w)?(T.root=T.dir=h,T):(T.base=T.name=h,T);if(m(w)){if(R=1,m(h.charCodeAt(1))){let B=2,X=B;for(;B<O&&!m(h.charCodeAt(B));)B++;if(B<O&&B!==X){for(X=B;B<O&&m(h.charCodeAt(B));)B++;if(B<O&&B!==X){for(X=B;B<O&&!m(h.charCodeAt(B));)B++;B===O?R=B:B!==X&&(R=B+1)}}}}else if(a(w)&&h.charCodeAt(1)===y){if(O<=2)return T.root=T.dir=h,T;if(R=2,m(h.charCodeAt(2))){if(O===3)return T.root=T.dir=h,T;R=3}}R>0&&(T.root=h.slice(0,R));let S=-1,M=R,H=-1,_=!0,N=h.length-1,I=0;for(;N>=R;--N){if(w=h.charCodeAt(N),m(w)){if(!_){M=N+1;break}continue}H===-1&&(_=!1,H=N+1),w===k?S===-1?S=N:I!==1&&(I=1):S!==-1&&(I=-1)}return H!==-1&&(S===-1||I===0||I===1&&S===H-1&&S===M+1?T.base=T.name=h.slice(M,H):(T.name=h.slice(M,S),T.base=h.slice(M,H),T.ext=h.slice(S,H))),M>0&&M!==R?T.dir=h.slice(0,M-1):T.dir=T.root,T},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(s){const h=/\\/g;return()=>{const T=A.cwd().replace(h,"/");return T.slice(T.indexOf("/"))}}return()=>A.cwd()})();t.$gc={resolve(...h){let T="",O=!1;for(let R=h.length-1;R>=-1&&!O;R--){const w=R>=0?h[R]:g();e(w,"path"),w.length!==0&&(T=`${w}/${T}`,O=w.charCodeAt(0)===b)}return T=p(T,!O,"/",$),O?`/${T}`:T.length>0?T:"."},normalize(h){if(e(h,"path"),h.length===0)return".";const T=h.charCodeAt(0)===b,O=h.charCodeAt(h.length-1)===b;return h=p(h,!T,"/",$),h.length===0?T?"/":O?"./":".":(O&&(h+="/"),T?`/${h}`:h)},isAbsolute(h){return e(h,"path"),h.length>0&&h.charCodeAt(0)===b},join(...h){if(h.length===0)return".";let T;for(let O=0;O<h.length;++O){const R=h[O];e(R,"path"),R.length>0&&(T===void 0?T=R:T+=`/${R}`)}return T===void 0?".":t.$gc.normalize(T)},relative(h,T){if(e(h,"from"),e(T,"to"),h===T||(h=t.$gc.resolve(h),T=t.$gc.resolve(T),h===T))return"";const O=1,R=h.length,w=R-O,S=1,M=T.length-S,H=w<M?w:M;let _=-1,N=0;for(;N<H;N++){const B=h.charCodeAt(O+N);if(B!==T.charCodeAt(S+N))break;B===b&&(_=N)}if(N===H)if(M>H){if(T.charCodeAt(S+N)===b)return T.slice(S+N+1);if(N===0)return T.slice(S+N)}else w>H&&(h.charCodeAt(O+N)===b?_=N:N===0&&(_=0));let I="";for(N=O+_+1;N<=R;++N)(N===R||h.charCodeAt(N)===b)&&(I+=I.length===0?"..":"/..");return`${I}${T.slice(S+_)}`},toNamespacedPath(h){return h},dirname(h){if(e(h,"path"),h.length===0)return".";const T=h.charCodeAt(0)===b;let O=-1,R=!0;for(let w=h.length-1;w>=1;--w)if(h.charCodeAt(w)===b){if(!R){O=w;break}}else R=!1;return O===-1?T?"/":".":T&&O===1?"//":h.slice(0,O)},basename(h,T){T!==void 0&&e(T,"ext"),e(h,"path");let O=0,R=-1,w=!0,S;if(T!==void 0&&T.length>0&&T.length<=h.length){if(T===h)return"";let M=T.length-1,H=-1;for(S=h.length-1;S>=0;--S){const _=h.charCodeAt(S);if(_===b){if(!w){O=S+1;break}}else H===-1&&(w=!1,H=S+1),M>=0&&(_===T.charCodeAt(M)?--M===-1&&(R=S):(M=-1,R=H))}return O===R?R=H:R===-1&&(R=h.length),h.slice(O,R)}for(S=h.length-1;S>=0;--S)if(h.charCodeAt(S)===b){if(!w){O=S+1;break}}else R===-1&&(w=!1,R=S+1);return R===-1?"":h.slice(O,R)},extname(h){e(h,"path");let T=-1,O=0,R=-1,w=!0,S=0;for(let M=h.length-1;M>=0;--M){const H=h.charCodeAt(M);if(H===b){if(!w){O=M+1;break}continue}R===-1&&(w=!1,R=M+1),H===k?T===-1?T=M:S!==1&&(S=1):T!==-1&&(S=-1)}return T===-1||R===-1||S===0||S===1&&T===R-1&&T===O+1?"":h.slice(T,R)},format:f.bind(null,"/"),parse(h){e(h,"path");const T={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return T;const O=h.charCodeAt(0)===b;let R;O?(T.root="/",R=1):R=0;let w=-1,S=0,M=-1,H=!0,_=h.length-1,N=0;for(;_>=R;--_){const I=h.charCodeAt(_);if(I===b){if(!H){S=_+1;break}continue}M===-1&&(H=!1,M=_+1),I===k?w===-1?w=_:N!==1&&(N=1):w!==-1&&(N=-1)}if(M!==-1){const I=S===0&&O?1:S;w===-1||N===0||N===1&&w===M-1&&w===S+1?T.base=T.name=h.slice(I,M):(T.name=h.slice(I,w),T.base=h.slice(I,M),T.ext=h.slice(w,M))}return S>0?T.dir=h.slice(0,S-1):O&&(T.dir="/"),T},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],$e([1,0,24,5,10,7]),function(ie,t,A,P,n,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=void 0;function E(S){return S===47||S===92}t.$Yf=E;function k(S){return S.replace(/[\\/]/g,A.$gc.sep)}t.$Zf=k;function b(S){return S.indexOf("/")===-1&&(S=k(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}t.$1f=b;function v(S,M=A.$gc.sep){if(!S)return"";const H=S.length,_=S.charCodeAt(0);if(E(_)){if(E(S.charCodeAt(1))&&!E(S.charCodeAt(2))){let I=3;const B=I;for(;I<H&&!E(S.charCodeAt(I));I++);if(B!==I&&!E(S.charCodeAt(I+1))){for(I+=1;I<H;I++)if(E(S.charCodeAt(I)))return S.slice(0,I+1).replace(/[\\/]/g,M)}}return M}else if($(_)&&S.charCodeAt(1)===58)return E(S.charCodeAt(2))?S.slice(0,2)+M:S.slice(0,2);let N=S.indexOf("://");if(N!==-1){for(N+=3;N<H;N++)if(E(S.charCodeAt(N)))return S.slice(0,N+1)}return""}t.$2f=v;function y(S){if(!P.$i||!S||S.length<5)return!1;let M=S.charCodeAt(0);if(M!==92||(M=S.charCodeAt(1),M!==92))return!1;let H=2;const _=H;for(;H<S.length&&(M=S.charCodeAt(H),M!==92);H++);return!(_===H||(M=S.charCodeAt(H+1),isNaN(M)||M===92))}t.$3f=y;const L=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(S,M=P.$i){const H=M?L:o;return!(!S||S.length===0||/^\s+$/.test(S)||(H.lastIndex=0,H.test(S))||M&&l.test(S)||S==="."||S===".."||M&&S[S.length-1]==="."||M&&S.length!==S.trim().length||S.length>255)}t.$4f=e;function s(S,M,H){const _=S===M;return!H||_?_:!S||!M?!1:(0,n.$0e)(S,M)}t.$5f=s;function m(S,M,H,_=A.sep){if(S===M)return!0;if(!S||!M||M.length>S.length)return!1;if(H){if(!(0,n.$$e)(S,M))return!1;if(M.length===S.length)return!0;let I=M.length;return M.charAt(M.length-1)===_&&I--,S.charAt(I)===_}return M.charAt(M.length-1)!==_&&(M+=_),S.indexOf(M)===0}t.$6f=m;function $(S){return S>=65&&S<=90||S>=97&&S<=122}t.$7f=$;function a(S,M){return P.$i&&S.endsWith(":")&&(S+=A.sep),(0,A.$ic)(S)||(S=(0,A.$jc)(M,S)),S=(0,A.$hc)(S),P.$i?(S=(0,n.$Se)(S,A.sep),S.endsWith(":")&&(S+=A.sep)):(S=(0,n.$Se)(S,A.sep),S||(S=A.sep)),S}t.$8f=a;function p(S){const M=(0,A.$hc)(S);return P.$i?S.length>3?!1:f(M)&&(S.length===2||M.charCodeAt(2)===92):M===A.$gc.sep}t.$9f=p;function f(S,M=P.$i){return M?$(S.charCodeAt(0))&&S.charCodeAt(1)===58:!1}t.$0f=f;function g(S,M=P.$i){return f(S,M)?S[0]:void 0}t.$$f=g;function h(S,M,H){return M.length>S.length?-1:S===M?0:(H&&(S=S.toLowerCase(),M=M.toLowerCase()),S.indexOf(M))}t.$_f=h;function T(S){const M=S.split(":");let H,_,N;for(const I of M){const B=Number(I);(0,z.$Kf)(B)?_===void 0?_=B:N===void 0&&(N=B):H=H?[H,I].join(":"):I}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:_!==void 0?_:void 0,column:N!==void 0?N:_!==void 0?1:void 0}}t.$ag=T;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(S,M,H=8){let _="";for(let I=0;I<H;I++){let B;I===0&&P.$i&&!M&&(H===3||H===4)?B=R:B=O,_+=B.charAt(Math.floor(Math.random()*B.length))}let N;return M?N=`${M}-${_}`:N=_,S?(0,A.$jc)(S,N):N}t.$bg=w}),define(be[117],$e([1,0,24]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=t.$0r=t.$9r=t.$8r=t.$7r=void 0,t.$7r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(y){const L=(0,A.$oc)(y),o=P[L.toLowerCase()];return o!==void 0?o:E(y)}t.$8r=z;function E(y){const L=(0,A.$oc)(y);return n[L.toLowerCase()]}t.$9r=E;function k(y){for(const L in n)if(n[L]===y)return L}t.$0r=k;const b=/^(.+)\/(.+?)(;.+)?$/;function v(y,L){const o=b.exec(y);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:L?void 0:y}t.$$r=v}),define(be[15],$e([1,0,24,5]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,z=/^\//,E=/^\/\//;function k(R,w){if(!R.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!n.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!z.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(R,w){return!R&&!w?"file":R}function v(R,w){switch(R){case"https":case"http":case"file":w?w[0]!==L&&(w=L+w):w=L;break}return w}const y="",L="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(w){return w instanceof l?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,S,M,H,_,N=!1){typeof w=="object"?(this.scheme=w.scheme||y,this.authority=w.authority||y,this.path=w.path||y,this.query=w.query||y,this.fragment=w.fragment||y):(this.scheme=b(w,N),this.authority=S||y,this.path=v(this.scheme,M||y),this.query=H||y,this.fragment=_||y,k(this,N))}get fsPath(){return f(this,!1)}with(w){if(!w)return this;let{scheme:S,authority:M,path:H,query:_,fragment:N}=w;return S===void 0?S=this.scheme:S===null&&(S=y),M===void 0?M=this.authority:M===null&&(M=y),H===void 0?H=this.path:H===null&&(H=y),_===void 0?_=this.query:_===null&&(_=y),N===void 0?N=this.fragment:N===null&&(N=y),S===this.scheme&&M===this.authority&&H===this.path&&_===this.query&&N===this.fragment?this:new m(S,M,H,_,N)}static parse(w,S=!1){const M=o.exec(w);return M?new m(M[2]||y,O(M[4]||y),O(M[5]||y),O(M[7]||y),O(M[9]||y),S):new m(y,y,y,y,y)}static file(w){let S=y;if(P.$i&&(w=w.replace(/\\/g,L)),w[0]===L&&w[1]===L){const M=w.indexOf(L,2);M===-1?(S=w.substring(2),w=L):(S=w.substring(2,M),w=w.substring(M)||L)}return new m("file",S,w,y,y)}static from(w,S){return new m(w.scheme,w.authority,w.path,w.query,w.fragment,S)}static joinPath(w,...S){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return P.$i&&w.scheme==="file"?M=l.file(A.$fc.join(f(w,!0),...S)).path:M=A.$gc.join(w.path,...S),w.with({path:M})}toString(w=!1){return g(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof l)return w;{const S=new m(w);return S._formatted=w.external??null,S._fsPath=w._sep===s?w.fsPath??null:null,S}}else return w}}t.URI=l;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const s=P.$i?1:void 0;class m extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(w=!1){return w?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=s),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(R,w,S){let M,H=-1;for(let _=0;_<R.length;_++){const N=R.charCodeAt(_);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||w&&N===47||S&&N===91||S&&N===93||S&&N===58)H!==-1&&(M+=encodeURIComponent(R.substring(H,_)),H=-1),M!==void 0&&(M+=R.charAt(_));else{M===void 0&&(M=R.substr(0,_));const I=$[N];I!==void 0?(H!==-1&&(M+=encodeURIComponent(R.substring(H,_)),H=-1),M+=I):H===-1&&(H=_)}}return H!==-1&&(M+=encodeURIComponent(R.substring(H))),M!==void 0?M:R}function p(R){let w;for(let S=0;S<R.length;S++){const M=R.charCodeAt(S);M===35||M===63?(w===void 0&&(w=R.substr(0,S)),w+=$[M]):w!==void 0&&(w+=R[S])}return w!==void 0?w:R}function f(R,w){let S;return R.authority&&R.path.length>1&&R.scheme==="file"?S=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?w?S=R.path.substr(1):S=R.path[1].toLowerCase()+R.path.substr(2):S=R.path,P.$i&&(S=S.replace(/\//g,"\\")),S}t.$wc=f;function g(R,w){const S=w?p:a;let M="",{scheme:H,authority:_,path:N,query:I,fragment:B}=R;if(H&&(M+=H,M+=":"),(_||H==="file")&&(M+=L,M+=L),_){let X=_.indexOf("@");if(X!==-1){const Y=_.substr(0,X);_=_.substr(X+1),X=Y.lastIndexOf(":"),X===-1?M+=S(Y,!1,!1):(M+=S(Y.substr(0,X),!1,!1),M+=":",M+=S(Y.substr(X+1),!1,!0)),M+="@"}_=_.toLowerCase(),X=_.lastIndexOf(":"),X===-1?M+=S(_,!1,!0):(M+=S(_.substr(0,X),!1,!0),M+=_.substr(X))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const X=N.charCodeAt(1);X>=65&&X<=90&&(N=`/${String.fromCharCode(X+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const X=N.charCodeAt(0);X>=65&&X<=90&&(N=`${String.fromCharCode(X+32)}:${N.substr(2)}`)}M+=S(N,!0,!1)}return I&&(M+="?",M+=S(I,!1,!1)),B&&(M+="#",M+=w?B:a(B,!1,!1)),M}function h(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+h(R.substr(3)):R}}const T=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(R){return R.match(T)?R.replace(T,w=>h(w)):R}}),define(be[53],$e([1,0,33,15]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ah=t.$zh=t.$yh=void 0;function n(b){return JSON.stringify(b,E)}t.$yh=n;function z(b){let v=JSON.parse(b);return v=k(v),v}t.$zh=z;function E(b,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function k(b,v=0){if(!b||v>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return P.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof A.$he||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=k(b[y],v+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=k(b[y],v+1))}return b}t.$Ah=k}),define(be[31],$e([1,0,6,5,10,15]),function(ie,t,A,P,n,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.Schemas=void 0;var E;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(E||(t.Schemas=E={}));function k(o,l){return z.URI.isUri(o)?(0,n.$0e)(o.scheme,l):(0,n.$$e)(o,l+":")}t.$cg=k;function b(o,...l){return l.some(e=>k(o,e))}t.$dg=b,t.$eg="vscode-tkn",t.$fg="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${E.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${E.vscodeRemoteResource}`}set(l,e,s){this.a[l]=e,this.b[l]=s}setConnectionToken(l,e){this.c[l]=e}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(p){return A.$1(p),l}const e=l.authority;let s=this.a[e];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const m=this.b[e],$=this.c[e];let a=`path=${encodeURIComponent(l.path)}`;return typeof $=="string"&&(a+=`&${t.$fg}=${encodeURIComponent($)}`),z.URI.from({scheme:P.$o?this.d:E.vscodeRemoteResource,authority:`${s}:${m}`,path:this.f,query:a})}}t.$gg=new v,t.$hg="vs/../../extensions",t.$ig="vs/../../node_modules",t.$jg="vs/../../node_modules.asar",t.$kg="vs/../../node_modules.asar.unpacked",t.$lg="vscode-app";class y{static{this.a=t.$lg}asBrowserUri(l){const e=this.b(l,ie);return this.uriToBrowserUri(e)}uriToBrowserUri(l){return l.scheme===E.vscodeRemote?t.$gg.rewrite(l):l.scheme===E.file&&(P.$m||P.$q===`${E.vscodeFileResource}://${y.a}`)?l.with({scheme:E.vscodeFileResource,authority:l.authority||y.a,query:null,fragment:null}):l}asFileUri(l){const e=this.b(l,ie);return this.uriToFileUri(e)}uriToFileUri(l){return l.scheme===E.vscodeFileResource?l.with({scheme:E.file,authority:l.authority!==y.a?l.authority:null,query:null,fragment:null}):l}b(l,e){return z.URI.isUri(l)?l:z.URI.parse(e.toUrl(l))}}t.$mg=new y;var L;(function(o){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(l.get("3"));const e="vscode-coi";function s($){let a;typeof $=="string"?a=new URL($).searchParams:$ instanceof URL?a=$.searchParams:z.URI.isUri($)&&(a=new URL($.toString(!0)).searchParams);const p=a?.get(e);if(p)return l.get(p)}o.getHeadersFromQuery=s;function m($,a,p){if(!globalThis.crossOriginIsolated)return;const f=a&&p?"3":p?"2":"1";$ instanceof URLSearchParams?$.set(e,f):$[e]=f}o.addSearchParam=m})(L||(t.COI=L={}))}),define(be[37],$e([1,0,116,31,24,5,10,15]),function(ie,t,A,P,n,z,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pg=t.DataUri=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=void 0;function b(l){return(0,k.$wc)(l,!0)}t.$tg=b;class v{constructor(e){this.a=e}compare(e,s,m=!1){return e===s?0:(0,E.$3e)(this.getComparisonKey(e,m),this.getComparisonKey(s,m))}isEqual(e,s,m=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,m)===this.getComparisonKey(s,m)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,m=!1){if(e.scheme===s.scheme){if(e.scheme===P.Schemas.file)return A.$6f(b(e),b(s),this.a(e))&&e.query===s.query&&(m||e.fragment===s.fragment);if((0,t.$Kg)(e.authority,s.authority))return A.$6f(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(m||e.fragment===s.fragment)}return!1}joinPath(e,...s){return k.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Cg)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===P.Schemas.file?s=k.URI.file(n.$mc(b(e))).path:(s=n.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===P.Schemas.file?s=k.URI.file(n.$hc(b(e))).path:s=n.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Kg)(e.authority,s.authority))return;if(e.scheme===P.Schemas.file){const a=n.$lc(b(e),b(s));return z.$i?A.$Zf(a):a}let m=e.path||"/";const $=s.path||"/";if(this.a(e)){let a=0;for(const p=Math.min(m.length,$.length);a<p&&!(m.charCodeAt(a)!==$.charCodeAt(a)&&m.charAt(a).toLowerCase()!==$.charAt(a).toLowerCase());a++);m=$.substr(0,a)+m.substr(a)}return n.$gc.relative(m,$)}resolvePath(e,s){if(e.scheme===P.Schemas.file){const m=k.URI.file(n.$kc(b(e),s));return e.with({authority:m.authority,path:m.path})}return s=A.$1f(s),e.with({path:n.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,E.$0e)(e,s)}hasTrailingPathSeparator(e,s=n.sep){if(e.scheme===P.Schemas.file){const m=b(e);return m.length>A.$2f(m).length&&m[m.length-1]===s}else{const m=e.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=n.sep){return(0,t.$Lg)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=n.sep){let m=!1;if(e.scheme===P.Schemas.file){const $=b(e);m=$!==void 0&&$.length===A.$2f($).length&&$[$.length-1]===s}else{s="/";const $=e.path;m=$.length===1&&$.charCodeAt($.length-1)===47}return!m&&!(0,t.$Lg)(e,s)?e.with({path:e.path+"/"}):e}}t.$ug=v,t.$vg=new v(()=>!1),t.$wg=new v(l=>l.scheme===P.Schemas.file?!z.$k:!0),t.$xg=new v(l=>!0),t.$yg=t.$vg.isEqual.bind(t.$vg),t.$zg=t.$vg.isEqualOrParent.bind(t.$vg),t.$Ag=t.$vg.getComparisonKey.bind(t.$vg),t.$Bg=t.$vg.basenameOrAuthority.bind(t.$vg),t.$Cg=t.$vg.basename.bind(t.$vg),t.$Dg=t.$vg.extname.bind(t.$vg),t.$Eg=t.$vg.dirname.bind(t.$vg),t.$Fg=t.$vg.joinPath.bind(t.$vg),t.$Gg=t.$vg.normalizePath.bind(t.$vg),t.$Hg=t.$vg.relativePath.bind(t.$vg),t.$Ig=t.$vg.resolvePath.bind(t.$vg),t.$Jg=t.$vg.isAbsolutePath.bind(t.$vg),t.$Kg=t.$vg.isEqualAuthority.bind(t.$vg),t.$Lg=t.$vg.hasTrailingPathSeparator.bind(t.$vg),t.$Mg=t.$vg.removeTrailingPathSeparator.bind(t.$vg),t.$Ng=t.$vg.addTrailingPathSeparator.bind(t.$vg);function y(l,e){const s=[];for(let m=0;m<l.length;m++){const $=e(l[m]);l.some((a,p)=>p===m?!1:(0,t.$zg)($,e(a)))||s.push(l[m])}return s}t.$Og=y;var L;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(s){const m=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(p=>{const[f,g]=p.split(":");f&&g&&m.set(f,g)});const a=s.path.substring(0,s.path.indexOf(";"));return a&&m.set(l.META_DATA_MIME,a),m}l.parseMetaData=e})(L||(t.DataUri=L={}));function o(l,e,s){if(e){let m=l.path;return m&&m[0]!==n.$gc.sep&&(m=n.$gc.sep+m),l.with({scheme:s,authority:e,path:m})}return l.with({scheme:s})}t.$Pg=o}),define(be[9],$e([1,0,29,6,4,2,37,5,50,23]),function(ie,t,A,P,n,z,E,k,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.Promises=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=void 0;function y(r){return!!r&&typeof r.then=="function"}t.$Qg=y;function L(r){const c=new A.$4d,u=r(c.token),d=new Promise((F,C)=>{const W=c.token.onCancellationRequested(()=>{W.dispose(),C(new P.$5)});Promise.resolve(u).then(j=>{W.dispose(),c.dispose(),F(j)},j=>{W.dispose(),c.dispose(),C(j)})});return new class{cancel(){c.cancel(),c.dispose()}then(F,C){return d.then(F,C)}catch(F){return this.then(void 0,F)}finally(F){return d.finally(F)}}}t.$Rg=L;function o(r,c,u){return new Promise((d,F)=>{const C=c.onCancellationRequested(()=>{C.dispose(),d(u)});r.then(d,F).finally(()=>C.dispose())})}t.$Sg=o;function l(r,c){return new Promise((u,d)=>{const F=c.onCancellationRequested(()=>{F.dispose(),d(new P.$5)});r.then(u,d).finally(()=>F.dispose())})}t.$Tg=l;async function e(r){let c=-1;const u=r.map((d,F)=>d.then(C=>(c=F,C)));try{return await Promise.race(u)}finally{r.forEach((d,F)=>{F!==c&&d.cancel()})}}t.$Ug=e;function s(r,c,u){let d;const F=setTimeout(()=>{d?.(void 0),u?.()},c);return Promise.race([r.finally(()=>clearTimeout(F)),new Promise(C=>d=C)])}t.$Vg=s;function m(r){return new Promise((c,u)=>{const d=r();y(d)?d.then(c,u):c(d)})}t.$Wg=m;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const u=()=>{if(this.b=null,this.f)return;const d=this.queue(this.d);return this.d=null,d};this.b=new Promise(d=>{this.a.then(u,u).then(d)})}return new Promise((u,d)=>{this.b.then(u,d)})}return this.a=c(),new Promise((u,d)=>{this.a.then(F=>{this.a=null,u(F)},F=>{this.a=null,d(F)})})}dispose(){this.f=!0}}t.$Xg=$;class a{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}t.$Yg=a;class p{constructor(){this.a=new Map}queue(c,u){const F=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(u).finally(()=>{this.a.get(c)===F&&this.a.delete(c)});return this.a.set(c,F),F}}t.$Zg=p;const f=(r,c)=>{let u=!0;const d=setTimeout(()=>{u=!1,c()},r);return{isTriggered:()=>u,dispose:()=>{clearTimeout(d),u=!1}}},g=r=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,r())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class h{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,u=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((F,C)=>{this.d=F,this.f=C}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const d=()=>{this.a=null,this.d?.(null)};return this.a=u===b.$Qd?g(d):f(u,d),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$1g=h;class T{constructor(c){this.a=new h(c),this.b=new $}trigger(c,u){return this.a.trigger(()=>this.b.queue(c),u)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$2g=T;class O{constructor(){this.a=!1,this.b=new Promise((c,u)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$3g=O;class R extends O{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}t.$4g=R;function w(r,c){return c?new Promise((u,d)=>{const F=setTimeout(()=>{C.dispose(),u()},r),C=c.onCancellationRequested(()=>{clearTimeout(F),C.dispose(),d(new P.$5)})}):L(u=>w(r,u))}t.$5g=w;function S(r,c=0,u){const d=setTimeout(()=>{r(),u&&F.dispose()},c),F=(0,z.$Rc)(()=>{clearTimeout(d),u?.deleteAndLeak(F)});return u?.add(F),F}t.$6g=S;function M(r){const c=[];let u=0;const d=r.length;function F(){return u<d?r[u++]():null}function C(W){W!=null&&c.push(W);const j=F();return j?j.then(C):Promise.resolve(c)}return Promise.resolve(null).then(C)}t.$7g=M;function H(r,c=d=>!!d,u=null){let d=0;const F=r.length,C=()=>{if(d>=F)return Promise.resolve(u);const W=r[d++];return Promise.resolve(W()).then(V=>c(V)?Promise.resolve(V):C())};return C()}t.$8g=H;function _(r,c=d=>!!d,u=null){if(r.length===0)return Promise.resolve(u);let d=r.length;const F=()=>{d=-1;for(const C of r)C.cancel?.()};return new Promise((C,W)=>{for(const j of r)j.then(V=>{--d>=0&&c(V)?(F(),C(V)):d===0&&C(u)}).catch(V=>{--d>=0&&(F(),W(V))})})}t.$9g=_;class N{constructor(c){this.a=0,this.d=c,this.f=[],this.b=0,this.g=new n.$Td}get onDrained(){return this.g.event}get size(){return this.a}queue(c){return this.a++,new Promise((u,d)=>{this.f.push({factory:c,c:u,e:d}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const c=this.f.shift();this.b++;const u=c.factory();u.then(c.c,c.e),u.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$0g=N;class I extends N{constructor(){super(1)}}t.$$g=I;class B{constructor(){this.a=new J,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}t.$_g=B;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new U;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueFor(c,u=E.$vg){const d=u.getComparisonKey(c);let F=this.a.get(d);if(!F){F=new I;const C=this.f++,W=n.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(d),this.h(),this.d?.deleteAndDispose(C),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new z.$3c),this.d.set(C,W),this.a.set(d,F)}return F}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$ah=X;class Y{constructor(c,u){this.a=-1,typeof c=="function"&&typeof u=="number"&&this.setIfNotSet(c,u)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,u){this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},u)}setIfNotSet(c,u){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},u))}}t.$bh=Y;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(c,u,d=globalThis){this.cancel();const F=d.setInterval(()=>{c()},u);this.d=(0,z.$Rc)(()=>{d.clearInterval(F),this.d=void 0})}dispose(){this.cancel()}}t.$ch=ue;class ne{constructor(c,u){this.b=-1,this.a=c,this.d=u,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$dh=ne;class te{constructor(c,u){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.a=c,this.b=u,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$eh=te;class we extends ne{constructor(c,u){super(c,u),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}t.$fh=we;class Re extends z.$Tc{constructor(c,u){super(),this.g=c,this.h=u,this.a=[],this.b=this.B(new z.$Uc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const u of c)this.a.push(u);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$gh=Re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$ih=(r,c)=>{(0,k.$B)(()=>{if(u)return;const d=Date.now()+15;c(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:t.$ih=(r,c,u)=>{const d=r.requestIdleCallback(c,typeof u=="number"?{timeout:u}:void 0);let F=!1;return{dispose(){F||(F=!0,r.cancelIdleCallback(d))}}},t.$hh=r=>(0,t.$ih)(globalThis,r)}();class Te{constructor(c,u){this.g=!1,this.d=()=>{try{this.j=u()}catch(d){this.l=d}finally{this.g=!0}},this.f=(0,t.$ih)(c,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$jh=Te;class Oe extends Te{constructor(c){super(globalThis,c)}}t.$kh=Oe;async function re(r,c,u){let d;for(let F=0;F<u;F++)try{return await r()}catch(C){d=C,await w(c)}throw d}t.$lh=re;class J{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,u,d){return this.a={taskId:c,cancel:()=>d?.(),promise:u},u.then(()=>this.d(c),()=>this.d(c)),u}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{let u,d;const F=new Promise((C,W)=>{u=C,d=W});this.b={run:c,promise:F,promiseResolve:u,promiseReject:d}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$mh=J;class ae{constructor(c,u=()=>Date.now()){this.d=c,this.f=u,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}t.$nh=ae;var K;(function(r){r[r.Resolved=0]="Resolved",r[r.Rejected=1]="Rejected"})(K||(K={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((c,u)=>{this.a=c,this.b=u})}complete(c){return new Promise(u=>{this.a(c),this.d={outcome:0,value:c},u()})}error(c){return new Promise(u=>{this.b(c),this.d={outcome:1,value:c},u()})}cancel(){return this.error(new P.$5)}}t.$oh=U;var Z;(function(r){async function c(d){let F;const C=await Promise.all(d.map(W=>W.then(j=>j,j=>{F||(F=j)})));if(typeof F<"u")throw F;return C}r.settled=c;function u(d){return new Promise(async(F,C)=>{try{await d(F,C)}catch(W){C(W)}})}r.withAsyncBody=u})(Z||(t.Promises=Z={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(c){this.a=void 0,this.b=void 0,this.d=!1,this.promise=c.then(u=>(this.a=u,this.d=!0,u),u=>{throw this.b=u,this.d=!0,u})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$ph=me;class ve{constructor(c){this.b=c,this.a=new v.$V(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}t.$qh=ve;var ke;(function(r){r[r.Initial=0]="Initial",r[r.DoneOK=1]="DoneOK",r[r.DoneError=2]="DoneError"})(ke||(ke={}));class Ee{static fromArray(c){return new Ee(u=>{u.emitMany(c)})}static fromPromise(c){return new Ee(async u=>{u.emitMany(await c)})}static fromPromises(c){return new Ee(async u=>{await Promise.all(c.map(async d=>u.emitOne(await d)))})}static merge(c){return new Ee(async u=>{await Promise.all(c.map(async d=>{for await(const F of d)u.emitOne(F)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(c){this.a=0,this.b=[],this.d=null,this.f=new n.$Td,queueMicrotask(async()=>{const u={emitOne:d=>this.g(d),emitMany:d=>this.h(d),reject:d=>this.k(d)};try{await Promise.resolve(c(u)),this.j()}catch(d){this.k(d)}finally{u.emitOne=void 0,u.emitMany=void 0,u.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(c,u){return new Ee(async d=>{for await(const F of c)d.emitOne(u(F))})}map(c){return Ee.map(this,c)}static filter(c,u){return new Ee(async d=>{for await(const F of c)u(F)&&d.emitOne(F)})}filter(c){return Ee.filter(this,c)}static coalesce(c){return Ee.filter(c,u=>!!u)}coalesce(){return Ee.coalesce(this)}static async toPromise(c){const u=[];for await(const d of c)u.push(d);return u}toPromise(){return Ee.toPromise(this)}g(c){this.a===0&&(this.b.push(c),this.f.fire())}h(c){this.a===0&&(this.b=this.b.concat(c),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(c){this.a===0&&(this.a=2,this.d=c,this.f.fire())}}t.$rh=Ee;class ge extends Ee{constructor(c,u){super(u),this.l=c}cancel(){this.l.cancel()}}t.$sh=ge;function D(r){const c=new A.$4d,u=r(c.token);return new ge(c,async d=>{const F=c.token.onCancellationRequested(()=>{F.dispose(),c.dispose(),d.reject(new P.$5)});try{for await(const C of u){if(c.token.isCancellationRequested)return;d.emitOne(C)}F.dispose(),c.dispose()}catch(C){F.dispose(),c.dispose(),d.reject(C)}})}t.$th=D;class i{constructor(){this.a=new U,this.b=new Ee(d=>{if(c){d.reject(c);return}return u&&d.emitMany(u),this.d=F=>d.reject(F),this.f=F=>d.emitOne(F),this.a.p});let c,u;this.f=d=>{u||(u=[]),u.push(d)},this.d=d=>{c||(c=d)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(c){this.d(c),this.a.complete()}emitOne(c){this.f(c)}}t.$uh=i}),define(be[3],$e([1,0,16,114,14,19,9,6,4,118,2,31,5,15,49,21]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l,e,s){"use strict";var m;Object.defineProperty(t,"__esModule",{value:!0}),t.$VQ=t.$UQ=t.h=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.DetectedFullscreenMode=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$=t.Namespace=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,m=function(){const q=new Map;(0,s.$TO)(s.$UO,1),q.set(s.$UO.vscodeWindowId,{window:s.$UO,disposables:new y.$Sc});const Q=new b.$Td,ee=new b.$Td,ce=new b.$Td;return{onDidRegisterWindow:Q.event,onWillUnregisterWindow:ce.event,onDidUnregisterWindow:ee.event,registerWindow(ye){if(q.has(ye.vscodeWindowId))return y.$Tc.None;const Le=new y.$Sc,Ue={window:ye,disposables:Le.add(new y.$Sc)};return q.set(ye.vscodeWindowId,Ue),Le.add((0,y.$Rc)(()=>{q.delete(ye.vscodeWindowId),ee.fire(ye)})),Le.add(p(ye,t.$jQ.BEFORE_UNLOAD,()=>{ce.fire(ye)})),Q.fire(Ue),Le},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(ye){return ye.vscodeWindowId},hasWindow(ye){return q.has(ye)},getWindowById(ye){return q.get(ye)},getWindow(ye){const Le=ye;if(Le?.ownerDocument?.defaultView)return Le.ownerDocument.defaultView.window;const Ue=ye;return Ue?.view?Ue.view.window:s.$UO},getDocument(ye){const Le=ye;return(0,t.getWindow)(Le).document}}}(),t.registerWindow=m.registerWindow,t.getWindow=m.getWindow,t.getDocument=m.getDocument,t.getWindows=m.getWindows,t.getWindowsCount=m.getWindowsCount,t.getWindowId=m.getWindowId,t.getWindowById=m.getWindowById,t.hasWindow=m.hasWindow,t.onDidRegisterWindow=m.onDidRegisterWindow,t.onWillUnregisterWindow=m.onWillUnregisterWindow,t.onDidUnregisterWindow=m.onDidUnregisterWindow;function $(q){for(;q.firstChild;)q.firstChild.remove()}t.$pP=$;class a{constructor(Q,ee,ce,ye){this.f=Q,this.g=ee,this.d=ce,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function p(q,Q,ee,ce){return new a(q,Q,ee,ce)}t.$qP=p;function f(q,Q){return function(ee){return Q(new z.$iP(q,ee))}}function g(q){return function(Q){return q(new n.$nP(Q))}}const h=function(Q,ee,ce,ye){let Le=ce;return ee==="click"||ee==="mousedown"?Le=f((0,t.getWindow)(Q),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(Le=g(ce)),p(Q,ee,Le,ye)};t.$rP=h;const T=function(Q,ee,ce){const ye=f((0,t.getWindow)(Q),ee);return R(Q,ye,ce)};t.$sP=T;const O=function(Q,ee,ce){const ye=f((0,t.getWindow)(Q),ee);return S(Q,ye,ce)};t.$tP=O;function R(q,Q,ee){return p(q,o.$r&&P.$fP.pointerEvents?t.$jQ.POINTER_DOWN:t.$jQ.MOUSE_DOWN,Q,ee)}t.$uP=R;function w(q,Q,ee){return p(q,o.$r&&P.$fP.pointerEvents?t.$jQ.POINTER_MOVE:t.$jQ.MOUSE_MOVE,Q,ee)}t.$vP=w;function S(q,Q,ee){return p(q,o.$r&&P.$fP.pointerEvents?t.$jQ.POINTER_UP:t.$jQ.MOUSE_UP,Q,ee)}t.$wP=S;function M(q,Q,ee){return(0,E.$ih)(q,Q,ee)}t.$xP=M;class H extends E.$jh{constructor(Q,ee){super(Q,ee)}}t.$yP=H;function _(q,Q,ee,ce){let ye=0;const Le=q.setInterval(()=>{ye++,(typeof ce=="number"&&ye>=ce||Q()===!0)&&Ue.dispose()},ee),Ue=(0,y.$Rc)(()=>{q.clearInterval(Le)});return Ue}t.$BP=_;class N extends E.$ch{cancelAndSet(Q,ee,ce){return super.cancelAndSet(Q,ee,ce)}}t.$CP=N;class I{constructor(Q,ee=0){this.d=Q,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,k.$1)(Q)}}static sort(Q,ee){return ee.priority-Q.priority}}(function(){const q=new Map,Q=new Map,ee=new Map,ce=new Map,ye=Le=>{ee.set(Le,!1);const Ue=q.get(Le)??[];for(Q.set(Le,Ue),q.set(Le,[]),ce.set(Le,!0);Ue.length>0;)Ue.sort(I.sort),Ue.shift().execute();ce.set(Le,!1)};t.$AP=(Le,Ue,Ge=0)=>{const Xe=(0,t.getWindowId)(Le),Ve=new I(Ue,Ge);let lt=q.get(Xe);return lt||(lt=[],q.set(Xe,lt)),lt.push(Ve),ee.get(Xe)||(ee.set(Xe,!0),Le.requestAnimationFrame(()=>ye(Xe))),Ve},t.$zP=(Le,Ue,Ge)=>{const Xe=(0,t.getWindowId)(Le);if(ce.get(Xe)){const Ve=new I(Ue,Ge);let lt=Q.get(Xe);return lt||(lt=[],Q.set(Xe,lt)),lt.push(Ve),Ve}else return(0,t.$AP)(Le,Ue,Ge)}})();function B(q,Q){return(0,t.$AP)(q,Q,1e4)}t.$DP=B;function X(q,Q){return(0,t.$AP)(q,Q,-1e4)}t.$EP=X;const Y=8,ue=function(q,Q){return Q};class ne extends y.$Tc{constructor(Q,ee,ce,ye=ue,Le=Y){super();let Ue=null,Ge=0;const Xe=this.B(new E.$bh),Ve=()=>{Ge=new Date().getTime(),ce(Ue),Ue=null};this.B(p(Q,ee,lt=>{Ue=ye(Ue,lt);const Tt=new Date().getTime()-Ge;Tt>=Le?(Xe.cancel(),Ve()):Xe.setIfNotSet(Ve,Le-Tt)}))}}function te(q,Q,ee,ce,ye){return new ne(q,Q,ee,ce,ye)}t.$FP=te;function we(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}t.$GP=we;function Re(q,Q){const ee=(0,t.getWindow)(q),ce=ee.document;if(q!==ce.body)return new Oe(q.clientWidth,q.clientHeight);if(o.$r&&ee?.visualViewport)return new Oe(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Oe(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Oe(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Oe(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(Q)return Re(Q);throw new Error("Unable to figure out browser width and height")}t.$HP=Re;class Te{static d(Q,ee){return parseFloat(ee)||0}static f(Q,ee,ce){const ye=we(Q),Le=ye?ye.getPropertyValue(ee):"0";return Te.d(Q,Le)}static getBorderLeftWidth(Q){return Te.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Te.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Te.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Te.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Te.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Te.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Te.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Te.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Te.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Te.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Te.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Te.f(Q,"margin-bottom","marginBottom")}}class Oe{static{this.None=new Oe(0,0)}constructor(Q,ee){this.width=Q,this.height=ee}with(Q=this.width,ee=this.height){return Q!==this.width||ee!==this.height?new Oe(Q,ee):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Oe?Q:new Oe(Q.width,Q.height)}static equals(Q,ee){return Q===ee?!0:!Q||!ee?!1:Q.width===ee.width&&Q.height===ee.height}}t.$IP=Oe;function re(q){let Q=q.offsetParent,ee=q.offsetTop,ce=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){ee-=q.scrollTop;const ye=W(q)?null:we(q);ye&&(ce-=ye.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===Q&&(ce+=Te.getBorderLeftWidth(q),ee+=Te.getBorderTopWidth(q),ee+=q.offsetTop,ce+=q.offsetLeft,Q=q.offsetParent)}return{left:ce,top:ee}}t.$JP=re;function J(q,Q,ee){typeof Q=="number"&&(q.style.width=`${Q}px`),typeof ee=="number"&&(q.style.height=`${ee}px`)}t.$KP=J;function ae(q,Q,ee,ce,ye,Le="absolute"){typeof Q=="number"&&(q.style.top=`${Q}px`),typeof ee=="number"&&(q.style.right=`${ee}px`),typeof ce=="number"&&(q.style.bottom=`${ce}px`),typeof ye=="number"&&(q.style.left=`${ye}px`),q.style.position=Le}t.$LP=ae;function K(q){const Q=q.getBoundingClientRect(),ee=(0,t.getWindow)(q);return{left:Q.left+ee.scrollX,top:Q.top+ee.scrollY,width:Q.width,height:Q.height}}t.$MP=K;function U(q){let Q=q,ee=1;do{const ce=we(Q).zoom;ce!=null&&ce!=="1"&&(ee*=ce),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return ee}t.$NP=U;function Z(q){const Q=Te.getMarginLeft(q)+Te.getMarginRight(q);return q.offsetWidth+Q}t.$OP=Z;function me(q){const Q=Te.getBorderLeftWidth(q)+Te.getBorderRightWidth(q),ee=Te.getPaddingLeft(q)+Te.getPaddingRight(q);return q.offsetWidth-Q-ee}t.$PP=me;function ve(q){const Q=Te.getMarginLeft(q)+Te.getMarginRight(q);return q.scrollWidth+Q}t.$QP=ve;function ke(q){const Q=Te.getBorderTopWidth(q)+Te.getBorderBottomWidth(q),ee=Te.getPaddingTop(q)+Te.getPaddingBottom(q);return q.offsetHeight-Q-ee}t.$RP=ke;function Ee(q){const Q=Te.getMarginTop(q)+Te.getMarginBottom(q);return q.offsetHeight+Q}t.$SP=Ee;function ge(q,Q){if(q===null)return 0;const ee=re(q),ce=re(Q);return ee.left-ce.left}function D(q,Q){const ee=Q.map(ye=>Math.max(ve(ye),Z(ye))+ge(ye,q)||0);return Math.max(...ee)}t.$TP=D;function i(q,Q){return!!Q?.contains(q)}t.$UP=i;const r="parentFlowToElementId";function c(q,Q){q.dataset[r]=Q.id}t.$VP=c;function u(q){const Q=q.dataset[r];return typeof Q=="string"?q.ownerDocument.getElementById(Q):null}function d(q,Q){let ee=q;for(;ee;){if(ee===Q)return!0;if(ee instanceof HTMLElement){const ce=u(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}t.$WP=d;function F(q,Q,ee){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(Q))return q;if(ee){if(typeof ee=="string"){if(q.classList.contains(ee))return null}else if(q===ee)return null}q=q.parentNode}return null}t.$XP=F;function C(q,Q,ee){return!!F(q,Q,ee)}t.$YP=C;function W(q){return q&&!!q.host&&!!q.mode}t.$ZP=W;function j(q){return!!V(q)}t.$1P=j;function V(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return W(q)?q:null}t.$2P=V;function G(){let q=De().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}t.$3P=G;function oe(q){return G()===q}t.$4P=oe;function se(q){return i(G(),q)}t.$5P=se;function de(q){return q.ownerDocument===De()}t.$6P=de;function De(){return(0,t.getWindowsCount)()<=1?s.$UO.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??s.$UO.document}t.$7P=De;function pe(){return De().defaultView?.window??s.$UO}t.$8P=pe;function Ce(q){const Q=(0,t.getWindow)(q);Q.document.hasFocus()||Q.focus()}t.$9P=Ce;const Fe=new Map;function Me(q){return Fe.has(q)}t.$0P=Me;function Be(q=s.$UO.document.head,Q,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",Q?.(ce),q.appendChild(ce),ee&&ee.add((0,y.$Rc)(()=>q.removeChild(ce))),q===s.$UO.document.head){const ye=new Set;Fe.set(ce,ye);for(const{window:Le,disposables:Ue}of(0,t.getWindows)()){if(Le===s.$UO)continue;const Ge=Ue.add(Je(ce,ye,Le));ee?.add(Ge)}}return ce}t.$$P=Be;function Ie(q){const Q=new y.$Sc;for(const[ee,ce]of Fe)Q.add(Je(ee,ce,q));return Q}t.$_P=Ie;function Je(q,Q,ee){const ce=new y.$Sc,ye=q.cloneNode(!0);ee.document.head.appendChild(ye),ce.add((0,y.$Rc)(()=>ee.document.head.removeChild(ye)));for(const Le of Ae(q))ye.sheet?.insertRule(Le.cssText,ye.sheet?.cssRules.length);return ce.add(t.$aQ.observe(q,ce,{childList:!0})(()=>{ye.textContent=q.textContent})),Q.add(ye),ce.add((0,y.$Rc)(()=>Q.delete(ye))),ce}t.$aQ=new class{constructor(){this.mutationObservers=new Map}observe(q,Q,ee){let ce=this.mutationObservers.get(q);ce||(ce=new Map,this.mutationObservers.set(q,ce));const ye=(0,e.$Ri)(ee);let Le=ce.get(ye);if(Le)Le.users+=1;else{const Ue=new b.$Td,Ge=new MutationObserver(Ve=>Ue.fire(Ve));Ge.observe(q,ee);const Xe=Le={users:1,observer:Ge,onDidMutate:Ue.event};Q.add((0,y.$Rc)(()=>{Xe.users-=1,Xe.users===0&&(Ue.dispose(),Ge.disconnect(),ce?.delete(ye),ce?.size===0&&this.mutationObservers.delete(q))})),ce.set(ye,Le)}return Le.onDidMutate}};function Ke(q=s.$UO.document.head){return x("meta",q)}t.$bQ=Ke;function xe(q=s.$UO.document.head){return x("link",q)}t.$cQ=xe;function x(q,Q=s.$UO.document.head){const ee=document.createElement(q);return Q.appendChild(ee),ee}let le=null;function fe(){return le||(le=Be()),le}function Ae(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Ne(q,Q,ee=fe()){if(!(!ee||!Q)){ee.sheet?.insertRule(`${q} {${Q}}`,0);for(const ce of Fe.get(ee)??[])Ne(q,Q,ce)}}t.$dQ=Ne;function ze(q,Q=fe()){if(!Q)return;const ee=Ae(Q),ce=[];for(let ye=0;ye<ee.length;ye++){const Le=ee[ye];qe(Le)&&Le.selectorText.indexOf(q)!==-1&&ce.push(ye)}for(let ye=ce.length-1;ye>=0;ye--)Q.sheet?.deleteRule(ce[ye]);for(const ye of Fe.get(Q)??[])ze(q,ye)}t.$eQ=ze;function qe(q){return typeof q.selectorText=="string"}function _e(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}t.$fQ=_e;function et(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}t.$gQ=et;function tt(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}t.$hQ=tt;function Ze(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$iQ=Ze,t.$jQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:A.$0O?"webkitAnimationStart":"animationstart",ANIMATION_END:A.$0O?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:A.$0O?"webkitAnimationIteration":"animationiteration"};function nt(q){const Q=q;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$kQ=nt,t.$lQ={stop:(q,Q)=>(q.preventDefault(),Q&&q.stopPropagation(),q)};function st(q){const Q=[];for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)Q[ee]=q.scrollTop,q=q.parentNode;return Q}t.$mQ=st;function rt(q,Q){for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)q.scrollTop!==Q[ee]&&(q.scrollTop=Q[ee]),q=q.parentNode}t.$nQ=rt;class gt extends y.$Tc{static m(Q){if(Q instanceof HTMLElement){const ee=V(Q),ce=ee?ee.activeElement:Q.ownerDocument.activeElement;return i(ce,Q)}else{const ee=Q;return i(ee.document.activeElement,ee.document)}}constructor(Q){super(),this.f=this.B(new b.$Td),this.onDidFocus=this.f.event,this.g=this.B(new b.$Td),this.onDidBlur=this.g.event;let ee=gt.m(Q),ce=!1;const ye=()=>{ce=!1,ee||(ee=!0,this.f.fire())},Le=()=>{ee&&(ce=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{gt.m(Q)!==ee&&(ee?Le():ye())},this.B(p(Q,t.$jQ.FOCUS,ye,!0)),this.B(p(Q,t.$jQ.BLUR,Le,!0)),Q instanceof HTMLElement&&(this.B(p(Q,t.$jQ.FOCUS_IN,()=>this.j())),this.B(p(Q,t.$jQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(q){return new gt(q)}t.$oQ=kt;function St(q,Q){return q.after(Q),Q}t.$pQ=St;function wt(q,...Q){if(q.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$qQ=wt;function Mt(q,Q){return q.insertBefore(Q,q.firstChild),Q}t.$rQ=Mt;function je(q,...Q){q.innerText="",wt(q,...Q)}t.$sQ=je;const he=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Se;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(Se||(t.Namespace=Se={}));function Pe(q,Q,ee,...ce){const ye=he.exec(Q);if(!ye)throw new Error("Bad use of emmet");const Le=ye[1]||"div";let Ue;return q!==Se.HTML?Ue=document.createElementNS(q,Le):Ue=document.createElement(Le),ye[3]&&(Ue.id=ye[3]),ye[4]&&(Ue.className=ye[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([Ge,Xe])=>{typeof Xe>"u"||(/^on\w+$/.test(Ge)?Ue[Ge]=Xe:Ge==="selected"?Xe&&Ue.setAttribute(Ge,"true"):Ue.setAttribute(Ge,Xe))}),Ue.append(...ce),Ue}function We(q,Q,...ee){return Pe(Se.HTML,q,Q,...ee)}t.$=We,We.SVG=function(q,Q,...ee){return Pe(Se.SVG,q,Q,...ee)};function it(q,Q){const ee=[];return q.forEach((ce,ye)=>{ye>0&&(Q instanceof Node?ee.push(Q.cloneNode()):ee.push(document.createTextNode(Q))),ee.push(ce)}),ee}t.$uQ=it;function at(q,...Q){q?Qe(...Q):ut(...Q)}t.$vQ=at;function Qe(...q){for(const Q of q)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$wQ=Qe;function ut(...q){for(const Q of q)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$xQ=ut;function vt(q,Q){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(Q))return q;q=q.parentNode}return null}function Ft(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&vt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}t.$yQ=Ft;function Gt(q){return Q=>{Q.preventDefault(),Q.stopPropagation(),q(Q)}}t.$zQ=Gt;function Ai(q){return new Promise(Q=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)Q(void 0);else{const ce=()=>{q.window.removeEventListener("DOMContentLoaded",ce,!1),Q()};q.window.addEventListener("DOMContentLoaded",ce,!1)}})}t.$AQ=Ai;function ki(q,Q){const ee=q.devicePixelRatio*Q;return Math.max(1,Math.floor(ee))/q.devicePixelRatio}t.$BQ=ki;function Si(q){s.$UO.open(q,"_blank","noopener")}t.$CQ=Si;const Xt=780,Yt=640;function Fi(q){const Q=Math.floor(s.$UO.screenLeft+s.$UO.innerWidth/2-Xt/2),ee=Math.floor(s.$UO.screenTop+s.$UO.innerHeight/2-Yt/2);s.$UO.open(q,"_blank",`width=${Xt},height=${Yt},top=${ee},left=${Q}`)}t.$DQ=Fi;function Ti(q,Q=!0){const ee=s.$UO.open();return ee?(Q&&(ee.opener=null),ee.location.href=q,!0):!1}t.$EQ=Ti;function Ni(q,Q){const ee=()=>{Q(),ce=(0,t.$AP)(q,ee)};let ce=(0,t.$AP)(q,ee);return(0,y.$Rc)(()=>ce.dispose())}t.$FQ=Ni,L.$gg.setPreferredWebSchema(/^https:/.test(s.$UO.location.href)?"https":"http");function Pi(q){return q?`url('${L.$mg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$GQ=Pi;function Ci(q){return`'${q.replace(/'/g,"%27")}'`}t.$HQ=Ci;function Jt(q,Q){if(q!==void 0){const ee=q.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(Q=Jt(ce[1].trim(),Q)),`var(${ce[0]}, ${Q})`}return q}return Q}t.$IQ=Jt;function Ri(q,Q){let ee;if(l.URI.isUri(q))ee=q.toString(!0);else{const Le=new Blob([q]);ee=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=pe(),ye=document.createElement("a");ce.document.body.appendChild(ye),ye.download=Q,ye.href=ee,ye.click(),setTimeout(()=>ce.document.body.removeChild(ye))}t.$JQ=Ri;function Li(){return new Promise(q=>{const Q=pe(),ee=document.createElement("input");Q.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(ee,"input"))(()=>{q(ee.files??void 0)}),ee.click(),setTimeout(()=>Q.document.body.removeChild(ee))})}t.$KQ=Li;var Dt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Ii(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:Dt.BROWSER,guess:!1}:(o.$j||o.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}t.$LQ=Ii;function Zt(q,Q=!1){const ee=document.createElement("a");return v.addHook("afterSanitizeAttributes",ce=>{for(const ye of["href","src"])if(ce.hasAttribute(ye)){const Le=ce.getAttribute(ye);if(ye==="href"&&Le.startsWith("#"))continue;if(ee.href=Le,!q.includes(ee.protocol.replace(/:$/,""))){if(Q&&ye==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(ye)}}}),(0,y.$Rc)(()=>{v.removeHook("afterSanitizeAttributes")})}t.$MQ=Zt;const Oi=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$NQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Mi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(q,Q){const ee=Zt(Oi);try{const ce=v.sanitize(Q,Mi);q.innerHTML=ce}finally{ee.dispose()}}t.$OQ=Bi;function ji(q){const Q=new Uint16Array(q.length);for(let ye=0;ye<Q.length;ye++)Q[ye]=q.charCodeAt(ye);let ee="";const ce=new Uint8Array(Q.buffer);for(let ye=0;ye<ce.length;ye++)ee+=String.fromCharCode(ce[ye]);return ee}function zi(q){return btoa(ji(q))}t.$PQ=zi;class bt extends b.$Td{constructor(){super(),this.o=new y.$Sc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:ee})=>this.B(Q,ee),{window:s.$UO,disposables:this.o}))}B(Q,ee){ee.add(p(Q,"keydown",ce=>{if(ce.defaultPrevented)return;const ye=new n.$nP(ce);if(!(ye.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ce.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ce.altKey,this.s.ctrlKey=ce.ctrlKey,this.s.metaKey=ce.metaKey,this.s.shiftKey=ce.shiftKey,this.s.lastKeyPressed&&(this.s.event=ce,this.fire(this.s))}},!0)),ee.add(p(Q,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ce.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ce.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ce.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ce.altKey,this.s.ctrlKey=ce.ctrlKey,this.s.metaKey=ce.metaKey,this.s.shiftKey=ce.shiftKey,this.s.lastKeyReleased&&(this.s.event=ce,this.fire(this.s)))},!0)),ee.add(p(Q.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),ee.add(p(Q.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),ee.add(p(Q.document.body,"mousemove",ce=>{ce.buttons&&(this.s.lastKeyPressed=void 0)},!0)),ee.add(p(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$QQ=bt;function Ui(q){const Q=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$RQ=Ui;class Hi extends y.$Tc{constructor(Q,ee){super(),this.j=Q,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(p(this.j,t.$jQ.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B(p(this.j,t.$jQ.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B(p(this.j,t.$jQ.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B(p(this.j,t.$jQ.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(p(this.j,t.$jQ.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B(p(this.j,t.$jQ.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B(p(this.j,t.$jQ.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$SQ=Hi;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(q,...Q){let ee,ce;Array.isArray(Q[0])?(ee={},ce=Q[0]):(ee=Q[0]||{},ce=Q[1]);const ye=Wi.exec(q);if(!ye||!ye.groups)throw new Error("Bad use of h");const Le=ye.groups.tag||"div",Ue=document.createElement(Le);ye.groups.id&&(Ue.id=ye.groups.id);const Ge=[];if(ye.groups.class)for(const Ve of ye.groups.class.split("."))Ve!==""&&Ge.push(Ve);if(ee.className!==void 0)for(const Ve of ee.className.split("."))Ve!==""&&Ge.push(Ve);Ge.length>0&&(Ue.className=Ge.join(" "));const Xe={};if(ye.groups.name&&(Xe[ye.groups.name]=Ue),ce)for(const Ve of ce)Ve instanceof HTMLElement?Ue.appendChild(Ve):typeof Ve=="string"?Ue.append(Ve):"root"in Ve&&(Object.assign(Xe,Ve),Ue.appendChild(Ve.root));for(const[Ve,lt]of Object.entries(ee))if(Ve!=="className")if(Ve==="style")for(const[Tt,Bt]of Object.entries(lt))Ue.style.setProperty(ei(Tt),typeof Bt=="number"?Bt+"px":""+Bt);else Ve==="tabIndex"?Ue.tabIndex=lt:Ue.setAttribute(ei(Ve),lt.toString());return Xe.root=Ue,Xe}t.h=qi;function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,Q){for(const{name:ee,value:ce}of q.attributes)Q.setAttribute(ee,ce)}t.$UQ=ti;function Vi(q,Q,ee){const ce=q.getAttribute(ee);ce?Q.setAttribute(ee,ce):Q.removeAttribute(ee)}function _i(q,Q,ee){ti(q,Q);const ce=new y.$Sc;return ce.add(t.$aQ.observe(q,ce,{attributes:!0,attributeFilter:ee})(ye=>{for(const Le of ye)Le.type==="attributes"&&Le.attributeName&&Vi(q,Q,Le.attributeName)})),ce}t.$VQ=_i}),define(be[54],$e([1,0,3,2,117]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=t.$XQ=t.$WQ=void 0;class z extends P.$Tc{constructor(b,v){super(),this.B((0,A.$qP)(b,"dragover",y=>{y.preventDefault(),this.a||(this.a=setTimeout(()=>{v(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(y=>{this.B((0,A.$qP)(b,y,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$WQ=z,t.$XQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$7r.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(k,b,v,y,L){const o=document.createElement("div");if(o.className=v,o.textContent=b,L&&(o.style.color=L),y&&(o.style.background=y),k.dataTransfer){const l=(0,A.getWindow)(k).document;l.body.appendChild(o),k.dataTransfer.setDragImage(o,-10,-10),setTimeout(()=>l.body.removeChild(o),0)}}t.$YQ=E}),define(be[55],$e([1,0,3]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=t.$pR=t.$oR=void 0;function P(o,l={}){const e=z(l);return e.textContent=o,e}t.$oR=P;function n(o,l={}){const e=z(l);return b(e,v(o,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.$pR=n;function z(o){const l=o.inline?"span":"div",e=document.createElement(l);return o.className&&(e.className=o.className),e}t.$qR=z;class E{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(k||(k={}));function b(o,l,e,s){let m;if(l.type===2)m=document.createTextNode(l.content||"");else if(l.type===3)m=document.createElement("b");else if(l.type===4)m=document.createElement("i");else if(l.type===7&&s)m=document.createElement("code");else if(l.type===5&&e){const $=document.createElement("a");e.disposables.add(A.$rP($,"click",a=>{e.callback(String(l.index),a)})),m=$}else l.type===8?m=document.createElement("br"):l.type===1&&(m=o);m&&o!==m&&o.appendChild(m),m&&Array.isArray(l.children)&&l.children.forEach($=>{b(m,$,e,s)})}function v(o,l){const e={type:1,children:[]};let s=0,m=e;const $=[],a=new E(o);for(;!a.eos();){let p=a.next();const f=p==="\\"&&L(a.peek(),l)!==0;if(f&&(p=a.next()),!f&&y(p,l)&&p===a.peek()){a.advance(),m.type===2&&(m=$.pop());const g=L(p,l);if(m.type===g||m.type===5&&g===6)m=$.pop();else{const h={type:g,children:[]};g===5&&(h.index=s,s++),m.children.push(h),$.push(m),m=h}}else if(p===`
`)m.type===2&&(m=$.pop()),m.children.push({type:8});else if(m.type!==2){const g={type:2,content:p};m.children.push(g),$.push(m),m=g}else m.content+=p}return m.type===2&&(m=$.pop()),$.length,e}function y(o,l){return L(o,l)!==0}function L(o,l){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(be[56],$e([1,0,3,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=void 0;class n{constructor(){this.a=new P.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,E&&b&&b(k)}isMonitoring(){return!!this.b}startMonitoring(E,k,b,v,y){this.isMonitoring()&&this.stopMonitoring(!1),this.b=v,this.c=y;let L=E;try{E.setPointerCapture(k),this.a.add((0,P.$Rc)(()=>{try{E.releasePointerCapture(k)}catch{}}))}catch{L=A.getWindow(E)}this.a.add(A.$qP(L,A.$jQ.POINTER_MOVE,o=>{if(o.buttons!==b){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(A.$qP(L,A.$jQ.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.$3Q=n});var Ye=this&&this.__decorate||function(ie,t,A,P){var n=arguments.length,z=n<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,A):P,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(ie,t,A,P);else for(var k=ie.length-1;k>=0;k--)(E=ie[k])&&(z=(n<3?E(z):n>3?E(t,A,z):E(t,A))||z);return n>3&&z&&Object.defineProperty(t,A,z),z};define(be[25],$e([1,0,3,21,12,27,4,2,45]),function(ie,t,A,P,n,z,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=t.EventType=void 0;var v;(function(L){L.Tap="-monaco-gesturetap",L.Change="-monaco-gesturechange",L.Start="-monaco-gesturestart",L.End="-monaco-gesturesend",L.Contextmenu="-monaco-gesturecontextmenu"})(v||(t.EventType=v={}));class y extends k.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$4c,this.h=new b.$4c,this.m={},this.j=null,this.n=0,this.B(E.Event.runAndSubscribe(A.onDidRegisterWindow,({window:o,disposables:l})=>{l.add(A.$qP(o.document,"touchstart",e=>this.s(e),{passive:!1})),l.add(A.$qP(o.document,"touchend",e=>this.u(o,e))),l.add(A.$qP(o.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:P.$UO,disposables:this.q}))}static addTarget(o){if(!y.isTouchDevice())return k.$Tc.None;y.b||(y.b=(0,k.$Mc)(new y));const l=y.b.g.push(o);return(0,k.$Rc)(l)}static ignoreTarget(o){if(!y.isTouchDevice())return k.$Tc.None;y.b||(y.b=(0,k.$Mc)(new y));const l=y.b.h.push(o);return(0,k.$Rc)(l)}static isTouchDevice(){return"ontouchstart"in P.$UO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(o){const l=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=o.targetTouches.length;e<s;e++){const m=o.targetTouches.item(e);this.m[m.identifier]={id:m.identifier,initialTarget:m.target,initialTimeStamp:l,initialPageX:m.pageX,initialPageY:m.pageY,rollingTimestamps:[l],rollingPageX:[m.pageX],rollingPageY:[m.pageY]};const $=this.w(v.Start,m.target);$.pageX=m.pageX,$.pageY=m.pageY,this.z($)}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}u(o,l){const e=Date.now(),s=Object.keys(this.m).length;for(let m=0,$=l.changedTouches.length;m<$;m++){const a=l.changedTouches.item(m);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const p=this.m[a.identifier],f=Date.now()-p.initialTimeStamp;if(f<y.c&&Math.abs(p.initialPageX-n.$sb(p.rollingPageX))<30&&Math.abs(p.initialPageY-n.$sb(p.rollingPageY))<30){const g=this.w(v.Tap,p.initialTarget);g.pageX=n.$sb(p.rollingPageX),g.pageY=n.$sb(p.rollingPageY),this.z(g)}else if(f>=y.c&&Math.abs(p.initialPageX-n.$sb(p.rollingPageX))<30&&Math.abs(p.initialPageY-n.$sb(p.rollingPageY))<30){const g=this.w(v.Contextmenu,p.initialTarget);g.pageX=n.$sb(p.rollingPageX),g.pageY=n.$sb(p.rollingPageY),this.z(g)}else if(s===1){const g=n.$sb(p.rollingPageX),h=n.$sb(p.rollingPageY),T=n.$sb(p.rollingTimestamps)-p.rollingTimestamps[0],O=g-p.rollingPageX[0],R=h-p.rollingPageY[0],w=[...this.g].filter(S=>p.initialTarget instanceof Node&&S.contains(p.initialTarget));this.C(o,w,e,Math.abs(O)/T,O>0?1:-1,g,Math.abs(R)/T,R>0?1:-1,h)}this.z(this.w(v.End,p.initialTarget)),delete this.m[a.identifier]}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}w(o,l){const e=document.createEvent("CustomEvent");return e.initEvent(o,!1,!0),e.initialTarget=l,e.tapCount=0,e}z(o){if(o.type===v.Tap){const l=new Date().getTime();let e=0;l-this.n>y.r?e=1:e=2,this.n=l,o.tapCount=e}else(o.type===v.Change||o.type===v.Contextmenu)&&(this.n=0);if(o.initialTarget instanceof Node){for(const l of this.h)if(l.contains(o.initialTarget))return;for(const l of this.g)l.contains(o.initialTarget)&&(l.dispatchEvent(o),this.f=!0)}}C(o,l,e,s,m,$,a,p,f){this.j=A.$AP(o,()=>{const g=Date.now(),h=g-e;let T=0,O=0,R=!0;s+=y.a*h,a+=y.a*h,s>0&&(R=!1,T=m*s*h),a>0&&(R=!1,O=p*a*h);const w=this.w(v.Change);w.translationX=T,w.translationY=O,l.forEach(S=>S.dispatchEvent(w)),R||this.C(o,l,g,s,m,$+T,a,p,f+O)})}D(o){const l=Date.now();for(let e=0,s=o.changedTouches.length;e<s;e++){const m=o.changedTouches.item(e);if(!this.m.hasOwnProperty(String(m.identifier))){console.warn("end of an UNKNOWN touch",m);continue}const $=this.m[m.identifier],a=this.w(v.Change,$.initialTarget);a.translationX=m.pageX-n.$sb($.rollingPageX),a.translationY=m.pageY-n.$sb($.rollingPageY),a.pageX=m.pageX,a.pageY=m.pageY,this.z(a),$.rollingPageX.length>3&&($.rollingPageX.shift(),$.rollingPageY.shift(),$.rollingTimestamps.shift()),$.rollingPageX.push(m.pageX),$.rollingPageY.push(m.pageY),$.rollingTimestamps.push(l)}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}}t.$ZQ=y,Ye([z.$vh],y,"isTouchDevice",null)}),define(be[57],$e([1,0,3,92]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=t.$tR=t.$sR=void 0;const P=2e4;let n,z,E,k,b;function v(l){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const m=document.createElement("div");return m.className="monaco-alert",m.setAttribute("role","alert"),m.setAttribute("aria-atomic","true"),n.appendChild(m),m};z=e(),E=e();const s=()=>{const m=document.createElement("div");return m.className="monaco-status",m.setAttribute("aria-live","polite"),m.setAttribute("aria-atomic","true"),n.appendChild(m),m};k=s(),b=s(),l.appendChild(n)}t.$sR=v;function y(l){n&&(z.textContent!==l?(A.$pP(E),o(z,l)):(A.$pP(z),o(E,l)))}t.$tR=y;function L(l){n&&(k.textContent!==l?(A.$pP(b),o(k,l)):(A.$pP(k),o(b,l)))}t.$uR=L;function o(l,e){A.$pP(l),e.length>P&&(e=e.substr(0,P)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define(be[119],$e([1,0,3,18]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XR=t.$WR=void 0;const n=new RegExp(`(\\\\)?\\$\\((${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?)\\)`,"g");function z(k){const b=new Array;let v,y=0,L=0;for(;(v=n.exec(k))!==null;){L=v.index||0,y<L&&b.push(k.substring(y,L)),y=(v.index||0)+v[0].length;const[,o,l]=v;b.push(o?`$(${l})`:E({id:l}))}return y<k.length&&b.push(k.substring(y)),b}t.$WR=z;function E(k){const b=A.$("span");return b.classList.add(...P.ThemeIcon.asClassNameArray(k)),b}t.$XR=E}),define(be[120],$e([1,0,3]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=void 0;function P(z){try{z.parentElement?.removeChild(z)}catch{}}class n{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let k=this.h(E).pop(),b=!1;if(k)b=this.b.has(k.domNode),b&&this.b.delete(k.domNode);else{const v=(0,A.$)(".monaco-list-row"),L=this.i(E).renderTemplate(v);k={domNode:v,templateId:E,templateData:L}}return{row:k,isReusingConnectedDomNode:b}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(E){const{domNode:k,templateId:b}=E;k&&(this.c?this.b.add(k):this.g(k)),this.h(b).push(E)}g(E){E.classList.remove("scrolling"),P(E)}h(E){let k=this.a.get(E);return k||(k=[],this.a.set(E,k)),k}dispose(){this.a.forEach((E,k)=>{for(const b of E)this.i(k).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(E){const k=this.d.get(E);if(!k)throw new Error(`No renderer found for ${E}`);return k}}t.$DR=n}),define(be[121],$e([1,0,9,2]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=void 0;class n extends P.$Tc{constructor(E,k,b){super(),this.a=E,this.b=k,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new A.$bh)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$8Q=n}),define(be[122],$e([1,0,3,25,12,4,2,5]),function(ie,t,A,P,n,z,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5R=void 0;class b extends E.$Tc{constructor(y,L,o,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new z.$Td),this.h=o,this.j(),this.setOptions(y,L)}j(){this.B(P.$ZQ.addTarget(this.a)),[P.EventType.Tap].forEach(y=>{this.B(A.$qP(this.a,y,L=>{this.a.focus()}))}),this.B(A.$rP(this.a,"click",y=>{A.$lQ.stop(y,!0)})),this.B(A.$rP(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(A.$rP(this.a,"keydown",y=>{let L=!1;k.$j?(y.keyCode===18||y.keyCode===16||y.keyCode===10)&&(L=!0):(y.keyCode===18&&y.altKey||y.keyCode===10||y.keyCode===3)&&(L=!0),L&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,L){(!this.c||!n.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((o,l)=>{this.a.add(this.m(o.text,l,o.isDisabled))})),L!==void 0&&this.select(L)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,L,o){const l=document.createElement("option");return l.value=y,l.text=y,l.disabled=!!o,l}}t.$5R=b}),define(be[58],$e([1,0,26,12,9,50,87,4,28]),function(ie,t,A,P,n,z,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=t.$zT=t.$yT=void 0;function v(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.$yT=v;function y(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.$zT=y;function L(l){return typeof l.collapsible=="boolean"}class o{constructor(e,s,m,$={}){this.o=e,this.p=s,this.rootRef=[],this.d=new k.$2d,this.f=new k.$Td,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$Td,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new k.$Td,this.onDidSplice=this.l.event,this.m=new n.$1g(z.$Qd),this.h=typeof $.collapseByDefault>"u"?!1:$.collapseByDefault,this.j=$.filter,this.k=typeof $.autoExpandSingleChildren>"u"?!1:$.autoExpandSingleChildren,this.c={parent:void 0,element:m,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,m=b.Iterable.empty(),$={}){if(e.length===0)throw new A.$wT(this.o,"Invalid tree location");$.diffIdentityProvider?this.q($.diffIdentityProvider,e,s,m,$):this.s(e,s,m,$)}q(e,s,m,$=b.Iterable.empty(),a,p=a.diffDepth??0){const{parentNode:f}=this.G(s);if(!f.lastDiffIds)return this.s(s,m,$,a);const g=[...$],h=s[s.length-1],T=new E.$Qs({getElements:()=>f.lastDiffIds},{getElements:()=>[...f.children.slice(0,h),...g,...f.children.slice(h+m)].map(M=>e.getId(M.element).toString())}).ComputeDiff(!1);if(T.quitEarly)return f.lastDiffIds=void 0,this.s(s,m,g,a);const O=s.slice(0,-1),R=(M,H,_)=>{if(p>0)for(let N=0;N<_;N++)M--,H--,this.q(e,[...O,M,0],Number.MAX_SAFE_INTEGER,g[H].children,a,p-1)};let w=Math.min(f.children.length,h+m),S=g.length;for(const M of T.changes.sort((H,_)=>_.originalStart-H.originalStart))R(w,S,w-(M.originalStart+M.originalLength)),w=M.originalStart,S=M.modifiedStart-h,this.s([...O,w],M.originalLength,b.Iterable.slice(g,S,S+M.modifiedLength),a);R(w,S,w)}s(e,s,m=b.Iterable.empty(),{onDidCreateNode:$,onDidDeleteNode:a,diffIdentityProvider:p}){const{parentNode:f,listIndex:g,revealed:h,visible:T}=this.G(e),O=[],R=b.Iterable.map(m,ue=>this.w(ue,f,f.visible?1:0,h,O,$)),w=e[e.length-1],S=f.children.length>0;let M=0;for(let ue=w;ue>=0&&ue<f.children.length;ue--){const ne=f.children[ue];if(ne.visible){M=ne.visibleChildIndex;break}}const H=[];let _=0,N=0;for(const ue of R)H.push(ue),N+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=M+_++);const I=(0,P.$6b)(f.children,w,s,H);p?f.lastDiffIds?(0,P.$6b)(f.lastDiffIds,w,s,H.map(ue=>p.getId(ue.element).toString())):f.lastDiffIds=f.children.map(ue=>p.getId(ue.element).toString()):f.lastDiffIds=void 0;let B=0;for(const ue of I)ue.visible&&B++;if(B!==0)for(let ue=w+H.length;ue<f.children.length;ue++){const ne=f.children[ue];ne.visible&&(ne.visibleChildIndex-=B)}if(f.visibleChildrenCount+=_-B,h&&T){const ue=I.reduce((ne,te)=>ne+(te.visible?te.renderNodeCount:0),0);this.B(f,N-ue),this.p.splice(g,ue,O)}if(I.length>0&&a){const ue=ne=>{a(ne),ne.children.forEach(ue)};I.forEach(ue)}this.l.fire({insertedNodes:H,deletedNodes:I});const X=f.children.length>0;S!==X&&this.setCollapsible(e.slice(0,-1),X);let Y=f;for(;Y;){if(Y.visibility===2){this.m.trigger(()=>this.refilter());break}Y=Y.parent}}rerender(e){if(e.length===0)throw new A.$wT(this.o,"Invalid tree location");const{node:s,listIndex:m,revealed:$}=this.F(e);s.visible&&$&&this.p.splice(m,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new A.$wT(this.o,"Invalid tree location");const{listIndex:m}=this.F(e);this.p.updateElementHeight(m,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:m,revealed:$}=this.F(e);return m&&$?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const m=this.E(e);typeof s>"u"&&(s=!m.collapsible);const $={collapsible:s};return this.d.bufferEvents(()=>this.t(e,$))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,m){const $=this.E(e);typeof s>"u"&&(s=!$.collapsed);const a={collapsed:s,recursive:m||!1};return this.d.bufferEvents(()=>this.t(e,a))}t(e,s){const{node:m,listIndex:$,revealed:a}=this.F(e),p=this.u(m,$,a,s);if(m!==this.c&&this.k&&p&&!L(s)&&m.collapsible&&!m.collapsed&&!s.recursive){let f=-1;for(let g=0;g<m.children.length;g++)if(m.children[g].visible)if(f>-1){f=-1;break}else f=g;f>-1&&this.t([...e,f],s)}return p}u(e,s,m,$){const a=this.v(e,$,!1);if(!m||!e.visible||!a)return a;const p=e.renderNodeCount,f=this.x(e),g=p-(s===-1?0:1);return this.p.splice(s+1,g,f.slice(1)),a}v(e,s,m){let $;if(e===this.c?$=!1:(L(s)?($=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?($=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):$=!1,$&&this.f.fire({node:e,deep:m})),!L(s)&&s.recursive)for(const a of e.children)$=this.v(a,s,!0)||$;return $}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,m,$,a,p){const f={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},g=this.C(f,m);f.visibility=g,$&&a.push(f);const h=e.children||b.Iterable.empty(),T=$&&g!==0&&!f.collapsed;let O=0,R=1;for(const w of h){const S=this.w(w,f,g,T,a,p);f.children.push(S),R+=S.renderNodeCount,S.visible&&(S.visibleChildIndex=O++)}return f.collapsible=f.collapsible||f.children.length>0,f.visibleChildrenCount=O,f.visible=g===2?O>0:g===1,f.visible?f.collapsed||(f.renderNodeCount=R):(f.renderNodeCount=0,$&&a.pop()),p?.(f),f}x(e){const s=e.renderNodeCount,m=[];return this.y(e,m),this.B(e.parent,m.length-s),m}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const m of e.children)e.renderNodeCount+=this.y(m,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,m=[];return this.A(e,e.visible?1:0,m),this.B(e.parent,m.length-s),m}A(e,s,m,$=!0){let a;if(e!==this.c){if(a=this.C(e,s),a===0)return e.visible=!1,e.renderNodeCount=0,!1;$&&m.push(e)}const p=m.length;e.renderNodeCount=e===this.c?0:1;let f=!1;if(!e.collapsed||a!==0){let g=0;for(const h of e.children)f=this.A(h,a,m,$&&!e.collapsed)||f,h.visible&&(h.visibleChildIndex=g++);e.visibleChildrenCount=g}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=a===2?f:a===1,e.visibility=a),e.visible?e.collapsed||(e.renderNodeCount+=m.length-p):(e.renderNodeCount=0,$&&m.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const m=this.j?this.j.filter(e.element,s):1;return typeof m=="boolean"?(e.filterData=void 0,m?1:0):v(m)?(e.filterData=m.data,y(m.visibility)):(e.filterData=void 0,y(m))}D(e,s=this.c){if(!e||e.length===0)return!0;const[m,...$]=e;return m<0||m>s.children.length?!1:this.D($,s.children[m])}E(e,s=this.c){if(!e||e.length===0)return s;const[m,...$]=e;if(m<0||m>s.children.length)throw new A.$wT(this.o,"Invalid tree location");return this.E($,s.children[m])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:m,revealed:$,visible:a}=this.G(e),p=e[e.length-1];if(p<0||p>s.children.length)throw new A.$wT(this.o,"Invalid tree location");const f=s.children[p];return{node:f,listIndex:m,revealed:$,visible:a&&f.visible}}G(e,s=this.c,m=0,$=!0,a=!0){const[p,...f]=e;if(p<0||p>s.children.length)throw new A.$wT(this.o,"Invalid tree location");for(let g=0;g<p;g++)m+=s.children[g].renderNodeCount;return $=$&&!s.collapsed,a=a&&s.visible,f.length===0?{parentNode:s,listIndex:m,revealed:$,visible:a}:this.G(f,s.children[p],m+1,$,a)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let m=e;for(;m.parent;)s.push(m.parent.children.indexOf(m)),m=m.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,P.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$AT=o}),define(be[123],$e([1,0,58,26,28]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HT=void 0;class z{get size(){return this.d.size}constructor(k,b,v={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new A.$AT(k,b,null,v),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,v.sorter&&(this.j={compare(y,L){return v.sorter.compare(y.element,L.element)}}),this.h=v.identityProvider}setChildren(k,b=n.Iterable.empty(),v={}){const y=this.o(k);this.l(y,this.m(b),v)}l(k,b=n.Iterable.empty(),v){const y=new Set,L=new Set,o=e=>{if(e.element===null)return;const s=e;if(y.add(s.element),this.d.set(s.element,s),this.h){const m=this.h.getId(s.element).toString();L.add(m),this.f.set(m,s)}v.onDidCreateNode?.(s)},l=e=>{if(e.element===null)return;const s=e;if(y.has(s.element)||this.d.delete(s.element),this.h){const m=this.h.getId(s.element).toString();L.has(m)||this.f.delete(m)}v.onDidDeleteNode?.(s)};this.c.splice([...k,0],Number.MAX_VALUE,b,{...v,onDidCreateNode:o,onDidDeleteNode:l})}m(k=n.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),n.Iterable.map(k,b=>{let v=this.d.get(b.element);if(!v&&this.h){const o=this.h.getId(b.element).toString();v=this.f.get(o)}if(!v){let o;return typeof b.collapsed>"u"?o=void 0:b.collapsed===P.ObjectTreeElementCollapseState.Collapsed||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed?o=!0:b.collapsed===P.ObjectTreeElementCollapseState.Expanded||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?o=!1:o=!!b.collapsed,{...b,children:this.m(b.children),collapsed:o}}const y=typeof b.collapsible=="boolean"?b.collapsible:v.collapsible;let L;return typeof b.collapsed>"u"||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?L=v.collapsed:b.collapsed===P.ObjectTreeElementCollapseState.Collapsed?L=!0:b.collapsed===P.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!b.collapsed,{...b,collapsible:y,collapsed:L,children:this.m(b.children)}})}rerender(k){const b=this.o(k);this.c.rerender(b)}updateElementHeight(k,b){const v=this.o(k);this.c.updateElementHeight(v,b)}resort(k=null,b=!0){if(!this.j)return;const v=this.o(k),y=this.c.getNode(v);this.l(v,this.n(y,b),{})}n(k,b,v=!0){let y=[...k.children];return(b||v)&&(y=y.sort(this.j.compare.bind(this.j))),n.Iterable.map(y,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,b,!1)}))}getFirstElementChild(k=null){const b=this.o(k);return this.c.getFirstElementChild(b)}getLastElementAncestor(k=null){const b=this.o(k);return this.c.getLastElementAncestor(b)}has(k){return this.d.has(k)}getListIndex(k){const b=this.o(k);return this.c.getListIndex(b)}getListRenderCount(k){const b=this.o(k);return this.c.getListRenderCount(b)}isCollapsible(k){const b=this.o(k);return this.c.isCollapsible(b)}setCollapsible(k,b){const v=this.o(k);return this.c.setCollapsible(v,b)}isCollapsed(k){const b=this.o(k);return this.c.isCollapsed(b)}setCollapsed(k,b,v){const y=this.o(k);return this.c.setCollapsed(y,b,v)}expandTo(k){const b=this.o(k);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(k);if(!b)throw new P.$wT(this.k,`Tree element not found: ${k}`);return b}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new P.$wT(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(k);if(!b)throw new P.$wT(this.k,`Tree element not found: ${k}`);const v=this.c.getNodeLocation(b),y=this.c.getParentNodeLocation(v);return this.c.getNode(y).element}o(k){if(k===null)return[];const b=this.d.get(k);if(!b)throw new P.$wT(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(b)}}t.$HT=z}),define(be[20],$e([1,0,3,14,19,25,2]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=void 0;class k extends E.$Tc{f(v,y){this.B(A.$qP(v,A.$jQ.CLICK,L=>y(new n.$iP(A.getWindow(v),L))))}j(v,y){this.B(A.$qP(v,A.$jQ.MOUSE_DOWN,L=>y(new n.$iP(A.getWindow(v),L))))}m(v,y){this.B(A.$qP(v,A.$jQ.MOUSE_OVER,L=>y(new n.$iP(A.getWindow(v),L))))}u(v,y){this.B(A.$qP(v,A.$jQ.MOUSE_LEAVE,L=>y(new n.$iP(A.getWindow(v),L))))}z(v,y){this.B(A.$qP(v,A.$jQ.KEY_DOWN,L=>y(new P.$nP(L))))}C(v,y){this.B(A.$qP(v,A.$jQ.KEY_UP,L=>y(new P.$nP(L))))}D(v,y){this.B(A.$qP(v,A.$jQ.INPUT,y))}F(v,y){this.B(A.$qP(v,A.$jQ.BLUR,y))}G(v,y){this.B(A.$qP(v,A.$jQ.FOCUS,y))}H(v,y){this.B(A.$qP(v,A.$jQ.CHANGE,y))}I(v){return z.$ZQ.ignoreTarget(v)}}t.$4Q=k}),define(be[38],$e([1,0,56,20,9,18,3]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Q=t.$5Q=void 0,t.$5Q=11;class k extends P.$4Q{constructor(v){super(),this.a=v.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=v.bgWidth+"px",this.bgDomNode.style.height=v.bgHeight+"px",typeof v.top<"u"&&(this.bgDomNode.style.top="0px"),typeof v.left<"u"&&(this.bgDomNode.style.left="0px"),typeof v.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof v.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=v.className,this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(v.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$5Q+"px",this.domNode.style.height=t.$5Q+"px",typeof v.top<"u"&&(this.domNode.style.top=v.top+"px"),typeof v.left<"u"&&(this.domNode.style.left=v.left+"px"),typeof v.bottom<"u"&&(this.domNode.style.bottom=v.bottom+"px"),typeof v.right<"u"&&(this.domNode.style.right=v.right+"px"),this.g=this.B(new A.$3Q),this.B(E.$rP(this.bgDomNode,E.$jQ.POINTER_DOWN,y=>this.h(y))),this.B(E.$rP(this.domNode,E.$jQ.POINTER_DOWN,y=>this.h(y))),this.b=this.B(new E.$CP),this.c=this.B(new n.$bh)}h(v){if(!v.target||!(v.target instanceof Element))return;const y=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow(v))};this.a(),this.b.cancel(),this.c.cancelAndSet(y,200),this.g.startMonitoring(v.target,v.pointerId,v.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),v.preventDefault()}}t.$6Q=k}),define(be[59],$e([1,0,3,41,56,38,121,20,5]),function(ie,t,A,P,n,z,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=void 0;const v=140;class y extends k.$4Q{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.n=this.B(new E.$8Q(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$3Q),this.s=!0,this.domNode=(0,P.$2Q)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(A.$qP(this.domNode.domNode,A.$jQ.POINTER_DOWN,l=>this.M(l)))}t(o){const l=this.B(new z.$6Q(o));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}w(o,l,e,s){this.slider=(0,P.$2Q)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(A.$qP(this.slider.domNode,A.$jQ.POINTER_DOWN,m=>{m.button===0&&(m.preventDefault(),this.O(m))})),this.f(this.slider.domNode,m=>{m.leftButton&&m.stopPropagation()})}y(o){return this.h.setVisibleSize(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(o){return this.h.setScrollSize(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(o){return this.h.setScrollPosition(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(o){o.target===this.domNode.domNode&&this.N(o)}delegatePointerDown(o){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),s=l+this.h.getSliderPosition()+this.h.getSliderSize(),m=this.U(o);e<=m&&m<=s?o.button===0&&(o.preventDefault(),this.O(o)):this.N(o)}N(o){let l,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")l=o.offsetX,e=o.offsetY;else{const m=A.$MP(this.domNode.domNode);l=o.pageX-m.left,e=o.pageY-m.top}const s=this.S(l,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),o.button===0&&(o.preventDefault(),this.O(o))}O(o){if(!o.target||!(o.target instanceof Element))return;const l=this.U(o),e=this.W(o),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(o.target,o.pointerId,o.buttons,m=>{const $=this.W(m),a=Math.abs($-e);if(b.$i&&a>v){this.P(s.getScrollPosition());return}const f=this.U(m)-l;this.P(s.getDesiredScrollPositionFromDelta(f))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(o){const l={};this.writeScrollPosition(l,o),this.b.setScrollPositionNow(l)}updateScrollbarSize(o){this.X(o),this.h.setScrollbarSize(o),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$9Q=y}),define(be[124],$e([1,0,19,59,38,42,17]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=void 0;class k extends P.$9Q{constructor(v,y,L){const o=v.getScrollDimensions(),l=v.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:L,scrollbarState:new z.$7Q(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===2?0:y.horizontalScrollbarSize,y.vertical===2?0:y.verticalScrollbarSize,o.width,o.scrollWidth,l.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:v,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const e=(y.arrowSize-n.$5Q)/2,s=(y.horizontalScrollbarSize-n.$5Q)/2;this.t({className:"scra",icon:E.$0j.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$kP(null,1,0))}),this.t({className:"scra",icon:E.$0j.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$kP(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(v,y){this.slider.setWidth(v),this.slider.setLeft(y)}Q(v,y){this.domNode.setWidth(v),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(v){return this.s=this.J(v.scrollWidth)||this.s,this.s=this.L(v.scrollLeft)||this.s,this.s=this.y(v.width)||this.s,this.s}S(v,y){return v}U(v){return v.pageX}W(v){return v.pageY}X(v){this.slider.setHeight(v)}writeScrollPosition(v,y){v.scrollLeft=y}updateOptions(v){this.updateScrollbarSize(v.horizontal===2?0:v.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(v.vertical===2?0:v.verticalScrollbarSize),this.n.setVisibility(v.horizontal),this.c=v.scrollByPage}}t.$0Q=k}),define(be[125],$e([1,0,19,59,38,42,17]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=void 0;class k extends P.$9Q{constructor(v,y,L){const o=v.getScrollDimensions(),l=v.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:L,scrollbarState:new z.$7Q(y.verticalHasArrows?y.arrowSize:0,y.vertical===2?0:y.verticalScrollbarSize,0,o.height,o.scrollHeight,l.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:v,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const e=(y.arrowSize-n.$5Q)/2,s=(y.verticalScrollbarSize-n.$5Q)/2;this.t({className:"scra",icon:E.$0j.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$kP(null,0,1))}),this.t({className:"scra",icon:E.$0j.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$kP(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(v,y){this.slider.setHeight(v),this.slider.setTop(y)}Q(v,y){this.domNode.setWidth(y),this.domNode.setHeight(v),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(v){return this.s=this.J(v.scrollHeight)||this.s,this.s=this.L(v.scrollTop)||this.s,this.s=this.y(v.height)||this.s,this.s}S(v,y){return y}U(v){return v.pageY}W(v){return v.pageX}X(v){this.slider.setWidth(v)}writeScrollPosition(v,y){v.scrollTop=y}updateOptions(v){this.updateScrollbarSize(v.vertical===2?0:v.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(v.vertical),this.c=v.scrollByPage}}t.$$Q=k}),define(be[60],$e([1,0,16,3,41,19,124,125,20,9,4,2,5,48,99]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=t.$cR=t.$bR=t.$aR=t.$_Q=void 0;const e=500,s=50,m=!0;class ${constructor(R,w,S){this.timestamp=R,this.deltaX=w,this.deltaY=S,this.score=0}}class a{static{this.INSTANCE=new a}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,w=0,S=1,M=this.d;do{const H=M===this.c?R:Math.pow(2,-S);if(R-=H,w+=this.b[M].score*H,M===this.c)break;M=(this.a+M-1)%this.a,S++}while(!0);return w<=.5}acceptStandardWheelEvent(R){const w=P.getWindow(R.browserEvent),S=w.devicePixelRatio/(0,A.$4O)(w);o.$i||o.$k?this.accept(Date.now(),R.deltaX/S,R.deltaY/S):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,w,S){const M=new $(R,w,S);M.score=this.f(M),this.c===-1&&this.d===-1?(this.b[0]=M,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=M)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let w=.5;const S=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(w+=.25),Math.min(Math.max(w,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$_Q=a;class p extends b.$4Q{get options(){return this.a}constructor(R,w,S){super(),this.O=this.B(new y.$Td),this.onScroll=this.O.event,this.P=this.B(new y.$Td),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=T(w),this.b=S,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const M={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$$Q(this.b,this.a,M)),this.g=this.B(new E.$0Q(this.b,this.a,M)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$2Q)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$2Q)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$2Q)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new v.$bh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,o.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new z.$kP(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,L.$Oc)(this.w),R)){const S=M=>{this.R(new z.$kP(M))};this.w.push(P.$qP(this.t,P.$jQ.MOUSE_WHEEL,S,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const w=a.INSTANCE;m&&w.acceptStandardWheelEvent(R);let S=!1;if(R.deltaY||R.deltaX){let H=R.deltaY*this.a.mouseWheelScrollSensitivity,_=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&_+H===0?_=H=0:Math.abs(H)>=Math.abs(_)?_=0:H=0),this.a.flipAxes&&([H,_]=[_,H]);const N=!o.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||N)&&!_&&(_=H,H=0),R.browserEvent&&R.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const I=this.b.getFutureScrollPosition();let B={};if(H){const X=s*H,Y=I.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(B,Y)}if(_){const X=s*_,Y=I.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(B,Y)}B=this.b.validateScrollPosition(B),(I.scrollLeft!==B.scrollLeft||I.scrollTop!==B.scrollTop)&&(m&&this.a.mouseWheelSmoothScroll&&w.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),S=!0)}let M=S;!M&&this.a.alwaysConsumeMouseWheel&&(M=!0),!M&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(M=!0),M&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),w=R.scrollTop>0,S=R.scrollLeft>0,M=S?" left":"",H=w?" top":"",_=S||w?" top-left-corner":"";this.n.setClassName(`shadow${M}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${_}${H}${M}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$aR=p;class f extends p{constructor(R,w){w=w||{},w.mouseWheelSmoothScroll=!1;const S=new l.$as({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>P.$AP(P.getWindow(R),M)});super(R,w,S),this.B(S)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$bR=f;class g extends p{constructor(R,w,S){super(R,w,S)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$cR=g;class h extends p{constructor(R,w){w=w||{},w.mouseWheelSmoothScroll=!1;const S=new l.$as({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>P.$AP(P.getWindow(R),M)});super(R,w,S),this.B(S),this.cb=R,this.B(this.onScroll(M=>{M.scrollTopChanged&&(this.cb.scrollTop=M.scrollTop),M.scrollLeftChanged&&(this.cb.scrollLeft=M.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$dR=h;function T(O){const R={lazyRender:typeof O.lazyRender<"u"?O.lazyRender:!1,className:typeof O.className<"u"?O.className:"",useShadows:typeof O.useShadows<"u"?O.useShadows:!0,handleMouseWheel:typeof O.handleMouseWheel<"u"?O.handleMouseWheel:!0,flipAxes:typeof O.flipAxes<"u"?O.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof O.consumeMouseWheelIfScrollbarIsNeeded<"u"?O.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof O.alwaysConsumeMouseWheel<"u"?O.alwaysConsumeMouseWheel:!1,scrollYToX:typeof O.scrollYToX<"u"?O.scrollYToX:!1,mouseWheelScrollSensitivity:typeof O.mouseWheelScrollSensitivity<"u"?O.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof O.fastScrollSensitivity<"u"?O.fastScrollSensitivity:5,scrollPredominantAxis:typeof O.scrollPredominantAxis<"u"?O.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof O.mouseWheelSmoothScroll<"u"?O.mouseWheelSmoothScroll:!0,arrowSize:typeof O.arrowSize<"u"?O.arrowSize:11,listenOnDomNode:typeof O.listenOnDomNode<"u"?O.listenOnDomNode:null,horizontal:typeof O.horizontal<"u"?O.horizontal:1,horizontalScrollbarSize:typeof O.horizontalScrollbarSize<"u"?O.horizontalScrollbarSize:10,horizontalSliderSize:typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:0,horizontalHasArrows:typeof O.horizontalHasArrows<"u"?O.horizontalHasArrows:!1,vertical:typeof O.vertical<"u"?O.vertical:1,verticalScrollbarSize:typeof O.verticalScrollbarSize<"u"?O.verticalScrollbarSize:10,verticalHasArrows:typeof O.verticalHasArrows<"u"?O.verticalHasArrows:!1,verticalSliderSize:typeof O.verticalSliderSize<"u"?O.verticalSliderSize:0,scrollByPage:typeof O.scrollByPage<"u"?O.scrollByPage:!1};return R.horizontalSliderSize=typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof O.verticalSliderSize<"u"?O.verticalSliderSize:R.verticalScrollbarSize,o.$j&&(R.className+=" mac"),R}}),define(be[61],$e([1,0,54,3,22,25,60,12,9,27,4,2,47,48,83,120,6]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l,e,s,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HR=t.$GR=t.$FR=t.$ER=void 0;const $={CurrentDragAndDropData:void 0},a={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class p{get context(){return this.d}set context(w){this.d=w}constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$ER=p;class f{constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$FR=f;class g{constructor(){this.types=[],this.files=[]}update(w){if(w.types&&this.types.splice(0,this.types.length,...w.types),w.files){this.files.splice(0,this.files.length);for(let S=0;S<w.files.length;S++){const M=w.files.item(S);M&&(M.size||M.type)&&this.files.push(M)}}}getData(){return{types:this.types,files:this.files}}}t.$GR=g;function h(R,w){return Array.isArray(R)&&Array.isArray(w)?(0,k.$ub)(R,w):R===w}class T{constructor(w){w?.getSetSize?this.getSetSize=w.getSetSize.bind(w):this.getSetSize=(S,M,H)=>H,w?.getPosInSet?this.getPosInSet=w.getPosInSet.bind(w):this.getPosInSet=(S,M)=>M+1,w?.getRole?this.getRole=w.getRole.bind(w):this.getRole=S=>"listitem",w?.isChecked?this.isChecked=w.isChecked.bind(w):this.isChecked=S=>{}}}class O{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(w){if(w!==this.O){if(w&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=w,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const S of this.d)this.Y(S);this.V(),this.q.setScrollDimensions({width:(0,P.$PP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(w,S,M,H=a){if(this.Q=S,this.domId=`list_id_${++O.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$1g(50),this.v=!1,this.x=L.$Tc.None,this.y=0,this.G=!1,this.J=L.$Tc.None,this.K=L.$Tc.None,this.L=new L.$Sc,this.M=new y.$Td,this.N=new y.$Td,this.onDidChangeContentHeight=y.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=y.Event.latch(this.N.event,void 0,this.L),this.O=!1,H.horizontalScrolling&&H.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$CR(H.paddingTop??0);for(const N of M)this.j.set(N.templateId,N);this.h=this.L.add(new s.$DR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof H.mouseSupport=="boolean"?H.mouseSupport:!0),this.O=H.horizontalScrolling??a.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof H.paddingBottom>"u"?0:H.paddingBottom,this.D=new T(H.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(H.transformOptimization??a.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(z.$ZQ.addTarget(this.o)),this.p=this.L.add(new l.$as({forceIntegerValues:!0,smoothScrollDuration:H.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:N=>(0,P.$AP)((0,P.getWindow)(this.domNode),N)})),this.q=this.L.add(new E.$cR(this.o,{alwaysConsumeMouseWheel:H.alwaysConsumeMouseWheel??a.alwaysConsumeMouseWheel,horizontal:1,vertical:H.verticalScrollMode??a.verticalScrollMode,useShadows:H.useShadows??a.useShadows,mouseWheelScrollSensitivity:H.mouseWheelScrollSensitivity,fastScrollSensitivity:H.fastScrollSensitivity,scrollByPage:H.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),w.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,P.$qP)(this.o,z.EventType.Change,N=>this.hb(N))),this.L.add((0,P.$qP)(this.q.getDomNode(),"scroll",N=>N.target.scrollTop=0)),this.L.add((0,P.$qP)(this.domNode,"dragover",N=>this.jb(this.fb(N)))),this.L.add((0,P.$qP)(this.domNode,"drop",N=>this.lb(this.fb(N)))),this.L.add((0,P.$qP)(this.domNode,"dragleave",N=>this.kb(this.fb(N)))),this.L.add((0,P.$qP)(this.domNode,"dragend",N=>this.mb(N))),this.z=H.setRowLineHeight??a.setRowLineHeight,this.A=H.setRowHeight??a.setRowHeight,this.B=H.supportDynamicHeights??a.supportDynamicHeights,this.F=H.dnd??this.L.add(a.dnd),this.layout(H.initialSize?.height,H.initialSize?.width)}updateOptions(w){w.paddingBottom!==void 0&&(this.C=w.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),w.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(w.smoothScrolling?125:0),w.horizontalScrolling!==void 0&&(this.P=w.horizontalScrolling);let S;if(w.scrollByPage!==void 0&&(S={...S??{},scrollByPage:w.scrollByPage}),w.mouseWheelScrollSensitivity!==void 0&&(S={...S??{},mouseWheelScrollSensitivity:w.mouseWheelScrollSensitivity}),w.fastScrollSensitivity!==void 0&&(S={...S??{},fastScrollSensitivity:w.fastScrollSensitivity}),S&&this.q.updateOptions(S),w.paddingTop!==void 0&&w.paddingTop!==this.g.paddingTop){const M=this.sb(this.k,this.m),H=w.paddingTop-this.g.paddingTop;this.g.paddingTop=w.paddingTop,this.W(M,Math.max(0,this.k+H),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(w){this.q.delegateScrollFromMouseWheelEvent(w)}delegateVerticalScrollbarPointerDown(w){this.q.delegateVerticalScrollbarPointerDown(w)}updateElementHeight(w,S,M){if(w<0||w>=this.d.length)return;const H=this.d[w].size;if(typeof S>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[w].lastDynamicHeightWidth=void 0,S=H+this.ub(w)}if(H===S)return;const _=this.sb(this.k,this.m);let N=0;w<_.start||M!==null&&M>w&&M<_.end?N=S-H:N=0,this.g.splice(w,1,[{size:S}]),this.d[w].size=S,this.W(_,Math.max(0,this.k+N),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(w,S,M=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(w,S,M)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(w,S,M=[]){const H=this.sb(this.k,this.m),_={start:w,end:w+S},N=o.Range.intersect(H,_),I=new Map;for(let U=N.end-1;U>=N.start;U--){const Z=this.d[U];if(Z.dragStartDisposable.dispose(),Z.checkedDisposable.dispose(),Z.row){let me=I.get(Z.templateId);me||(me=[],I.set(Z.templateId,me));const ve=this.j.get(Z.templateId);ve&&ve.disposeElement&&ve.disposeElement(Z.element,U,Z.row.templateData,Z.size),me.push(Z.row)}Z.row=null}const B={start:w+S,end:this.d.length},X=o.Range.intersect(B,H),Y=o.Range.relativeComplement(B,H),ue=M.map(U=>({id:String(this.f++),element:U,templateId:this.Q.getTemplateId(U),size:this.Q.getHeight(U),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(U),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Tc.None,checkedDisposable:L.$Tc.None}));let ne;w===0&&S>=this.d.length?(this.g=new e.$CR(this.g.paddingTop),this.g.splice(0,0,ue),ne=this.d,this.d=ue):(this.g.splice(w,S,ue),ne=this.d.splice(w,S,...ue));const te=M.length-S,we=this.sb(this.k,this.m),Re=(0,e.$AR)(X,te),Te=o.Range.intersect(we,Re);for(let U=Te.start;U<Te.end;U++)this.Z(this.d[U],U);const Oe=o.Range.relativeComplement(Re,we);for(const U of Oe)for(let Z=U.start;Z<U.end;Z++)this.ab(Z);const re=Y.map(U=>(0,e.$AR)(U,te)),ae=[{start:w,end:w+M.length},...re].map(U=>o.Range.intersect(we,U)),K=this.vb(ae);for(const U of ae)for(let Z=U.start;Z<U.end;Z++){const me=this.d[Z],ke=I.get(me.templateId)?.pop();this.X(Z,K,ke)}for(const U of I.values())for(const Z of U)this.h.release(Z);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ne.map(U=>U.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,P.$AP)((0,P.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let w=0;for(const S of this.d)typeof S.width<"u"&&(w=Math.max(w,S.width));this.E=w,this.q.setScrollDimensions({scrollWidth:w===0?0:w+10}),this.N.fire(this.E)}updateWidth(w){if(!this.P||typeof this.E>"u")return;const S=this.d[w];this.Y(S),typeof S.width<"u"&&S.width>this.E&&(this.E=S.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const w of this.d)w.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.sb(this.k,this.m).start}get firstMostlyVisibleIndex(){const w=this.firstVisibleIndex,S=this.g.positionAt(w),M=this.g.positionAt(w+1);return M!==-1&&(M-S)/2+S<this.scrollTop?w+1:w}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(w){return this.d[w].element}indexOf(w){return this.d.findIndex(S=>S.element===w)}domElement(w){const S=this.d[w].row;return S&&S.domNode}elementHeight(w){return this.d[w].size}elementTop(w){return this.g.positionAt(w)}indexAt(w){return this.g.indexAt(w)}indexAfter(w){return this.g.indexAfter(w)}layout(w,S){const M={height:typeof w=="number"?w:(0,P.$RP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,M.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(M),typeof S<"u"&&(this.n=S,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof S=="number"?S:(0,P.$PP)(this.domNode)})}W(w,S,M,H,_,N=!1){const I=this.sb(S,M),B=o.Range.relativeComplement(I,w),X=o.Range.relativeComplement(w,I),Y=this.vb(B);if(N){const ue=o.Range.intersect(w,I);for(let ne=ue.start;ne<ue.end;ne++)this.Z(this.d[ne],ne)}this.h.transact(()=>{for(const ue of X)for(let ne=ue.start;ne<ue.end;ne++)this.ab(ne);for(const ue of B)for(let ne=ue.start;ne<ue.end;ne++)this.X(ne,Y)}),H!==void 0&&(this.o.style.left=`-${H}px`),this.o.style.top=`-${S}px`,this.P&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=S,this.m=M}X(w,S,M){const H=this.d[w];let _=!1;if(!H.row)if(M)H.row=M;else{const Y=this.h.alloc(H.templateId);H.row=Y.row,_=Y.isReusingConnectedDomNode}const N=this.D.getRole(H.element)||"listitem";H.row.domNode.setAttribute("role",N);const I=this.D.isChecked(H.element);if(typeof I=="boolean")H.row.domNode.setAttribute("aria-checked",String(!!I));else if(I){const Y=ue=>H.row.domNode.setAttribute("aria-checked",String(!!ue));Y(I.value),H.checkedDisposable=I.onDidChange(Y)}(_||!H.row.domNode.parentElement)&&(S?this.o.insertBefore(H.row.domNode,S):this.o.appendChild(H.row.domNode)),this.Z(H,w);const B=this.j.get(H.templateId);if(!B)throw new Error(`No renderer found for template id ${H.templateId}`);B?.renderElement(H.element,w,H.row.templateData,H.size);const X=this.F.getDragURI(H.element);H.dragStartDisposable.dispose(),H.row.domNode.draggable=!!X,X&&(H.dragStartDisposable=(0,P.$qP)(H.row.domNode,"dragstart",Y=>this.ib(H.element,X,Y))),this.P&&(this.Y(H),this.U())}Y(w){if(!w.row||!w.row.domNode)return;w.row.domNode.style.width="fit-content",w.width=(0,P.$PP)(w.row.domNode);const S=(0,P.getWindow)(w.row.domNode).getComputedStyle(w.row.domNode);S.paddingLeft&&(w.width+=parseFloat(S.paddingLeft)),S.paddingRight&&(w.width+=parseFloat(S.paddingRight)),w.row.domNode.style.width=""}Z(w,S){w.row.domNode.style.top=`${this.elementTop(S)}px`,this.A&&(w.row.domNode.style.height=`${w.size}px`),this.z&&(w.row.domNode.style.lineHeight=`${w.size}px`),w.row.domNode.setAttribute("data-index",`${S}`),w.row.domNode.setAttribute("data-last-element",S===this.length-1?"true":"false"),w.row.domNode.setAttribute("data-parity",S%2===0?"even":"odd"),w.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(w.element,S,this.length))),w.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(w.element,S))),w.row.domNode.setAttribute("id",this.getElementDomId(S)),w.row.domNode.classList.toggle("drop-target",w.dropTarget)}ab(w){const S=this.d[w];if(S.dragStartDisposable.dispose(),S.checkedDisposable.dispose(),S.row){const M=this.j.get(S.templateId);M&&M.disposeElement&&M.disposeElement(S.element,w,S.row.templateData,S.size),this.h.release(S.row),S.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(w,S){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:w,reuseAnimation:S})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:w})}get scrollTop(){return this.getScrollTop()}set scrollTop(w){this.setScrollTop(w)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"click")).event,w=>this.bb(w),this.L)}get onMouseDblClick(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"dblclick")).event,w=>this.bb(w),this.L)}get onMouseMiddleClick(){return y.Event.filter(y.Event.map(this.L.add(new n.$rR(this.domNode,"auxclick")).event,w=>this.bb(w),this.L),w=>w.browserEvent.button===1,this.L)}get onMouseUp(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"mouseup")).event,w=>this.bb(w),this.L)}get onMouseDown(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"mousedown")).event,w=>this.bb(w),this.L)}get onMouseOver(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"mouseover")).event,w=>this.bb(w),this.L)}get onMouseMove(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"mousemove")).event,w=>this.bb(w),this.L)}get onMouseOut(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"mouseout")).event,w=>this.bb(w),this.L)}get onContextMenu(){return y.Event.any(y.Event.map(this.L.add(new n.$rR(this.domNode,"contextmenu")).event,w=>this.bb(w),this.L),y.Event.map(this.L.add(new n.$rR(this.domNode,z.EventType.Contextmenu)).event,w=>this.eb(w),this.L))}get onTouchStart(){return y.Event.map(this.L.add(new n.$rR(this.domNode,"touchstart")).event,w=>this.db(w),this.L)}get onTap(){return y.Event.map(this.L.add(new n.$rR(this.o,z.EventType.Tap)).event,w=>this.eb(w),this.L)}bb(w){const S=this.rb(w.target||null),M=typeof S>"u"?void 0:this.d[S],H=M&&M.element;return{browserEvent:w,index:S,element:H}}db(w){const S=this.rb(w.target||null),M=typeof S>"u"?void 0:this.d[S],H=M&&M.element;return{browserEvent:w,index:S,element:H}}eb(w){const S=this.rb(w.initialTarget||null),M=typeof S>"u"?void 0:this.d[S],H=M&&M.element;return{browserEvent:w,index:S,element:H}}fb(w){const S=this.rb(w.target||null),M=typeof S>"u"?void 0:this.d[S],H=M&&M.element;return{browserEvent:w,index:S,element:H}}gb(w){try{const S=this.sb(this.k,this.m);this.W(S,w.scrollTop,w.height,w.scrollLeft,w.scrollWidth),this.B&&this.tb(w.scrollTop,w.height,w.inSmoothScrolling)}catch(S){throw console.error("Got bad scroll event:",w),S}}hb(w){w.preventDefault(),w.stopPropagation(),this.scrollTop-=w.translationY}ib(w,S,M){if(!M.dataTransfer)return;const H=this.F.getDragElements(w);if(M.dataTransfer.effectAllowed="copyMove",M.dataTransfer.setData(A.$XQ.TEXT,S),M.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(H,M)),typeof _>"u"&&(_=String(H.length));const N=(0,P.$)(".monaco-drag-image");N.textContent=_;const B=(X=>{for(;X&&!X.classList.contains("monaco-workbench");)X=X.parentElement;return X||this.domNode.ownerDocument})(this.domNode);B.appendChild(N),M.dataTransfer.setDragImage(N,-10,-10),setTimeout(()=>B.removeChild(N),0)}this.domNode.classList.add("dragging"),this.H=new p(H),$.CurrentDragAndDropData=new f(H),this.F.onDragStart?.(this.H,M)}jb(w){if(w.browserEvent.preventDefault(),this.K.dispose(),$.CurrentDragAndDropData&&$.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(w.browserEvent),!w.browserEvent.dataTransfer))return!1;if(!this.H)if($.CurrentDragAndDropData)this.H=$.CurrentDragAndDropData;else{if(!w.browserEvent.dataTransfer.types)return!1;this.H=new g}const S=this.F.onDragOver(this.H,w.element,w.index,w.browserEvent);if(this.G=typeof S=="boolean"?S:S.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;w.browserEvent.dataTransfer.dropEffect=typeof S!="boolean"&&S.effect===0?"copy":"move";let M;if(typeof S!="boolean"&&S.feedback?M=S.feedback:typeof w.index>"u"?M=[-1]:M=[w.index],M=(0,k.$Mb)(M).filter(H=>H>=-1&&H<this.length).sort((H,_)=>H-_),M=M[0]===-1?[-1]:M,h(this.I,M))return!0;if(this.I=M,this.J.dispose(),M[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Rc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const H of M){const _=this.d[H];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Rc)(()=>{for(const H of M){const _=this.d[H];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}kb(w){this.K.dispose(),this.K=(0,b.$6g)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,w.element,w.index,w.browserEvent)}lb(w){if(!this.G)return;const S=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,!(!S||!w.browserEvent.dataTransfer)&&(w.browserEvent.preventDefault(),S.update(w.browserEvent.dataTransfer),this.F.drop(S,w.element,w.index,w.browserEvent))}mb(w){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(w)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Tc.None}ob(w){if(!this.w){const S=(0,P.$JP)(this.domNode).top;this.w=(0,P.$FQ)((0,P.getWindow)(this.domNode),this.pb.bind(this,S))}this.x.dispose(),this.x=(0,b.$6g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=w.pageY}pb(w){if(this.y===void 0)return;const S=this.y-w,M=this.renderHeight-35;S<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(S-35))):S>M&&(this.scrollTop+=Math.min(14,Math.floor(.3*(S-M))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(w){const S=this.q.getDomNode();let M=w;for(;M instanceof HTMLElement&&M!==this.o&&S.contains(M);){const H=M.getAttribute("data-index");if(H){const _=Number(H);if(!isNaN(_))return _}M=M.parentElement}}sb(w,S){return{start:this.g.indexAt(w),end:this.g.indexAfter(w+S-1)}}tb(w,S,M){const H=this.sb(w,S);let _,N;w===this.elementTop(H.start)?(_=H.start,N=0):H.end-H.start>1&&(_=H.start+1,N=this.elementTop(_)-w);let I=0;for(;;){const B=this.sb(w,S);let X=!1;for(let Y=B.start;Y<B.end;Y++){const ue=this.ub(Y);ue!==0&&this.g.splice(Y,1,[this.d[Y]]),I+=ue,X=X||ue!==0}if(!X){I!==0&&this.S();const Y=o.Range.relativeComplement(H,B);for(const ne of Y)for(let te=ne.start;te<ne.end;te++)this.d[te].row&&this.ab(te);const ue=o.Range.relativeComplement(B,H);for(const ne of ue)for(let te=ne.start;te<ne.end;te++){const we=te+1,Re=we<this.d.length?this.d[we].row:null,Te=Re?Re.domNode:null;this.X(te,Te)}for(let ne=B.start;ne<B.end;ne++)this.d[ne].row&&this.Z(this.d[ne],ne);if(typeof _=="number"){const ne=this.p.getFutureScrollPosition().scrollTop-w,te=this.elementTop(_)-N+ne;this.setScrollTop(te,M)}this.M.fire(this.contentHeight);return}}}ub(w){const S=this.d[w];if(this.Q.getDynamicHeight){const N=this.Q.getDynamicHeight(S.element);if(N!==null){const I=S.size;return S.size=N,S.lastDynamicHeightWidth=this.n,N-I}}if(!S.hasDynamicHeight||S.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(S.element))return 0;const M=S.size;if(S.row)return S.row.domNode.style.height="",S.size=S.row.domNode.offsetHeight,S.lastDynamicHeightWidth=this.n,S.size-M;const{row:H}=this.h.alloc(S.templateId);H.domNode.style.height="",this.o.appendChild(H.domNode);const _=this.j.get(S.templateId);if(!_)throw new m.$cb("Missing renderer for templateId: "+S.templateId);return _.renderElement(S.element,w,H.templateData,void 0),S.size=H.domNode.offsetHeight,_.disposeElement?.(S.element,w,H.templateData,void 0),this.Q.setDynamicHeight?.(S.element,S.size),S.lastDynamicHeightWidth=this.n,this.o.removeChild(H.domNode),this.h.release(H),S.size-M}vb(w){const S=w[w.length-1];if(!S)return null;const M=this.d[S.end];return!M||!M.row?null:M.row.domNode}getElementDomId(w){return`${this.domId}_${w}`}dispose(){for(const w of this.d)if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const S=this.j.get(w.row.templateId);S&&(S.disposeElement?.(w.element,-1,w.row.templateData,void 0),S.disposeTemplate(w.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$HR=O,Ye([v.$vh],O.prototype,"onMouseClick",null),Ye([v.$vh],O.prototype,"onMouseDblClick",null),Ye([v.$vh],O.prototype,"onMouseMiddleClick",null),Ye([v.$vh],O.prototype,"onMouseUp",null),Ye([v.$vh],O.prototype,"onMouseDown",null),Ye([v.$vh],O.prototype,"onMouseOver",null),Ye([v.$vh],O.prototype,"onMouseMove",null),Ye([v.$vh],O.prototype,"onMouseOut",null),Ye([v.$vh],O.prototype,"onContextMenu",null),Ye([v.$vh],O.prototype,"onTouchStart",null),Ye([v.$vh],O.prototype,"onTap",null)}),define(be[39],$e([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,98]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l,e,s,m,$,a,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VR=t.$UR=t.$TR=t.$SR=t.$RR=t.$QR=t.$PR=t.TypeNavigationMode=t.$OR=t.$NR=t.$MR=t.$LR=t.$KR=t.$JR=t.$IR=void 0;class g{constructor(D){this.d=D,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(D){return D}renderElement(D,i,r){const c=this.c.findIndex(u=>u.templateData===r);if(c>=0){const u=this.c[c];this.d.unrender(r),u.index=i}else{const u={index:i,templateData:r};this.c.push(u)}this.d.renderIndex(i,r)}splice(D,i,r){const c=[];for(const u of this.c)u.index<D?c.push(u):u.index>=D+i&&c.push({index:u.index+r-i,templateData:u.templateData});this.c=c}renderIndexes(D){for(const{index:i,templateData:r}of this.c)D.indexOf(i)>-1&&this.d.renderIndex(i,r)}disposeTemplate(D){const i=this.c.findIndex(r=>r.templateData===D);i<0||this.c.splice(i,1)}}class h{get name(){return this.g}get renderer(){return new g(this)}constructor(D){this.g=D,this.c=[],this.d=[],this.f=new o.$Td,this.onChange=this.f.event}splice(D,i,r){const c=r.length-i,u=D+i,d=[];let F=0;for(;F<this.d.length&&this.d[F]<D;)d.push(this.d[F++]);for(let C=0;C<r.length;C++)r[C]&&d.push(C+D);for(;F<this.d.length&&this.d[F]>=u;)d.push(this.d[F++]+c);this.renderer.splice(D,i,r.length),this.h(d,d)}renderIndex(D,i){i.classList.toggle(this.g,this.contains(D))}unrender(D){D.classList.remove(this.g)}set(D,i){return this.h(D,[...D].sort(Z),i)}h(D,i,r){const c=this.c,u=this.d;this.c=D,this.d=i;const d=K(u,D);return this.renderer.renderIndexes(d),this.f.fire({indexes:D,browserEvent:r}),c}get(){return this.c}contains(D){return(0,b.$wb)(this.d,D,Z)>=0}dispose(){(0,e.$Oc)(this.f)}}Ye([L.$vh],h.prototype,"renderer",null);class T extends h{constructor(D){super("selected"),this.k=D}renderIndex(D,i){super.renderIndex(D,i),this.k&&(this.contains(D)?i.setAttribute("aria-selected","true"):i.setAttribute("aria-selected","false"))}}class O{constructor(D,i,r){this.c=D,this.d=i,this.f=r}splice(D,i,r){if(!this.f)return this.c.splice(D,i,new Array(r.length).fill(!1));const c=this.c.get().map(F=>this.f.getId(this.d.element(F)).toString());if(c.length===0)return this.c.splice(D,i,new Array(r.length).fill(!1));const u=new Set(c),d=r.map(F=>u.has(this.f.getId(F).toString()));this.c.splice(D,i,d)}}function R(ge){return ge.tagName==="INPUT"||ge.tagName==="TEXTAREA"}t.$IR=R;function w(ge,D){return ge.classList.contains(D)?!0:ge.classList.contains("monaco-list")||!ge.parentElement?!1:w(ge.parentElement,D)}function S(ge){return w(ge,"monaco-editor")}t.$JR=S;function M(ge){return w(ge,"monaco-custom-toggle")}t.$KR=M;function H(ge){return w(ge,"action-item")}t.$LR=H;function _(ge){return w(ge,"monaco-tl-twistie")}t.$MR=_;function N(ge){return w(ge,"monaco-tree-sticky-row")}t.$NR=N;function I(ge){return ge.tagName==="A"&&ge.classList.contains("monaco-button")||ge.tagName==="DIV"&&ge.classList.contains("monaco-button-dropdown")?!0:ge.classList.contains("monaco-list")||!ge.parentElement?!1:I(ge.parentElement)}t.$OR=I;class B{get g(){return o.Event.chain(this.c.add(new P.$rR(this.k.domNode,"keydown")).event,D=>D.filter(i=>!R(i.target)).map(i=>new n.$nP(i)))}constructor(D,i,r){this.h=D,this.k=i,this.c=new e.$Sc,this.d=new e.$Sc,this.f=r.multipleSelectionSupport,this.c.add(this.g(c=>{switch(c.keyCode){case 3:return this.l(c);case 16:return this.o(c);case 18:return this.p(c);case 11:return this.q(c);case 12:return this.s(c);case 9:return this.u(c);case 31:this.f&&(m.$j?c.metaKey:c.ctrlKey)&&this.t(c)}}))}updateOptions(D){D.multipleSelectionSupport!==void 0&&(this.f=D.multipleSelectionSupport)}l(D){D.preventDefault(),D.stopPropagation(),this.h.setSelection(this.h.getFocus(),D.browserEvent)}o(D){D.preventDefault(),D.stopPropagation(),this.h.focusPrevious(1,!1,D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}p(D){D.preventDefault(),D.stopPropagation(),this.h.focusNext(1,!1,D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}q(D){D.preventDefault(),D.stopPropagation(),this.h.focusPreviousPage(D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}s(D){D.preventDefault(),D.stopPropagation(),this.h.focusNextPage(D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}t(D){D.preventDefault(),D.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),D.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(D){this.h.getSelection().length&&(D.preventDefault(),D.stopPropagation(),this.h.setSelection([],D.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([L.$vh],B.prototype,"g",null);var X;(function(ge){ge[ge.Automatic=0]="Automatic",ge[ge.Trigger=1]="Trigger"})(X||(t.TypeNavigationMode=X={}));var Y;(function(ge){ge[ge.Idle=0]="Idle",ge[ge.Typing=1]="Typing"})(Y||(Y={})),t.$PR=new class{mightProducePrintableCharacter(ge){return ge.ctrlKey||ge.metaKey||ge.altKey?!1:ge.keyCode>=31&&ge.keyCode<=56||ge.keyCode>=21&&ge.keyCode<=30||ge.keyCode>=98&&ge.keyCode<=107||ge.keyCode>=85&&ge.keyCode<=95}};class ue{constructor(D,i,r,c,u){this.o=D,this.p=i,this.q=r,this.s=c,this.t=u,this.c=!1,this.d=Y.Idle,this.f=X.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(D.options)}updateOptions(D){D.typeNavigationEnabled??!0?this.u():this.v(),this.f=D.typeNavigationMode??X.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let D=!1;const i=o.Event.chain(this.k.add(new P.$rR(this.p.domNode,"keydown")).event,u=>u.filter(d=>!R(d.target)).filter(()=>this.f===X.Automatic||this.g).map(d=>new n.$nP(d)).filter(d=>D||this.s(d)).filter(d=>this.t.mightProducePrintableCharacter(d)).forEach(d=>A.$lQ.stop(d,!0)).map(d=>d.browserEvent.key)),r=o.Event.debounce(i,()=>null,800,void 0,void 0,void 0,this.k);o.Event.reduce(o.Event.any(i,r),(u,d)=>d===null?null:(u||"")+d,void 0,this.k)(this.x,this,this.k),r(this.w,this,this.k),i(()=>D=!0,void 0,this.k),r(()=>D=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const D=this.o.getFocus();if(D.length>0&&D[0]===this.h){const i=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(D[0]));i&&(0,E.$tR)(i)}this.h=-1}x(D){if(!D){this.d=Y.Idle,this.g=!1;return}const i=this.o.getFocus(),r=i.length>0?i[0]:0,c=this.d===Y.Idle?1:0;this.d=Y.Typing;for(let u=0;u<this.o.length;u++){const d=(r+u+c)%this.o.length,F=this.q.getKeyboardNavigationLabel(this.p.element(d)),C=F&&F.toString();if(this.o.options.typeNavigationEnabled){if(typeof C<"u"){if((0,l.$Sj)(D,C)){this.h=r,this.o.setFocus([d]),this.o.reveal(d);return}const W=(0,l.$Zj)(D,C);if(W&&W[0].end-W[0].start>1&&W.length===1){this.h=r,this.o.setFocus([d]),this.o.reveal(d);return}}}else if(typeof C>"u"||(0,l.$Sj)(D,C)){this.h=r,this.o.setFocus([d]),this.o.reveal(d);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ne{constructor(D,i){this.d=D,this.f=i,this.c=new e.$Sc;const r=o.Event.chain(this.c.add(new P.$rR(i.domNode,"keydown")).event,u=>u.filter(d=>!R(d.target)).map(d=>new n.$nP(d)));o.Event.chain(r,u=>u.filter(d=>d.keyCode===2&&!d.ctrlKey&&!d.metaKey&&!d.shiftKey&&!d.altKey))(this.g,this,this.c)}g(D){if(D.target!==this.f.domNode)return;const i=this.d.getFocus();if(i.length===0)return;const r=this.f.domElement(i[0]);if(!r)return;const c=r.querySelector("[tabIndex]");if(!c||!(c instanceof HTMLElement)||c.tabIndex===-1)return;const u=(0,A.getWindow)(c).getComputedStyle(c);u.visibility==="hidden"||u.display==="none"||(D.preventDefault(),D.stopPropagation(),c.focus())}dispose(){this.c.dispose()}}function te(ge){return m.$j?ge.browserEvent.metaKey:ge.browserEvent.ctrlKey}t.$QR=te;function we(ge){return ge.browserEvent.shiftKey}t.$RR=we;function Re(ge){return(0,A.$fQ)(ge)&&ge.button===2}const Te={isSelectionSingleChangeEvent:te,isSelectionRangeChangeEvent:we};class Oe{constructor(D){this.k=D,this.f=new e.$Sc,this.g=new o.$Td,this.onPointer=this.g.event,D.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Te),this.d=typeof D.options.mouseSupport>"u"||!!D.options.mouseSupport,this.d&&(D.onMouseDown(this.s,this,this.f),D.onContextMenu(this.t,this,this.f),D.onMouseDblClick(this.v,this,this.f),D.onTouchStart(this.s,this,this.f),this.f.add(z.$ZQ.addTarget(D.getHTMLElement()))),o.Event.any(D.onMouseClick,D.onMouseMiddleClick,D.onTap)(this.u,this,this.f)}updateOptions(D){D.multipleSelectionSupport!==void 0&&(this.c=void 0,D.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Te))}o(D){return this.c?this.c.isSelectionSingleChangeEvent(D):!1}p(D){return this.c?this.c.isSelectionRangeChangeEvent(D):!1}q(D){return this.o(D)||this.p(D)}s(D){S(D.browserEvent.target)||(0,A.$3P)()!==D.browserEvent.target&&this.k.domFocus()}t(D){if(R(D.browserEvent.target)||S(D.browserEvent.target))return;const i=typeof D.index>"u"?[]:[D.index];this.k.setFocus(i,D.browserEvent)}u(D){if(!this.d||R(D.browserEvent.target)||S(D.browserEvent.target)||D.browserEvent.isHandledByList)return;D.browserEvent.isHandledByList=!0;const i=D.index;if(typeof i>"u"){this.k.setFocus([],D.browserEvent),this.k.setSelection([],D.browserEvent),this.k.setAnchor(void 0);return}if(this.q(D))return this.w(D);this.k.setFocus([i],D.browserEvent),this.k.setAnchor(i),Re(D.browserEvent)||this.k.setSelection([i],D.browserEvent),this.g.fire(D)}v(D){if(R(D.browserEvent.target)||S(D.browserEvent.target)||this.q(D)||D.browserEvent.isHandledByList)return;D.browserEvent.isHandledByList=!0;const i=this.k.getFocus();this.k.setSelection(i,D.browserEvent)}w(D){const i=D.index;let r=this.k.getAnchor();if(this.p(D)){typeof r>"u"&&(r=this.k.getFocus()[0]??i,this.k.setAnchor(r));const c=Math.min(r,i),u=Math.max(r,i),d=(0,b.$Sb)(c,u+1),F=this.k.getSelection(),C=ae(K(F,[r]),r);if(C.length===0)return;const W=K(d,U(F,C));this.k.setSelection(W,D.browserEvent),this.k.setFocus([i],D.browserEvent)}else if(this.o(D)){const c=this.k.getSelection(),u=c.filter(d=>d!==i);this.k.setFocus([i]),this.k.setAnchor(i),c.length===u.length?this.k.setSelection([...u,i],D.browserEvent):this.k.setSelection(u,D.browserEvent)}}dispose(){this.f.dispose()}}t.$SR=Oe;class re{constructor(D,i){this.c=D,this.d=i}style(D){const i=this.d&&`.${this.d}`,r=[];D.listBackground&&r.push(`.monaco-list${i} .monaco-list-rows { background: ${D.listBackground}; }`),D.listFocusBackground&&(r.push(`.monaco-list${i}:focus .monaco-list-row.focused { background-color: ${D.listFocusBackground}; }`),r.push(`.monaco-list${i}:focus .monaco-list-row.focused:hover { background-color: ${D.listFocusBackground}; }`)),D.listFocusForeground&&r.push(`.monaco-list${i}:focus .monaco-list-row.focused { color: ${D.listFocusForeground}; }`),D.listActiveSelectionBackground&&(r.push(`.monaco-list${i}:focus .monaco-list-row.selected { background-color: ${D.listActiveSelectionBackground}; }`),r.push(`.monaco-list${i}:focus .monaco-list-row.selected:hover { background-color: ${D.listActiveSelectionBackground}; }`)),D.listActiveSelectionForeground&&r.push(`.monaco-list${i}:focus .monaco-list-row.selected { color: ${D.listActiveSelectionForeground}; }`),D.listActiveSelectionIconForeground&&r.push(`.monaco-list${i}:focus .monaco-list-row.selected .codicon { color: ${D.listActiveSelectionIconForeground}; }`),D.listFocusAndSelectionBackground&&r.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.selected.focused { background-color: ${D.listFocusAndSelectionBackground}; }
			`),D.listFocusAndSelectionForeground&&r.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.selected.focused { color: ${D.listFocusAndSelectionForeground}; }
			`),D.listInactiveFocusForeground&&(r.push(`.monaco-list${i} .monaco-list-row.focused { color:  ${D.listInactiveFocusForeground}; }`),r.push(`.monaco-list${i} .monaco-list-row.focused:hover { color:  ${D.listInactiveFocusForeground}; }`)),D.listInactiveSelectionIconForeground&&r.push(`.monaco-list${i} .monaco-list-row.focused .codicon { color:  ${D.listInactiveSelectionIconForeground}; }`),D.listInactiveFocusBackground&&(r.push(`.monaco-list${i} .monaco-list-row.focused { background-color:  ${D.listInactiveFocusBackground}; }`),r.push(`.monaco-list${i} .monaco-list-row.focused:hover { background-color:  ${D.listInactiveFocusBackground}; }`)),D.listInactiveSelectionBackground&&(r.push(`.monaco-list${i} .monaco-list-row.selected { background-color:  ${D.listInactiveSelectionBackground}; }`),r.push(`.monaco-list${i} .monaco-list-row.selected:hover { background-color:  ${D.listInactiveSelectionBackground}; }`)),D.listInactiveSelectionForeground&&r.push(`.monaco-list${i} .monaco-list-row.selected { color: ${D.listInactiveSelectionForeground}; }`),D.listHoverBackground&&r.push(`.monaco-list${i}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${D.listHoverBackground}; }`),D.listHoverForeground&&r.push(`.monaco-list${i}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${D.listHoverForeground}; }`);const c=(0,A.$IQ)(D.listFocusAndSelectionOutline,(0,A.$IQ)(D.listSelectionOutline,D.listFocusOutline??""));c&&r.push(`.monaco-list${i}:focus .monaco-list-row.focused.selected { outline: 1px solid ${c}; outline-offset: -1px;}`),D.listFocusOutline&&r.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${i}.last-focused .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }
			`);const u=(0,A.$IQ)(D.listSelectionOutline,D.listInactiveFocusOutline??"");u&&r.push(`.monaco-list${i} .monaco-list-row.focused.selected { outline: 1px dotted ${u}; outline-offset: -1px; }`),D.listSelectionOutline&&r.push(`.monaco-list${i} .monaco-list-row.selected { outline: 1px dotted ${D.listSelectionOutline}; outline-offset: -1px; }`),D.listInactiveFocusOutline&&r.push(`.monaco-list${i} .monaco-list-row.focused { outline: 1px dotted ${D.listInactiveFocusOutline}; outline-offset: -1px; }`),D.listHoverOutline&&r.push(`.monaco-list${i} .monaco-list-row:hover { outline: 1px dashed ${D.listHoverOutline}; outline-offset: -1px; }`),D.listDropBackground&&r.push(`
				.monaco-list${i}.drop-target,
				.monaco-list${i} .monaco-list-rows.drop-target,
				.monaco-list${i} .monaco-list-row.drop-target { background-color: ${D.listDropBackground} !important; color: inherit !important; }
			`),D.tableColumnsBorder&&r.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${D.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),D.tableOddRowsBackgroundColor&&r.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${D.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=r.join(`
`)}}t.$TR=re,t.$UR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:y.$ct.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:y.$ct.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:y.$ct.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const J={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ae(ge,D){const i=ge.indexOf(D);if(i===-1)return[];const r=[];let c=i-1;for(;c>=0&&ge[c]===D-(i-c);)r.push(ge[c--]);for(r.reverse(),c=i;c<ge.length&&ge[c]===D+(c-i);)r.push(ge[c++]);return r}function K(ge,D){const i=[];let r=0,c=0;for(;r<ge.length||c<D.length;)if(r>=ge.length)i.push(D[c++]);else if(c>=D.length)i.push(ge[r++]);else if(ge[r]===D[c]){i.push(ge[r]),r++,c++;continue}else ge[r]<D[c]?i.push(ge[r++]):i.push(D[c++]);return i}function U(ge,D){const i=[];let r=0,c=0;for(;r<ge.length||c<D.length;)if(r>=ge.length)i.push(D[c++]);else if(c>=D.length)i.push(ge[r++]);else if(ge[r]===D[c]){r++,c++;continue}else ge[r]<D[c]?i.push(ge[r++]):c++;return i}const Z=(ge,D)=>ge-D;class me{constructor(D,i){this.c=D,this.d=i}get templateId(){return this.c}renderTemplate(D){return this.d.map(i=>i.renderTemplate(D))}renderElement(D,i,r,c){let u=0;for(const d of this.d)d.renderElement(D,i,r[u++],c)}disposeElement(D,i,r,c){let u=0;for(const d of this.d)d.disposeElement?.(D,i,r[u],c),u+=1}disposeTemplate(D){let i=0;for(const r of this.d)r.disposeTemplate(D[i++])}}class ve{constructor(D){this.c=D,this.templateId="a18n"}renderTemplate(D){return D}renderElement(D,i,r){const c=this.c.getAriaLabel(D);c?r.setAttribute("aria-label",c):r.removeAttribute("aria-label");const u=this.c.getAriaLevel&&this.c.getAriaLevel(D);typeof u=="number"?r.setAttribute("aria-level",`${u}`):r.removeAttribute("aria-level")}disposeTemplate(D){}}class ke{constructor(D,i){this.c=D,this.d=i}getDragElements(D){const i=this.c.getSelectedElements();return i.indexOf(D)>-1?i:[D]}getDragURI(D){return this.d.getDragURI(D)}getDragLabel(D,i){if(this.d.getDragLabel)return this.d.getDragLabel(D,i)}onDragStart(D,i){this.d.onDragStart?.(D,i)}onDragOver(D,i,r,c){return this.d.onDragOver(D,i,r,c)}onDragLeave(D,i,r,c){this.d.onDragLeave?.(D,i,r,c)}onDragEnd(D){this.d.onDragEnd?.(D)}drop(D,i,r,c){this.d.drop(D,i,r,c)}dispose(){this.d.dispose()}}class Ee{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),D=>this.G(D),this.y)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),D=>this.G(D),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let D=!1;const i=o.Event.chain(this.y.add(new P.$rR(this.k.domNode,"keydown")).event,u=>u.map(d=>new n.$nP(d)).filter(d=>D=d.keyCode===58||d.shiftKey&&d.keyCode===68).map(d=>A.$lQ.stop(d,!0)).filter(()=>!1)),r=o.Event.chain(this.y.add(new P.$rR(this.k.domNode,"keyup")).event,u=>u.forEach(()=>D=!1).map(d=>new n.$nP(d)).filter(d=>d.keyCode===58||d.shiftKey&&d.keyCode===68).map(d=>A.$lQ.stop(d,!0)).map(({browserEvent:d})=>{const F=this.getFocus(),C=F.length?F[0]:void 0,W=typeof C<"u"?this.k.element(C):void 0,j=typeof C<"u"?this.k.domElement(C):this.k.domNode;return{index:C,element:W,anchor:j,browserEvent:d}})),c=o.Event.chain(this.k.onContextMenu,u=>u.filter(d=>!D).map(({element:d,index:F,browserEvent:C})=>({element:d,index:F,anchor:new f.$iP((0,A.getWindow)(this.k.domNode),C),browserEvent:C})));return o.Event.any(i,r,c)}get onKeyDown(){return this.y.add(new P.$rR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new P.$rR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new P.$rR(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.y.add(new P.$rR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.y.add(new P.$rR(this.k.domNode,"blur",!0)).event)}constructor(D,i,r,c,u=J){this.A=D,this.B=u,this.c=new h("focused"),this.f=new h("anchor"),this.g=new o.$2d,this.x="",this.y=new e.$Sc,this.z=new o.$Td,this.onDidDispose=this.z.event;const d=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new T(d!=="listbox");const F=[this.c.renderer,this.d.renderer];this.u=u.accessibilityProvider,this.u&&(F.push(new ve(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),c=c.map(W=>new me(W.templateId,[...F,W]));const C={...u,dnd:u.dnd&&new ke(this,u.dnd)};if(this.k=this.C(i,r,c,C),this.k.domNode.setAttribute("role",d),u.styleController)this.q=u.styleController(this.k.domId);else{const W=(0,A.$$P)(this.k.domNode);this.q=new re(W,this.k.domId)}if(this.o=new k.$vR([new O(this.c,this.k,u.identityProvider),new O(this.d,this.k,u.identityProvider),new O(this.f,this.k,u.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ne(this,this.k)),(typeof u.keyboardSupport!="boolean"||u.keyboardSupport)&&(this.v=new B(this,this.k,u),this.y.add(this.v)),u.keyboardNavigationLabelProvider){const W=u.keyboardNavigationDelegate||t.$PR;this.t=new ue(this,this.k,u.keyboardNavigationLabelProvider,u.keyboardNavigationEventFilter??(()=>!0),W),this.y.add(this.t)}this.w=this.D(u),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(D,i,r,c){return new p.$HR(D,i,r,c)}D(D){return new Oe(this)}updateOptions(D={}){this.B={...this.B,...D},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(D),this.v?.updateOptions(D),this.k.updateOptions(D)}get options(){return this.B}splice(D,i,r=[]){if(D<0||D>this.k.length)throw new a.$xR(this.A,`Invalid start index: ${D}`);if(i<0)throw new a.$xR(this.A,`Invalid delete count: ${i}`);i===0&&r.length===0||this.g.bufferEvents(()=>this.o.splice(D,i,r))}updateWidth(D){this.k.updateWidth(D)}updateElementHeight(D,i){this.k.updateElementHeight(D,i,null)}rerender(){this.k.rerender()}element(D){return this.k.element(D)}indexOf(D){return this.k.indexOf(D)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(D){this.k.setScrollTop(D)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(D){this.k.setScrollLeft(D)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(D){this.x=D,this.k.domNode.setAttribute("aria-label",D)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(D,i){this.k.layout(D,i)}triggerTypeNavigation(){this.t?.trigger()}setSelection(D,i){for(const r of D)if(r<0||r>=this.length)throw new a.$xR(this.A,`Invalid index ${r}`);this.d.set(D,i)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(D=>this.k.element(D))}setAnchor(D){if(typeof D>"u"){this.f.set([]);return}if(D<0||D>=this.length)throw new a.$xR(this.A,`Invalid index ${D}`);this.f.set([D])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const D=this.getAnchor();return typeof D>"u"?void 0:this.element(D)}setFocus(D,i){for(const r of D)if(r<0||r>=this.length)throw new a.$xR(this.A,`Invalid index ${r}`);this.c.set(D,i)}focusNext(D=1,i=!1,r,c){if(this.length===0)return;const u=this.c.get(),d=this.E(u.length>0?u[0]+D:0,i,c);d>-1&&this.setFocus([d],r)}focusPrevious(D=1,i=!1,r,c){if(this.length===0)return;const u=this.c.get(),d=this.F(u.length>0?u[0]-D:0,i,c);d>-1&&this.setFocus([d],r)}async focusNextPage(D,i){let r=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);r=r===0?0:r-1;const c=this.getFocus()[0];if(c!==r&&(c===void 0||r>c)){const u=this.F(r,!1,i);u>-1&&c!==u?this.setFocus([u],D):this.setFocus([r],D)}else{const u=this.k.getScrollTop();let d=u+this.k.renderHeight;r>c&&(d-=this.k.elementHeight(r)),this.k.setScrollTop(d),this.k.getScrollTop()!==u&&(this.setFocus([]),await(0,v.$5g)(0),await this.focusNextPage(D,i))}}async focusPreviousPage(D,i){let r;const c=this.k.getScrollTop();c===0?r=this.k.indexAt(c):r=this.k.indexAfter(c-1);const u=this.getFocus()[0];if(u!==r&&(u===void 0||u>=r)){const d=this.E(r,!1,i);d>-1&&u!==d?this.setFocus([d],D):this.setFocus([r],D)}else{const d=c;this.k.setScrollTop(c-this.k.renderHeight),this.k.getScrollTop()!==d&&(this.setFocus([]),await(0,v.$5g)(0),await this.focusPreviousPage(D,i))}}focusLast(D,i){if(this.length===0)return;const r=this.F(this.length-1,!1,i);r>-1&&this.setFocus([r],D)}focusFirst(D,i){this.focusNth(0,D,i)}focusNth(D,i,r){if(this.length===0)return;const c=this.E(D,!1,r);c>-1&&this.setFocus([c],i)}E(D,i=!1,r){for(let c=0;c<this.length;c++){if(D>=this.length&&!i)return-1;if(D=D%this.length,!r||r(this.element(D)))return D;D++}return-1}F(D,i=!1,r){for(let c=0;c<this.length;c++){if(D<0&&!i)return-1;if(D=(this.length+D%this.length)%this.length,!r||r(this.element(D)))return D;D--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(D=>this.k.element(D))}reveal(D,i,r=0){if(D<0||D>=this.length)throw new a.$xR(this.A,`Invalid index ${D}`);const c=this.k.getScrollTop(),u=this.k.elementTop(D),d=this.k.elementHeight(D);if((0,$.$Kf)(i)){const F=d-this.k.renderHeight+r;this.k.setScrollTop(F*(0,s.$5l)(i,0,1)+u-r)}else{const F=u+d,C=c+this.k.renderHeight;u<c+r&&F>=C||(u<c+r||F>=C&&d>=this.k.renderHeight?this.k.setScrollTop(u-r):F>=C&&this.k.setScrollTop(F-this.k.renderHeight))}}getRelativeTop(D,i=0){if(D<0||D>=this.length)throw new a.$xR(this.A,`Invalid index ${D}`);const r=this.k.getScrollTop(),c=this.k.elementTop(D),u=this.k.elementHeight(D);if(c<r+i||c+u>r+this.k.renderHeight)return null;const d=u-this.k.renderHeight+i;return Math.abs((r+i-c)/d)}isDOMFocused(){return(0,A.$4P)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(D){return this.k.getElementDomId(D)}getElementTop(D){return this.k.elementTop(D)}style(D){this.q.style(D)}G({indexes:D,browserEvent:i}){return{indexes:D,elements:D.map(r=>this.k.element(r)),browserEvent:i}}H(){const D=this.c.get();this.k.domNode.classList.toggle("element-focused",D.length>0),this.I()}I(){const D=this.c.get();if(D.length>0){let i;this.u?.getActiveDescendantId&&(i=this.u.getActiveDescendantId(this.k.element(D[0]))),this.k.domNode.setAttribute("aria-activedescendant",i||this.k.getElementDomId(D[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const D=this.d.get();this.k.domNode.classList.toggle("selection-none",D.length===0),this.k.domNode.classList.toggle("selection-single",D.length===1),this.k.domNode.classList.toggle("selection-multiple",D.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$VR=Ee,Ye([L.$vh],Ee.prototype,"onDidChangeFocus",null),Ye([L.$vh],Ee.prototype,"onDidChangeSelection",null),Ye([L.$vh],Ee.prototype,"onContextMenu",null),Ye([L.$vh],Ee.prototype,"onKeyDown",null),Ye([L.$vh],Ee.prototype,"onKeyUp",null),Ye([L.$vh],Ee.prototype,"onKeyPress",null),Ye([L.$vh],Ee.prototype,"onDidFocus",null),Ye([L.$vh],Ee.prototype,"onDidBlur",null)}),define(be[62],$e([1,0,6,35,37,10,15]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.MarkdownStringTextNewlineStyle=void 0;var k;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class b{constructor(a="",p=!1){if(this.value=a,typeof this.value!="string")throw(0,A.$7)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(a,p=0){return this.value+=o(this.supportThemeIcons?(0,P.$_j)(a):a).replace(/([ \t]+)/g,(f,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+=`
${l(p,a)}
`,this}appendLink(a,p,f){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(a),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(a,p){const f=new RegExp((0,z.$Me)(p),"g");return a.replace(f,(g,h)=>a.charAt(h-1)!=="\\"?`\\${g}`:g)}}t.$fk=b;function v($){return y($)?!$.value:Array.isArray($)?$.every(v):!0}t.$gk=v;function y($){return $ instanceof b?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}t.$hk=y;function L($,a){return $===a?!0:!$||!a?!1:$.value===a.value&&$.isTrusted===a.isTrusted&&$.supportThemeIcons===a.supportThemeIcons&&$.supportHtml===a.supportHtml&&($.baseUri===a.baseUri||!!$.baseUri&&!!a.baseUri&&(0,n.$yg)(E.URI.from($.baseUri),E.URI.from(a.baseUri)))}t.$ik=L;function o($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$jk=o;function l($,a){const p=$.match(/^`+/gm)?.reduce((g,h)=>g.length>h.length?g:h).length??0,f=p>=3?p+1:3;return[`${"`".repeat(f)}${a}`,$,`${"`".repeat(f)}`].join(`
`)}t.$kk=l;function e($){return $.replace(/"/g,"&quot;")}t.$lk=e;function s($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$mk=s;function m($){const a=[],p=$.split("|").map(g=>g.trim());$=p[0];const f=p[1];if(f){const g=/height=(\d+)/.exec(f),h=/width=(\d+)/.exec(f),T=g?g[1]:"",O=h?h[1]:"",R=isFinite(parseInt(O)),w=isFinite(parseInt(T));R&&a.push(`width="${O}"`),w&&a.push(`height="${T}"`)}return{href:$,dimensions:a}}t.$nk=m}),define(be[126],$e([1,0,3,118,22,55,14,19,119,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l,e,s,m,$,a,p,f,g,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3R=t.$2R=t.$1R=t.$ZR=t.$YR=void 0;const T=Object.freeze({image:(K,U,Z)=>{let me=[],ve=[];return K&&({href:K,dimensions:me}=(0,L.$nk)(K),ve.push(`src="${(0,L.$lk)(K)}"`)),Z&&ve.push(`alt="${(0,L.$lk)(Z)}"`),U&&ve.push(`title="${(0,L.$lk)(U)}"`),me.length&&(ve=ve.concat(me)),"<img "+ve.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,U,Z)=>typeof K!="string"?"":(K===Z&&(Z=(0,L.$mk)(Z)),U=typeof U=="string"?(0,L.$lk)((0,L.$mk)(U)):"",K=(0,L.$mk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${U||K}" draggable="false">${Z}</a>`)});function O(K,U={},Z={}){const me=new s.$Sc;let ve=!1;const ke=(0,z.$qR)(U),Ee=function(C){let W;try{W=(0,$.$zh)(decodeURIComponent(C))}catch{}return W?(W=(0,p.$mn)(W,j=>{if(K.uris&&K.uris[j])return h.URI.revive(K.uris[j])}),encodeURIComponent(JSON.stringify(W))):C},ge=function(C,W){const j=K.uris&&K.uris[C];let V=h.URI.revive(j);return W?C.startsWith(a.Schemas.data+":")?C:(V||(V=h.URI.parse(C)),a.$mg.uriToBrowserUri(V).toString(!0)):!V||h.URI.parse(C).toString()===V.toString()?C:(V.query&&(V=V.with({query:Ee(V.query)})),V.toString())},D=new m.marked.Renderer;D.image=T.image,D.link=T.link,D.paragraph=T.paragraph;const i=[],r=[];if(U.codeBlockRendererSync?D.code=(C,W)=>{const j=l.$5M.nextId(),V=U.codeBlockRendererSync(R(W),C);return r.push([j,V]),`<div class="code" data-code="${j}">${(0,g.$Le)(C)}</div>`}:U.codeBlockRenderer&&(D.code=(C,W)=>{const j=l.$5M.nextId(),V=U.codeBlockRenderer(R(W),C);return i.push(V.then(G=>[j,G])),`<div class="code" data-code="${j}">${(0,g.$Le)(C)}</div>`}),U.actionHandler){const C=function(V){let G=V.target;if(!(G.tagName!=="A"&&(G=G.parentElement,!G||G.tagName!=="A")))try{let oe=G.dataset.href;oe&&(K.baseUri&&(oe=w(h.URI.from(K.baseUri),oe)),U.actionHandler.callback(oe,V))}catch(oe){(0,v.$1)(oe)}finally{V.preventDefault()}},W=U.actionHandler.disposables.add(new n.$rR(ke,"click")),j=U.actionHandler.disposables.add(new n.$rR(ke,"auxclick"));U.actionHandler.disposables.add(y.Event.any(W.event,j.event)(V=>{const G=new k.$iP(A.getWindow(ke),V);!G.leftButton&&!G.middleButton||C(G)})),U.actionHandler.disposables.add(A.$qP(ke,"keydown",V=>{const G=new E.$nP(V);!G.equals(10)&&!G.equals(3)||C(G)}))}K.supportHtml||(Z.sanitizer=C=>(K.isTrusted?C.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?C:"",Z.sanitize=!0,Z.silent=!0),Z.renderer=D;let c=K.value??"";c.length>1e5&&(c=`${c.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(c=(0,o.$ak)(c));let u;if(U.fillInIncompleteTokens){const C={...m.marked.defaults,...Z},W=m.marked.lexer(c,C),j=Y(W);u=m.marked.parser(j,C)}else u=m.marked.parse(c,Z);K.supportThemeIcons&&(u=(0,b.$WR)(u).map(W=>typeof W=="string"?W:W.outerHTML).join(""));const F=new DOMParser().parseFromString(S(K,u),"text/html");if(F.body.querySelectorAll("img").forEach(C=>{const W=C.getAttribute("src");if(W){let j=W;try{K.baseUri&&(j=w(h.URI.from(K.baseUri),j))}catch{}C.src=ge(j,!0)}}),F.body.querySelectorAll("a").forEach(C=>{const W=C.getAttribute("href");if(C.setAttribute("href",""),!W||/^data:|javascript:/i.test(W)||/^command:/i.test(W)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(W))C.replaceWith(...C.childNodes);else{let j=ge(W,!1);K.baseUri&&(j=w(h.URI.from(K.baseUri),W)),C.dataset.href=j}}),ke.innerHTML=S(K,F.body.innerHTML),i.length>0)Promise.all(i).then(C=>{if(ve)return;const W=new Map(C),j=ke.querySelectorAll("div[data-code]");for(const V of j){const G=W.get(V.dataset.code??"");G&&A.$sQ(V,G)}U.asyncRenderCallback?.()});else if(r.length>0){const C=new Map(r),W=ke.querySelectorAll("div[data-code]");for(const j of W){const V=C.get(j.dataset.code??"");V&&A.$sQ(j,V)}}if(U.asyncRenderCallback)for(const C of ke.getElementsByTagName("img")){const W=me.add(A.$qP(C,"load",()=>{W.dispose(),U.asyncRenderCallback()}))}return{element:ke,dispose:()=>{ve=!0,me.dispose()}}}t.$YR=O;function R(K){if(!K)return"";const U=K.split(/[\s+|:|,|\{|\?]/,1);return U.length?U[0]:K}function w(K,U){return/^\w[\w\d+.-]*:/.test(U)?U:K.path.endsWith("/")?(0,f.$Ig)(K,U).toString():(0,f.$Ig)((0,f.$Eg)(K),U).toString()}function S(K,U){const{config:Z,allowedSchemes:me}=M(K);P.addHook("uponSanitizeAttribute",(ke,Ee)=>{if(Ee.attrName==="style"||Ee.attrName==="class"){if(ke.tagName==="SPAN"){if(Ee.attrName==="style"){Ee.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ee.attrValue);return}else if(Ee.attrName==="class"){Ee.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ee.attrValue);return}}Ee.keepAttr=!1;return}else if(ke.tagName==="INPUT"&&ke.attributes.getNamedItem("type")?.value==="checkbox"){if(Ee.attrName==="type"&&Ee.attrValue==="checkbox"||Ee.attrName==="disabled"||Ee.attrName==="checked"){Ee.keepAttr=!0;return}Ee.keepAttr=!1}}),P.addHook("uponSanitizeElement",(ke,Ee)=>{Ee.tagName==="input"&&(ke.attributes.getNamedItem("type")?.value==="checkbox"?ke.setAttribute("disabled",""):ke.parentElement?.removeChild(ke))});const ve=A.$MQ(me);try{return P.sanitize(U,{...Z,RETURN_TRUSTED_TYPE:!0})}finally{P.removeHook("uponSanitizeAttribute"),ve.dispose()}}t.$ZR=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function M(K){const U=[a.Schemas.http,a.Schemas.https,a.Schemas.mailto,a.Schemas.data,a.Schemas.file,a.Schemas.vscodeFileResource,a.Schemas.vscodeRemote,a.Schemas.vscodeRemoteResource];return K.isTrusted&&U.push(a.Schemas.command),{config:{ALLOWED_TAGS:[...A.$NQ],ALLOWED_ATTR:t.$ZR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:U}}function H(K){return typeof K=="string"?K:_(K)}t.$1R=H;function _(K){let U=K.value??"";U.length>1e5&&(U=`${U.substr(0,1e5)}\u2026`);const Z=m.marked.parse(U,{renderer:I.value}).replace(/&(#\d+|[a-zA-Z]+);/g,me=>N.get(me)??me);return S({isTrusted:!1},Z).toString()}t.$2R=_;const N=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),I=new e.$V(()=>{const K=new m.marked.Renderer;return K.code=U=>U,K.blockquote=U=>U,K.html=U=>"",K.heading=(U,Z,me)=>U+`
`,K.hr=()=>"",K.list=(U,Z)=>U,K.listitem=U=>U+`
`,K.paragraph=U=>U+`
`,K.table=(U,Z)=>U+Z+`
`,K.tablerow=U=>U,K.tablecell=(U,Z)=>U+" ",K.strong=U=>U,K.em=U=>U,K.codespan=U=>U,K.br=()=>`
`,K.del=U=>U,K.image=(U,Z,me)=>"",K.text=U=>U,K.link=(U,Z,me)=>me,K});function B(K){let U="";return K.forEach(Z=>{U+=Z.raw}),U}function X(K){for(const U of K.tokens)if(U.type==="text"){const Z=U.raw.split(`
`),me=Z[Z.length-1];if(me.includes("`"))return ne(K);if(me.includes("**"))return Oe(K);if(me.match(/\*\w/))return te(K);if(me.match(/(^|\s)__\w/))return re(K);if(me.match(/(^|\s)_\w/))return we(K);if(me.match(/(^|\s)\[.*\]\(\w*/))return Re(K);if(me.match(/(^|\s)\[\w/))return Te(K)}}function Y(K){let U,Z;for(U=0;U<K.length;U++){const me=K[U];if(me.type==="paragraph"&&me.raw.match(/(\n|^)```/)){Z=ue(K.slice(U));break}if(me.type==="paragraph"&&me.raw.match(/(\n|^)\|/)){Z=ae(K.slice(U));break}if(U===K.length-1&&me.type==="paragraph"){const ve=X(me);if(ve){Z=[ve];break}}}if(Z){const me=[...K.slice(0,U),...Z];return me.links=K.links,me}return K}t.$3R=Y;function ue(K){const U=B(K);return m.marked.lexer(U+"\n```")}function ne(K){return J(K,"`")}function te(K){return J(K,"*")}function we(K){return J(K,"_")}function Re(K){return J(K,")")}function Te(K){return J(K,"](about:blank)")}function Oe(K){return J(K,"**")}function re(K){return J(K,"__")}function J(K,U){const Z=B(Array.isArray(K)?K:[K]);return m.marked.lexer(Z+U)[0]}function ae(K){const U=B(K),Z=U.split(`
`);let me,ve=!1;for(let ke=0;ke<Z.length;ke++){const Ee=Z[ke].trim();if(typeof me>"u"&&Ee.match(/^\s*\|/)){const ge=Ee.match(/(\|[^\|]+)(?=\||$)/g);ge&&(me=ge.length)}else if(typeof me=="number")if(Ee.match(/^\s*\|/)){if(ke!==Z.length-1)return;ve=!0}else return}if(typeof me=="number"&&me>0){const ke=ve?Z.slice(0,-1).join(`
`):U,Ee=!!ke.match(/\|\s*$/),ge=ke+(Ee?"":"|")+`
|${" --- |".repeat(me)}`;return m.marked.lexer(ge)}}}),define(be[127],$e([1,0,3,9,29,62,35,2,7,108]),function(ie,t,A,P,n,z,E,k,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=t.$hR=void 0;function y(l,e){(0,b.$Gf)(e)?l.title=(0,E.$bk)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.$hR=y;class L{constructor(e,s,m){this.c=e,this.d=s,this.f=m}async update(e,s,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let $;if(e===void 0||(0,b.$Gf)(e)||e instanceof HTMLElement)$=e;else if(!(0,b.$Uf)(e.markdown))$=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,v.localize)(0,null),s),this.b=new n.$4d;const a=this.b.token;if($=await e.markdown(a),$===void 0&&($=e.markdownNotSupportedFallback),this.isDisposed||a.isCancellationRequested)return}this.g($,s,m)}g(e,s,m){const $=this.a;if(this.h(e)){const a={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!$},position:{hoverPosition:2},...m};this.a=this.c.showHover(a,s)}$?.dispose()}h(e){return e?(0,z.$hk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(l,e,s,m){let $,a;const p=(_,N)=>{const I=a!==void 0;_&&(a?.dispose(),a=void 0),N&&($?.dispose(),$=void 0),I&&l.onDidHideHover?.()},f=(_,N,I)=>new P.$bh(async()=>{(!a||a.isDisposed)&&(a=new L(l,I||e,_>0),await a.update(s,N,m))},_);let g=!1;const h=A.$qP(e,A.$jQ.MOUSE_DOWN,()=>{g=!0,p(!0,!0)},!0),T=A.$qP(e,A.$jQ.MOUSE_UP,()=>{g=!1},!0),O=A.$qP(e,A.$jQ.MOUSE_LEAVE,_=>{g=!1,p(!1,_.fromElement===e)},!0),R=()=>{if($)return;const _=new k.$Sc,N={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const I=B=>{N.x=B.x+10,B.target instanceof HTMLElement&&B.target.classList.contains("action-label")&&p(!0,!0)};_.add(A.$qP(e,A.$jQ.MOUSE_MOVE,I,!0))}_.add(f(l.delay,!1,N)),$=_},w=A.$qP(e,A.$jQ.MOUSE_OVER,R,!0),S=()=>{if(g||$)return;const _={targetElements:[e],dispose:()=>{}},N=new k.$Sc,I=()=>p(!0,!0);N.add(A.$qP(e,A.$jQ.BLUR,I,!0)),N.add(f(l.delay,!1,_)),$=N},M=A.$qP(e,A.$jQ.FOCUS,S,!0);return{show:_=>{p(!1,!0),f(0,_)},hide:()=>{p(!0,!0)},update:async(_,N)=>{s=_,await a?.update(s,void 0,N)},dispose:()=>{w.dispose(),O.dispose(),h.dispose(),T.dispose(),M.dispose(),p(!0,!0)}}}t.$iR=o}),define(be[128],$e([1,0,3,22,14,126,39,12,4,44,2,5,110,101]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4R=void 0;const l=A.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(a){const p=Object.create(null);return p.root=a,p.text=A.$qQ(a,l(".option-text")),p.detail=A.$qQ(a,l(".option-detail")),p.decoratorRight=A.$qQ(a,l(".option-decorator-right")),p}renderElement(a,p,f){const g=f,h=a.text,T=a.detail,O=a.decoratorRight,R=a.isDisabled;g.text.textContent=h,g.detail.textContent=T||"",g.decoratorRight.innerText=O||"",R?g.root.classList.add("option-disabled"):g.root.classList.remove("option-disabled")}disposeTemplate(a){}}class m extends y.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(a,p,f,g,h){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=g,this.g=h||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=m.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new b.$Td,this.B(this.r),this.O(),this.N(f),this.n=p||0,a&&this.setOptions(a,p),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(a){this.u=a,this.w=A.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=A.$qQ(this.w,l(".select-box-details-pane"));const p=A.$qQ(this.w,l(".select-box-dropdown-container-width-control")),f=A.$qQ(p,l(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",A.$qQ(f,this.D),this.G=0,this.y=A.$$P(this.w),this.w.setAttribute("draggable","true"),this.B(A.$qP(this.w,A.$jQ.DRAG_START,g=>{A.$lQ.stop(g,!0)}))}O(){this.B(A.$rP(this.h,"change",p=>{this.n=p.target.selectedIndex,this.r.fire({index:p.target.selectedIndex,selected:p.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(A.$qP(this.h,A.$jQ.CLICK,p=>{A.$lQ.stop(p),this.f?this.X(!0):this.W()})),this.B(A.$qP(this.h,A.$jQ.MOUSE_DOWN,p=>{A.$lQ.stop(p)}));let a;this.B(A.$qP(this.h,"touchstart",p=>{a=this.f})),this.B(A.$qP(this.h,"touchend",p=>{A.$lQ.stop(p),a?this.X(!0):this.W()})),this.B(A.$qP(this.h,A.$jQ.KEY_DOWN,p=>{const f=new n.$nP(p);let g=!1;L.$j?(f.keyCode===18||f.keyCode===16||f.keyCode===10||f.keyCode===3)&&(g=!0):(f.keyCode===18&&f.altKey||f.keyCode===16&&f.altKey||f.keyCode===10||f.keyCode===3)&&(g=!0),g&&(this.W(),A.$lQ.stop(p,!0))}))}get onDidSelect(){return this.r.event}setOptions(a,p){k.$ub(this.m,a)||(this.m=a,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((f,g)=>{this.h.add(this.U(f.text,g,f.isDisabled)),typeof f.description=="string"&&(this.H=!0)})),p!==void 0&&(this.select(p),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(a){a>=0&&a<this.m.length?this.n=a:a>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(a){this.g.ariaLabel=a,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(a){this.h.tabIndex=a?0:-1}render(a){this.j=a,a.classList.add("select-container"),a.appendChild(this.h),this.R()}Q(){const a=[];this.s.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=a.join(`
`)}R(){const a=this.s.selectBackground??"",p=this.s.selectForeground??"",f=this.s.selectBorder??"";this.h.style.backgroundColor=a,this.h.style.color=p,this.h.style.borderColor=f}S(){const a=this.s.selectBackground??"",p=A.$IQ(this.s.selectListBackground,a);this.C.style.backgroundColor=p,this.I.style.backgroundColor=p;const f=this.s.focusBorder??"";this.w.style.outlineColor=f,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(a,p,f){const g=document.createElement("option");return g.value=a,g.text=a,g.disabled=!!f,g}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.Y(a,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.Y(a),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(a){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),a&&this.h.focus(),this.u.hideContextView())}Y(a,p){return a.appendChild(this.w),this.ab(p),{dispose:()=>{try{a.removeChild(this.w)}catch{}}}}Z(){let a=0;return this.m.forEach((p,f)=>{this.hb(f),this.I.offsetHeight>a&&(a=this.I.offsetHeight)}),a}ab(a){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const p=A.getWindow(this.h),f=A.$MP(this.h),g=A.getWindow(this.h).getComputedStyle(this.h),h=parseFloat(g.getPropertyValue("--dropdown-padding-top"))+parseFloat(g.getPropertyValue("--dropdown-padding-bottom")),T=p.innerHeight-f.top-f.height-(this.g.minBottomMargin||0),O=f.top-m.b,R=this.h.offsetWidth,w=this.bb(this.D),S=Math.max(w,Math.round(R)).toString()+"px";this.w.style.width=S,this.z.getHTMLElement().style.height="",this.z.layout();let M=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const H=this.H?this.L:0,_=M+h+H,N=Math.floor((T-h-H)/this.getHeight()),I=Math.floor((O-h-H)/this.getHeight());if(a)return f.top+f.height>p.innerHeight-22||f.top<m.b||N<1&&I<1?!1:(N<m.c&&I>N&&this.m.length>N?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(f.top+f.height>p.innerHeight-22||f.top<m.b||this.G===0&&N<1||this.G===1&&I<1)return this.X(!0),!1;if(this.G===0){if(this.f&&N+I<1)return this.X(!0),!1;_>T&&(M=N*this.getHeight())}else _>O&&(M=I*this.getHeight());return this.z.layout(M),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=M+h+"px",this.w.style.height=""):this.w.style.height=M+h+"px",this.hb(this.n),this.w.style.width=S,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(a){let p=0;if(a){let f=0,g=0;this.m.forEach((h,T)=>{const O=h.detail?h.detail.length:0,R=h.decoratorRight?h.decoratorRight.length:0,w=h.text.length+O+R;w>g&&(f=T,g=w)}),a.textContent=this.m[f].text+(this.m[f].decoratorRight?this.m[f].decoratorRight+" ":""),p=A.$OP(a)}return p}cb(a){if(this.z)return;this.C=A.$qQ(a,l(".select-box-dropdown-list-container")),this.t=new s,this.z=new E.$VR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:g=>{let h=g.text;return g.detail&&(h+=`. ${g.detail}`),g.decoratorRight&&(h+=`. ${g.decoratorRight}`),g.description&&(h+=`. ${g.description}`),h},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>L.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const p=this.B(new P.$rR(this.C,"keydown")),f=b.Event.chain(p.event,g=>g.filter(()=>this.z.length>0).map(h=>new n.$nP(h)));this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===3))(this.jb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===2))(this.jb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===9))(this.ib,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===16))(this.lb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===18))(this.kb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===12))(this.nb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===11))(this.mb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===14))(this.ob,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode===13))(this.pb,this)),this.B(b.Event.chain(f,g=>g.filter(h=>h.keyCode>=21&&h.keyCode<=56||h.keyCode>=85&&h.keyCode<=113))(this.qb,this)),this.B(A.$qP(this.z.getHTMLElement(),A.$jQ.POINTER_UP,g=>this.db(g))),this.B(this.z.onMouseOver(g=>typeof g.index<"u"&&this.z.setFocus([g.index]))),this.B(this.z.onDidChangeFocus(g=>this.gb(g))),this.B(A.$qP(this.w,A.$jQ.FOCUS_OUT,g=>{!this.f||A.$UP(g.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(a){if(!this.z.length)return;A.$lQ.stop(a);const p=a.target;if(!p||p.classList.contains("slider"))return;const f=p.closest(".monaco-list-row");if(!f)return;const g=Number(f.getAttribute("data-index")),h=f.classList.contains("option-disabled");g>=0&&g<this.m.length&&!h&&(this.n=g,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(a,p){const f=h=>{for(let T=0;T<h.childNodes.length;T++){const O=h.childNodes.item(T);(O.tagName&&O.tagName.toLowerCase())==="img"?h.removeChild(O):f(O)}},g=(0,z.$YR)({value:a,supportThemeIcons:!0},{actionHandler:p});return g.element.classList.add("select-box-description-markdown"),f(g.element),g.element}gb(a){!this.f||!this.H||this.hb(a.indexes[0])}hb(a){this.I.innerText="";const p=this.m[a],f=p?.description??"",g=p?.descriptionIsMarkdown??!1;if(f){if(g){const h=p.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(f,h))}else this.I.innerText=f;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(a){A.$lQ.stop(a),this.select(this.F),this.X(!0)}jb(a){A.$lQ.stop(a),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(a){if(this.n<this.m.length-1){A.$lQ.stop(a,!0);const p=this.m[this.n+1].isDisabled;if(p&&this.m.length>this.n+2)this.n+=2;else{if(p)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(a){this.n>0&&(A.$lQ.stop(a,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(a){A.$lQ.stop(a),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(a){A.$lQ.stop(a),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(a){A.$lQ.stop(a),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(a){A.$lQ.stop(a),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(a){const p=v.KeyCodeUtils.toString(a.keyCode);let f=-1;for(let g=0;g<this.m.length-1;g++)if(f=(g+this.n+1)%this.m.length,this.m[f].text.charAt(0).toUpperCase()===p&&!this.m[f].isDisabled){this.select(f),this.z.setFocus([f]),this.z.reveal(this.z.getFocus()[0]),A.$lQ.stop(a);break}}dispose(){this.X(!1),super.dispose()}}t.$4R=m}),define(be[129],$e([1,0,39,128,122,20,5,100]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7R=t.$6R=void 0,t.$6R={...A.$UR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends z.$4Q{constructor(v,y,L,o,l){super(),E.$j&&!l?.useCustomDrawn?this.a=new n.$5R(v,y,o,l):this.a=new P.$4R(v,y,L,o,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(v,y){this.a.setOptions(v,y)}select(v){this.a.select(v)}setAriaLabel(v){this.a.setAriaLabel(v)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(v){this.a.setFocusable(v)}render(v){this.a.render(v)}}t.$7R=k}),define(be[63],$e([1,0,16,54,3,25,127,129,36,2,5,7,105,52]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cS=t.$bS=t.$aS=void 0;class l extends v.$Tc{get action(){return this._action}constructor($,a,p={}){super(),this.m=p,this._context=$||this,this._action=a,a instanceof b.$Ii&&this.B(a.onDidChange(f=>{this.element&&this.t(f)}))}t($){$.enabled!==void 0&&this.u(),$.checked!==void 0&&this.H(),$.class!==void 0&&this.G(),$.label!==void 0&&(this.w(),this.D()),$.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new b.$Ji)),this.j}set actionRunner($){this.j=$}isEnabled(){return this._action.enabled}setActionContext($){this._context=$}render($){const a=this.element=$;this.B(z.$ZQ.addTarget($));const p=this.m&&this.m.draggable;p&&($.draggable=!0,A.$9O&&this.B((0,n.$qP)($,n.$jQ.DRAG_START,f=>f.dataTransfer?.setData(P.$XQ.TEXT,this._action.label)))),this.B((0,n.$qP)(a,z.EventType.Tap,f=>this.onClick(f,!0))),this.B((0,n.$qP)(a,n.$jQ.MOUSE_DOWN,f=>{p||n.$lQ.stop(f,!0),this._action.enabled&&f.button===0&&a.classList.add("active")})),y.$j&&this.B((0,n.$qP)(a,n.$jQ.CONTEXT_MENU,f=>{f.button===0&&f.ctrlKey===!0&&this.onClick(f)})),this.B((0,n.$qP)(a,n.$jQ.CLICK,f=>{n.$lQ.stop(f,!0),this.m&&this.m.isMenu||this.onClick(f)})),this.B((0,n.$qP)(a,n.$jQ.DBLCLICK,f=>{n.$lQ.stop(f,!0)})),[n.$jQ.MOUSE_UP,n.$jQ.MOUSE_OUT].forEach(f=>{this.B((0,n.$qP)(a,f,g=>{n.$lQ.stop(g),a.classList.remove("active")}))})}onClick($,a=!1){n.$lQ.stop($,!0);const p=L.$Pf(this._context)?this.m?.useEventAsContext?$:{preserveFocus:a}:this._context;this.actionRunner.run(this._action,p)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable($){this.element&&(this.element.tabIndex=$?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const $=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update($):(this.f=(0,E.$iR)(this.m.hoverDelegate,this.element,$),this.q.add(this.f))):this.element.title=$}F(){if(this.element){const $=this.C()??"";this.element.setAttribute("aria-label",$)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$aS=l;class e extends l{constructor($,a,p){super($,a,p),this.m=p,this.m.icon=p.icon!==void 0?p.icon:!1,this.m.label=p.label!==void 0?p.label:!0,this.L=""}render($){super.render($),L.$Qf(this.element);const a=document.createElement("a");if(a.classList.add("action-label"),a.setAttribute("role",this.M()),this.I=a,this.element.appendChild(a),this.m.label&&this.m.keybinding){const p=document.createElement("span");p.classList.add("keybinding"),p.textContent=this.m.keybinding,this.element.appendChild(p)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===b.$Ki.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable($){this.I&&(this.I.tabIndex=$?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let $=null;return this.action.tooltip?$=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&($=this.action.label,this.m.keybinding&&($=o.localize(0,null,$,this.m.keybinding))),$??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const $=this.C()??"";this.I.setAttribute("aria-label",$)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$bS=e;class s extends l{constructor($,a,p,f,g,h,T){super($,a),this.b=new k.$7R(p,f,g,h,T),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions($,a){this.b.setOptions($,a)}select($){this.b.select($)}g(){this.B(this.b.onDidSelect($=>this.n($.selected,$.index)))}n($,a){this.actionRunner.run(this._action,this.r($,a))}r($,a){return $}setFocusable($){this.b.setFocusable($)}focus(){this.b?.focus()}blur(){this.b?.blur()}render($){this.b.render($)}}t.$cS=s}),define(be[64],$e([1,0,3,14,63,36,4,2,7,52]),function(ie,t,A,P,n,z,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kR=t.$jR=t.ActionsOrientation=void 0;var v;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(v||(t.ActionsOrientation=v={}));class y extends k.$Tc{constructor(l,e={}){super(),this.g=this.B(new k.$Sc),this.r=this.B(new k.$3c),this.w=!1,this.y=!0,this.C=this.B(new E.$Td),this.onDidBlur=this.C.event,this.D=this.B(new E.$Td({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new E.$Td),this.onDidRun=this.G.event,this.H=this.B(new E.$Td),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new z.$Ji,this.g.add(this.f)),this.g.add(this.f.onDidRun($=>this.G.fire($))),this.g.add(this.f.onWillRun($=>this.H.fire($))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,m;switch(this.m){case 0:s=[15],m=[17];break;case 1:s=[16],m=[18],this.domNode.className+=" vertical";break}this.B(A.$qP(this.domNode,A.$jQ.KEY_DOWN,$=>{const a=new P.$nP($);let p=!0;const f=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(a.equals(s[0])||a.equals(s[1]))?p=this.P():m&&(a.equals(m[0])||a.equals(m[1]))?p=this.O():a.equals(9)&&this.F?this.D.fire():a.equals(14)?p=this.M():a.equals(13)?p=this.N():a.equals(2)&&f instanceof n.$aS&&f.trapsArrowNavigation?p=this.O():this.J(a)?this.n.keyDown?this.R(a):this.w=!0:p=!1,p&&(a.preventDefault(),a.stopPropagation())})),this.B(A.$qP(this.domNode,A.$jQ.KEY_UP,$=>{const a=new P.$nP($);this.J(a)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(a)),a.preventDefault(),a.stopPropagation()):(a.equals(2)||a.equals(1026)||a.equals(16)||a.equals(18)||a.equals(15)||a.equals(17))&&this.L()})),this.u=this.B(A.$oQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(A.$3P()===this.domNode||!A.$UP(A.$3P(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),l.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(l){l?this.z.setAttribute("aria-label",l):this.z.removeAttribute("aria-label")}setFocusable(l){if(this.y=l,this.y){const e=this.viewItems.find(s=>s instanceof n.$aS&&s.isEnabled());e instanceof n.$aS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$aS&&e.setFocusable(!1)})}J(l){let e=!1;return this.n.keys.forEach(s=>{e=e||l.equals(s)}),e}L(){for(let l=0;l<this.z.children.length;l++){const e=this.z.children[l];if(A.$UP(A.$3P(),e)){this.t=l,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.z;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const s=Array.isArray(l)?l:[l];let m=b.$Kf(e.index)?e.index:null;s.forEach($=>{const a=document.createElement("li");a.className="action-item",a.setAttribute("role","presentation");let p;const f={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(p=this.b.actionViewItemProvider($,f)),p||(p=new n.$bS(this.context,$,f)),this.b.allowContextMenu||this.r.set(p,A.$qP(a,A.$jQ.CONTEXT_MENU,g=>{A.$lQ.stop(g,!0)})),p.actionRunner=this.f,p.setActionContext(this.context),p.render(a),this.y&&p instanceof n.$aS&&this.viewItems.length===0&&p.setFocusable(!0),m===null||m<0||m>=this.z.children.length?(this.z.appendChild(a),this.viewItems.push(p)):(this.z.insertBefore(a,this.z.children[m]),this.viewItems.splice(m,0,p),m++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[l]),this.r.deleteAndDispose(this.viewItems[l]),(0,k.$Oc)(this.viewItems.splice(l,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,k.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),A.$pP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,s;if(l===void 0?e=!0:typeof l=="number"?s=l:typeof l=="boolean"&&(e=l),e&&typeof this.t>"u"){const m=this.viewItems.findIndex($=>$.isEnabled());this.t=m===-1?void 0:m,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(l){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(!l&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===z.$Ki.ID));return this.Q(),!0}P(l){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!l&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===z.$Ki.ID));return this.Q(!0),!0}Q(l,e,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const m=this.t!==void 0?this.viewItems[this.t]:void 0;if(m){let $=!0;b.$Uf(m.focus)||($=!1),this.b.focusOnlyEnabledItems&&b.$Uf(m.isEnabled)&&!m.isEnabled()&&($=!1),m.action.id===z.$Ki.ID&&($=!1),$?(s||this.s!==this.t)&&(m.focus(l),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),$&&m.showHover?.()}}R(l){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$aS){const s=e._context===null||e._context===void 0?l:e._context;this.run(e._action,s)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,k.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$jR=y;function L(o){if(!o.length)return o;let l=-1;for(let s=0;s<o.length;s++)if(o[s].id!==z.$Ki.ID){l=s;break}if(l===-1)return[];o=o.slice(l);for(let s=o.length-1;s>=0&&o[s].id===z.$Ki.ID;s--)o.splice(s,1);let e=!1;for(let s=o.length-1;s>=0;s--){const m=o[s].id===z.$Ki.ID;m&&!e?o.splice(s,1):m?m&&(e=!1):e=!0}return o}t.$kR=L}),define(be[65],$e([1,0,3,22,55,64,57,60,20,4,82,51,109,97]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TS=t.$SS=t.$RS=t.MessageType=void 0;const l=A.$;var e;(function($){$[$.INFO=1]="INFO",$[$.WARNING=2]="WARNING",$[$.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$RS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends b.$4Q{constructor(a,p,f){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new v.$Td),this.onDidChange=this.O.event,this.P=this.B(new v.$Td),this.onDidHeightChange=this.P.event,this.a=p,this.g=f,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=A.$qQ(a,l(".monaco-inputbox.idle"));const g=this.g.flexibleHeight?"textarea":"input",h=A.$qQ(this.element,l(".ibwrapper"));if(this.b=A.$qQ(h,l(g+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=A.$qQ(h,l("div.mirror")),this.y.innerText="\xA0",this.N=new k.$bR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),A.$qQ(a,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const T=this.B(new P.$rR(a.ownerDocument,"selectionchange")),O=v.Event.filter(T.event,()=>a.ownerDocument.getSelection()?.anchorNode===h);this.B(O(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new z.$jR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(a){this.n=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.r=a,this.b.title=a}setAriaLabel(a){this.s=a,a?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.Y())}get step(){return this.b.step}set step(a){this.b.step=a}get height(){return typeof this.J=="number"?this.J:A.$SP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return A.$4P(this.b)}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(a){a?this.enable():this.disable()}get width(){return A.$OP(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let p=0;if(this.y){const f=parseFloat(this.y.style.paddingLeft||"")||0,g=parseFloat(this.y.style.paddingRight||"")||0;p=f+g}this.b.style.width=a-p+"px"}else this.b.style.width=a+"px";this.y&&(this.y.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.y&&(this.y.style.paddingRight=a+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const a=this.L,p=this.J,f=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:a,height:p}),this.N.setScrollPosition({scrollTop:f})}showMessage(a,p){if(this.w==="open"&&(0,L.$on)(this.h,a))return;this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(a.type));const f=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${A.$IQ(f.border,"transparent")}`,this.h.content&&(this.hasFocus()||p)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let a=null;return this.t&&(a=this.t(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const p=this.g.inputBoxStyles;switch(a){case 1:return{border:p.inputValidationInfoBorder,background:p.inputValidationInfoBackground,foreground:p.inputValidationInfoForeground};case 2:return{border:p.inputValidationWarningBorder,background:p.inputValidationWarningBackground,foreground:p.inputValidationWarningForeground};default:return{border:p.inputValidationErrorBorder,background:p.inputValidationErrorBackground,foreground:p.inputValidationErrorForeground}}}U(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let a;const p=()=>a.style.width=A.$OP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:g=>{if(!this.h)return null;a=A.$qQ(g,l(".monaco-inputbox-container")),p();const h={inline:!0,className:"monaco-inputbox-message"},T=this.h.formatContent?(0,n.$pR)(this.h.content,h):(0,n.$oR)(this.h.content,h);T.classList.add(this.U(this.h.type));const O=this.stylesForType(this.h.type);return T.style.backgroundColor=O.background??"",T.style.color=O.foreground??"",T.style.border=O.border?`1px solid ${O.border}`:"",A.$qQ(a,T),null},onHide:()=>{this.w="closed"},layout:p});let f;this.h.type===3?f=o.localize(0,null,this.h.content):this.h.type===2?f=o.localize(1,null,this.h.content):f=o.localize(2,null,this.h.content),E.$tR(f),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const a=this.value,f=a.charCodeAt(a.length-1)===10?" ":"";(a+f).replace(/\u000c/g,"")?this.y.textContent=a+f:this.y.innerText="\xA0",this.layout()}ab(){const a=this.g.inputBoxStyles,p=a.inputBackground??"",f=a.inputForeground??"",g=a.inputBorder??"";this.element.style.backgroundColor=p,this.element.style.color=f,this.b.style.backgroundColor="inherit",this.b.style.color=f,this.element.style.border=`1px solid ${A.$IQ(g,"transparent")}`}layout(){if(!this.y)return;const a=this.L;this.L=A.$SP(this.y),a!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(a){const p=this.inputElement,f=p.selectionStart,g=p.selectionEnd,h=p.value;f!==null&&g!==null&&(this.value=h.substr(0,f)+a+h.substr(g),p.setSelectionRange(f+1,f+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$SS=s;class m extends s{constructor(a,p,f){const g=o.localize(3,null,"\u21C5"),h=o.localize(4,null,"\u21C5");super(a,p,f),this.db=this.B(new v.$Td),this.onDidFocus=this.db.event,this.eb=this.B(new v.$Td),this.onDidBlur=this.eb.event,this.bb=new y.$PS(f.history,100);const T=()=>{if(f.showHistoryHint&&f.showHistoryHint()&&!this.n.endsWith(g)&&!this.n.endsWith(h)&&this.bb.getHistory().length){const O=this.n.endsWith(")")?g:h,R=this.n+O;f.showPlaceholderOnFocus&&!A.$4P(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((O,R)=>{O.forEach(w=>{w.target.textContent||T()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>T()),this.F(this.b,()=>{const O=R=>{if(this.n.endsWith(R)){const w=this.n.slice(0,this.n.length-R.length);return f.showPlaceholderOnFocus?this.n=w:this.setPlaceHolder(w),!0}else return!1};O(h)||O(g)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(a){this.value&&(a||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(a){const p=this.getHistory();this.clearHistory(),a.forEach(f=>{this.bb.add(f)}),p.forEach(f=>{this.bb.add(f)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let a=this.jb();a&&(a=a===this.value?this.jb():a),this.value=a??"",E.$uR(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let a=this.ib();a&&(a=a===this.value?this.ib():a),a&&(this.value=a,E.$uR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(a){super.setPlaceHolder(a),this.setTooltip(a)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let a=this.bb.current();return a||(a=this.bb.last(),this.bb.next()),a}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$TS=m}),define(be[66],$e([1,0,63,20,17,18,4,3,102]),function(ie,t,A,P,n,z,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_R=t.$$R=t.$0R=t.$9R=t.$8R=void 0,t.$8R={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class b extends A.$aS{constructor(l,e,s){super(l,e,s),this.a=this.B(new v({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(l){this.element=l,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(l){this.a.domNode.tabIndex=l?0:-1}}t.$9R=b;class v extends P.$4Q{constructor(l){super(),this.a=this.B(new E.$Td),this.onChange=this.a.event,this.b=this.B(new E.$Td),this.onKeyDown=this.b.event,this.c=l,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...z.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(l){this.s=l,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(l){this.g&&this.domNode.classList.remove(...z.ThemeIcon.asClassNameArray(this.g)),this.g=l,this.g&&this.domNode.classList.add(...z.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.$0R=v;class y extends P.$4Q{constructor(l,e,s){super(),this.g=l,this.h=e,this.a=this.B(new E.$Td),this.onChange=this.a.event,this.b=new v({title:this.g,isChecked:this.h,icon:n.$0j.check,actionClassName:"monaco-checkbox",...t.$8R}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(m=>{this.n(),this.a.fire(m)}))}get checked(){return this.b.checked}set checked(l){this.b.checked=l,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$4P)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$$R=y;class L extends A.$aS{constructor(l,e,s){super(l,e,s),this.a=this.B(new y(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(l){if(this.element=l,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$qP)(e,k.$jQ.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(l){this.a.domNode.tabIndex=l?0:-1}}t.$_R=L}),define(be[130],$e([1,0,66,17,107]),function(ie,t,A,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7S=t.$6S=t.$5S=void 0;const z=n.localize(0,null),E=n.localize(1,null),k=n.localize(2,null);class b extends A.$0R{constructor(o){super({icon:P.$0j.caseSensitive,title:z+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$5S=b;class v extends A.$0R{constructor(o){super({icon:P.$0j.wholeWord,title:E+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$6S=v;class y extends A.$0R{constructor(o){super({icon:P.$0j.regex,title:k+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$7S=y}),define(be[131],$e([1,0,3,130,65,20,4,106,2,96]),function(ie,t,A,P,n,z,E,k,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=void 0;const v=k.localize(0,null);class y extends z.$4Q{static{this.OPTION_CHANGE="optionChange"}constructor(o,l,e){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Uc),this.N=[],this.O=this.B(new E.$Td),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$Td),this.onKeyDown=this.P.event,this.Q=this.B(new E.$Td),this.onMouseDown=this.Q.event,this.R=this.B(new E.$Td),this.onInput=this.R.event,this.S=this.B(new E.$Td),this.onKeyUp=this.S.event,this.U=this.B(new E.$Td),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$Td),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||v,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",m=e.appendWholeWordsLabel||"",$=e.appendRegexLabel||"",a=e.history||[],p=!!e.flexibleHeight,f=!!e.flexibleWidth,g=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$TS(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:a,showHistoryHint:e.showHistoryHint,flexibleHeight:p,flexibleWidth:f,flexibleMaxHeight:g,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new P.$7S({appendTitle:$,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(T=>{this.W.fire(T)})),this.L=this.B(new P.$6S({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new P.$5S({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(T=>{this.U.fire(T)}));const h=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,T=>{if(T.equals(15)||T.equals(17)||T.equals(9)){const O=h.indexOf(this.domNode.ownerDocument.activeElement);if(O>=0){let R=-1;T.equals(17)?R=(O+1)%h.length:T.equals(15)&&(O===0?R=h.length-1:R=O-1),T.equals(9)?(h[O].blur(),this.inputBox.focus()):R>=0&&h[R].focus(),A.$lQ.stop(T,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),o?.appendChild(this.domNode),this.B(A.$qP(this.inputBox.inputElement,"compositionstart",h=>{this.s=!0})),this.B(A.$qP(this.inputBox.inputElement,"compositionend",h=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,h=>this.P.fire(h)),this.C(this.inputBox.inputElement,h=>this.S.fire(h)),this.D(this.inputBox.inputElement,h=>this.R.fire()),this.j(this.inputBox.inputElement,h=>this.Q.fire(h))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(o){this.inputBox.layout(),this.X(o.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const o of this.N)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const o of this.N)o.disable()}setFocusInputOnOptionClick(o){this.n=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const l of this.N)l.domNode.remove();this.N=[],this.w.value=new b.$Sc;for(const l of o??[])this.w.value.add(l),this.y.appendChild(l.domNode),this.w.value.add(l.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(l);this.N.length>0&&(this.y.style.display=""),this.X()}X(o=!1){o?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((l,e)=>l+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(o){this.M&&(this.M.checked=o)}getWholeWords(){return this.L?.checked??!1}setWholeWords(o){this.L&&(this.L.checked=o)}getRegex(){return this.J?.checked??!1}setRegex(o){this.J&&(this.J.checked=o,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$8S=y}),define(be[132],$e([1,0,3,22,14,64,131,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,111,103]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l,e,s,m,$,a,p,f,g,h,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GT=t.TreeFindMatchType=t.TreeFindMode=t.$FT=t.$ET=t.$DT=t.RenderIndentGuides=t.$CT=t.$BT=void 0;class R extends b.$ER{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(r=>r.element)),this.c=i}}function w(D){return D instanceof b.$ER?new R(D):D}class S{constructor(i,r){this.d=i,this.f=r,this.b=g.$Tc.None,this.c=new g.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,r){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(c=>c.element),r)}onDragStart(i,r){this.f.onDragStart?.(w(i),r)}onDragOver(i,r,c,u,d=!0){const F=this.f.onDragOver(w(i),r&&r.element,c,u),C=this.a!==r;if(C&&(this.b.dispose(),this.a=r),typeof r>"u")return F;if(C&&typeof F!="boolean"&&F.autoExpand&&(this.b=(0,s.$6g)(()=>{const oe=this.d(),se=oe.getNodeLocation(r);oe.isCollapsed(se)&&oe.setCollapsed(se,!1),this.a=void 0},500,this.c)),typeof F=="boolean"||!F.accept||typeof F.bubble>"u"||F.feedback){if(!d){const oe=typeof F=="boolean"?F:F.accept,se=typeof F=="boolean"?void 0:F.effect;return{accept:oe,effect:se,feedback:[c]}}return F}if(F.bubble===1){const oe=this.d(),se=oe.getNodeLocation(r),de=oe.getParentNodeLocation(se),De=oe.getNode(de),pe=de&&oe.getListIndex(de);return this.onDragOver(i,De,pe,u,!1)}const W=this.d(),j=W.getNodeLocation(r),V=W.getListIndex(j),G=W.getListRenderCount(j);return{...F,feedback:(0,e.$Sb)(V,V+G)}}drop(i,r,c,u){this.b.dispose(),this.a=void 0,this.f.drop(w(i),r&&r.element,c,u)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function M(D,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(r){return i.identityProvider.getId(r.element)}},dnd:i.dnd&&new S(D,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(r){return i.multipleSelectionController.isSelectionSingleChangeEvent({...r,element:r.element})},isSelectionRangeChangeEvent(r){return i.multipleSelectionController.isSelectionRangeChangeEvent({...r,element:r.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(r){const c=D(),u=c.getNodeLocation(r),d=c.getParentNodeLocation(u);return c.getNode(d).visibleChildrenCount},getPosInSet(r){return r.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?r=>i.accessibilityProvider.isChecked(r.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?r=>i.accessibilityProvider.getRole(r.element):()=>"treeitem",getAriaLabel(r){return i.accessibilityProvider.getAriaLabel(r.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?r=>i.accessibilityProvider.getAriaLevel(r.element):r=>r.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(r=>i.accessibilityProvider.getActiveDescendantId(r.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(r){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(r.element)}}}}class H{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,r){this.a.setDynamicHeight?.(i.element,r)}}t.$BT=H;class _{static lift(i){return i instanceof _?i:new _(i)}static empty(i=0){return new _({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const r of i.expanded)this.expanded[r]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$CT=_;var N;(function(D){D.None="none",D.OnHover="onHover",D.Always="always"})(N||(t.RenderIndentGuides=N={}));class I{get elements(){return this.b}constructor(i,r=[]){this.b=r,this.a=new g.$Sc,this.onDidChange=p.Event.forEach(i,c=>this.b=c,this.a)}dispose(){this.a.dispose()}}class B{static{this.a=8}constructor(i,r,c,u,d,F={}){this.o=i,this.p=r,this.q=u,this.s=d,this.b=new Map,this.c=new Map,this.d=B.a,this.f=!1,this.g=!1,this.j=new Set,this.k=g.$Tc.None,this.m=new g.$Sc,this.templateId=i.templateId,this.updateOptions(F),p.Event.map(c,C=>C.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const r=(0,h.$5l)(i.indent,0,40);if(r!==this.d){this.d=r;for(const[c,u]of this.c)this.v(c,u)}}if(typeof i.renderIndentGuides<"u"){const r=i.renderIndentGuides!==N.None;if(r!==this.g){this.g=r;for(const[c,u]of this.c)this.w(c,u);if(this.k.dispose(),r){const c=new g.$Sc;this.q.onDidChange(this.x,this,c),this.k=c,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const r=(0,A.$qQ)(i,(0,A.$)(".monaco-tl-row")),c=(0,A.$qQ)(r,(0,A.$)(".monaco-tl-indent")),u=(0,A.$qQ)(r,(0,A.$)(".monaco-tl-twistie")),d=(0,A.$qQ)(r,(0,A.$)(".monaco-tl-contents")),F=this.o.renderTemplate(d);return{container:i,indent:c,twistie:u,indentGuidesDisposable:g.$Tc.None,templateData:F}}renderElement(i,r,c,u){this.c.set(i,c),this.b.set(i.element,i),this.v(i,c),this.o.renderElement(i,r,c.templateData,u)}disposeElement(i,r,c,u){c.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,r,c.templateData,u),typeof u=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const r=this.b.get(i);r&&this.u(r)}u(i){const r=this.c.get(i);r&&(this.x(this.q.elements),this.v(i,r))}v(i,r){const c=B.a+(i.depth-1)*this.d;r.twistie.style.paddingLeft=`${c}px`,r.indent.style.width=`${c+this.d-16}px`,i.collapsible?r.container.setAttribute("aria-expanded",String(!i.collapsed)):r.container.removeAttribute("aria-expanded"),r.twistie.classList.remove(...$.ThemeIcon.asClassNameArray(m.$0j.treeItemExpanded));let u=!1;this.o.renderTwistie&&(u=this.o.renderTwistie(i.element,r.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(u||r.twistie.classList.add(...$.ThemeIcon.asClassNameArray(m.$0j.treeItemExpanded)),r.twistie.classList.add("collapsible"),r.twistie.classList.toggle("collapsed",i.collapsed)):r.twistie.classList.remove("collapsible","collapsed"),this.w(i,r)}w(i,r){if((0,A.$pP)(r.indent),r.indentGuidesDisposable.dispose(),!this.g)return;const c=new g.$Sc,u=this.p();for(;;){const d=u.getNodeLocation(i),F=u.getParentNodeLocation(d);if(!F)break;const C=u.getNode(F),W=(0,A.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(C)&&W.classList.add("active"),r.indent.childElementCount===0?r.indent.appendChild(W):r.indent.insertBefore(W,r.indent.firstElementChild),this.s.add(C,W),c.add((0,g.$Rc)(()=>this.s.delete(C,W))),i=C}r.indentGuidesDisposable=c}x(i){if(!this.g)return;const r=new Set,c=this.p();i.forEach(u=>{const d=c.getNodeLocation(u);try{const F=c.getParentNodeLocation(d);u.collapsible&&u.children.length>0&&!u.collapsed?r.add(u):F&&r.add(c.getNode(F))}catch{}}),this.j.forEach(u=>{r.has(u)||this.s.forEach(u,d=>d.classList.remove("active"))}),r.forEach(u=>{this.j.has(u)||this.s.forEach(u,d=>d.classList.add("active"))}),this.j=r}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,g.$Oc)(this.m)}}t.$DT=B;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,r,c){this.g=i,this.j=r,this.k=c,this.a=0,this.b=0,this.c="",this.d="",this.f=new g.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,r){let c=1;if(this.k){const F=this.k.filter(i,r);if(typeof F=="boolean"?c=F?1:0:(0,L.$yT)(F)?c=(0,L.$zT)(F.visibility):c=F,c===0)return!1}if(this.a++,!this.c)return this.b++,{data:f.FuzzyScore.Default,visibility:c};const u=this.j.getKeyboardNavigationLabel(i),d=Array.isArray(u)?u:[u];for(const F of d){const C=F&&F.toString();if(typeof C>"u")return{data:f.FuzzyScore.Default,visibility:c};let W;if(this.g.findMatchType===we.Contiguous){const j=C.toLowerCase().indexOf(this.d);if(j>-1){W=[Number.MAX_SAFE_INTEGER,0];for(let V=this.d.length;V>0;V--)W.push(j+V-1)}}else W=(0,f.$5j)(this.c,this.d,0,C,C.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(W)return this.b++,d.length===1?{data:W,visibility:c}:{data:{label:C,score:W},visibility:c}}return this.g.findMode===te.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:f.FuzzyScore.Default,visibility:c}}m(){this.a=0,this.b=0}dispose(){(0,g.$Oc)(this.f)}}class Y extends y.$0R{constructor(i){super({icon:m.$0j.listFilter,title:(0,O.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$ET=Y;class ue extends y.$0R{constructor(i){super({icon:m.$0j.searchFuzzy,title:(0,O.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$FT=ue;const ne={inputBoxStyles:k.$RS,toggleStyles:y.$8R,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(D){D[D.Highlight=0]="Highlight",D[D.Filter=1]="Filter"})(te||(t.TreeFindMode=te={}));var we;(function(D){D[D.Fuzzy=0]="Fuzzy",D[D.Contiguous=1]="Contiguous"})(we||(t.TreeFindMatchType=we={}));class Re extends g.$Tc{set mode(i){this.b.checked=i===te.Filter,this.f.inputBox.setPlaceHolder(i===te.Filter?(0,O.localize)(2,null):(0,O.localize)(3,null))}set matchType(i){this.c.checked=i===we.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,r,c,u,d,F){super(),this.t=r,this.a=(0,A.h)(".monaco-tree-type-filter",[(0,A.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,A.h)(".monaco-tree-type-filter-input@findInput"),(0,A.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new p.$Td,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,g.$Rc)(()=>i.removeChild(this.a.root)));const C=F?.styles??ne;C.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=C.listFilterWidgetBackground),C.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${C.listFilterWidgetShadow}`),this.b=this.B(new Y({...C.toggleStyles,isChecked:u===te.Filter})),this.c=this.B(new ue({...C.toggleStyles,isChecked:d===we.Fuzzy})),this.onDidChangeMode=p.Event.map(this.b.onChange,()=>this.b.checked?te.Filter:te.Highlight,this.q),this.onDidChangeMatchType=p.Event.map(this.c.onChange,()=>this.c.checked?we.Fuzzy:we.Contiguous,this.q),this.f=this.B(new E.$8S(this.a.findInput,c,{label:(0,O.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:C.inputBoxStyles,toggleStyles:C.toggleStyles,history:F?.history})),this.g=this.B(new z.$jR(this.a.actionbar)),this.mode=u;const W=this.B(new P.$rR(this.f.inputBox.inputElement,"keydown")),j=p.Event.chain(W.event,se=>se.map(de=>new n.$nP(de)));this.B(j(se=>{if(se.equals(3)){se.preventDefault(),se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(se.equals(18)){se.preventDefault(),se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(se.equals(16)){se.preventDefault(),se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const V=this.B(new l.$Ii("close",(0,O.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(V,{icon:!0,label:!1});const G=this.B(new P.$rR(this.a.grab,"mousedown"));this.B(G.event(se=>{const de=new g.$Sc,De=de.add(new P.$rR((0,A.getWindow)(se),"mousemove")),pe=de.add(new P.$rR((0,A.getWindow)(se),"mouseup")),Ce=this.m,Fe=se.pageX,Me=this.s,Be=se.pageY;this.a.grab.classList.add("grabbing");const Ie=this.a.root.style.transition;this.a.root.style.transition="unset";const Je=Ke=>{const xe=Ke.pageX-Fe;this.m=Ce-xe;const x=Ke.pageY-Be;this.s=Me+x,this.layout()};de.add(De.event(Je)),de.add(pe.event(Ke=>{Je(Ke),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ie,de.dispose()}))}));const oe=p.Event.chain(this.B(new P.$rR(this.a.grab,"keydown")).event,se=>se.map(de=>new n.$nP(de)));this.B(oe(se=>{let de,De;if(se.keyCode===15?de=Number.POSITIVE_INFINITY:se.keyCode===17?de=0:se.keyCode===10&&(de=this.m===0?Number.POSITIVE_INFINITY:0),se.keyCode===16?De=0:se.keyCode===18&&(De=Number.POSITIVE_INFINITY),de!==void 0&&(se.preventDefault(),se.stopPropagation(),this.m=de,this.layout()),De!==void 0){se.preventDefault(),se.stopPropagation(),this.s=De;const pe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=pe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,h.$5l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,h.$5l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$5g)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,r,c,u,d,F={}){this.t=i,this.u=c,this.v=u,this.w=d,this.x=F,this.b="",this.c="",this.j=0,this.k=new p.$Td,this.onDidChangeMode=this.k.event,this.m=new p.$Td,this.onDidChangeMatchType=this.m.event,this.o=new p.$Td,this.onDidChangePattern=this.o.event,this.p=new p.$Td,this.onDidChangeOpenState=this.p.event,this.q=new g.$Sc,this.s=new g.$Sc,this.d=i.options.defaultFindMode??te.Highlight,this.f=i.options.defaultFindMatchType??we.Fuzzy,r.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Re(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,c=>!f.FuzzyScore.isDefault(c.filterData));const r=this.t.getFocus();if(r.length>0){const c=r[0];this.t.getRelativeTop(c)===null&&this.t.reveal(c,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,O.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!f.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Oe(D,i){return D.position===i.position&&D.node.element===i.node.element&&D.startIndex===i.startIndex&&D.height===i.height&&D.endIndex===i.endIndex}class re extends g.$Tc{constructor(i=[]){super(),this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Oe)}addDisposable(i){this.B(i)}}class J extends g.$Tc{get f(){const i=this.m.firstVisibleIndex;if(!(i<0||i>=this.m.length))return this.m.element(i)}constructor(i,r,c,u,d,F={}){super(),this.g=i,this.j=r,this.m=c,this.s=d,this.b=.4;const C=this.validateStickySettings(F);this.a=C.stickyScrollMaxItemCount,this.c=this.B(new ae(c.getScrollableElement(),c,r,u,d)),this.B(c.onDidScroll(()=>this.t())),this.B(c.onDidChangeContentHeight(()=>this.t())),this.B(i.onDidChangeCollapseState(()=>this.t())),this.t()}get height(){return this.c.height}get count(){return this.c.count}getNode(i){return this.c.getNode(i)}t(){const i=this.f;if(!i||this.g.scrollTop===0){this.c.setState(void 0);return}const r=this.u(i);this.c.setState(r)}u(i){const r=[],c=this.m.renderHeight*this.b;let u=i,d=0,F=this.y(u,void 0,d);for(;F&&d+F.height<c&&(r.push(F),d+=F.height,!(r.length>=this.a||(u=this.w(u),!u)));)F=this.y(u,F.node,d);return r.length?new re(r):void 0}w(i){const r=this.I(i);return r===-1||r===this.m.length-1?void 0:this.m.element(r+1)}y(i,r,c){const u=this.D(i,r);if(u&&!(u===i&&(!this.H(i)||this.z(i,c))))return this.C(u,c)}z(i,r){const c=this.I(i),u=this.m.getElementTop(c),d=r;return this.m.scrollTop===u-d}C(i,r){const c=this.s.getHeight(i),{startIndex:u,endIndex:d}=this.J(i),F=this.F(d,r);return{node:i,position:F,height:c,startIndex:u,endIndex:d}}D(i,r=void 0){let c=i,u=this.G(c);for(;u;){if(u===r)return c;c=u,u=this.G(c)}if(r===void 0)return c}F(i,r){let c=this.m.getRelativeTop(i);if(c===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const W=this.s.getHeight(this.m.element(i)),j=this.m.getRelativeTop(i+1);c=j?j-W/this.m.renderHeight:null}if(c===null)return r;const u=this.m.element(i),d=this.s.getHeight(u),F=c*this.m.renderHeight,C=F+d;return r>F&&r<=C?F:r}G(i){const r=this.j.getNodeLocation(i),c=this.j.getParentNodeLocation(r);return c?this.j.getNode(c):void 0}H(i){const r=this.j.getNodeLocation(i);return this.j.getListRenderCount(r)>1}I(i,r){return r===void 0&&(r=this.j.getNodeLocation(i)),this.j.getListIndex(r)}J(i){const r=this.j.getNodeLocation(i),c=this.j.getListIndex(r);if(c<0)throw new Error("Node not found in tree");const u=this.j.getListRenderCount(r),d=c+u-1;return{startIndex:c,endIndex:d}}nodePositionTopBelowWidget(i){const r=[];let c=this.G(i);for(;c;)r.push(c),c=this.G(c);let u=0;for(let d=0;d<r.length&&d<this.a;d++)u+=this.s.getHeight(r[d]);return u}updateOptions(i={}){const r=this.validateStickySettings(i);this.a!==r.stickyScrollMaxItemCount&&(this.a=r.stickyScrollMaxItemCount,this.t())}validateStickySettings(i){let r=5;return typeof i.stickyScrollMaxItemCount=="number"&&(r=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:r}}}class ae{constructor(i,r,c,u,d){this.c=r,this.d=c,this.f=u,this.g=d,this.a=document.createElement("div"),this.a.classList.add("monaco-tree-sticky-container"),i.appendChild(this.a)}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(r=>r.node===i)}setState(i){const r=!!this.b&&this.b.count>0,c=!!i&&i.count>0;if(!r&&!c||r&&c&&this.b.equal(i)||(r!==c&&this.k(c),this.b?.dispose(),this.b=i,!c))return;for(let F=i.count-1;F>=0;F--){const C=i.stickyNodes[F],W=F?i.stickyNodes[F-1]:void 0,j=W?W.position+W.height:0,{element:V,disposable:G}=this.j(C,j);this.a.appendChild(V),i.addDisposable(G)}const u=(0,A.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(u),i.addDisposable((0,g.$Rc)(()=>u.remove()));const d=i.stickyNodes[i.count-1];this.a.style.height=`${d.position+d.height}px`}j(i,r){const c=this.d.getNodeLocation(i.node),u=this.d.getListIndex(c),d=document.createElement("div");d.style.top=`${i.position}px`,d.style.height=`${i.height}px`,d.style.lineHeight=`${i.height}px`,d.classList.add("monaco-tree-sticky-row"),d.classList.add("monaco-list-row"),d.setAttribute("data-index",`${u}`),d.setAttribute("data-parity",u%2===0?"even":"odd"),d.setAttribute("id",this.c.getElementID(u));const F=this.g.getTemplateId(i.node),C=this.f.find(G=>G.templateId===F);if(!C)throw new Error(`No renderer found for template id ${F}`);const W=new Proxy(i.node,{}),j=C.renderTemplate(d);C.renderElement(W,i.startIndex,j,i.height);const V=(0,g.$Rc)(()=>{C.disposeElement(W,i.startIndex,j,i.height),C.disposeTemplate(j),d.remove()});return{element:d,disposable:V}}k(i){this.a.style.display=i?"block":"none"}dispose(){this.b?.dispose(),this.a.remove()}}function K(D){let i=o.TreeMouseEventTarget.Unknown;return(0,A.$YP)(D.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=o.TreeMouseEventTarget.Twistie:(0,A.$YP)(D.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=o.TreeMouseEventTarget.Element:(0,A.$YP)(D.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=o.TreeMouseEventTarget.Filter),{browserEvent:D.browserEvent,element:D.element?D.element.element:null,target:i}}function U(D){return{element:D.element?D.element.element:null,browserEvent:D.browserEvent,anchor:D.anchor}}function Z(D,i){i(D),D.children.forEach(r=>Z(r,i))}class me{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,r){this.g=i,this.j=r,this.a=[],this.c=new p.$Td,this.onDidChange=this.c.event}set(i,r){!r?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,r)}k(i,r,c){if(this.a=[...i],this.b=void 0,this.d=void 0,!r){const u=this;this.c.fire({get elements(){return u.get()},browserEvent:c})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:r}){if(!this.j){const W=this.m(),j=V=>W.delete(V);r.forEach(V=>Z(V,j)),this.set([...W.values()]);return}const c=new Set,u=W=>c.add(this.j.getId(W.element).toString());r.forEach(W=>Z(W,u));const d=new Map,F=W=>d.set(this.j.getId(W.element).toString(),W);i.forEach(W=>Z(W,F));const C=[];for(const W of this.a){const j=this.j.getId(W.element).toString();if(!c.has(j))C.push(W);else{const G=d.get(j);G&&G.visible&&C.push(G)}}if(this.a.length>0&&C.length===0){const W=this.g();W&&C.push(W)}this.k(C,!0)}m(){const i=new Set;for(const r of this.a)i.add(r);return i}}class ve extends v.$SR{constructor(i,r,c){super(i),this.x=r,this.y=c}u(i){if((0,v.$OR)(i.browserEvent.target)||(0,v.$IR)(i.browserEvent.target)||(0,v.$JR)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const r=i.element;if(!r)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const c=i.browserEvent.target,u=c.classList.contains("monaco-tl-twistie")||c.classList.contains("monaco-icon-label")&&c.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,d=(0,v.$NR)(i.browserEvent.target);let F=!1;if(d?F=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?F=this.x.expandOnlyOnTwistieClick(r.element):F=!!this.x.expandOnlyOnTwistieClick,d)this.A(i,r);else{if(F&&!u&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(r.collapsible&&(!d||u)){const C=this.x.getNodeLocation(r),W=i.browserEvent.altKey;if(this.x.setFocus([C]),this.x.toggleCollapsed(C,W),F&&u){i.browserEvent.isHandledByList=!0;return}}d||super.u(i)}A(i,r){if((0,v.$KR)(i.browserEvent.target)||(0,v.$LR)(i.browserEvent.target))return;const c=this.y();if(!c)throw new Error("Sticky scroll controller not found");const u=this.k.indexOf(r),d=this.k.getElementTop(u),F=c.nodePositionTopBelowWidget(r);this.x.scrollTop=d-F,this.k.setFocus([u]),this.k.setSelection([u])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}}class ke extends v.$VR{constructor(i,r,c,u,d,F,C,W){super(i,r,c,u,W),this.p=d,this.s=F,this.K=C}D(i){return new ve(this,i.tree,i.stickyScrollProvider)}splice(i,r,c=[]){if(super.splice(i,r,c),c.length===0)return;const u=[],d=[];let F;c.forEach((C,W)=>{this.p.has(C)&&u.push(i+W),this.s.has(C)&&d.push(i+W),this.K.has(C)&&(F=i+W)}),u.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...u])),d.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...d])),typeof F=="number"&&super.setAnchor(F)}setFocus(i,r,c=!1){super.setFocus(i,r),c||this.p.set(i.map(u=>this.element(u)),r)}setSelection(i,r,c=!1){super.setSelection(i,r),c||this.s.set(i.map(u=>this.element(u)),r)}setAnchor(i,r=!1){super.setAnchor(i),r||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}class Ee{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return p.Event.map(this.j.onMouseClick,K)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.j.onMouseDblClick,K),i=>i.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return p.Event.map(this.j.onContextMenu,U)}get onTap(){return p.Event.map(this.j.onTap,K)}get onPointer(){return p.Event.map(this.j.onPointer,K)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??te.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??we.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,r,c,u,d={}){this.G=i,this.H=d,this.y=new p.$2d,this.onDidChangeFindOpenState=p.Event.None,this.D=new g.$Sc,this.E=new p.$Td,this.onWillRefilter=this.E.event,this.F=new p.$Td,this.onDidUpdateOptions=this.F.event,this.p=new H(c);const F=new p.$3d,C=new p.$3d,W=this.D.add(new I(C.event)),j=new a.$Gc;this.k=u.map(de=>new B(de,()=>this.o,F.event,W,j,d));for(const de of this.k)this.D.add(de);let V;d.keyboardNavigationLabelProvider&&(V=new X(this,d.keyboardNavigationLabelProvider,d.filter),d={...d,filter:V},this.D.add(V)),this.q=new me(()=>this.j.getFocusedElements()[0],d.identityProvider),this.w=new me(()=>this.j.getSelectedElements()[0],d.identityProvider),this.x=new me(()=>this.j.getAnchorElement(),d.identityProvider),this.j=new ke(i,r,this.p,this.k,this.q,this.w,this.x,{...M(()=>this.o,d),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,d),F.input=this.o.onDidChangeCollapseState;const G=p.Event.forEach(this.o.onDidSplice,de=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(de),this.w.onDidModelSplice(de)})},this.D);G(()=>null,null,this.D);const oe=this.D.add(new p.$Td),se=this.D.add(new s.$1g(0));if(this.D.add(p.Event.any(G,this.q.onDidChange,this.w.onDidChange)(()=>{se.trigger(()=>{const de=new Set;for(const De of this.q.getNodes())de.add(De);for(const De of this.w.getNodes())de.add(De);oe.fire([...de.values()])})})),C.input=oe.event,d.keyboardSupport!==!1){const de=p.Event.chain(this.j.onKeyDown,De=>De.filter(pe=>!(0,v.$IR)(pe.target)).map(pe=>new n.$nP(pe)));p.Event.chain(de,De=>De.filter(pe=>pe.keyCode===15))(this.J,this,this.D),p.Event.chain(de,De=>De.filter(pe=>pe.keyCode===17))(this.K,this,this.D),p.Event.chain(de,De=>De.filter(pe=>pe.keyCode===10))(this.L,this,this.D)}if((d.findWidgetEnabled??!0)&&d.keyboardNavigationLabelProvider&&d.contextViewProvider){const de=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Te(this,this.o,this.j,V,d.contextViewProvider,de),this.A=De=>this.z.shouldAllowFocus(De),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;d.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,d)),this.C=(0,A.$$P)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===N.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const r of this.k)r.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===N.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?this.B=new J(this,this.o,this.j,this.k,this.p,this.H):this.B&&!this.H.enableStickyScroll&&(this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const r=this.o.getListIndex(i);r!==-1&&this.j.updateWidth(r)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,A.$4P)(this.getHTMLElement())}layout(i,r){this.j.layout(i,r),(0,T.$Kf)(r)&&this.z?.layout(r)}style(i){const r=`.${this.j.domId}`,c=[];i.treeIndentGuidesStroke&&(c.push(`.monaco-list${r}:hover .monaco-tl-indent > .indent-guide, .monaco-list${r}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),c.push(`.monaco-list${r} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(c.push(`.monaco-list${r} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),c.push(`.monaco-list${r} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),this.C.textContent=c.join(`
`),this.j.style(i)}getParentElement(i){const r=this.o.getParentNodeLocation(i);return this.o.getNode(r).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,r=!1){return this.o.setCollapsed(i,!0,r)}expand(i,r=!1){return this.o.setCollapsed(i,!1,r)}toggleCollapsed(i,r=!1){return this.o.setCollapsed(i,void 0,r)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,r){return this.o.setCollapsible(i,r)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const r=this.o.getNode(i);this.x.set([r]);const c=this.o.getListIndex(i);c>-1&&this.j.setAnchor(c,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,r){this.y.bufferEvents(()=>{const c=i.map(d=>this.o.getNode(d));this.w.set(c,r);const u=i.map(d=>this.o.getListIndex(d)).filter(d=>d>-1);this.j.setSelection(u,r,!0)})}getSelection(){return this.w.get()}setFocus(i,r){this.y.bufferEvents(()=>{const c=i.map(d=>this.o.getNode(d));this.q.set(c,r);const u=i.map(d=>this.o.getListIndex(d)).filter(d=>d>-1);this.j.setFocus(u,r,!0)})}focusNext(i=1,r=!1,c,u=(0,A.$gQ)(c)&&c.altKey?void 0:this.A){this.j.focusNext(i,r,c,u)}focusPrevious(i=1,r=!1,c,u=(0,A.$gQ)(c)&&c.altKey?void 0:this.A){this.j.focusPrevious(i,r,c,u)}focusNextPage(i,r=(0,A.$gQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,r)}focusPreviousPage(i,r=(0,A.$gQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,r)}focusLast(i,r=(0,A.$gQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,r)}focusFirst(i,r=(0,A.$gQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,r)}getFocus(){return this.q.get()}reveal(i,r){this.o.expandTo(i);const c=this.o.getListIndex(i);if(c!==-1)if(!this.B)this.j.reveal(c,r);else{const u=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(c,r,u)}}getRelativeTop(i){const r=this.o.getListIndex(i);if(r===-1)return null;const c=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(r,c?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new o.$wT(this.G,"Can't get tree view state without an identity provider");const r=F=>i.getId(F).toString(),c=_.empty(this.scrollTop);for(const F of this.getFocus())c.focus.add(r(F));for(const F of this.getSelection())c.selection.add(r(F));const u=this.o.getNode(),d=[u];for(;d.length>0;){const F=d.shift();F!==u&&F.collapsible&&(c.expanded[r(F.element)]=F.collapsed?0:1),d.push(...F.children)}return c}J(i){i.preventDefault(),i.stopPropagation();const r=this.j.getFocusedElements();if(r.length===0)return;const c=r[0],u=this.o.getNodeLocation(c);if(!this.o.setCollapsed(u,!0)){const F=this.o.getParentNodeLocation(u);if(!F)return;const C=this.o.getListIndex(F);this.j.reveal(C),this.j.setFocus([C])}}K(i){i.preventDefault(),i.stopPropagation();const r=this.j.getFocusedElements();if(r.length===0)return;const c=r[0],u=this.o.getNodeLocation(c);if(!this.o.setCollapsed(u,!1)){if(!c.children.some(W=>W.visible))return;const[F]=this.j.getFocus(),C=F+1;this.j.reveal(C),this.j.setFocus([C])}}L(i){i.preventDefault(),i.stopPropagation();const r=this.j.getFocusedElements();if(r.length===0)return;const c=r[0],u=this.o.getNodeLocation(c),d=i.browserEvent.altKey;this.o.setCollapsed(u,void 0,d)}navigate(i){return new ge(this.j,this.o,i)}dispose(){(0,g.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$GT=Ee;class ge{constructor(i,r,c){this.b=i,this.c=r,c?this.a=this.c.getListIndex(c):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],$e([1,0,132,123,26,28]),function(ie,t,A,P,n,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=void 0;class E extends A.$GT{constructor(b,v,y,L,o,l={}){super(b,v,y,L,l),this.f=b,this.g=o,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(b,v){if(v&&!this.c)throw new n.$wT(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,z.Iterable.empty());return}if(!v){this.m(b);return}const y=[],L=[],o=e=>{const s=this.c.getId(e).toString();return!v.expanded[s]},l=e=>{const s=this.c.getId(e.element).toString();v.focus.has(s)&&y.push(e.element),v.selection.has(s)&&L.push(e.element)};this.m(b,o,l),this.setFocus(y),this.setSelection(L),v&&typeof v.scrollTop=="number"&&(this.scrollTop=v.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new n.$wT(this.f,"Tree input not set");let v;this.c&&(v=y=>{const L=this.c.getId(y).toString(),o=this.d.get(L);if(o)return o.collapsed}),this.m(b,v)}resort(b=this.b,v=!0){this.o.resort(b===this.b?null:b,v)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,v,y){let L;if(this.c){const o=new Set,l=y;y=e=>{const s=this.c.getId(e.element).toString();o.add(s),this.d.set(s,e),l?.(e)},L=e=>{const s=this.c.getId(e.element).toString();o.has(s)||this.d.delete(s)}}this.o.setChildren(b===this.b?null:b,this.s(b,v).elements,{onDidCreateNode:y,onDidDeleteNode:L})}s(b,v){const y=[...this.g.getChildren(b)];return{elements:z.Iterable.map(y,o=>{const{elements:l,size:e}=this.s(o,v),s=this.g.hasChildren?this.g.hasChildren(o):void 0,m=e===0?void 0:v&&v(o);return{element:o,children:l,collapsible:s,collapsed:m}}),size:y.length}}M(b,v,y){return new P.$HT(b,v,y)}}t.$RT=E}),define(be[67],$e([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mh=t.ProxyChannel=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.RequestInitiator=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=void 0;var l;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(l||(l={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(s||(s={}));function m(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})($||($={}));function a(re){let J=0;for(let ae=0;;ae+=7){const K=re.read(1);if(J|=(K.buffer[0]&127)<<ae,!(K.buffer[0]&128))return J}}const p=O(0);function f(re,J){if(J===0){re.write(p);return}let ae=0;for(let U=J;U!==0;U=U>>>7)ae++;const K=n.$he.alloc(ae);for(let U=0;J!==0;U++)K.buffer[U]=J&127,J=J>>>7,J>0&&(K.buffer[U]|=128);re.write(K)}class g{constructor(J){this.b=J,this.a=0}read(J){const ae=this.b.slice(this.a,this.a+J);return this.a+=ae.byteLength,ae}}t.$Bh=g;class h{constructor(){this.a=[]}get buffer(){return n.$he.concat(this.a)}write(J){this.a.push(J)}}t.$Ch=h;var T;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(T||(T={}));function O(re){const J=n.$he.alloc(1);return J.writeUInt8(re,0),J}const R={Undefined:O(T.Undefined),String:O(T.String),Buffer:O(T.Buffer),VSBuffer:O(T.VSBuffer),Array:O(T.Array),Object:O(T.Object),Uint:O(T.Int)},w=typeof Buffer<"u";function S(re,J){if(typeof J>"u")re.write(R.Undefined);else if(typeof J=="string"){const ae=n.$he.fromString(J);re.write(R.String),f(re,ae.byteLength),re.write(ae)}else if(w&&Buffer.isBuffer(J)){const ae=n.$he.wrap(J);re.write(R.Buffer),f(re,ae.byteLength),re.write(ae)}else if(J instanceof n.$he)re.write(R.VSBuffer),f(re,J.byteLength),re.write(J);else if(Array.isArray(J)){re.write(R.Array),f(re,J.length);for(const ae of J)S(re,ae)}else if(typeof J=="number"&&(J|0)===J)re.write(R.Uint),f(re,J);else{const ae=n.$he.fromString(JSON.stringify(J));re.write(R.Object),f(re,ae.byteLength),re.write(ae)}}t.$Dh=S;function M(re){switch(re.read(1).readUInt8(0)){case T.Undefined:return;case T.String:return re.read(a(re)).toString();case T.Buffer:return re.read(a(re)).buffer;case T.VSBuffer:return re.read(a(re));case T.Array:{const ae=a(re),K=[];for(let U=0;U<ae;U++)K.push(M(re));return K}case T.Object:return JSON.parse(re.read(a(re)).toString());case T.Int:return a(re)}}t.$Eh=M;class H{constructor(J,ae,K=null,U=1e3){this.h=J,this.j=ae,this.k=K,this.l=U,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:200})}registerChannel(J,ae){this.b.set(J,ae),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const ae=this.o([J.type]);this.k?.logOutgoing(ae,0,1,m(J.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([J.type,J.id],J.data);this.k?.logOutgoing(ae,J.id,1,m(J.type),J.data);return}}}o(J,ae=void 0){const K=new h;return S(K,J),S(K,ae),this.p(K.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const ae=new g(J),K=M(ae),U=M(ae),Z=K[0];switch(Z){case 100:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}: ${K[2]}.${K[3]}`,U),this.s({type:Z,id:K[1],channelName:K[2],name:K[3],arg:U});case 102:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}: ${K[2]}.${K[3]}`,U),this.t({type:Z,id:K[1],channelName:K[2],name:K[3],arg:U});case 101:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}`),this.u({type:Z,id:K[1]});case 103:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}`),this.u({type:Z,id:K[1]})}}s(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const K=new z.$4d;let U;try{U=ae.call(this.j,J.name,J.arg,K.token)}catch(ve){U=Promise.reject(ve)}const Z=J.id;U.then(ve=>{this.m({id:Z,data:ve,type:201})},ve=>{ve instanceof Error?this.m({id:Z,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.m({id:Z,data:ve,type:203})}).finally(()=>{me.dispose(),this.d.delete(J.id)});const me=(0,v.$Rc)(()=>K.cancel());this.d.set(J.id,me)}t(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const K=J.id,Z=ae.listen(this.j,J.name,J.arg)(me=>this.m({id:K,data:me,type:204}));this.d.set(J.id,Z)}u(J){const ae=this.d.get(J.id);ae&&(ae.dispose(),this.d.delete(J.id))}v(J){let ae=this.g.get(J.channelName);ae||(ae=[],this.g.set(J.channelName,ae));const K=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:J,timeoutTimer:K})}w(J){const ae=this.g.get(J);if(ae){for(const K of ae)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Oc)(this.d.values()),this.d.clear()}}t.$Fh=H;var _;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(_||(t.RequestInitiator=_={}));class N{constructor(J,ae=null){this.l=J,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Td,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=ae}getChannel(J){const ae=this;return{call(K,U,Z){return ae.a?Promise.reject(new k.$5):ae.m(J,K,U,Z)},listen(K,U){return ae.a?b.Event.None:ae.o(J,K,U)}}}m(J,ae,K,U=z.CancellationToken.None){const Z=this.g++,ve={id:Z,type:100,channelName:J,name:ae,arg:K};if(U.isCancellationRequested)return Promise.reject(new k.$5);let ke;return new Promise((ge,D)=>{if(U.isCancellationRequested)return D(new k.$5);const i=()=>{const d=F=>{switch(F.type){case 201:this.f.delete(Z),ge(F.data);break;case 202:{this.f.delete(Z);const C=new Error(F.data.message);C.stack=Array.isArray(F.data.stack)?F.data.stack.join(`
`):F.data.stack,C.name=F.data.name,D(C);break}case 203:this.f.delete(Z),D(F.data);break}};this.f.set(Z,d),this.p(ve)};let r=null;this.b===$.Idle?i():(r=(0,P.$Rg)(d=>this.u()),r.then(()=>{r=null,i()}));const c=()=>{r?(r.cancel(),r=null):this.p({id:Z,type:101}),D(new k.$5)},u=U.onCancellationRequested(c);ke=(0,v.$Qc)((0,v.$Rc)(c),u),this.d.add(ke)}).finally(()=>{ke.dispose(),this.d.delete(ke)})}o(J,ae,K){const U=this.g++,me={id:U,type:102,channelName:J,name:ae,arg:K};let ve=null;const ke=new b.$Td({onWillAddFirstListener:()=>{ve=(0,P.$Rg)(ge=>this.u()),ve.then(()=>{ve=null,this.d.add(ke),this.p(me)})},onDidRemoveLastListener:()=>{ve?(ve.cancel(),ve=null):(this.d.delete(ke),this.p({id:U,type:103}))}}),Ee=ge=>ke.fire(ge.data);return this.f.set(U,Ee),ke.event}p(J){switch(J.type){case 100:case 102:{const ae=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(ae,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const ae=this.q([J.type,J.id]);this.j?.logOutgoing(ae,J.id,0,e(J.type));return}}}q(J,ae=void 0){const K=new h;return S(K,J),S(K,ae),this.r(K.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const ae=new g(J),K=M(ae),U=M(ae),Z=K[0];switch(Z){case 200:return this.j?.logIncoming(J.byteLength,0,0,m(Z)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,K[1],0,m(Z),U),this.t({type:K[0],id:K[1],data:U})}}t(J){if(J.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Oc)(this.d.values()),this.d.clear()}}t.$Gh=N,Ye([E.$vh],N.prototype,"onDidInitializePromise",null);class I{get connections(){const J=[];return this.f.forEach(ae=>J.push(ae)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new b.$Td,this.onDidAddConnection=this.g.event,this.h=new b.$Td,this.onDidRemoveConnection=this.h.event,this.j=new v.$Sc,this.j.add(J(({protocol:ae,onDidClientDisconnect:K})=>{const U=b.Event.once(ae.onMessage);this.j.add(U(Z=>{const me=new g(Z),ve=M(me),ke=new H(ae,ve),Ee=new N(ae);this.a.forEach((D,i)=>ke.registerChannel(i,D));const ge={channelServer:ke,channelClient:Ee,ctx:ve};this.f.add(ge),this.g.fire(ge),this.j.add(K(()=>{ke.dispose(),Ee.dispose(),this.f.delete(ge),this.h.fire(ge)}))}))}))}getChannel(J,ae){const K=this;return{call(U,Z,me){let ve;if((0,o.$Uf)(ae)){const Ee=(0,A.$4b)(K.connections.filter(ae));ve=Ee?Promise.resolve(Ee):b.Event.toPromise(b.Event.filter(K.onDidAddConnection,ae))}else ve=ae.routeCall(K,U,Z);const ke=ve.then(Ee=>Ee.channelClient.getChannel(J));return X(ke).call(U,Z,me)},listen(U,Z){if((0,o.$Uf)(ae))return K.k(J,ae,U,Z);const me=ae.routeEvent(K,U,Z).then(ve=>ve.channelClient.getChannel(J));return X(me).listen(U,Z)}}}k(J,ae,K,U){const Z=this;let me;const ve=new b.$Td({onWillAddFirstListener:()=>{me=new v.$Sc;const ke=new b.$Zd,Ee=new Map,ge=i=>{const c=i.channelClient.getChannel(J).listen(K,U),u=ke.add(c);Ee.set(i,u)},D=i=>{const r=Ee.get(i);r&&(r.dispose(),Ee.delete(i))};Z.connections.filter(ae).forEach(ge),b.Event.filter(Z.onDidAddConnection,ae)(ge,void 0,me),Z.onDidRemoveConnection(D,void 0,me),ke.event(ve.fire,ve,me),me.add(ke)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return ve.event}registerChannel(J,ae){this.a.set(J,ae);for(const K of this.f)K.channelServer.registerChannel(J,ae)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Hh=I;class B{constructor(J,ae,K=null){const U=new h;S(U,ae),J.send(U.buffer),this.a=new N(J,K),this.d=new H(J,ae,K)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,ae){this.d.registerChannel(J,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Ih=B;function X(re){return{call(J,ae,K){return re.then(U=>U.call(J,ae,K))},listen(J,ae){const K=new b.$3d;return re.then(U=>K.input=U.listen(J,ae)),K.event}}}t.$Jh=X;function Y(re){let J=!1;return{call(ae,K,U){return J?re.call(ae,K,U):(0,P.$5g)(0).then(()=>J=!0).then(()=>re.call(ae,K,U))},listen(ae,K){if(J)return re.listen(ae,K);const U=new b.$3d;return(0,P.$5g)(0).then(()=>J=!0).then(()=>U.input=re.listen(ae,K)),U.event}}}t.$Kh=Y;class ue{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const ae of J.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await b.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Lh=ue;var ne;(function(re){function J(Z,me,ve){const ke=Z,Ee=ve&&ve.disableMarshalling,ge=new Map;for(const D in ke)K(D)&&ge.set(D,b.Event.buffer(ke[D],!0,void 0,me));return new class{listen(D,i,r){const c=ge.get(i);if(c)return c;if(U(i)){const u=ke[i];if(typeof u=="function")return u.call(ke,r)}throw new k.$bb(`Event not found: ${i}`)}call(D,i,r){const c=ke[i];if(typeof c=="function"){if(!Ee&&Array.isArray(r))for(let d=0;d<r.length;d++)r[d]=(0,y.$Ah)(r[d]);let u=c.apply(ke,r);return u instanceof Promise||(u=Promise.resolve(u)),u}throw new k.$bb(`Method not found: ${i}`)}}}re.fromService=J;function ae(Z,me){const ve=me&&me.disableMarshalling;return new Proxy({},{get(ke,Ee){if(typeof Ee=="string")return me?.properties?.has(Ee)?me.properties.get(Ee):U(Ee)?function(ge){return Z.listen(Ee,ge)}:K(Ee)?Z.listen(Ee):async function(...ge){let D;me&&!(0,o.$Pf)(me.context)?D=[me.context,...ge]:D=ge;const i=await Z.call(Ee,D);return ve?i:(0,y.$Ah)(i)};throw new k.$bb(`Property not found: ${String(Ee)}`)}})}re.toService=ae;function K(Z){return Z[0]==="o"&&Z[1]==="n"&&L.$9e(Z.charCodeAt(2))}function U(Z){return/^onDynamic/.test(Z)&&L.$9e(Z.charCodeAt(9))}})(ne||(t.ProxyChannel=ne={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function we(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const J=re.toString();if(J!=="[object Object]")return J}return re}function Re(re){return Array.isArray(re)?re.map(we):we(re)}function Te(re,J,ae,K,U,Z,me){me=Re(me);const ve=te[U],ke=ve[K%ve.length];let Ee=[`%c[${re}]%c[${String(J).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${ke}`];/\($/.test(Z)?(Ee=Ee.concat(me),Ee.push(")")):Ee.push(me),console.log.apply(console,Ee)}class Oe{constructor(J,ae){this.d=J,this.f=ae,this.a=0,this.b=0}logOutgoing(J,ae,K,U,Z){this.b+=J,Te(this.d,this.b,J,ae,K,U,Z)}logIncoming(J,ae,K,U,Z){this.a+=J,Te(this.f,this.a,J,ae,K,U,Z)}}t.$Mh=Oe}),define(be[134],$e([1,0,33,4,67,90,30]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=void 0;class k extends n.$Ih{static f(){const v=P.Event.fromNodeEventEmitter(E.$O,"vscode:message",(y,L)=>A.$he.wrap(L));return E.$O.send("vscode:hello"),new z.$uU(E.$O,v)}constructor(v){const y=k.f();super(y,v),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}t.$yU=k}),define(be[135],$e([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(be[136],$e([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5h=t.$4h=t.$3h=t._util=void 0;var A;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function k(b){return b[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=k})(A||(t._util=A={})),t.$3h=n("instantiationService");function P(E,k,b){k[A.DI_TARGET]===k?k[A.DI_DEPENDENCIES].push({id:E,index:b}):(k[A.DI_DEPENDENCIES]=[{id:E,index:b}],k[A.DI_TARGET]=k)}function n(E){if(A.serviceIds.has(E))return A.serviceIds.get(E);const k=function(b,v,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(k,b,y)};return k.toString=()=>E,A.serviceIds.set(E,k),k}t.$4h=n;function z(E){return E}t.$5h=z}),define(be[137],$e([1,0,40]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Im=t.$Hm=t.$Gm=t.ID=void 0,t.ID="diagnosticsService",t.$Gm=(0,A.$4h)(t.ID);function P(z){return!!z.hostName&&!!z.errorMessage}t.$Hm=P;class n{async getPerformanceInfo(E,k){return{}}async getSystemInfo(E,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,k){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$Im=n}),define(be[138],$e([1,0,88,24,10,7,15,135,40,5,31,23]),function(ie,t,A,P,n,z,E,k,b,v,y,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xk=t.$Wk=t.$Vk=t.$Uk=t.$Tk=t.FileKind=t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.$Nk=t.$Mk=t.FileOperationResult=t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.FileChangeType=t.$Gk=t.FileOperation=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.FileSystemProviderErrorCode=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.FileSystemProviderCapabilities=t.$qk=t.FilePermission=t.FileType=t.$pk=t.$ok=void 0,t.$ok=(0,b.$4h)("fileService");function o(U){return U.create===!0}t.$pk=o;var l;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(l||(t.FileType=l={}));var e;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(U){const Z=U;return!!Z&&typeof Z.onDidChange=="function"}t.$qk=s;var m;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(m||(t.FileSystemProviderCapabilities=m={}));function $(U){return!!(U.capabilities&2)}t.$rk=$;function a(U){return!!(U.capabilities&8)}t.$sk=a;function p(U){return!!(U.capabilities&131072)}t.$tk=p;function f(U){return!!(U.capabilities&4)}t.$uk=f;function g(U){return!!(U.capabilities&16)}t.$vk=g;function h(U){return $(U)?!!(U.capabilities&16384):!1}t.$wk=h;function T(U){return $(U)?!!(U.capabilities&32768):!1}t.$xk=T;function O(U){return!!(U.capabilities&65536)}t.$yk=O;function R(U){return!!(U.capabilities&2048)}t.$zk=R;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w||(t.FileSystemProviderErrorCode=w={}));class S extends Error{static create(Z,me){const ve=new S(Z.toString(),me);return _(ve,me),ve}constructor(Z,me){super(Z),this.code=me}}t.$Ak=S;function M(U,Z){return S.create(U,Z)}t.$Bk=M;function H(U){return U||M((0,k.localize)(0,null),w.Unknown)}t.$Ck=H;function _(U,Z){return U.name=Z?`${Z} (FileSystemError)`:"FileSystemError",U}t.$Dk=_;function N(U){if(!U)return w.Unknown;if(U instanceof S)return U.code;const Z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!Z)return w.Unknown;switch(Z[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}t.$Ek=N;function I(U){if(U instanceof te)return U.fileOperationResult;switch(N(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}t.$Fk=I;var B;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(B||(t.FileOperation=B={}));class X{constructor(Z,me,ve){this.resource=Z,this.operation=me,this.target=ve}isOperation(Z){return this.operation===Z}}t.$Gk=X;var Y;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class ue{static{this.a=null}constructor(Z,me){this.c=me,this.b=void 0,this.d=new L.$V(()=>{const ve=A.$0h.forUris(()=>this.c);return ve.fill(this.rawAdded.map(ke=>[ke,!0])),ve}),this.f=new L.$V(()=>{const ve=A.$0h.forUris(()=>this.c);return ve.fill(this.rawUpdated.map(ke=>[ke,!0])),ve}),this.g=new L.$V(()=>{const ve=A.$0h.forUris(()=>this.c);return ve.fill(this.rawDeleted.map(ke=>[ke,!0])),ve}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ve of Z){switch(ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}this.b!==ue.a&&(typeof ve.cId=="number"?this.b===void 0?this.b=ve.cId:this.b!==ve.cId&&(this.b=ue.a):this.b!==void 0&&(this.b=ue.a))}}contains(Z,...me){return this.h(Z,{includeChildren:!1},...me)}affects(Z,...me){return this.h(Z,{includeChildren:!0},...me)}h(Z,me,...ve){if(!Z)return!1;const ke=ve.length>0;return!!((!ke||ve.includes(1))&&(this.d.value.get(Z)||me.includeChildren&&this.d.value.findSuperstr(Z))||(!ke||ve.includes(0))&&(this.f.value.get(Z)||me.includeChildren&&this.f.value.findSuperstr(Z))||(!ke||ve.includes(2))&&(this.g.value.findSubstr(Z)||me.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}t.$Hk=ue;function ne(U,Z,me){return!U||!Z||U===Z||Z.length>U.length?!1:(Z.charAt(Z.length-1)!==P.sep&&(Z+=P.sep),me?(0,n.$$e)(U,Z):U.indexOf(Z)===0)}t.$Ik=ne;class te extends Error{constructor(Z,me,ve){super(Z),this.fileOperationResult=me,this.options=ve}}t.$Jk=te;class we extends te{constructor(Z,me,ve,ke){super(Z,me,ke),this.fileOperationResult=me,this.size=ve}}t.$Kk=we;class Re extends te{constructor(Z,me,ve){super(Z,2,ve),this.stat=me}}t.$Lk=Re;var Te;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(t.FileOperationResult=Te={})),t.$Mk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Nk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Ok="files.associations",t.$Pk="files.exclude",t.$Qk="files.readonlyInclude",t.$Rk="files.readonlyExclude",t.$Sk="files.readonlyFromPermissions";var Oe;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(Oe||(t.FileKind=Oe={})),t.$Tk="";function re(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}t.$Uk=re;async function J(U,Z){if(!Z.hasProvider(E.URI.from({scheme:U.scheme})))return new Promise(me=>{const ve=Z.onDidChangeFileSystemProviderRegistrations(ke=>{ke.scheme===U.scheme&&ke.added&&(ve.dispose(),me())})})}t.$Vk=J;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(Z){return(0,z.$Kf)(Z)||(Z=0),Z<ae.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<ae.MB?(0,k.localize)(2,null,(Z/ae.KB).toFixed(2)):Z<ae.GB?(0,k.localize)(3,null,(Z/ae.MB).toFixed(2)):Z<ae.TB?(0,k.localize)(4,null,(Z/ae.GB).toFixed(2)):(0,k.localize)(5,null,(Z/ae.TB).toFixed(2))}}t.$Wk=ae;function K(U){const Z=typeof U=="string"||U?.scheme===y.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===y.Schemas.file?1024*ae.MB:Z?10*ae.MB:v.$o?50*ae.MB:1024*ae.MB}t.$Xk=K}),define(be[139],$e([1,0,40]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w$b=t.$v$b=void 0,t.$v$b=(0,A.$4h)("mainProcessService");class P{constructor(z,E){this.a=z,this.b=E}getChannel(z){return this.a.getChannel(z,this.b)}registerChannel(z,E){this.a.registerChannel(z,E)}}t.$w$b=P}),define(be[140],$e([1,0,2,134]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x$b=void 0;class n extends A.$Tc{constructor(E){super(),this.a=this.B(new P.$yU(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,k){this.a.registerChannel(E,k)}}t.$x$b=n});var Ei=this&&this.__param||function(ie,t){return function(A,P){t(A,P,ie)}};define(be[141],$e([1,0,67,139]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B$b=void 0;let n=class{constructor(E,k){return this.windowId=E,A.ProxyChannel.toService(k.getChannel("nativeHost"),{context:E,properties:(()=>{const b=new Map;return b.set("windowId",E),b})()})}};t.$B$b=n,t.$B$b=n=Ye([Ei(1,P.$v$b)],n)}),define(be[68],$e([1,0,76,7]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wn=void 0;class n{constructor(){this.a=new Map}add(E,k){A.ok(P.$Gf(E)),A.ok(P.$If(k)),A.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,k)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$wn=new n}),define(be[142],$e([1,0,4,68]),function(ie,t,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xn=void 0,t.$xn={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class z{constructor(){this.b=new A.$Td,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,v){this.a[n(b)]=v,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const E=new z;P.$wn.add(t.$xn.JSONContribution,E)}),define(be[143],$e([1,0,9,17,18,4,7,15,136,142,68]),function(ie,t,A,P,n,z,E,k,b,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uw=t.$tw=t.$sw=t.$rw=t.$qw=t.$pw=t.$ow=t.$nw=t.IconFontDefinition=t.IconContribution=t.$mw=void 0,t.$mw={IconContribution:"base.contributions.icons"};var L;(function(f){function g(h,T){let O=h.defaults;for(;n.ThemeIcon.isThemeIcon(O);){const R=e.getIcon(O.id);if(!R)return;O=R.defaults}return O}f.getDefinition=g})(L||(t.IconContribution=L={}));var o;(function(f){function g(T){return{weight:T.weight,style:T.style,src:T.src.map(O=>({format:O.format,location:O.location.toString()}))}}f.toJSONObject=g;function h(T){const O=R=>(0,E.$Gf)(R)?R:void 0;if(T&&Array.isArray(T.src)&&T.src.every(R=>(0,E.$Gf)(R.format)&&(0,E.$Gf)(R.location)))return{weight:O(T.weight),style:O(T.style),src:T.src.map(R=>({format:R.format,location:k.URI.parse(R.location)}))}}f.fromJSONObject=h})(o||(t.IconFontDefinition=o={}));class l{constructor(){this.a=new z.$Td,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,h,T,O){const R=this.b[g];if(R){if(T&&!R.description){R.description=T,this.d.properties[g].markdownDescription=`${T} $(${g})`;const M=this.e.enum.indexOf(g);M!==-1&&(this.e.enumDescriptions[M]=T),this.a.fire()}return R}const w={id:g,description:T,defaults:h,deprecationMessage:O};this.b[g]=w;const S={$ref:"#/definitions/icons"};return O&&(S.deprecationMessage=O),T&&(S.markdownDescription=`${T}: $(${g})`),this.d.properties[g]=S,this.e.enum.push(g),this.e.enumDescriptions.push(T||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const h=this.e.enum.indexOf(g);h!==-1&&(this.e.enum.splice(h,1),this.e.enumDescriptions.splice(h,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,h){const T=this.f[g];return T||(this.f[g]=h,this.a.fire(),h)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(R,w)=>R.id.localeCompare(w.id),h=R=>{for(;n.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},T=[];T.push("| preview     | identifier                        | default codicon ID                | description"),T.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const O=Object.keys(this.b).map(R=>this.b[R]);for(const R of O.filter(w=>!!w.description).sort(g))T.push(`|<i class="${h(R)}"></i>|${R.id}|${n.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);T.push("| preview     | identifier                        "),T.push("| ----------- | --------------------------------- |");for(const R of O.filter(w=>!n.ThemeIcon.isThemeIcon(w.defaults)).sort(g))T.push(`|<i class="${h(R)}"></i>|${R.id}|`);return T.join(`
`)}}const e=new l;y.$wn.add(t.$mw.IconContribution,e);function s(f,g,h,T){return e.registerIcon(f,g,h,T)}t.$nw=s;function m(){return e}t.$ow=m;function $(){const f=(0,P.$8j)();for(const g in f){const h="\\"+f[g].toString(16);e.registerIcon(g,{fontCharacter:h})}}$(),t.$pw="vscode://schemas/icons";const a=y.$wn.as(v.$xn.JSONContribution);a.registerSchema(t.$pw,e.getIconSchema());const p=new A.$dh(()=>a.notifySchemaChanged(t.$pw),200);e.onDidChange(()=>{p.isScheduled()||p.schedule()}),t.$qw=s("widget-close",P.$0j.close,(0,b.localize)(2,null)),t.$rw=s("goto-previous-location",P.$0j.arrowUp,(0,b.localize)(3,null)),t.$sw=s("goto-next-location",P.$0j.arrowDown,(0,b.localize)(4,null)),t.$tw=n.ThemeIcon.modify(P.$0j.sync,"spin"),t.$uw=n.ThemeIcon.modify(P.$0j.loading,"spin")}),define(be[144],$e([1,0,3,4,2,18,143]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IEb=t.$HEb=void 0;function k(v){const y=new n.$Sc,L=y.add(new P.$Td),o=(0,E.$ow)();return y.add(o.onDidChange(()=>L.fire())),v&&y.add(v.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>y.dispose(),onDidChange:L.event,getCSS(){const l=v?v.getProductIconTheme():new b,e={},s=$=>{const a=l.getIcon($);if(!a)return;const p=a.font;return p?(e[p.id]=p.definition,`.codicon-${$.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,A.$HQ)(p.id)}; }`):`.codicon-${$.id}:before { content: '${a.fontCharacter}'; }`},m=[];for(const $ of o.getIcons()){const a=s($);a&&m.push(a)}for(const $ in e){const a=e[$],p=a.weight?`font-weight: ${a.weight};`:"",f=a.style?`font-style: ${a.style};`:"",g=a.src.map(h=>`${(0,A.$GQ)(h.location)} format('${h.format}')`).join(", ");m.push(`@font-face { src: ${g}; font-family: ${(0,A.$HQ)($)};${p}${f} font-display: block; }`)}return m.join(`
`)}}}t.$HEb=k;class b{getIcon(y){const L=(0,E.$ow)();let o=y.defaults;for(;z.ThemeIcon.isThemeIcon(o);){const l=L.getIcon(o.id);if(!l)return;o=l.defaults}return o}}t.$IEb=b}),define(be[145],$e([1,0,5]),function(ie,t,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LC=t.$KC=t.$JC=t.$IC=t.$HC=t.$GC=t.$FC=t.$EC=t.$DC=t.$CC=void 0,t.$CC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function P(o){return typeof o.parentId=="number"}t.$DC=P;function n(o){return!!o.workspaceUri}t.$EC=n;function z(o){return!!o.folderUri}t.$FC=z;function E(o){return!!o.fileUri}t.$GC=E;function k(o){const l=b(o),e=o.getValue("window.menuBarVisibility");return e==="default"||l==="native"&&e==="compact"||A.$j&&A.$m?"classic":e}t.$HC=k;function b(o){if(A.$o)return"custom";const l=o.getValue("window");if(l){if(A.$j&&l.nativeTabs===!0||A.$j&&l.nativeFullScreen===!1)return"native";const m=l.titleBarStyle;if(m==="native"||m==="custom")return m}return A.$k?"native":"custom"}t.$IC=b;function v(o){return!(!A.$i||A.$o||b(o)==="native")}t.$JC=v;function y(o){const l=o.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}t.$KC=y;function L(o=0){return Math.pow(1.2,o)}t.$LC=L}),define(be[146],$e([1,0,16,3,21,30,145]),function(ie,t,A,P,n,z,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$F$b=t.$E$b=t.$D$b=t.ApplyZoomTarget=void 0;var k;(function(o){o[o.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",o[o.ALL_WINDOWS=2]="ALL_WINDOWS"})(k||(t.ApplyZoomTarget=k={}));function b(o,l){const e=[];l===k.ACTIVE_WINDOW?e.push((0,P.$8P)()):l===k.ALL_WINDOWS?e.push(...Array.from((0,P.getWindows)()).map(({window:s})=>s)):e.push(l);for(const s of e)v(s)?.webFrame?.setZoomLevel(o),(0,A.$5O)((0,E.$LC)(o),s),(0,A.$1O)(o,s)}t.$D$b=b;function v(o){if(o===n.$UO)return{ipcRenderer:z.$O,webFrame:z.$Q};{const l=o;if(l?.vscode?.ipcRenderer&&l?.vscode?.webFrame)return l.vscode}}function y(o){b((0,A.$2O)(typeof o=="number"?(0,P.$8P)():o)+1,o)}t.$E$b=y;function L(o){b((0,A.$2O)(typeof o=="number"?(0,P.$8P)():o)-1,o)}t.$F$b=L}),define(be[147],$e([1,0,11,3,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ie,t,A,P,n,z,E,k,b,v,y,L,o,l,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const m=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,$=/\s--inspect-port=(?<port>\d+)/;class a{getHeight(N){return 22}getTemplateId(N){return w(N)?"process":O(N)?"machine":(0,b.$Hm)(N)?"error":R(N)?"header":""}}class p{hasChildren(N){return(0,b.$Hm)(N)?!1:w(N)?!!N.children?.length:!0}getChildren(N){return w(N)?N.children?N.children:[]:(0,b.$Hm)(N)?[]:R(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:O(N)?[N.rootProcess]:[N.processes]}}class f{constructor(){this.templateId="header"}renderTemplate(N){const I=(0,P.$qQ)(N,(0,P.$)(".row")),B=(0,P.$qQ)(I,(0,P.$)(".nameLabel")),X=(0,P.$qQ)(I,(0,P.$)(".cpu")),Y=(0,P.$qQ)(I,(0,P.$)(".memory")),ue=(0,P.$qQ)(I,(0,P.$)(".pid"));return{name:B,CPU:X,memory:Y,PID:ue}}renderElement(N,I,B,X){B.name.textContent=(0,A.localize)(0,null),B.CPU.textContent=(0,A.localize)(1,null),B.PID.textContent=(0,A.localize)(2,null),B.memory.textContent=(0,A.localize)(3,null)}disposeTemplate(N){}}class g{constructor(){this.templateId="machine"}renderTemplate(N){const I=Object.create(null),B=(0,P.$qQ)(N,(0,P.$)(".row"));return I.name=(0,P.$qQ)(B,(0,P.$)(".nameLabel")),I}renderElement(N,I,B,X){B.name.textContent=N.element.name}disposeTemplate(N){}}class h{constructor(){this.templateId="error"}renderTemplate(N){const I=Object.create(null),B=(0,P.$qQ)(N,(0,P.$)(".row"));return I.name=(0,P.$qQ)(B,(0,P.$)(".nameLabel")),I}renderElement(N,I,B,X){B.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class T{constructor(N,I,B){this.a=N,this.b=I,this.c=B,this.templateId="process"}renderTemplate(N){const I=(0,P.$qQ)(N,(0,P.$)(".row")),B=(0,P.$qQ)(I,(0,P.$)(".nameLabel")),X=(0,P.$qQ)(I,(0,P.$)(".cpu")),Y=(0,P.$qQ)(I,(0,P.$)(".memory")),ue=(0,P.$qQ)(I,(0,P.$)(".pid"));return{name:B,CPU:X,PID:ue,memory:Y}}renderElement(N,I,B,X){const{element:Y}=N,ue=Y.pid.toFixed(0);let ne=Y.name;this.c.has(Y.pid)&&(ne=this.c.get(Y.pid)),B.name.textContent=ne,B.name.title=Y.cmd,B.CPU.textContent=Y.load.toFixed(0),B.PID.textContent=ue,B.PID.parentElement.id=`pid-${ue}`;const te=this.a==="win32"?Y.mem:this.b*(Y.mem/100);B.memory.textContent=(te/v.$Wk.MB).toFixed(0)}disposeTemplate(N){}}function O(_){return!!_.name&&!!_.rootProcess}function R(_){return!!_.processRoots}function w(_){return!!_.pid}class S{constructor(N,I){this.f=I,this.b=new Map;const B=new y.$x$b(N);this.c=new L.$B$b(N,B),this.k(I.styles),this.g(I),k.$O.on("vscode:pidToNameResponse",(X,Y)=>{this.b.clear();for(const[ue,ne]of Y)this.b.set(ue,ne)}),k.$O.on("vscode:listProcessesResponse",async(X,Y)=>{Y.forEach((ue,ne)=>{w(ue.rootProcess)&&(ue.rootProcess.name=ne===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Y}}),this.d.layout(s.$UO.innerHeight,s.$UO.innerWidth)):await this.h(Y),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(N){s.$UO.document.onkeydown=I=>{const B=N.platform==="darwin"?I.metaKey:I.ctrlKey;B&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),B&&I.keyCode===187&&(0,l.$E$b)(s.$UO),B&&I.keyCode===189&&(0,l.$F$b)(s.$UO)}}async h(N){const I=s.$UO.document.getElementById("process-list");if(!I)return;const{totalmem:B}=await this.c.getOSStatistics(),X=[new T(this.f.platform,B,this.b),new f,new g,new h];this.d=new n.$RT("processExplorer",I,new a,X,new p,{identityProvider:{getId:Y=>w(Y)?Y.pid.toString():(0,b.$Hm)(Y)?Y.hostName:R(Y)?"processes":O(Y)?Y.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(s.$UO.innerHeight,s.$UO.innerWidth),this.d.onKeyDown(Y=>{const ue=new e.$nP(Y);if(ue.keyCode===35&&ue.altKey){const ne=this.n();Promise.all(ne.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Y=>{w(Y.element)&&this.l(Y.element,!0)}),I.style.height=`${s.$UO.innerHeight}px`,s.$UO.addEventListener("resize",()=>{I.style.height=`${s.$UO.innerHeight}px`,this.d?.layout(s.$UO.innerHeight,s.$UO.innerWidth)})}i(N){const I=m.exec(N);return I&&I.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const I={type:"node",request:"attach",name:`process ${N.pid}`};let B=m.exec(N.cmd);B?I.port=Number(B.groups.port):I.processId=String(N.pid),B=$.exec(N.cmd),B&&(I.port=Number(B.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(N){const I=(0,P.$$P)(),B=[];N.listFocusBackground&&(B.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&B.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(B.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&B.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&B.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&B.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&B.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=B.join(`
`),N.color&&(s.$UO.document.body.style.color=N.color)}l(N,I){const B=[],X=Number(N.pid);I&&(B.push({accelerator:"Alt+E",label:(0,A.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),B.push({label:(0,A.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),B.push({type:"separator"})),B.push({label:(0,A.localize)(6,null),click:()=>{const Y=this.n();Y?.includes(X)||(Y.length=0,Y.push(X));const ue=Y?.map(ne=>s.$UO.document.getElementById(`pid-${ne}`)).filter(ne=>!!ne);if(ue){const ne=ue.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(ne.join(`
`))}}}),B.push({label:(0,A.localize)(7,null),click:()=>{const Y=s.$UO.document.getElementById("process-list");Y&&this.c.writeClipboardText(Y.innerText)}}),N&&I&&this.i(N.cmd)&&(B.push({type:"separator"}),B.push({label:(0,A.localize)(8,null),click:()=>{this.j(N)}})),(0,E.$qU)(B)}m(N){setTimeout(()=>{const I=Date.now(),B=N+I-this.a;this.a=I,B>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(B)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function M(){const _=(0,P.$$P)();_.id="codiconStyles";const N=(0,o.$HEb)(void 0);function I(){_.textContent=N.getCSS()}const B=new z.$dh(I,0);N.onDidChange(()=>B.schedule()),B.schedule()}function H(_){const N=_.data.platform==="win32"?"windows":_.data.platform==="linux"?"linux":"mac";s.$UO.document.body.classList.add(N),M(),(0,l.$D$b)(_.data.zoomLevel,s.$UO),new S(_.windowId,_.data)}t.startup=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d8a75eacf7c70e7327a460a8224dec14a65e1e27/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
